/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/registry/common/platform","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/editor/common/core/range","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","path","vs/base/common/hash","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/stopwatch","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","http","yauzl","yazl","zlib","vs/server/node/server.main"],ve=function(oe){for(var e=[],w=0,R=oe.length;w<R;w++)e[w]=pe[oe[w]];return e};define(pe[139],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class w{static get(){const o=new Map,D=new Map,C=new Map,A=new Map;function v(m,p){m.has(p.detail)||m.set(p.detail,-p.timestamp)}function g(m,p){const b=m.get(p.detail);!b||b>=0||m.set(p.detail,b+p.timestamp)}let T=[];typeof oe.getStats=="function"&&(T=oe.getStats().slice(0).sort((m,p)=>m.timestamp-p.timestamp));for(const m of T)switch(m.type){case 10:v(o,m);break;case 11:case 12:g(o,m);break;case 21:v(D,m);break;case 22:g(D,m);break;case 33:v(C,m);break;case 34:g(C,m);break;case 31:v(A,m);break;case 32:g(A,m);break}let I=0;C.forEach(m=>I+=m);function y(m){const p=[];return m.forEach((b,a)=>p.push([a,b])),p}return{amdLoad:y(o),amdInvoke:y(D),nodeRequire:y(C),nodeEval:y(A),nodeRequireTotal:I}}static toMarkdownTable(o,D){let C="";const A=[];return o.forEach((v,g)=>{A[g]=v.length}),D.forEach(v=>{v.forEach((g,T)=>{typeof g>"u"&&(g=v[T]="-");const I=g.toString().length;A[T]=Math.max(I,A[T])})}),o.forEach((v,g)=>{C+=`| ${v+" ".repeat(A[g]-v.toString().length)} `}),C+=`|
`,o.forEach((v,g)=>{C+=`| ${"-".repeat(A[g])} `}),C+=`|
`,D.forEach(v=>{v.forEach((g,T)=>{typeof g<"u"&&(C+=`| ${g+" ".repeat(A[T]-g.toString().length)} `)}),C+=`|
`}),C}}e.LoaderStats=w}),define(pe[89],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(C){return(A,v,g)=>{let T=null,I=null;if(typeof g.value=="function"?(T="value",I=g.value):typeof g.get=="function"&&(T="get",I=g.get),!I)throw new Error("not supported");g[T]=C(I,v)}}function R(C,A,v){let g=null,T=null;if(typeof v.value=="function"?(g="value",T=v.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(g="get",T=v.get),!T)throw new Error("not supported");const I=`$memoize$${A}`;v[g]=function(...y){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,y)}),this[I]}}e.memoize=R;function o(C,A,v){return w((g,T)=>{const I=`$debounce$${T}`,y=`$debounce$result$${T}`;return function(...m){this[y]||(this[y]=v?v():void 0),clearTimeout(this[I]),A&&(this[y]=A(this[y],...m),m=[this[y]]),this[I]=setTimeout(()=>{g.apply(this,m),this[y]=v?v():void 0},C)}})}e.debounce=o;function D(C,A,v){return w((g,T)=>{const I=`$throttle$timer$${T}`,y=`$throttle$result$${T}`,m=`$throttle$lastRun$${T}`,p=`$throttle$pending$${T}`;return function(...b){if(this[y]||(this[y]=v?v():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),A&&(this[y]=A(this[y],...b)),this[p])return;const a=this[m]+C;a<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[y]]),this[y]=v?v():void 0):(this[p]=!0,this[I]=setTimeout(()=>{this[p]=!1,this[m]=Date.now(),g.apply(this,[this[y]]),this[y]=v?v():void 0},a-Date.now()))}})}e.throttle=D}),define(pe[11],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?S.isErrorNoTelemetry(n)?new S(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=w,e.errorHandler=new w;function R(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function o(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=o;function D(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=D;function C(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function A(t){if(t instanceof Error){const{name:n,message:r}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=A;const v="Canceled";function g(t){return t instanceof T?!0:t instanceof Error&&t.name===v&&t.message===v}e.isCancellationError=g;class T extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=T;function I(){const t=new Error(v);return t.name=t.message,t}e.canceled=I;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=y;function m(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=m;function p(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function b(t){const n=new Error(`${t} has been disposed`);return n.name="DISPOSED",n}e.disposed=b;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=a;class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=f;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=h;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class S extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof S)return n;const r=new S;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class L extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}e.BugIndicatingError=L}),define(pe[18],ve([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(z,V=0){return z[z.length-(1+V)]}e.tail=R;function o(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=o;function D(z,V,J=(H,X)=>H===X){if(z===V)return!0;if(!z||!V||z.length!==V.length)return!1;for(let H=0,X=z.length;H<X;H++)if(!J(z[H],V[H]))return!1;return!0}e.equals=D;function C(z,V){const J=z.length-1;V<J&&(z[V]=z[J]),z.pop()}e.removeFastWithoutKeepingOrder=C;function A(z,V,J){return v(z.length,H=>J(z[H],V))}e.binarySearch=A;function v(z,V){let J=0,H=z-1;for(;J<=H;){const X=(J+H)/2|0,G=V(X);if(G<0)J=X+1;else if(G>0)H=X-1;else return X}return-(J+1)}e.binarySearch2=v;function g(z,V){let J=0,H=z.length;if(H===0)return 0;for(;J<H;){const X=Math.floor((J+H)/2);V(z[X])?H=X:J=X+1}return J}e.findFirstInSorted=g;function T(z,V,J){if(z=z|0,z>=V.length)throw new TypeError("invalid index");const H=V[Math.floor(V.length*Math.random())],X=[],G=[],Q=[];for(const ce of V){const Ee=J(ce,H);Ee<0?X.push(ce):Ee>0?G.push(ce):Q.push(ce)}return z<X.length?T(z,X,J):z<X.length+Q.length?Q[0]:T(z-(X.length+Q.length),G,J)}e.quickSelect=T;function I(z,V){const J=[];let H;for(const X of z.slice(0).sort(V))!H||V(H[0],X)!==0?(H=[X],J.push(H)):H.push(X);return J}e.groupBy=I;function y(z,V,J){const H=[];function X(ce,Ee,De){if(Ee===0&&De.length===0)return;const ke=H[H.length-1];ke&&ke.start+ke.deleteCount===ce?(ke.deleteCount+=Ee,ke.toInsert.push(...De)):H.push({start:ce,deleteCount:Ee,toInsert:De})}let G=0,Q=0;for(;;){if(G===z.length){X(G,0,V.slice(Q));break}if(Q===V.length){X(G,z.length-G,[]);break}const ce=z[G],Ee=V[Q],De=J(ce,Ee);De===0?(G+=1,Q+=1):De<0?(X(G,1,[]),G+=1):De>0&&(X(G,0,[Ee]),Q+=1)}return H}e.sortedDiff=y;function m(z,V,J){const H=y(z,V,J),X=[],G=[];for(const Q of H)X.push(...z.slice(Q.start,Q.start+Q.deleteCount)),G.push(...Q.toInsert);return{removed:X,added:G}}e.delta=m;function p(z,V,J){if(J===0)return[];const H=z.slice(0,J).sort(V);return a(z,V,H,J,z.length),H}e.top=p;function b(z,V,J,H,X){return J===0?Promise.resolve([]):new Promise((G,Q)=>{(async()=>{const ce=z.length,Ee=z.slice(0,J).sort(V);for(let De=J,ke=Math.min(J+H,ce);De<ce;De=ke,ke=Math.min(ke+H,ce)){if(De>J&&await new Promise(Ue=>setTimeout(Ue)),X&&X.isCancellationRequested)throw new w.CancellationError;a(z,V,Ee,De,ke)}return Ee})().then(G,Q)})}e.topAsync=b;function a(z,V,J,H,X){for(const G=J.length;H<X;H++){const Q=z[H];if(V(Q,J[G-1])<0){J.pop();const ce=g(J,Ee=>V(Q,Ee)<0);J.splice(ce,0,Q)}}}function f(z){return z.filter(V=>!!V)}e.coalesce=f;function h(z){let V=0;for(let J=0;J<z.length;J++)z[J]&&(z[V]=z[J],V+=1);z.length=V}e.coalesceInPlace=h;function d(z,V,J){z.splice(J,0,z.splice(V,1)[0])}e.move=d;function S(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=S;function L(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=L;function t(z,V=J=>J){const J=new Set;return z.filter(H=>{const X=V(H);return J.has(X)?!1:(J.add(X),!0)})}e.distinct=t;function n(z){const V=new Set;return J=>{const H=z(J);return V.has(H)?!1:(V.add(H),!0)}}e.uniqueFilter=n;function r(z,V){const J=i(z,V);if(J!==-1)return z[J]}e.findLast=r;function i(z,V){for(let J=z.length-1;J>=0;J--){const H=z[J];if(V(H))return J}return-1}e.lastIndex=i;function l(z,V){return z.length>0?z[0]:V}e.firstOrDefault=l;function c(z,V){return z.length>0?z[z.length-1]:V}e.lastOrDefault=c;function s(z,V,J=(H,X)=>H===X){let H=0;for(let X=0,G=Math.min(z.length,V.length);X<G&&J(z[X],V[X]);X++)H++;return H}e.commonPrefixLength=s;function u(z){return[].concat(...z)}e.flatten=u;function E(z,V){let J=typeof V=="number"?z:0;typeof V=="number"?J=z:(J=0,V=z);const H=[];if(J<=V)for(let X=J;X<V;X++)H.push(X);else for(let X=J;X>V;X--)H.push(X);return H}e.range=E;function k(z,V,J){return z.reduce((H,X)=>(H[V(X)]=J?J(X):X,H),Object.create(null))}e.index=k;function O(z,V){return z.push(V),()=>B(z,V)}e.insert=O;function B(z,V){const J=z.indexOf(V);if(J>-1)return z.splice(J,1),V}e.remove=B;function q(z,V,J){const H=z.slice(0,V),X=z.slice(V);return H.concat(J,X)}e.arrayInsert=q;function le(z,V){let J;if(typeof V=="number"){let H=V;J=()=>{const X=Math.sin(H++)*179426549;return X-Math.floor(X)}}else J=Math.random;for(let H=z.length-1;H>0;H-=1){const X=Math.floor(J()*(H+1)),G=z[H];z[H]=z[X],z[X]=G}}e.shuffle=le;function de(z,V){const J=z.indexOf(V);J>-1&&(z.splice(J,1),z.unshift(V))}e.pushToStart=de;function ue(z,V){const J=z.indexOf(V);J>-1&&(z.splice(J,1),z.push(V))}e.pushToEnd=ue;function ae(z,V){for(const J of V)z.push(J)}e.pushMany=ae;function _(z,V){return Array.isArray(z)?z.map(V):V(z)}e.mapArrayOrNot=_;function ee(z){return Array.isArray(z)?z:[z]}e.asArray=ee;function ne(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=ne;function te(z,V){for(const J of z){const H=V(J);if(H!==void 0)return H}}e.mapFind=te;function x(z,V,J){const H=Z(z,V),X=z.length,G=J.length;z.length=X+G;for(let Q=X-1;Q>=H;Q--)z[Q+G]=z[Q];for(let Q=0;Q<G;Q++)z[Q+H]=J[Q]}e.insertInto=x;function U(z,V,J,H){const X=Z(z,V),G=z.splice(X,J);return x(z,X,H),G}e.splice=U;function Z(z,V){return V<0?Math.max(V+z.length,0):Math.min(V,z.length)}var re;(function(z){function V(X){return X<0}z.isLessThan=V;function J(X){return X>0}z.isGreaterThan=J;function H(X){return X===0}z.isNeitherLessOrGreaterThan=H,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(re=e.CompareResult||(e.CompareResult={}));function me(z,V){return(J,H)=>V(z(J),z(H))}e.compareBy=me;function $(...z){return(V,J)=>{for(const H of z){const X=H(V,J);if(!re.isNeitherLessOrGreaterThan(X))return X}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const W=(z,V)=>z-V;e.numberComparator=W;function N(z,V){if(z.length===0)return;let J=z[0];for(let H=1;H<z.length;H++){const X=z[H];V(X,J)>0&&(J=X)}return J}e.findMaxBy=N;function P(z,V){if(z.length===0)return;let J=z[0];for(let H=1;H<z.length;H++){const X=z[H];V(X,J)>=0&&(J=X)}return J}e.findLastMaxBy=P;function M(z,V){return N(z,(J,H)=>-V(J,H))}e.findMinBy=M;class Y{constructor(V){this.f=V,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(V){let J=this.c;for(;J<this.f.length&&V(this.f[J]);)J++;const H=J===this.c?null:this.f.slice(this.c,J);return this.c=J,H}takeFromEndWhile(V){let J=this.d;for(;J>=0&&V(this.f[J]);)J--;const H=J===this.d?null:this.f.slice(J+1,this.d+1);return this.d=J,H}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const V=this.f[this.c];return this.c++,V}removeLast(){const V=this.f[this.d];return this.d--,V}takeCount(V){const J=this.f.slice(this.c,this.c+V);return this.c+=V,J}}e.ArrayQueue=Y;class ie{constructor(V){this.iterate=V}forEach(V){this.iterate(J=>(V(J),!0))}toArray(){const V=[];return this.iterate(J=>(V.push(J),!0)),V}filter(V){return new ie(J=>this.iterate(H=>V(H)?J(H):!0))}map(V){return new ie(J=>this.iterate(H=>J(V(H))))}some(V){let J=!1;return this.iterate(H=>(J=V(H),!J)),J}findFirst(V){let J;return this.iterate(H=>V(H)?(J=H,!1):!0),J}findLast(V){let J;return this.iterate(H=>(V(H)&&(J=H),!0)),J}findLastMaxBy(V){let J,H=!0;return this.iterate(X=>((H||re.isGreaterThan(V(X,J)))&&(H=!1,J=X),!0)),J}}ie.empty=new ie(z=>{}),e.CallbackIterable=ie}),define(pe[90],ve([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(v,g){if(!v)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=R;function o(v,g="Unreachable"){throw new Error(g)}e.assertNever=o;function D(v){if(!v)throw new w.BugIndicatingError("Assertion Failed")}e.assert=D;function C(v){if(!v()){debugger;v(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function A(v,g){let T=0;for(;T<v.length-1;){const I=v[T],y=v[T+1];if(!g(I,y))return!1;T++}return!0}e.checkAdjacentItems=A}),define(pe[71],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(R){const o=this;let D=!1,C;return function(){return D||(D=!0,C=R.apply(o,arguments)),C}}e.once=w}),define(pe[56],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(R){function o(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}R.is=o;const D=Object.freeze([]);function C(){return D}R.empty=C;function*A(S){yield S}R.single=A;function v(S){return o(S)?S:A(S)}R.wrap=v;function g(S){return S||D}R.from=g;function T(S){return!S||S[Symbol.iterator]().next().done===!0}R.isEmpty=T;function I(S){return S[Symbol.iterator]().next().value}R.first=I;function y(S,L){for(const t of S)if(L(t))return!0;return!1}R.some=y;function m(S,L){for(const t of S)if(L(t))return t}R.find=m;function*p(S,L){for(const t of S)L(t)&&(yield t)}R.filter=p;function*b(S,L){let t=0;for(const n of S)yield L(n,t++)}R.map=b;function*a(...S){for(const L of S)for(const t of L)yield t}R.concat=a;function f(S,L,t){let n=t;for(const r of S)n=L(n,r);return n}R.reduce=f;function*h(S,L,t=S.length){for(L<0&&(L+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);L<t;L++)yield S[L]}R.slice=h;function d(S,L=Number.POSITIVE_INFINITY){const t=[];if(L===0)return[t,S];const n=S[Symbol.iterator]();for(let r=0;r<L;r++){const i=n.next();if(i.done)return[t,R.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return n}}]}R.consume=d})(w=e.Iterable||(e.Iterable={}))}),define(pe[72],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var o;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(o=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function C(t,n=!1){let r=0;const i=t.length;let l="",c=0,s=16,u=0;function E(ue){let ae=0,_=0;for(;ae<ue;){const ee=t.charCodeAt(r);if(ee>=48&&ee<=57)_=_*16+ee-48;else if(ee>=65&&ee<=70)_=_*16+ee-65+10;else if(ee>=97&&ee<=102)_=_*16+ee-97+10;else break;r++,ae++}return ae<ue&&(_=-1),_}function k(ue){r=ue,l="",c=0,s=16,u=0}function O(){const ue=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return u=3,t.substring(ue,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;ae=r}else u=3;return t.substring(ue,ae)}function B(){let ue="",ae=r;for(;;){if(r>=i){ue+=t.substring(ae,r),u=2;break}const _=t.charCodeAt(r);if(_===34){ue+=t.substring(ae,r),r++;break}if(_===92){if(ue+=t.substring(ae,r),r++,r>=i){u=2;break}switch(t.charCodeAt(r++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const ne=E(4);ne>=0?ue+=String.fromCharCode(ne):u=4;break}default:u=5}ae=r;continue}if(_>=0&&_<=31)if(v(_)){ue+=t.substring(ae,r),u=2;break}else u=6;r++}return ue}function q(){if(l="",u=0,c=r,r>=i)return c=i,s=17;let ue=t.charCodeAt(r);if(A(ue)){do r++,l+=String.fromCharCode(ue),ue=t.charCodeAt(r);while(A(ue));return s=15}if(v(ue))return r++,l+=String.fromCharCode(ue),ue===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),s=14;switch(ue){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,l=B(),s=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!v(t.charCodeAt(r));)r++;return l=t.substring(ae,r),s=12}if(t.charCodeAt(r+1)===42){r+=2;const _=i-1;let ee=!1;for(;r<_;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ee=!0;break}r++}return ee||(r++,u=1),l=t.substring(ae,r),s=13}return l+=String.fromCharCode(ue),r++,s=16}case 45:if(l+=String.fromCharCode(ue),r++,r===i||!g(t.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=O(),s=11;default:for(;r<i&&le(ue);)r++,ue=t.charCodeAt(r);if(c!==r){switch(l=t.substring(c,r),l){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return l+=String.fromCharCode(ue),r++,s=16}}function le(ue){if(A(ue)||v(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function de(){let ue;do ue=q();while(ue>=12&&ue<=15);return ue}return{setPosition:k,getPosition:()=>r,scan:n?de:q,getToken:()=>s,getTokenValue:()=>l,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>u}}e.createScanner=C;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function I(t,n){const r=[],i=new Object;let l;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function u(E,k,O,B){c.value=E,c.offset=k,c.length=O,c.type=B,c.colonOffset=void 0,l=c}try{d(t,{onObjectBegin:(E,k)=>{if(n<=E)throw i;l=void 0,s=n>E,r.push("")},onObjectProperty:(E,k,O)=>{if(n<k||(u(E,k,O,"property"),r[r.length-1]=E,n<=k+O))throw i},onObjectEnd:(E,k)=>{if(n<=E)throw i;l=void 0,r.pop()},onArrayBegin:(E,k)=>{if(n<=E)throw i;l=void 0,r.push(0)},onArrayEnd:(E,k)=>{if(n<=E)throw i;l=void 0,r.pop()},onLiteralValue:(E,k,O)=>{if(n<k||(u(E,k,O,L(E)),n<=k+O))throw i},onSeparator:(E,k,O)=>{if(n<=k)throw i;if(E===":"&&l&&l.type==="property")l.colonOffset=k,s=!1,l=void 0;else if(E===","){const B=r[r.length-1];typeof B=="number"?r[r.length-1]=B+1:(s=!0,r[r.length-1]=""),l=void 0}}})}catch(E){if(E!==i)throw E}return{path:r,previousNode:l,isAtPropertyKey:s,matches:E=>{let k=0;for(let O=0;k<E.length&&O<r.length;O++)if(E[k]===r[O]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}e.getLocation=I;function y(t,n=[],r=D.DEFAULT){let i=null,l=[];const c=[];function s(E){Array.isArray(l)?l.push(E):i!==null&&(l[i]=E)}return d(t,{onObjectBegin:()=>{const E={};s(E),c.push(l),l=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const E=[];s(E),c.push(l),l=E,i=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:s,onError:(E,k,O)=>{n.push({error:E,offset:k,length:O})}},r),l[0]}e.parse=y;function m(t,n=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function c(E){return i.children.push(E),E}d(t,{onObjectBegin:E=>{i=c({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,k,O)=>{i=c({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:k,length:O,parent:i})},onObjectEnd:(E,k)=>{i.length=E+k-i.offset,i=i.parent,l(E+k)},onArrayBegin:(E,k)=>{i=c({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,k)=>{i.length=E+k-i.offset,i=i.parent,l(E+k)},onLiteralValue:(E,k,O)=>{c({type:L(E),offset:k,length:O,parent:i,value:E}),l(k+O)},onSeparator:(E,k,O)=>{i.type==="property"&&(E===":"?i.colonOffset=k:E===","&&l(k))},onError:(E,k,O)=>{n.push({error:E,offset:k,length:O})}},r);const u=i.children[0];return u&&delete u.parent,u}e.parseTree=m;function p(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],l=!0;break}if(!l)return}else{const l=i;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=p;function b(t){if(!t.parent||!t.parent.children)return[];const n=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=b;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=a(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function f(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=f;function h(t,n,r=!1){if(f(t,n,r)){const i=t.children;if(Array.isArray(i))for(let l=0;l<i.length&&i[l].offset<=n;l++){const c=h(i[l],n,r);if(c)return c}return t}}e.findNodeAtOffset=h;function d(t,n,r=D.DEFAULT){const i=C(t,!1);function l(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(me){return me?$=>me($,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=l(n.onObjectBegin),u=c(n.onObjectProperty),E=l(n.onObjectEnd),k=l(n.onArrayBegin),O=l(n.onArrayEnd),B=c(n.onLiteralValue),q=c(n.onSeparator),le=l(n.onComment),de=c(n.onError),ue=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function _(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:ue||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(me){case 12:case 13:ue?ee(10):le();break;case 16:ee(1);break;case 15:case 14:break;default:return me}}}function ee(me,$=[],W=[]){if(de(me),$.length+W.length>0){let N=i.getToken();for(;N!==17;){if($.indexOf(N)!==-1){_();break}else if(W.indexOf(N)!==-1)break;N=_()}}}function ne(me){const $=i.getTokenValue();return me?B($):u($),_(),!0}function te(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(ee(2),me=0)}catch{ee(2)}B(me);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return _(),!0}function x(){return i.getToken()!==10?(ee(3,[],[2,5]),!1):(ne(!1),i.getToken()===6?(q(":"),_(),re()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function U(){s(),_();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||ee(4,[],[]),q(","),_(),i.getToken()===2&&ae)break}else me&&ee(6,[],[]);x()||ee(4,[],[2,5]),me=!0}return E(),i.getToken()!==2?ee(7,[2],[]):_(),!0}function Z(){k(),_();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||ee(4,[],[]),q(","),_(),i.getToken()===4&&ae)break}else me&&ee(6,[],[]);re()||ee(4,[],[4,5]),me=!0}return O(),i.getToken()!==4?ee(8,[4],[]):_(),!0}function re(){switch(i.getToken()){case 3:return Z();case 1:return U();case 10:return ne(!0);default:return te()}}return _(),i.getToken()===17?r.allowEmptyContent?!0:(ee(4,[],[]),!1):re()?(i.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.visit=d;function S(t,n){const r=C(t),i=[];let l,c=0,s;do switch(s=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:c!==s&&i.push(t.substring(c,s)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),c=r.getPosition();break}while(l!==17);return i.join("")}e.stripComments=S;function L(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(pe[140],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(o){this.d=o,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(o){this.c=o}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=w}),define(pe[2],ve([1,0,71,56]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const o=!1;let D=null;function C(c){D=c}if(e.setDisposableTracker=C,o){const c="__is_disposable_tracked__";C(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==h.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==h.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function A(c){return D?.trackDisposable(c),c}function v(c){D?.markAsDisposed(c)}function g(c,s){D?.setParent(c,s)}function T(c,s){if(!!D)for(const u of c)D.setParent(u,s)}function I(c){return D?.markAsSingleton(c),c}e.markAsSingleton=I;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function m(c){if(R.Iterable.is(c)){const s=[];for(const u of c)if(u)try{u.dispose()}catch(E){s.push(E)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=m;function p(c){for(const s of c)y(s)&&s.dispose();return[]}e.disposeIfDisposable=p;function b(...c){const s=a(()=>m(c));return T(c,s),s}e.combinedDisposable=b;function a(c){const s=A({dispose:(0,w.once)(()=>{v(s),c()})});return s}e.toDisposable=a;class f{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(v(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{m(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return g(s,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}f.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=f;class h{constructor(){this.q=new f,A(this),g(this.q,this)}dispose(){v(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class d{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&g(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&g(s,null),s}}e.MutableDisposable=d;class S{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(s){let u=s;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,v(this))},this}}e.SafeDisposable=L;class t{constructor(){this.a=new Map}acquire(s,...u){let E=this.a.get(s);E||(E={counter:0,object:this.b(s,...u)},this.a.set(s,E));const{object:k}=E,O=(0,w.once)(()=>{--E.counter===0&&(this.c(s,E.object),this.a.delete(s))});return E.counter++,{object:k,dispose:O}}}e.ReferenceCollection=t;class n{constructor(s){this.a=s}async acquire(s,...u){const E=this.a.acquire(s,...u);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(k){throw E.dispose(),k}}}e.AsyncReferenceCollection=n;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function i(c){const s=new f;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=i;class l{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,u,E=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this.a.get(s)?.dispose(),this.a.set(s,u)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(pe[91],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(D){this.element=D,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class R{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let D=this.a;for(;D!==w.Undefined;){const C=D.next;D.prev=w.Undefined,D.next=w.Undefined,D=C}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,C){const A=new w(D);if(this.a===w.Undefined)this.a=A,this.b=A;else if(C){const g=this.b;this.b=A,A.prev=g,g.next=A}else{const g=this.a;this.a=A,A.next=g,g.prev=A}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(A))}}shift(){if(this.a!==w.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==w.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==w.Undefined&&D.next!==w.Undefined){const C=D.prev;C.next=D.next,D.next.prev=C}else D.prev===w.Undefined&&D.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):D.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):D.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==w.Undefined;)yield D.element,D=D.next}}e.LinkedList=R}),define(pe[27],ve([1,0]),function(oe,e){"use strict";var w,R,o;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function D(b,a,f){let h=b.get(a);return h===void 0&&(h=f,b.set(a,h)),h}e.getOrSet=D;function C(b){const a=[];return b.forEach((f,h)=>{a.push(`${h} => ${f}`)}),`Map(${b.size}) {${a.join(", ")}}`}e.mapToString=C;function A(b){const a=[];return b.forEach(f=>{a.push(f)}),`Set(${b.size}) {${a.join(", ")}}`}e.setToString=A;class v{constructor(a,f){this.uri=a,this.value=f}}class g{constructor(a,f){this[w]="ResourceMap",a instanceof g?(this.b=new Map(a.b),this.c=f??g.a):(this.b=new Map,this.c=a??g.a)}set(a,f){return this.b.set(this.c(a),new v(a,f)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,f){typeof f<"u"&&(a=a.bind(f));for(const[h,d]of this.b)a(d.value,d.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}g.a=b=>b.toString(),e.ResourceMap=g;class T{constructor(a,f){this[R]="ResourceSet",!a||typeof a=="function"?this.a=new g(a):(this.a=new g(f),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,f){this.a.forEach((h,d)=>a.call(f,d,d,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var I;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class y{constructor(){this[o]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,f=0){const h=this.a.get(a);if(!!h)return f!==0&&this.j(h,f),h.value}set(a,f,h=0){let d=this.a.get(a);if(d)d.value=f,h!==0&&this.j(d,h);else{switch(d={key:a,value:f,next:void 0,previous:void 0},h){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(a,d),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const f=this.a.get(a);if(!!f)return this.a.delete(a),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,f){const h=this.e;let d=this.b;for(;d;){if(f?a.bind(f)(d.value,d.key,this):a(d.value,d.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const a=this,f=this.e;let h=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const S={value:h.key,done:!1};return h=h.next,S}else return{value:void 0,done:!0}}};return d}values(){const a=this,f=this.e;let h=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const S={value:h.value,done:!1};return h=h.next,S}else return{value:void 0,done:!0}}};return d}entries(){const a=this,f=this.e;let h=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const S={value:[h.key,h.value],done:!1};return h=h.next,S}else return{value:void 0,done:!0}}};return d}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let f=this.b,h=this.size;for(;f&&h>a;)this.a.delete(f.key),f=f.next,h--;this.b=f,this.d=h,f&&(f.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const f=a.next,h=a.previous;if(!f||!h)throw new Error("Invalid list");f.previous=h,h.next=f}a.next=void 0,a.previous=void 0,this.e++}j(a,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(a===this.b)return;const h=a.next,d=a.previous;a===this.c?(d.next=void 0,this.c=d):(h.previous=d,d.next=h),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(f===2){if(a===this.c)return;const h=a.next,d=a.previous;a===this.b?(h.previous=void 0,this.b=h):(h.previous=d,d.next=h),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((f,h)=>{a.push([h,f])}),a}fromJSON(a){this.clear();for(const[f,h]of a)this.set(f,h)}}e.LinkedMap=y;class m extends y{constructor(a,f=1){super(),this.k=a,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,f=2){return super.get(a,f)}peek(a){return super.get(a,0)}set(a,f){return super.set(a,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=m;class p{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let f=this.a.get(a)||0;return f===0?!1:(f--,f===0?this.a.delete(a):this.a.set(a,f),!0)}has(a){return this.a.has(a)}}e.CounterSet=p}),function(oe,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(pe[141],ve([0]),e):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(z,V){for(var J=0;J<V.length;J++){var H=V[J];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(z,H.key,H)}}function w(z,V,J){return V&&e(z.prototype,V),J&&e(z,J),Object.defineProperty(z,"prototype",{writable:!1}),z}function R(z,V){if(!!z){if(typeof z=="string")return o(z,V);var J=Object.prototype.toString.call(z).slice(8,-1);if(J==="Object"&&z.constructor&&(J=z.constructor.name),J==="Map"||J==="Set")return Array.from(z);if(J==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(J))return o(z,V)}}function o(z,V){(V==null||V>z.length)&&(V=z.length);for(var J=0,H=new Array(V);J<V;J++)H[J]=z[J];return H}function D(z,V){var J=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(J)return(J=J.call(z)).next.bind(J);if(Array.isArray(z)||(J=R(z))||V&&z&&typeof z.length=="number"){J&&(z=J);var H=0;return function(){return H>=z.length?{done:!0}:{done:!1,value:z[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=C();function A(z){oe.defaults=z}var v=/[&<>"']/,g=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(V){return y[V]};function p(z,V){if(V){if(v.test(z))return z.replace(g,m)}else if(T.test(z))return z.replace(I,m);return z}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(z){return z.replace(b,function(V,J){return J=J.toLowerCase(),J==="colon"?":":J.charAt(0)==="#"?J.charAt(1)==="x"?String.fromCharCode(parseInt(J.substring(2),16)):String.fromCharCode(+J.substring(1)):""})}var f=/(^|[^\[])\^/g;function h(z,V){z=typeof z=="string"?z:z.source,V=V||"";var J={replace:function(X,G){return G=G.source||G,G=G.replace(f,"$1"),z=z.replace(X,G),J},getRegex:function(){return new RegExp(z,V)}};return J}var d=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function L(z,V,J){if(z){var H;try{H=decodeURIComponent(a(J)).replace(d,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}V&&!S.test(J)&&(J=l(V,J));try{J=encodeURI(J).replace(/%25/g,"%")}catch{return null}return J}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(z,V){t[" "+z]||(n.test(z)?t[" "+z]=z+"/":t[" "+z]=E(z,"/",!0)),z=t[" "+z];var J=z.indexOf(":")===-1;return V.substring(0,2)==="//"?J?V:z.replace(r,"$1")+V:V.charAt(0)==="/"?J?V:z.replace(i,"$1")+V:z+V}var c={exec:function(){}};function s(z){for(var V=1,J,H;V<arguments.length;V++){J=arguments[V];for(H in J)Object.prototype.hasOwnProperty.call(J,H)&&(z[H]=J[H])}return z}function u(z,V){var J=z.replace(/\|/g,function(G,Q,ce){for(var Ee=!1,De=Q;--De>=0&&ce[De]==="\\";)Ee=!Ee;return Ee?"|":" |"}),H=J.split(/ \|/),X=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>V)H.splice(V);else for(;H.length<V;)H.push("");for(;X<H.length;X++)H[X]=H[X].trim().replace(/\\\|/g,"|");return H}function E(z,V,J){var H=z.length;if(H===0)return"";for(var X=0;X<H;){var G=z.charAt(H-X-1);if(G===V&&!J)X++;else if(G!==V&&J)X++;else break}return z.slice(0,H-X)}function k(z,V){if(z.indexOf(V[1])===-1)return-1;for(var J=z.length,H=0,X=0;X<J;X++)if(z[X]==="\\")X++;else if(z[X]===V[0])H++;else if(z[X]===V[1]&&(H--,H<0))return X;return-1}function O(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(z,V){if(V<1)return"";for(var J="";V>1;)V&1&&(J+=z),V>>=1,z+=z;return J+z}function q(z,V,J,H){var X=V.href,G=V.title?p(V.title):null,Q=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){H.state.inLink=!0;var ce={type:"link",raw:J,href:X,title:G,text:Q,tokens:H.inlineTokens(Q)};return H.state.inLink=!1,ce}return{type:"image",raw:J,href:X,title:G,text:p(Q)}}function le(z,V){var J=z.match(/^(\s+)(?:```)/);if(J===null)return V;var H=J[1];return V.split(`
`).map(function(X){var G=X.match(/^\s+/);if(G===null)return X;var Q=G[0];return Q.length>=H.length?X.slice(H.length):X}).join(`
`)}var de=function(){function z(J){this.options=J||oe.defaults}var V=z.prototype;return V.space=function(H){var X=this.rules.block.newline.exec(H);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},V.code=function(H){var X=this.rules.block.code.exec(H);if(X){var G=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?G:E(G,`
`)}}},V.fences=function(H){var X=this.rules.block.fences.exec(H);if(X){var G=X[0],Q=le(G,X[3]||"");return{type:"code",raw:G,lang:X[2]?X[2].trim():X[2],text:Q}}},V.heading=function(H){var X=this.rules.block.heading.exec(H);if(X){var G=X[2].trim();if(/#$/.test(G)){var Q=E(G,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(G=Q.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:G,tokens:this.lexer.inline(G)}}},V.hr=function(H){var X=this.rules.block.hr.exec(H);if(X)return{type:"hr",raw:X[0]}},V.blockquote=function(H){var X=this.rules.block.blockquote.exec(H);if(X){var G=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},V.list=function(H){var X=this.rules.block.list.exec(H);if(X){var G,Q,ce,Ee,De,ke,Ue,$e,ge,Se,ye,Me,Fe=X[1].trim(),_e=Fe.length>1,He={type:"list",raw:"",ordered:_e,start:_e?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=_e?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=_e?Fe:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(Me=!1,!(!(X=Je.exec(H))||this.rules.block.hr.test(H)));){if(G=X[0],H=H.substring(G.length),$e=X[2].split(`
`,1)[0],ge=H.split(`
`,1)[0],this.options.pedantic?(Ee=2,ye=$e.trimLeft()):(Ee=X[2].search(/[^ ]/),Ee=Ee>4?1:Ee,ye=$e.slice(Ee),Ee+=X[1].length),ke=!1,!$e&&/^ *$/.test(ge)&&(G+=ge+`
`,H=H.substring(ge.length+1),Me=!0),!Me)for(var Qe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ke=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),he=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");H&&(Se=H.split(`
`,1)[0],$e=Se,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ke.test($e)||he.test($e)||Qe.test($e)||et.test(H)));){if($e.search(/[^ ]/)>=Ee||!$e.trim())ye+=`
`+$e.slice(Ee);else if(!ke)ye+=`
`+$e;else break;!ke&&!$e.trim()&&(ke=!0),G+=Se+`
`,H=H.substring(Se.length+1)}He.loose||(Ue?He.loose=!0:/\n *\n *$/.test(G)&&(Ue=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ye),Q&&(ce=Q[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:G,task:!!Q,checked:ce,loose:!1,text:ye}),He.raw+=G}He.items[He.items.length-1].raw=G.trimRight(),He.items[He.items.length-1].text=ye.trimRight(),He.raw=He.raw.trimRight();var Ce=He.items.length;for(De=0;De<Ce;De++){this.lexer.state.top=!1,He.items[De].tokens=this.lexer.blockTokens(He.items[De].text,[]);var Te=He.items[De].tokens.filter(function(Re){return Re.type==="space"}),Ne=Te.every(function(Re){for(var ze=Re.raw.split(""),qe=0,Ve=D(ze),Ge;!(Ge=Ve()).done;){var Xe=Ge.value;if(Xe===`
`&&(qe+=1),qe>1)return!0}return!1});!He.loose&&Te.length&&Ne&&(He.loose=!0,He.items[De].loose=!0)}return He}},V.html=function(H){var X=this.rules.block.html.exec(H);if(X){var G={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var Q=this.options.sanitizer?this.options.sanitizer(X[0]):p(X[0]);G.type="paragraph",G.text=Q,G.tokens=this.lexer.inline(Q)}return G}},V.def=function(H){var X=this.rules.block.def.exec(H);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var G=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:X[0],href:X[2],title:X[3]}}},V.table=function(H){var X=this.rules.block.table.exec(H);if(X){var G={type:"table",header:u(X[1]).map(function(Ue){return{text:Ue}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=X[0];var Q=G.align.length,ce,Ee,De,ke;for(ce=0;ce<Q;ce++)/^ *-+: *$/.test(G.align[ce])?G.align[ce]="right":/^ *:-+: *$/.test(G.align[ce])?G.align[ce]="center":/^ *:-+ *$/.test(G.align[ce])?G.align[ce]="left":G.align[ce]=null;for(Q=G.rows.length,ce=0;ce<Q;ce++)G.rows[ce]=u(G.rows[ce],G.header.length).map(function(Ue){return{text:Ue}});for(Q=G.header.length,Ee=0;Ee<Q;Ee++)G.header[Ee].tokens=this.lexer.inline(G.header[Ee].text);for(Q=G.rows.length,Ee=0;Ee<Q;Ee++)for(ke=G.rows[Ee],De=0;De<ke.length;De++)ke[De].tokens=this.lexer.inline(ke[De].text);return G}}},V.lheading=function(H){var X=this.rules.block.lheading.exec(H);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},V.paragraph=function(H){var X=this.rules.block.paragraph.exec(H);if(X){var G=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:G,tokens:this.lexer.inline(G)}}},V.text=function(H){var X=this.rules.block.text.exec(H);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},V.escape=function(H){var X=this.rules.inline.escape.exec(H);if(X)return{type:"escape",raw:X[0],text:p(X[1])}},V.tag=function(H){var X=this.rules.inline.tag.exec(H);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):p(X[0]):X[0]}},V.link=function(H){var X=this.rules.inline.link.exec(H);if(X){var G=X[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Q=E(G.slice(0,-1),"\\");if((G.length-Q.length)%2===0)return}else{var ce=k(X[2],"()");if(ce>-1){var Ee=X[0].indexOf("!")===0?5:4,De=Ee+X[1].length+ce;X[2]=X[2].substring(0,ce),X[0]=X[0].substring(0,De).trim(),X[3]=""}}var ke=X[2],Ue="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);$e&&(ke=$e[1],Ue=$e[3])}else Ue=X[3]?X[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(G)?ke=ke.slice(1):ke=ke.slice(1,-1)),q(X,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},V.reflink=function(H,X){var G;if((G=this.rules.inline.reflink.exec(H))||(G=this.rules.inline.nolink.exec(H))){var Q=(G[2]||G[1]).replace(/\s+/g," ");if(Q=X[Q.toLowerCase()],!Q||!Q.href){var ce=G[0].charAt(0);return{type:"text",raw:ce,text:ce}}return q(G,Q,G[0],this.lexer)}},V.emStrong=function(H,X,G){G===void 0&&(G="");var Q=this.rules.inline.emStrong.lDelim.exec(H);if(!!Q&&!(Q[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=Q[1]||Q[2]||"";if(!ce||ce&&(G===""||this.rules.inline.punctuation.exec(G))){var Ee=Q[0].length-1,De,ke,Ue=Ee,$e=0,ge=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,X=X.slice(-1*H.length+Ee);(Q=ge.exec(X))!=null;)if(De=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!De){if(ke=De.length,Q[3]||Q[4]){Ue+=ke;continue}else if((Q[5]||Q[6])&&Ee%3&&!((Ee+ke)%3)){$e+=ke;continue}if(Ue-=ke,!(Ue>0)){if(ke=Math.min(ke,ke+Ue+$e),Math.min(Ee,ke)%2){var Se=H.slice(1,Ee+Q.index+ke);return{type:"em",raw:H.slice(0,Ee+Q.index+ke+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ye=H.slice(2,Ee+Q.index+ke-1);return{type:"strong",raw:H.slice(0,Ee+Q.index+ke+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},V.codespan=function(H){var X=this.rules.inline.code.exec(H);if(X){var G=X[2].replace(/\n/g," "),Q=/[^ ]/.test(G),ce=/^ /.test(G)&&/ $/.test(G);return Q&&ce&&(G=G.substring(1,G.length-1)),G=p(G,!0),{type:"codespan",raw:X[0],text:G}}},V.br=function(H){var X=this.rules.inline.br.exec(H);if(X)return{type:"br",raw:X[0]}},V.del=function(H){var X=this.rules.inline.del.exec(H);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},V.autolink=function(H,X){var G=this.rules.inline.autolink.exec(H);if(G){var Q,ce;return G[2]==="@"?(Q=p(this.options.mangle?X(G[1]):G[1]),ce="mailto:"+Q):(Q=p(G[1]),ce=Q),{type:"link",raw:G[0],text:Q,href:ce,tokens:[{type:"text",raw:Q,text:Q}]}}},V.url=function(H,X){var G;if(G=this.rules.inline.url.exec(H)){var Q,ce;if(G[2]==="@")Q=p(this.options.mangle?X(G[0]):G[0]),ce="mailto:"+Q;else{var Ee;do Ee=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(Ee!==G[0]);Q=p(G[0]),G[1]==="www."?ce="http://"+Q:ce=Q}return{type:"link",raw:G[0],text:Q,href:ce,tokens:[{type:"text",raw:Q,text:Q}]}}},V.inlineText=function(H,X){var G=this.rules.inline.text.exec(H);if(G){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):p(G[0]):G[0]:Q=p(this.options.smartypants?X(G[0]):G[0]),{type:"text",raw:G[0],text:Q}}},z}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=h(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=h(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=h(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=h(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=h(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=h(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=s({},ue),ue.gfm=s({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=h(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=h(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=s({},ue.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:h(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=h(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=h(ue._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=h(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=h(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=h(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=h(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=h(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=h(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=h(ae.reflink).replace("label",ae._label).replace("ref",ue._label).getRegex(),ae.nolink=h(ae.nolink).replace("ref",ue._label).getRegex(),ae.reflinkSearch=h(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=s({},ae),ae.pedantic=s({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=s({},ae.normal,{escape:h(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=h(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=s({},ae.gfm,{br:h(ae.br).replace("{2,}","*").getRegex(),text:h(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(z){var V="",J,H,X=z.length;for(J=0;J<X;J++)H=z.charCodeAt(J),Math.random()>.5&&(H="x"+H.toString(16)),V+="&#"+H+";";return V}var ne=function(){function z(J){this.tokens=[],this.tokens.links=Object.create(null),this.options=J||oe.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:ue.normal,inline:ae.normal};this.options.pedantic?(H.block=ue.pedantic,H.inline=ae.pedantic):this.options.gfm&&(H.block=ue.gfm,this.options.breaks?H.inline=ae.breaks:H.inline=ae.gfm),this.tokenizer.rules=H}z.lex=function(H,X){var G=new z(X);return G.lex(H)},z.lexInline=function(H,X){var G=new z(X);return G.inlineTokens(H)};var V=z.prototype;return V.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},V.blockTokens=function(H,X){var G=this;X===void 0&&(X=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Ue,$e,ge){return $e+"    ".repeat(ge.length)});for(var Q,ce,Ee,De;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(Q=Ue.call({lexer:G},H,X))?(H=H.substring(Q.raw.length),X.push(Q),!0):!1}))){if(Q=this.tokenizer.space(H)){H=H.substring(Q.raw.length),Q.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(Q);continue}if(Q=this.tokenizer.code(H)){H=H.substring(Q.raw.length),ce=X[X.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):X.push(Q);continue}if(Q=this.tokenizer.fences(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.heading(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.hr(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.blockquote(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.list(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.html(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.def(H)){H=H.substring(Q.raw.length),ce=X[X.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.lheading(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Ee=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,$e=H.slice(1),ge=void 0;G.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},$e),typeof ge=="number"&&ge>=0&&(Ue=Math.min(Ue,ge))}),Ue<1/0&&Ue>=0&&(Ee=H.substring(0,Ue+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(Ee))){ce=X[X.length-1],De&&ce.type==="paragraph"?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):X.push(Q),De=Ee.length!==H.length,H=H.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(H)){H=H.substring(Q.raw.length),ce=X[X.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):X.push(Q);continue}if(H){var ke="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,X},V.inline=function(H,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:H,tokens:X}),X},V.inlineTokens=function(H,X){var G=this;X===void 0&&(X=[]);var Q,ce,Ee,De=H,ke,Ue,$e;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)ge.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,ke.index)+"["+B("a",ke[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,ke.index)+"["+B("a",ke[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,ke.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Ue||($e=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Q=ye.call({lexer:G},H,X))?(H=H.substring(Q.raw.length),X.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.tag(H)){H=H.substring(Q.raw.length),ce=X[X.length-1],ce&&Q.type==="text"&&ce.type==="text"?(ce.raw+=Q.raw,ce.text+=Q.text):X.push(Q);continue}if(Q=this.tokenizer.link(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(Q.raw.length),ce=X[X.length-1],ce&&Q.type==="text"&&ce.type==="text"?(ce.raw+=Q.raw,ce.text+=Q.text):X.push(Q);continue}if(Q=this.tokenizer.emStrong(H,De,$e)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.codespan(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.br(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.del(H)){H=H.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.autolink(H,ee)){H=H.substring(Q.raw.length),X.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(H,ee))){H=H.substring(Q.raw.length),X.push(Q);continue}if(Ee=H,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Me=H.slice(1),Fe=void 0;G.options.extensions.startInline.forEach(function(_e){Fe=_e.call({lexer:this},Me),typeof Fe=="number"&&Fe>=0&&(ye=Math.min(ye,Fe))}),ye<1/0&&ye>=0&&(Ee=H.substring(0,ye+1))}(),Q=this.tokenizer.inlineText(Ee,_)){H=H.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&($e=Q.raw.slice(-1)),Ue=!0,ce=X[X.length-1],ce&&ce.type==="text"?(ce.raw+=Q.raw,ce.text+=Q.text):X.push(Q);continue}if(H){var Se="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return X},w(z,null,[{key:"rules",get:function(){return{block:ue,inline:ae}}}]),z}(),te=function(){function z(J){this.options=J||oe.defaults}var V=z.prototype;return V.code=function(H,X,G){var Q=(X||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(H,Q);ce!=null&&ce!==H&&(G=!0,H=ce)}return H=H.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+p(Q,!0)+'">'+(G?H:p(H,!0))+`</code></pre>
`:"<pre><code>"+(G?H:p(H,!0))+`</code></pre>
`},V.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},V.html=function(H){return H},V.heading=function(H,X,G,Q){if(this.options.headerIds){var ce=this.options.headerPrefix+Q.slug(G);return"<h"+X+' id="'+ce+'">'+H+"</h"+X+`>
`}return"<h"+X+">"+H+"</h"+X+`>
`},V.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},V.list=function(H,X,G){var Q=X?"ol":"ul",ce=X&&G!==1?' start="'+G+'"':"";return"<"+Q+ce+`>
`+H+"</"+Q+`>
`},V.listitem=function(H){return"<li>"+H+`</li>
`},V.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},V.paragraph=function(H){return"<p>"+H+`</p>
`},V.table=function(H,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+X+`</table>
`},V.tablerow=function(H){return`<tr>
`+H+`</tr>
`},V.tablecell=function(H,X){var G=X.header?"th":"td",Q=X.align?"<"+G+' align="'+X.align+'">':"<"+G+">";return Q+H+("</"+G+`>
`)},V.strong=function(H){return"<strong>"+H+"</strong>"},V.em=function(H){return"<em>"+H+"</em>"},V.codespan=function(H){return"<code>"+H+"</code>"},V.br=function(){return this.options.xhtml?"<br/>":"<br>"},V.del=function(H){return"<del>"+H+"</del>"},V.link=function(H,X,G){if(H=L(this.options.sanitize,this.options.baseUrl,H),H===null)return G;var Q='<a href="'+p(H)+'"';return X&&(Q+=' title="'+X+'"'),Q+=">"+G+"</a>",Q},V.image=function(H,X,G){if(H=L(this.options.sanitize,this.options.baseUrl,H),H===null)return G;var Q='<img src="'+H+'" alt="'+G+'"';return X&&(Q+=' title="'+X+'"'),Q+=this.options.xhtml?"/>":">",Q},V.text=function(H){return H},z}(),x=function(){function z(){}var V=z.prototype;return V.strong=function(H){return H},V.em=function(H){return H},V.codespan=function(H){return H},V.del=function(H){return H},V.html=function(H){return H},V.text=function(H){return H},V.link=function(H,X,G){return""+G},V.image=function(H,X,G){return""+G},V.br=function(){return""},z}(),U=function(){function z(){this.seen={}}var V=z.prototype;return V.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},V.getNextSafeSlug=function(H,X){var G=H,Q=0;if(this.seen.hasOwnProperty(G)){Q=this.seen[H];do Q++,G=H+"-"+Q;while(this.seen.hasOwnProperty(G))}return X||(this.seen[H]=Q,this.seen[G]=0),G},V.slug=function(H,X){X===void 0&&(X={});var G=this.serialize(H);return this.getNextSafeSlug(G,X.dryrun)},z}(),Z=function(){function z(J){this.options=J||oe.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new U}z.parse=function(H,X){var G=new z(X);return G.parse(H)},z.parseInline=function(H,X){var G=new z(X);return G.parseInline(H)};var V=z.prototype;return V.parse=function(H,X){X===void 0&&(X=!0);var G="",Q,ce,Ee,De,ke,Ue,$e,ge,Se,ye,Me,Fe,_e,He,Je,Qe,et,Ke,he,Ce=H.length;for(Q=0;Q<Ce;Q++){if(ye=H[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(he=this.options.extensions.renderers[ye.type].call({parser:this},ye),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){G+=he||"";continue}switch(ye.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,a(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ge="",$e="",De=ye.header.length,ce=0;ce<De;ce++)$e+=this.renderer.tablecell(this.parseInline(ye.header[ce].tokens),{header:!0,align:ye.align[ce]});for(ge+=this.renderer.tablerow($e),Se="",De=ye.rows.length,ce=0;ce<De;ce++){for(Ue=ye.rows[ce],$e="",ke=Ue.length,Ee=0;Ee<ke;Ee++)$e+=this.renderer.tablecell(this.parseInline(Ue[Ee].tokens),{header:!1,align:ye.align[Ee]});Se+=this.renderer.tablerow($e)}G+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(ye.tokens),G+=this.renderer.blockquote(Se);continue}case"list":{for(Me=ye.ordered,Fe=ye.start,_e=ye.loose,De=ye.items.length,Se="",ce=0;ce<De;ce++)Je=ye.items[ce],Qe=Je.checked,et=Je.task,He="",Je.task&&(Ke=this.renderer.checkbox(Qe),_e?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=Ke+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=Ke+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:Ke}):He+=Ke),He+=this.parse(Je.tokens,_e),Se+=this.renderer.listitem(He,et,Qe);G+=this.renderer.list(Se,Me,Fe);continue}case"html":{G+=this.renderer.html(ye.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Se=ye.tokens?this.parseInline(ye.tokens):ye.text;Q+1<Ce&&H[Q+1].type==="text";)ye=H[++Q],Se+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);G+=X?this.renderer.paragraph(Se):Se;continue}default:{var Te='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return G},V.parseInline=function(H,X){X=X||this.renderer;var G="",Q,ce,Ee,De=H.length;for(Q=0;Q<De;Q++){if(ce=H[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(Ee=this.options.extensions.renderers[ce.type].call({parser:this},ce),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){G+=Ee||"";continue}switch(ce.type){case"escape":{G+=X.text(ce.text);break}case"html":{G+=X.html(ce.text);break}case"link":{G+=X.link(ce.href,ce.title,this.parseInline(ce.tokens,X));break}case"image":{G+=X.image(ce.href,ce.title,ce.text);break}case"strong":{G+=X.strong(this.parseInline(ce.tokens,X));break}case"em":{G+=X.em(this.parseInline(ce.tokens,X));break}case"codespan":{G+=X.codespan(ce.text);break}case"br":{G+=X.br();break}case"del":{G+=X.del(this.parseInline(ce.tokens,X));break}case"text":{G+=X.text(ce.text);break}default:{var ke='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return G},z}();function re(z,V,J){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof V=="function"&&(J=V,V=null),V=s({},re.defaults,V||{}),O(V),J){var H=V.highlight,X;try{X=ne.lex(z,V)}catch(De){return J(De)}var G=function(ke){var Ue;if(!ke)try{V.walkTokens&&re.walkTokens(X,V.walkTokens),Ue=Z.parse(X,V)}catch($e){ke=$e}return V.highlight=H,ke?J(ke):J(null,Ue)};if(!H||H.length<3||(delete V.highlight,!X.length))return G();var Q=0;re.walkTokens(X,function(De){De.type==="code"&&(Q++,setTimeout(function(){H(De.text,De.lang,function(ke,Ue){if(ke)return G(ke);Ue!=null&&Ue!==De.text&&(De.text=Ue,De.escaped=!0),Q--,Q===0&&G()})},0))}),Q===0&&G();return}function ce(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,V.silent)return"<p>An error occurred:</p><pre>"+p(De.message+"",!0)+"</pre>";throw De}try{var Ee=ne.lex(z,V);if(V.walkTokens){if(V.async)return Promise.all(re.walkTokens(Ee,V.walkTokens)).then(function(){return Z.parse(Ee,V)}).catch(ce);re.walkTokens(Ee,V.walkTokens)}return Z.parse(Ee,V)}catch(De){ce(De)}}re.options=re.setOptions=function(z){return s(re.defaults,z),A(re.defaults),re},re.getDefaults=C,re.defaults=oe.defaults,re.use=function(){for(var z=arguments.length,V=new Array(z),J=0;J<z;J++)V[J]=arguments[J];var H=s.apply(void 0,[{}].concat(V)),X=re.defaults.extensions||{renderers:{},childTokens:{}},G;V.forEach(function(Q){if(Q.extensions&&(G=!0,Q.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var De=X.renderers?X.renderers[Ee.name]:null;De?X.renderers[Ee.name]=function(){for(var ke=arguments.length,Ue=new Array(ke),$e=0;$e<ke;$e++)Ue[$e]=arguments[$e];var ge=Ee.renderer.apply(this,Ue);return ge===!1&&(ge=De.apply(this,Ue)),ge}:X.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[Ee.level]?X[Ee.level].unshift(Ee.tokenizer):X[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?X.startBlock?X.startBlock.push(Ee.start):X.startBlock=[Ee.start]:Ee.level==="inline"&&(X.startInline?X.startInline.push(Ee.start):X.startInline=[Ee.start]))}Ee.childTokens&&(X.childTokens[Ee.name]=Ee.childTokens)})),Q.renderer&&function(){var Ee=re.defaults.renderer||new te,De=function($e){var ge=Ee[$e];Ee[$e]=function(){for(var Se=arguments.length,ye=new Array(Se),Me=0;Me<Se;Me++)ye[Me]=arguments[Me];var Fe=Q.renderer[$e].apply(Ee,ye);return Fe===!1&&(Fe=ge.apply(Ee,ye)),Fe}};for(var ke in Q.renderer)De(ke);H.renderer=Ee}(),Q.tokenizer&&function(){var Ee=re.defaults.tokenizer||new de,De=function($e){var ge=Ee[$e];Ee[$e]=function(){for(var Se=arguments.length,ye=new Array(Se),Me=0;Me<Se;Me++)ye[Me]=arguments[Me];var Fe=Q.tokenizer[$e].apply(Ee,ye);return Fe===!1&&(Fe=ge.apply(Ee,ye)),Fe}};for(var ke in Q.tokenizer)De(ke);H.tokenizer=Ee}(),Q.walkTokens){var ce=re.defaults.walkTokens;H.walkTokens=function(Ee){var De=[];return De.push(Q.walkTokens.call(this,Ee)),ce&&(De=De.concat(ce.call(this,Ee))),De}}G&&(H.extensions=X),re.setOptions(H)})},re.walkTokens=function(z,V){for(var J=[],H=function(){var ce=G.value;switch(J=J.concat(V.call(re,ce)),ce.type){case"table":{for(var Ee=D(ce.header),De;!(De=Ee()).done;){var ke=De.value;J=J.concat(re.walkTokens(ke.tokens,V))}for(var Ue=D(ce.rows),$e;!($e=Ue()).done;)for(var ge=$e.value,Se=D(ge),ye;!(ye=Se()).done;){var Me=ye.value;J=J.concat(re.walkTokens(Me.tokens,V))}break}case"list":{J=J.concat(re.walkTokens(ce.items,V));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[ce.type]?re.defaults.extensions.childTokens[ce.type].forEach(function(Fe){J=J.concat(re.walkTokens(ce[Fe],V))}):ce.tokens&&(J=J.concat(re.walkTokens(ce.tokens,V)))}},X=D(z),G;!(G=X()).done;)H();return J},re.parseInline=function(z,V){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");V=s({},re.defaults,V||{}),O(V);try{var J=ne.lexInline(z,V);return V.walkTokens&&re.walkTokens(J,V.walkTokens),Z.parseInline(J,V)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,V.silent)return"<p>An error occurred:</p><pre>"+p(H.message+"",!0)+"</pre>";throw H}},re.Parser=Z,re.parser=Z.parse,re.Renderer=te,re.TextRenderer=x,re.Lexer=ne,re.lexer=ne.lex,re.Tokenizer=de,re.Slugger=U,re.parse=re;var me=re.options,$=re.setOptions,W=re.use,N=re.walkTokens,P=re.parseInline,M=re,Y=Z.parse,ie=ne.lex;oe.Lexer=ne,oe.Parser=Z,oe.Renderer=te,oe.Slugger=U,oe.TextRenderer=x,oe.Tokenizer=de,oe.getDefaults=C,oe.lexer=ie,oe.marked=re,oe.options=me,oe.parse=M,oe.parseInline=P,oe.parser=Y,oe.setOptions=$,oe.use=W,oe.walkTokens=N,Object.defineProperty(oe,"__esModule",{value:!0})}),define(pe[92],ve([1,0,27]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new w.LRUCache(1e4);function o(g){return v(g,"NFC",R)}e.normalizeNFC=o;const D=new w.LRUCache(1e4);function C(g){return v(g,"NFD",D)}e.normalizeNFD=C;const A=/[^\u0000-\u0080]/;function v(g,T,I){if(!g)return g;const y=I.get(g);if(y)return y;let m;return A.test(g)?m=g.normalize(T):m=g,I.set(g,m),m}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(T){return C(T).replace(g,"")}}()}),define(pe[142],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(A,v,g){return Math.min(Math.max(A,v),g)}e.clamp=w;function R(A,v){return(v+A%v)%v}e.rot=R;class o{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=o;class D{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class C{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const g=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function oe(o){const D=[];typeof o=="number"&&D.push("code/timeOrigin",o);function C(v){D.push(v,Date.now())}function A(){const v=[];for(let g=0;g<D.length;g+=2)v.push({name:D[g],startTime:D[g+1]});return v}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(o){performance.mark(o)},getMarks(){let o=performance.timeOrigin;typeof o!="number"&&(o=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(o)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(o+C.startTime)});return D}};if(typeof process=="object"){const o=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(o)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(o){return o.MonacoPerformanceMarks||(o.MonacoPerformanceMarks=e()),o.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var R in w)(typeof exports=="object"?exports:oe)[R]=w[R]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(R){if(e[R])return e[R].exports;var o=e[R]={i:R,l:!1,exports:{}};return oe[R].call(o.exports,o,o.exports,w),o.l=!0,o.exports}return w.m=oe,w.c=e,w.d=function(R,o,D){w.o(R,o)||Object.defineProperty(R,o,{enumerable:!0,get:D})},w.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},w.t=function(R,o){if(1&o&&(R=w(R)),8&o||4&o&&typeof R=="object"&&R&&R.__esModule)return R;var D=Object.create(null);if(w.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:R}),2&o&&typeof R!="string")for(var C in R)w.d(D,C,function(A){return R[A]}.bind(null,C));return D},w.n=function(R){var o=R&&R.__esModule?function(){return R.default}:function(){return R};return w.d(o,"a",o),o},w.o=function(R,o){return Object.prototype.hasOwnProperty.call(R,o)},w.p="",w(w.s=0)}([function(oe,e,w){(function(R){var o;e=oe.exports=W,o=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],v=e.src=[],g=0,T=g++;v[T]="0|[1-9]\\d*";var I=g++;v[I]="[0-9]+";var y=g++;v[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=g++;v[m]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var p=g++;v[p]="("+v[I]+")\\.("+v[I]+")\\.("+v[I]+")";var b=g++;v[b]="(?:"+v[T]+"|"+v[y]+")";var a=g++;v[a]="(?:"+v[I]+"|"+v[y]+")";var f=g++;v[f]="(?:-("+v[b]+"(?:\\."+v[b]+")*))";var h=g++;v[h]="(?:-?("+v[a]+"(?:\\."+v[a]+")*))";var d=g++;v[d]="[0-9A-Za-z-]+";var S=g++;v[S]="(?:\\+("+v[d]+"(?:\\."+v[d]+")*))";var L=g++,t="v?"+v[m]+v[f]+"?"+v[S]+"?";v[L]="^"+t+"$";var n="[v=\\s]*"+v[p]+v[h]+"?"+v[S]+"?",r=g++;v[r]="^"+n+"$";var i=g++;v[i]="((?:<|>)?=?)";var l=g++;v[l]=v[I]+"|x|X|\\*";var c=g++;v[c]=v[T]+"|x|X|\\*";var s=g++;v[s]="[v=\\s]*("+v[c]+")(?:\\.("+v[c]+")(?:\\.("+v[c]+")(?:"+v[f]+")?"+v[S]+"?)?)?";var u=g++;v[u]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[h]+")?"+v[S]+"?)?)?";var E=g++;v[E]="^"+v[i]+"\\s*"+v[s]+"$";var k=g++;v[k]="^"+v[i]+"\\s*"+v[u]+"$";var O=g++;v[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=g++;v[B]="(?:~>?)";var q=g++;v[q]="(\\s*)"+v[B]+"\\s+",A[q]=new RegExp(v[q],"g");var le=g++;v[le]="^"+v[B]+v[s]+"$";var de=g++;v[de]="^"+v[B]+v[u]+"$";var ue=g++;v[ue]="(?:\\^)";var ae=g++;v[ae]="(\\s*)"+v[ue]+"\\s+",A[ae]=new RegExp(v[ae],"g");var _=g++;v[_]="^"+v[ue]+v[s]+"$";var ee=g++;v[ee]="^"+v[ue]+v[u]+"$";var ne=g++;v[ne]="^"+v[i]+"\\s*("+n+")$|^$";var te=g++;v[te]="^"+v[i]+"\\s*("+t+")$|^$";var x=g++;v[x]="(\\s*)"+v[i]+"\\s*("+n+"|"+v[s]+")",A[x]=new RegExp(v[x],"g");var U=g++;v[U]="^\\s*("+v[s]+")\\s+-\\s+("+v[s]+")\\s*$";var Z=g++;v[Z]="^\\s*("+v[u]+")\\s+-\\s+("+v[u]+")\\s*$";var re=g++;v[re]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)o(me,v[me]),A[me]||(A[me]=new RegExp(v[me]));function $(ge,Se){if(ge instanceof W)return ge;if(typeof ge!="string"||ge.length>D||!(Se?A[r]:A[L]).test(ge))return null;try{return new W(ge,Se)}catch{return null}}function W(ge,Se){if(ge instanceof W){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof W))return new W(ge,Se);o("SemVer",ge,Se),this.loose=Se;var ye=ge.trim().match(Se?A[r]:A[L]);if(!ye)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Fe=+Me;if(Fe>=0&&Fe<C)return Fe}return Me}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=$,e.valid=function(ge,Se){var ye=$(ge,Se);return ye?ye.version:null},e.clean=function(ge,Se){var ye=$(ge.trim().replace(/^[=v]+/,""),Se);return ye?ye.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(ge){return o("SemVer.compare",this.version,this.loose,ge),ge instanceof W||(ge=new W(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},W.prototype.compareMain=function(ge){return ge instanceof W||(ge=new W(ge,this.loose)),P(this.major,ge.major)||P(this.minor,ge.minor)||P(this.patch,ge.patch)},W.prototype.comparePre=function(ge){if(ge instanceof W||(ge=new W(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var ye=this.prerelease[Se],Me=ge.prerelease[Se];if(o("prerelease compare",Se,ye,Me),ye===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ye===void 0)return-1;if(ye!==Me)return P(ye,Me)}while(++Se)},W.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,ye,Me){typeof ye=="string"&&(Me=ye,ye=void 0);try{return new W(ge,ye).inc(Se,Me).version}catch{return null}},e.diff=function(ge,Se){if(z(ge,Se))return null;var ye=$(ge),Me=$(Se);if(ye.prerelease.length||Me.prerelease.length){for(var Fe in ye)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&ye[Fe]!==Me[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in ye)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&ye[Fe]!==Me[Fe])return Fe},e.compareIdentifiers=P;var N=/^[0-9]+$/;function P(ge,Se){var ye=N.test(ge),Me=N.test(Se);return ye&&Me&&(ge=+ge,Se=+Se),ye&&!Me?-1:Me&&!ye?1:ge<Se?-1:ge>Se?1:0}function M(ge,Se,ye){return new W(ge,ye).compare(new W(Se,ye))}function Y(ge,Se,ye){return M(ge,Se,ye)>0}function ie(ge,Se,ye){return M(ge,Se,ye)<0}function z(ge,Se,ye){return M(ge,Se,ye)===0}function V(ge,Se,ye){return M(ge,Se,ye)!==0}function J(ge,Se,ye){return M(ge,Se,ye)>=0}function H(ge,Se,ye){return M(ge,Se,ye)<=0}function X(ge,Se,ye,Me){var Fe;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),Fe=ge===ye;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),Fe=ge!==ye;break;case"":case"=":case"==":Fe=z(ge,ye,Me);break;case"!=":Fe=V(ge,ye,Me);break;case">":Fe=Y(ge,ye,Me);break;case">=":Fe=J(ge,ye,Me);break;case"<":Fe=ie(ge,ye,Me);break;case"<=":Fe=H(ge,ye,Me);break;default:throw new TypeError("Invalid operator: "+Se)}return Fe}function G(ge,Se){if(ge instanceof G){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof G))return new G(ge,Se);o("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,o("comp",this)}e.rcompareIdentifiers=function(ge,Se){return P(Se,ge)},e.major=function(ge,Se){return new W(ge,Se).major},e.minor=function(ge,Se){return new W(ge,Se).minor},e.patch=function(ge,Se){return new W(ge,Se).patch},e.compare=M,e.compareLoose=function(ge,Se){return M(ge,Se,!0)},e.rcompare=function(ge,Se,ye){return M(Se,ge,ye)},e.sort=function(ge,Se){return ge.sort(function(ye,Me){return e.compare(ye,Me,Se)})},e.rsort=function(ge,Se){return ge.sort(function(ye,Me){return e.rcompare(ye,Me,Se)})},e.gt=Y,e.lt=ie,e.eq=z,e.neq=V,e.gte=J,e.lte=H,e.cmp=X,e.Comparator=G;var Q={};function ce(ge,Se){if(ge instanceof ce)return ge.loose===Se?ge:new ce(ge.raw,Se);if(ge instanceof G)return new ce(ge.value,Se);if(!(this instanceof ce))return new ce(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function Ee(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function De(ge,Se,ye,Me,Fe,_e,He,Je,Qe,et,Ke,he,Ce){return((Se=Ee(ye)?"":Ee(Me)?">="+ye+".0.0":Ee(Fe)?">="+ye+"."+Me+".0":">="+Se)+" "+(Je=Ee(Qe)?"":Ee(et)?"<"+(+Qe+1)+".0.0":Ee(Ke)?"<"+Qe+"."+(+et+1)+".0":he?"<="+Qe+"."+et+"."+Ke+"-"+he:"<="+Je)).trim()}function ke(ge,Se){for(var ye=0;ye<ge.length;ye++)if(!ge[ye].test(Se))return!1;if(Se.prerelease.length){for(ye=0;ye<ge.length;ye++)if(o(ge[ye].semver),ge[ye].semver!==Q&&ge[ye].semver.prerelease.length>0){var Me=ge[ye].semver;if(Me.major===Se.major&&Me.minor===Se.minor&&Me.patch===Se.patch)return!0}return!1}return!0}function Ue(ge,Se,ye){try{Se=new ce(Se,ye)}catch{return!1}return Se.test(ge)}function $e(ge,Se,ye,Me){var Fe,_e,He,Je,Qe;switch(ge=new W(ge,Me),Se=new ce(Se,Me),ye){case">":Fe=Y,_e=H,He=ie,Je=">",Qe=">=";break;case"<":Fe=ie,_e=J,He=Y,Je="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(ge,Se,Me))return!1;for(var et=0;et<Se.set.length;++et){var Ke=Se.set[et],he=null,Ce=null;if(Ke.forEach(function(Te){Te.semver===Q&&(Te=new G(">=0.0.0")),he=he||Te,Ce=Ce||Te,Fe(Te.semver,he.semver,Me)?he=Te:He(Te.semver,Ce.semver,Me)&&(Ce=Te)}),he.operator===Je||he.operator===Qe||(!Ce.operator||Ce.operator===Je)&&_e(ge,Ce.semver)||Ce.operator===Qe&&He(ge,Ce.semver))return!1}return!0}G.prototype.parse=function(ge){var Se=this.loose?A[ne]:A[te],ye=ge.match(Se);if(!ye)throw new TypeError("Invalid comparator: "+ge);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new W(ye[2],this.loose):this.semver=Q},G.prototype.toString=function(){return this.value},G.prototype.test=function(ge){return o("Comparator.test",ge,this.loose),this.semver===Q||(typeof ge=="string"&&(ge=new W(ge,this.loose)),X(ge,this.operator,this.semver,this.loose))},G.prototype.intersects=function(ge,Se){if(!(ge instanceof G))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ce(ge.value,Se),Ue(this.value,ye,Se);if(ge.operator==="")return ye=new ce(this.value,Se),Ue(ge.semver,ye,Se);var Me=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),_e=this.semver.version===ge.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Je=X(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Qe=X(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Me||Fe||_e&&He||Je||Qe},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),o("range",ge,Se);var ye=Se?A[Z]:A[U];ge=ge.replace(ye,De),o("hyphen replace",ge),ge=ge.replace(A[x],"$1$2$3"),o("comparator trim",ge,A[x]),ge=(ge=(ge=ge.replace(A[q],"$1~")).replace(A[ae],"$1^")).split(/\s+/).join(" ");var Me=Se?A[ne]:A[te],Fe=ge.split(" ").map(function(_e){return function(He,Je){return o("comp",He),He=function(Qe,et){return Qe.trim().split(/\s+/).map(function(Ke){return function(he,Ce){o("caret",he,Ce);var Te=Ce?A[ee]:A[_];return he.replace(Te,function(Ne,Re,ze,qe,Ve){var Ge;return o("caret",he,Ne,Re,ze,qe,Ve),Ee(Re)?Ge="":Ee(ze)?Ge=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee(qe)?Ge=Re==="0"?">="+Re+"."+ze+".0 <"+Re+"."+(+ze+1)+".0":">="+Re+"."+ze+".0 <"+(+Re+1)+".0.0":Ve?(o("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=Re==="0"?ze==="0"?">="+Re+"."+ze+"."+qe+Ve+" <"+Re+"."+ze+"."+(+qe+1):">="+Re+"."+ze+"."+qe+Ve+" <"+Re+"."+(+ze+1)+".0":">="+Re+"."+ze+"."+qe+Ve+" <"+(+Re+1)+".0.0"):(o("no pr"),Ge=Re==="0"?ze==="0"?">="+Re+"."+ze+"."+qe+" <"+Re+"."+ze+"."+(+qe+1):">="+Re+"."+ze+"."+qe+" <"+Re+"."+(+ze+1)+".0":">="+Re+"."+ze+"."+qe+" <"+(+Re+1)+".0.0"),o("caret return",Ge),Ge})}(Ke,et)}).join(" ")}(He,Je),o("caret",He),He=function(Qe,et){return Qe.trim().split(/\s+/).map(function(Ke){return function(he,Ce){var Te=Ce?A[de]:A[le];return he.replace(Te,function(Ne,Re,ze,qe,Ve){var Ge;return o("tilde",he,Ne,Re,ze,qe,Ve),Ee(Re)?Ge="":Ee(ze)?Ge=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee(qe)?Ge=">="+Re+"."+ze+".0 <"+Re+"."+(+ze+1)+".0":Ve?(o("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+Re+"."+ze+"."+qe+Ve+" <"+Re+"."+(+ze+1)+".0"):Ge=">="+Re+"."+ze+"."+qe+" <"+Re+"."+(+ze+1)+".0",o("tilde return",Ge),Ge})}(Ke,et)}).join(" ")}(He,Je),o("tildes",He),He=function(Qe,et){return o("replaceXRanges",Qe,et),Qe.split(/\s+/).map(function(Ke){return function(he,Ce){he=he.trim();var Te=Ce?A[k]:A[E];return he.replace(Te,function(Ne,Re,ze,qe,Ve,Ge){o("xRange",he,Ne,Re,ze,qe,Ve,Ge);var Xe=Ee(ze),Ye=Xe||Ee(qe),st=Ye||Ee(Ve);return Re==="="&&st&&(Re=""),Xe?Ne=Re===">"||Re==="<"?"<0.0.0":"*":Re&&st?(Ye&&(qe=0),st&&(Ve=0),Re===">"?(Re=">=",Ye?(ze=+ze+1,qe=0,Ve=0):st&&(qe=+qe+1,Ve=0)):Re==="<="&&(Re="<",Ye?ze=+ze+1:qe=+qe+1),Ne=Re+ze+"."+qe+"."+Ve):Ye?Ne=">="+ze+".0.0 <"+(+ze+1)+".0.0":st&&(Ne=">="+ze+"."+qe+".0 <"+ze+"."+(+qe+1)+".0"),o("xRange return",Ne),Ne})}(Ke,et)}).join(" ")}(He,Je),o("xrange",He),He=function(Qe,et){return o("replaceStars",Qe,et),Qe.trim().replace(A[re],"")}(He,Je),o("stars",He),He}(_e,Se)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(_e){return!!_e.match(Me)})),Fe=Fe.map(function(_e){return new G(_e,Se)})},ce.prototype.intersects=function(ge,Se){if(!(ge instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Me){return ge.set.some(function(Fe){return Fe.every(function(_e){return Me.intersects(_e,Se)})})})})},e.toComparators=function(ge,Se){return new ce(ge,Se).set.map(function(ye){return ye.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new W(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ke(this.set[Se],ge))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(ge,Se,ye){var Me=null,Fe=null;try{var _e=new ce(Se,ye)}catch{return null}return ge.forEach(function(He){_e.test(He)&&(Me&&Fe.compare(He)!==-1||(Fe=new W(Me=He,ye)))}),Me},e.minSatisfying=function(ge,Se,ye){var Me=null,Fe=null;try{var _e=new ce(Se,ye)}catch{return null}return ge.forEach(function(He){_e.test(He)&&(Me&&Fe.compare(He)!==1||(Fe=new W(Me=He,ye)))}),Me},e.validRange=function(ge,Se){try{return new ce(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,ye){return $e(ge,Se,"<",ye)},e.gtr=function(ge,Se,ye){return $e(ge,Se,">",ye)},e.outside=$e,e.prerelease=function(ge,Se){var ye=$(ge,Se);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ge,Se,ye){return ge=new ce(ge,ye),Se=new ce(Se,ye),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof W)return ge;if(typeof ge!="string")return null;var Se=ge.match(A[O]);return Se==null?null:$((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,R,o=oe.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(a){if(w===setTimeout)return setTimeout(a,0);if((w===D||!w)&&setTimeout)return w=setTimeout,setTimeout(a,0);try{return w(a,0)}catch{try{return w.call(null,a,0)}catch{return w.call(this,a,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:D}catch{w=D}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var v,g=[],T=!1,I=-1;function y(){T&&v&&(T=!1,v.length?g=v.concat(g):I=-1,g.length&&m())}function m(){if(!T){var a=A(y);T=!0;for(var f=g.length;f;){for(v=g,g=[];++I<f;)v&&v[I].run();I=-1,f=g.length}v=null,T=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(a)}}function p(a,f){this.fun=a,this.array=f}function b(){}o.nextTick=function(a){var f=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)f[h-1]=arguments[h];g.push(new p(a,f)),g.length!==1||T||A(m)},p.prototype.run=function(){this.fun.apply(null,this.array)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=b,o.addListener=b,o.once=b,o.off=b,o.removeListener=b,o.removeAllListeners=b,o.emit=b,o.prependListener=b,o.prependOnceListener=b,o.listeners=function(a){return[]},o.binding=function(a){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(a){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}}])}),define(pe[143],ve([1,0]),function(oe,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(A,v,g){this.level=A,this.key=v,this.value=g,this.forward=[]}}const o=void 0;class D{constructor(A,v=2**16){this.comparator=A,this[w]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new R(this.c,o,o)}get size(){return this.f}clear(){this.e=new R(this.c,o,o)}has(A){return Boolean(D.g(this,A,this.comparator))}get(A){return D.g(this,A,this.comparator)?.value}set(A,v){return D.h(this,A,v,this.comparator)&&(this.f+=1),this}delete(A){const v=D.k(this,A,this.comparator);return v&&(this.f-=1),v}forEach(A,v){let g=this.e.forward[0];for(;g;)A.call(v,g.value,g.key,this),g=g.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",v=this.e.forward[0];for(;v;)A+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return A}static g(A,v,g){let T=A.e;for(let I=A.d-1;I>=0;I--)for(;T.forward[I]&&g(T.forward[I].key,v)<0;)T=T.forward[I];if(T=T.forward[0],T&&g(T.key,v)===0)return T}static h(A,v,g,T){const I=[];let y=A.e;for(let m=A.d-1;m>=0;m--){for(;y.forward[m]&&T(y.forward[m].key,v)<0;)y=y.forward[m];I[m]=y}if(y=y.forward[0],y&&T(y.key,v)===0)return y.value=g,!1;{const m=D.j(A);if(m>A.d){for(let p=A.d;p<m;p++)I[p]=A.e;A.d=m}y=new R(m,v,g);for(let p=0;p<m;p++)y.forward[p]=I[p].forward[p],I[p].forward[p]=y;return!0}}static j(A,v=.5){let g=1;for(;Math.random()<v&&g<A.c;)g+=1;return g}static k(A,v,g){const T=[];let I=A.e;for(let y=A.d-1;y>=0;y--){for(;I.forward[y]&&g(I.forward[y].key,v)<0;)I=I.forward[y];T[y]=I}if(I=I.forward[0],!I||g(I.key,v)!==0)return!1;for(let y=0;y<A.d&&T[y].forward[y]===I;y++)T[y].forward[y]=I.forward[y];for(;A.d>0&&A.e.forward[A.d-1]===o;)A.d-=1;return!0}}e.SkipList=D}),define(pe[46],ve([1,0,11,2]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function o(S){const L=S;return L?typeof L.read=="function":!1}e.isReadable=o;function D(S){const L=S;return L?[L.on,L.pause,L.resume,L.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function C(S){const L=S;return L?D(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(S,L){return new v(S,L)}e.newWriteableStream=A;class v{constructor(L,t){this.e=L,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(t=>t(L))}h(L){this.c.error.length===0?(0,w.onUnexpectedError)(L):this.c.error.slice(0).forEach(t=>t(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,t){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(L,t){if(this.a.destroyed)return;let n;switch(L){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(S,L){const t=[];let n;for(;(n=S.read())!==null;)t.push(n);return L(t)}e.consumeReadable=g;function T(S,L,t){const n=[];let r;for(;(r=S.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?L(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return S.read()}}}e.peekReadable=T;function I(S,L){return new Promise((t,n)=>{const r=[];y(S,{onData:i=>{L&&r.push(i)},onError:i=>{L?n(i):t(void 0)},onEnd:()=>{t(L?L(r):void 0)}})})}e.consumeStream=I;function y(S,L){let t=!1;return S.on("error",n=>{t||L.onError(n)}),S.on("end",()=>{t||L.onEnd()}),S.on("data",n=>{t||L.onData(n)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=y;function m(S,L){return new Promise((t,n)=>{const r=new R.DisposableStore,i=[],l=u=>{if(i.push(u),i.length>L)return r.dispose(),S.pause(),t({stream:S,buffer:i,ended:!1})},c=u=>n(u),s=()=>t({stream:S,buffer:i,ended:!0});r.add((0,R.toDisposable)(()=>S.removeListener("error",c))),S.on("error",c),r.add((0,R.toDisposable)(()=>S.removeListener("end",s))),S.on("end",s),r.add((0,R.toDisposable)(()=>S.removeListener("data",l))),S.on("data",l)})}e.peekStream=m;function p(S,L){const t=A(L);return t.end(S),t}e.toStream=p;function b(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=b;function a(S){let L=!1;return{read:()=>L?null:(L=!0,S)}}e.toReadable=a;function f(S,L,t){const n=A(t);return y(S,{onData:r=>n.write(L.data(r)),onError:r=>n.error(L.error?L.error(r):r),onEnd:()=>n.end()}),n}e.transform=f;function h(S,L,t){let n=!1;return{read:()=>{const r=L.read();return n?r:(n=!0,r!==null?t([S,r]):S)}}}e.prefixedReadable=h;function d(S,L,t){let n=!1;const r=A(t);return y(L,{onData:i=>n?r.write(i):(n=!0,r.write(t([S,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(S)),r.end()}}),r}e.prefixedStream=d}),define(pe[15],ve([1,0,46]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let o,D;class C{static alloc(u){return R?new C(Buffer.allocUnsafe(u)):new C(new Uint8Array(u))}static wrap(u){return R&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new C(u)}static fromString(u,E){return!(E?.dontUseNodeBuffer||!1)&&R?new C(Buffer.from(u)):(o||(o=new TextEncoder),new C(o.encode(u)))}static fromByteArray(u){const E=C.alloc(u.length);for(let k=0,O=u.length;k<O;k++)E.buffer[k]=u[k];return E}static concat(u,E){if(typeof E>"u"){E=0;for(let B=0,q=u.length;B<q;B++)E+=u[B].byteLength}const k=C.alloc(E);let O=0;for(let B=0,q=u.length;B<q;B++){const le=u[B];k.set(le,O),O+=le.byteLength}return k}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=C.alloc(this.byteLength);return u.set(this),u}toString(){return R?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(u,E){return new C(this.buffer.subarray(u,E))}set(u,E){if(u instanceof C)this.buffer.set(u.buffer,E);else if(u instanceof Uint8Array)this.buffer.set(u,E);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),E);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return g(this.buffer,u)}writeUInt32BE(u,E){T(this.buffer,u,E)}readUInt32LE(u){return I(this.buffer,u)}writeUInt32LE(u,E){y(this.buffer,u,E)}readUInt8(u){return m(this.buffer,u)}writeUInt8(u,E){p(this.buffer,u,E)}}e.VSBuffer=C;function A(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0}e.readUInt16LE=A;function v(s,u,E){s[E+0]=u&255,u=u>>>8,s[E+1]=u&255}e.writeUInt16LE=v;function g(s,u){return s[u]*2**24+s[u+1]*2**16+s[u+2]*2**8+s[u+3]}e.readUInt32BE=g;function T(s,u,E){s[E+3]=u,u=u>>>8,s[E+2]=u,u=u>>>8,s[E+1]=u,u=u>>>8,s[E]=u}e.writeUInt32BE=T;function I(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0|s[u+2]<<16>>>0|s[u+3]<<24>>>0}e.readUInt32LE=I;function y(s,u,E){s[E+0]=u&255,u=u>>>8,s[E+1]=u&255,u=u>>>8,s[E+2]=u&255,u=u>>>8,s[E+3]=u&255}e.writeUInt32LE=y;function m(s,u){return s[u]}e.readUInt8=m;function p(s,u,E){s[E]=u}e.writeUInt8=p;function b(s){return w.consumeReadable(s,u=>C.concat(u))}e.readableToBuffer=b;function a(s){return w.toReadable(s)}e.bufferToReadable=a;function f(s){return w.consumeStream(s,u=>C.concat(u))}e.streamToBuffer=f;async function h(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=h;function d(s){return w.toStream(s,u=>C.concat(u))}e.bufferToStream=d;function S(s){return w.transform(s,{data:u=>typeof u=="string"?C.fromString(u):C.wrap(u)},u=>C.concat(u))}e.streamToBufferReadableStream=S;function L(s){return w.newWriteableStream(u=>C.concat(u),s)}e.newWriteableBufferStream=L;function t(s,u){return w.prefixedReadable(s,u,E=>C.concat(E))}e.prefixedBufferReadable=t;function n(s,u){return w.prefixedStream(s,u,E=>C.concat(E))}e.prefixedBufferStream=n;function r(s){let u=0,E=0,k=0;const O=new Uint8Array(Math.floor(s.length/4*3)),B=le=>{switch(E){case 3:O[k++]=u|le,E=0;break;case 2:O[k++]=u|le>>>2,u=le<<6,E=3;break;case 1:O[k++]=u|le>>>4,u=le<<4,E=2;break;default:u=le<<2,E=1}};for(let le=0;le<s.length;le++){const de=s.charCodeAt(le);if(de>=65&&de<=90)B(de-65);else if(de>=97&&de<=122)B(de-97+26);else if(de>=48&&de<=57)B(de-48+52);else if(de===43||de===45)B(62);else if(de===47||de===95)B(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${s[le]}`)}}const q=k;for(;E>0;)B(0);return C.wrap(O).slice(0,q)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:s},u=!0,E=!1){const k=E?l:i;let O="";const B=s.byteLength%3;let q=0;for(;q<s.byteLength-B;q+=3){const le=s[q+0],de=s[q+1],ue=s[q+2];O+=k[le>>>2],O+=k[(le<<4|de>>>4)&63],O+=k[(de<<2|ue>>>6)&63],O+=k[ue&63]}if(B===1){const le=s[q+0];O+=k[le>>>2],O+=k[le<<4&63],u&&(O+="==")}else if(B===2){const le=s[q+0],de=s[q+1];O+=k[le>>>2],O+=k[(le<<4|de>>>4)&63],O+=k[de<<2&63],u&&(O+="=")}return O}e.encodeBase64=c}),define(pe[144],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[8],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(n){return typeof n=="string"}e.isString=w;function R(n){return Array.isArray(n)&&n.every(r=>w(r))}e.isStringArray=R;function o(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=o;function D(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=D;function C(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=C;function A(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=A;function v(n){return n===!0||n===!1}e.isBoolean=v;function g(n){return typeof n>"u"}e.isUndefined=g;function T(n){return!I(n)}e.isDefined=T;function I(n){return g(n)||n===null}e.isUndefinedOrNull=I;function y(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=y;function m(n){if(I(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=m;function p(...n){const r=[];for(let i=0;i<n.length;i++){const l=n[i];if(I(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(l)}return r}e.assertAllDefined=p;const b=Object.prototype.hasOwnProperty;function a(n){if(!o(n))return!1;for(const r in n)if(b.call(n,r))return!1;return!0}e.isEmptyObject=a;function f(n){return typeof n=="function"}e.isFunction=f;function h(...n){return n.length>0&&n.every(f)}e.areFunctions=h;function d(n,r){const i=Math.min(n.length,r.length);for(let l=0;l<i;l++)S(n[l],r[l])}e.validateConstraints=d;function S(n,r){if(w(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(f(r)){try{if(n instanceof r)return}catch{}if(!I(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function L(n){return n===null?void 0:n}e.withNullAsUndefined=L;function t(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=t}),define(pe[47],ve([1,0,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function o(A,v){if((0,w.isString)(v)){const g=R[v];if(g===void 0)throw new Error(`${A} references an unknown codicon: ${v}`);v=g}return R[A]=v,{id:A}}function D(){return R}e.getCodiconFontCharacters=D;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),bracket:o("bracket",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),send:o("send",60431),sparkle:o("sparkle",60432),insert:o("insert",60433),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(pe[21],ve([1,0,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const h=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([d,S])=>{h[d]=S&&typeof S=="object"?R(S):S}),h}e.deepClone=R;function o(f){if(!f||typeof f!="object")return f;const h=[f];for(;h.length>0;){const d=h.shift();Object.freeze(d);for(const S in d)if(D.call(d,S)){const L=d[S];typeof L=="object"&&!Object.isFrozen(L)&&!(0,w.isTypedArray)(L)&&h.push(L)}}return f}e.deepFreeze=o;const D=Object.prototype.hasOwnProperty;function C(f,h){return A(f,h,new Set)}e.cloneAndChange=C;function A(f,h,d){if((0,w.isUndefinedOrNull)(f))return f;const S=h(f);if(typeof S<"u")return S;if(Array.isArray(f)){const L=[];for(const t of f)L.push(A(t,h,d));return L}if((0,w.isObject)(f)){if(d.has(f))throw new Error("Cannot clone recursive data-structure");d.add(f);const L={};for(const t in f)D.call(f,t)&&(L[t]=A(f[t],h,d));return d.delete(f),L}return f}function v(f,h,d=!0){return(0,w.isObject)(f)?((0,w.isObject)(h)&&Object.keys(h).forEach(S=>{S in f?d&&((0,w.isObject)(f[S])&&(0,w.isObject)(h[S])?v(f[S],h[S],d):f[S]=h[S]):f[S]=h[S]}),f):h}e.mixin=v;function g(f,h){if(f===h)return!0;if(f==null||h===null||h===void 0||typeof f!=typeof h||typeof f!="object"||Array.isArray(f)!==Array.isArray(h))return!1;let d,S;if(Array.isArray(f)){if(f.length!==h.length)return!1;for(d=0;d<f.length;d++)if(!g(f[d],h[d]))return!1}else{const L=[];for(S in f)L.push(S);L.sort();const t=[];for(S in h)t.push(S);if(t.sort(),!g(L,t))return!1;for(d=0;d<L.length;d++)if(!g(f[L[d]],h[L[d]]))return!1}return!0}e.equals=g;function T(f){const h=new Set;return JSON.stringify(f,(d,S)=>{if((0,w.isObject)(S)||Array.isArray(S)){if(h.has(S))return"[Circular]";h.add(S)}return S})}e.safeStringify=T;function I(f,h){const d=Object.create(null);return!f||!h||Object.keys(h).forEach(L=>{const t=f[L],n=h[L];g(t,n)||(d[L]=n)}),d}e.distinct=I;function y(f,h){const d=h.toLowerCase(),S=Object.keys(f).find(L=>L.toLowerCase()===d);return S?f[S]:f[h]}e.getCaseInsensitive=y;function m(f,h){const d=Object.create(null);for(const[S,L]of Object.entries(f))h(S,L)&&(d[S]=L);return d}e.filter=m;function p(f){let h=[],d=Object.getPrototypeOf(f);for(;Object.prototype!==d;)h=h.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return h}e.getAllPropertyNames=p;function b(f){const h=[];for(const d of p(f))typeof f[d]=="function"&&h.push(d);return h}e.getAllMethodNames=b;function a(f,h){const d=L=>function(){const t=Array.prototype.slice.call(arguments,0);return h(L,t)},S={};for(const L of f)S[L]=d(L);return S}e.createProxyObject=a}),define(pe[93],ve([1,0,47]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(C){function A(v){return v&&typeof v=="object"&&typeof v.id=="string"}C.isThemeColor=A})(R=e.ThemeColor||(e.ThemeColor={}));function o(C){return{id:C}}e.themeColorFromId=o;var D;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function v(h){const d=A.exec(h.id);if(!d)return v(w.Codicon.error);const[,S,L]=d,t=["codicon","codicon-"+S];return L&&t.push("codicon-modifier-"+L.substring(1)),t}C.asClassNameArray=v;function g(h){return v(h).join(" ")}C.asClassName=g;function T(h){return"."+v(h).join(".")}C.asCSSSelector=T;function I(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}C.isThemeIcon=I;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function m(h){const d=y.exec(h);if(!d)return;const[,S]=d;return{id:S}}C.fromString=m;function p(h){return{id:h}}C.fromId=p;function b(h,d){let S=h.id;const L=S.lastIndexOf("~");return L!==-1&&(S=S.substring(0,L)),d&&(S=`${S}~${d}`),{id:S}}C.modify=b;function a(h){const d=h.id.lastIndexOf("~");if(d!==-1)return h.id.substring(d+1)}C.getModifier=a;function f(h,d){return h.id===d.id&&h.color?.id===d.color?.id}C.isEqual=f})(D=e.ThemeIcon||(e.ThemeIcon={}))}),define(pe[22],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(o){return w.test(o)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let o;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?o=crypto.getRandomValues.bind(crypto):o=function(A){for(let v=0;v<A.length;v++)A[v]=Math.floor(Math.random()*256);return A};const D=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){o(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let v=0,g="";return g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g}}()}),define(pe[145],ve([1,0,18,22]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function o(A){return{id:(0,R.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=o;function D(A,v,g){return{id:(0,R.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:v,data:g}),value:void 0}}e.createFileDataTransferItem=D;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(v){return this.a.has(this.b(v))}get(v){return this.a.get(this.b(v))?.[0]}append(v,g){const T=this.a.get(v);T?T.push(g):this.a.set(this.b(v),[g])}replace(v,g){this.a.set(this.b(v),[g])}delete(v){this.a.delete(this.b(v))}*entries(){for(const[v,g]of this.a.entries())for(const T of g)yield[v,T]}values(){return Array.from(this.a.values()).flat()}forEach(v){for(const[g,T]of this.entries())v(T,g)}b(v){return v.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:A=>(0,w.distinct)(A.map(v=>v.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function oe(e,w,R){function o(m){return new Promise(p=>w.exists(m,p))}function D(m){return new Promise((p,b)=>{const a=new Date;w.utimes(m,a,a,f=>f?b(f):p())})}function C(m){return new Promise((p,b)=>w.mkdir(m,{recursive:!0},a=>a&&a.code!=="EEXIST"?b(a):p(m)))}function A(m){return new Promise((p,b)=>w.rm(m,{recursive:!0,force:!0,maxRetries:3},a=>a?b(a):p()))}function v(m){return new Promise((p,b)=>w.readFile(m,"utf8",(a,f)=>a?b(a):p(f)))}function g(m,p){return new Promise((b,a)=>w.writeFile(m,p,"utf8",f=>f?a(f):b()))}async function T(m){const p=e.join(m,"languagepacks.json");try{return JSON.parse(await v(p))}catch{}}function I(m,p){try{for(;p;){if(m[p])return p;{const b=p.lastIndexOf("-");if(b>0)p=p.substring(0,b);else return}}}catch(b){console.error("Resolving language pack configuration failed.",b)}}function y(m,p,b,a,f){const h=function(S){return R.mark("code/didGenerateNls"),Promise.resolve({locale:S,osLocale:f,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),a==="pseudo")return Promise.resolve({locale:a,osLocale:f,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:a,osLocale:f,availableLanguages:{}});if(a&&(a==="en"||a==="en-us"))return Promise.resolve({locale:a,osLocale:f,availableLanguages:{}});const d=a;try{return m?T(p).then(S=>{if(!S)return h(d);const L=I(S,a);if(!L)return h(d);a=L;const t=S[a];let n;return!t||typeof t.hash!="string"||!t.translations||typeof(n=t.translations.vscode)!="string"?h(d):o(n).then(r=>{if(!r)return h(d);const i=t.hash+"."+a,l=e.join(p,"clp",i),c=e.join(l,m),s=e.join(l,"tcf.json"),u=e.join(l,"corrupted.info"),E={locale:d,osLocale:f,availableLanguages:{"*":a},_languagePackId:i,_translationsConfigFile:s,_cacheRoot:l,_resolvedLanguagePackCoreLocation:c,_corruptedFile:u};return o(u).then(k=>{let O;return k?O=A(l):O=Promise.resolve(void 0),O.then(()=>o(c).then(B=>B?(D(c).catch(()=>{}),R.mark("code/didGenerateNls"),E):C(c).then(()=>Promise.all([v(b),v(n)])).then(q=>{const le=JSON.parse(q[0]),de=JSON.parse(q[1]).contents,ue=Object.keys(le.bundles),ae=[];for(const _ of ue){const ee=le.bundles[_],ne=Object.create(null);for(const te of ee){const x=le.keys[te],U=le.messages[te],Z=de[te];let re;if(Z){re=[];for(let me=0;me<x.length;me++){const $=x[me],W=typeof $=="string"?$:$.key;let N=Z[W];N===void 0&&(N=U[me]),re.push(N)}}else re=U;ne[te]=re}ae.push(g(e.join(c,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(ne)))}return ae.push(g(s,JSON.stringify(t.translations))),Promise.all(ae)}).then(()=>(R.mark("code/didGenerateNls"),E)).catch(q=>(console.error("Generating translation files failed.",q),h(a)))))})})}):h(d)}catch(S){return console.error("Generating translation files failed.",S),h(a)}}return{getNLSConfiguration:y}}if(typeof define=="function")define(pe[146],ve([73,32,41]),function(e,w,R){return oe(e,w,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("fs"),R=require("../common/performance");module.exports=oe(e,w,R)}else throw new Error("Unknown context")}(),define(pe[147],ve([1,0,33]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(C){const A=C.replace(/\-/g,":").toLowerCase();return!R.has(A)}function D(){const C=(0,w.networkInterfaces)();for(const A in C){const v=C[A];if(v){for(const{mac:g}of v)if(o(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(pe[148],ve([1,0,94]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function R(A,v,g,T=1){let I=!1;return new Promise(y=>{const m=setTimeout(()=>{if(!I)return I=!0,y(0)},g);o(A,v,T,p=>{if(!I)return I=!0,clearTimeout(m),y(p)})})}e.findFreePort=R;function o(A,v,g,T){if(v===0)return T(0);const I=new w.Socket;I.once("connect",()=>(C(I),o(A+g,v-1,g,T))),I.once("data",()=>{}),I.once("error",y=>(C(I),y.code!=="ECONNREFUSED"?o(A+g,v-1,g,T):T(A))),I.connect(A,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(A,v,g,T="127.0.0.1"){let I=!1,y,m=1;const p=w.createServer({pauseOnConnect:!0});function b(a,f){I||(I=!0,p.removeAllListeners(),p.close(),y&&clearTimeout(y),f(a))}return new Promise(a=>{y=setTimeout(()=>{b(0,a)},g),p.on("listening",()=>{b(A,a)}),p.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&m<v?(A++,m++,p.listen(A,T)):b(0,a)}),p.on("close",()=>{b(0,a)}),p.listen(A,T)})}e.findFreePortFaster=D;function C(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(v){console.error(v)}}}),define(pe[95],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(o,D){this.lineNumber=o,this.column=D}with(o=this.lineNumber,D=this.column){return o===this.lineNumber&&D===this.column?this:new w(o,D)}delta(o=0,D=0){return this.with(this.lineNumber+o,this.column+D)}equals(o){return w.equals(this,o)}static equals(o,D){return!o&&!D?!0:!!o&&!!D&&o.lineNumber===D.lineNumber&&o.column===D.column}isBefore(o){return w.isBefore(this,o)}static isBefore(o,D){return o.lineNumber<D.lineNumber?!0:D.lineNumber<o.lineNumber?!1:o.column<D.column}isBeforeOrEqual(o){return w.isBeforeOrEqual(this,o)}static isBeforeOrEqual(o,D){return o.lineNumber<D.lineNumber?!0:D.lineNumber<o.lineNumber?!1:o.column<=D.column}static compare(o,D){const C=o.lineNumber|0,A=D.lineNumber|0;if(C===A){const v=o.column|0,g=D.column|0;return v-g}return C-A}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(o){return new w(o.lineNumber,o.column)}static isIPosition(o){return o&&typeof o.lineNumber=="number"&&typeof o.column=="number"}}e.Position=w}),define(pe[48],ve([1,0,95]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(D,C,A,v){D>A||D===A&&C>v?(this.startLineNumber=A,this.startColumn=v,this.endLineNumber=D,this.endColumn=C):(this.startLineNumber=D,this.startColumn=C,this.endLineNumber=A,this.endColumn=v)}isEmpty(){return R.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return R.containsPosition(this,D)}static containsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<D.startColumn||C.lineNumber===D.endLineNumber&&C.column>D.endColumn)}static strictContainsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<=D.startColumn||C.lineNumber===D.endLineNumber&&C.column>=D.endColumn)}containsRange(D){return R.containsRange(this,D)}static containsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>D.endColumn)}strictContainsRange(D){return R.strictContainsRange(this,D)}static strictContainsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<=D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>=D.endColumn)}plusRange(D){return R.plusRange(this,D)}static plusRange(D,C){let A,v,g,T;return C.startLineNumber<D.startLineNumber?(A=C.startLineNumber,v=C.startColumn):C.startLineNumber===D.startLineNumber?(A=C.startLineNumber,v=Math.min(C.startColumn,D.startColumn)):(A=D.startLineNumber,v=D.startColumn),C.endLineNumber>D.endLineNumber?(g=C.endLineNumber,T=C.endColumn):C.endLineNumber===D.endLineNumber?(g=C.endLineNumber,T=Math.max(C.endColumn,D.endColumn)):(g=D.endLineNumber,T=D.endColumn),new R(A,v,g,T)}intersectRanges(D){return R.intersectRanges(this,D)}static intersectRanges(D,C){let A=D.startLineNumber,v=D.startColumn,g=D.endLineNumber,T=D.endColumn;const I=C.startLineNumber,y=C.startColumn,m=C.endLineNumber,p=C.endColumn;return A<I?(A=I,v=y):A===I&&(v=Math.max(v,y)),g>m?(g=m,T=p):g===m&&(T=Math.min(T,p)),A>g||A===g&&v>T?null:new R(A,v,g,T)}equalsRange(D){return R.equalsRange(this,D)}static equalsRange(D,C){return!D&&!C?!0:!!D&&!!C&&D.startLineNumber===C.startLineNumber&&D.startColumn===C.startColumn&&D.endLineNumber===C.endLineNumber&&D.endColumn===C.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(D){return new w.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(D){return new w.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,C){return new R(this.startLineNumber,this.startColumn,D,C)}setStartPosition(D,C){return new R(D,C,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(D){return new R(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(D){return new R(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new R(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,C=D){return new R(D.lineNumber,D.column,C.lineNumber,C.column)}static lift(D){return D?new R(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<D.startColumn)}static areIntersecting(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<=C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,C){if(D&&C){const g=D.startLineNumber|0,T=C.startLineNumber|0;if(g===T){const I=D.startColumn|0,y=C.startColumn|0;if(I===y){const m=D.endLineNumber|0,p=C.endLineNumber|0;if(m===p){const b=D.endColumn|0,a=C.endColumn|0;return b-a}return m-p}return I-y}return g-T}return(D?1:0)-(C?1:0)}static compareRangesUsingEnds(D,C){return D.endLineNumber===C.endLineNumber?D.endColumn===C.endColumn?D.startLineNumber===C.startLineNumber?D.startColumn-C.startColumn:D.startLineNumber-C.startLineNumber:D.endColumn-C.endColumn:D.endLineNumber-C.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.Range=R}),define(pe[149],ve([9,10]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(pe[150],ve([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(pe[151],ve([1,0,150]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,o=R*60,D=o*24,C=D*7,A=D*30,v=D*365;function g(I,y,m,p){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,w.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(!p&&b<30)return(0,w.localize)(1,null);let a;return b<R?(a=b,y?a===1?m?(0,w.localize)(2,null,a):(0,w.localize)(3,null,a):m?(0,w.localize)(4,null,a):(0,w.localize)(5,null,a):a===1?m?(0,w.localize)(6,null,a):(0,w.localize)(7,null,a):m?(0,w.localize)(8,null,a):(0,w.localize)(9,null,a)):b<o?(a=Math.floor(b/R),y?a===1?m?(0,w.localize)(10,null,a):(0,w.localize)(11,null,a):m?(0,w.localize)(12,null,a):(0,w.localize)(13,null,a):a===1?m?(0,w.localize)(14,null,a):(0,w.localize)(15,null,a):m?(0,w.localize)(16,null,a):(0,w.localize)(17,null,a)):b<D?(a=Math.floor(b/o),y?a===1?m?(0,w.localize)(18,null,a):(0,w.localize)(19,null,a):m?(0,w.localize)(20,null,a):(0,w.localize)(21,null,a):a===1?m?(0,w.localize)(22,null,a):(0,w.localize)(23,null,a):m?(0,w.localize)(24,null,a):(0,w.localize)(25,null,a)):b<C?(a=Math.floor(b/D),y?a===1?(0,w.localize)(26,null,a):(0,w.localize)(27,null,a):a===1?(0,w.localize)(28,null,a):(0,w.localize)(29,null,a)):b<A?(a=Math.floor(b/C),y?a===1?m?(0,w.localize)(30,null,a):(0,w.localize)(31,null,a):m?(0,w.localize)(32,null,a):(0,w.localize)(33,null,a):a===1?m?(0,w.localize)(34,null,a):(0,w.localize)(35,null,a):m?(0,w.localize)(36,null,a):(0,w.localize)(37,null,a)):b<v?(a=Math.floor(b/A),y?a===1?m?(0,w.localize)(38,null,a):(0,w.localize)(39,null,a):m?(0,w.localize)(40,null,a):(0,w.localize)(41,null,a):a===1?m?(0,w.localize)(42,null,a):(0,w.localize)(43,null,a):m?(0,w.localize)(44,null,a):(0,w.localize)(45,null,a)):(a=Math.floor(b/v),y?a===1?m?(0,w.localize)(46,null,a):(0,w.localize)(47,null,a):m?(0,w.localize)(48,null,a):(0,w.localize)(49,null,a):a===1?m?(0,w.localize)(50,null,a):(0,w.localize)(51,null,a):m?(0,w.localize)(52,null,a):(0,w.localize)(53,null,a))}e.fromNow=g;function T(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(pe[152],ve([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(pe[38],ve([1,0,18,8,152]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(I,y){return y&&(I.stack||I.stacktrace)?o.localize(0,null,A(I),C(I.stack)||C(I.stacktrace)):A(I)}function C(I){return Array.isArray(I)?I.join(`
`):I}function A(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?o.localize(1,null,I.message):I.message||o.localize(2,null)}function v(I=null,y=!1){if(!I)return o.localize(3,null);if(Array.isArray(I)){const m=w.coalesce(I),p=v(m[0],y);return m.length>1?o.localize(4,null,p,m.length):p}if(R.isString(I))return I;if(I.detail){const m=I.detail;if(m.error)return D(m.error,y);if(m.exception)return D(m.exception,y)}return I.stack?D(I,y):I.message?I.message:o.localize(5,null)}e.toErrorMessage=v;function g(I){const y=I;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=g;function T(I,y){let m;return typeof I=="string"?m=new Error(I):m=I,m.actions=y,m}e.createErrorWithActions=T}),define(pe[153],ve([9,10]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(pe[154],ve([1,0,153]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(o){switch(o){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(pe[155],ve([9,10]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(pe[3],ve([1,0,155]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,o=!1,D=!1,C=!1,A=!1,v=!1,g=!1,T=!1,I=!1,y=!1,m,p=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,a,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const d=typeof h?.versions?.electron=="string",S=d&&h?.type==="renderer";if(typeof navigator=="object"&&!S)f=navigator.userAgent,R=f.indexOf("Windows")>=0,o=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=f.indexOf("Linux")>=0,y=f?.indexOf("Mobi")>=0,v=!0,m=w.getConfiguredDefaultLocale(w.localize(0,null))||e.LANGUAGE_DEFAULT,p=m,b=navigator.language;else if(typeof h=="object"){R=h.platform==="win32",o=h.platform==="darwin",D=h.platform==="linux",C=D&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,g=d,I=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const u=h.env.VSCODE_NLS_CONFIG;if(u)try{const E=JSON.parse(u),k=E.availableLanguages["*"];m=E.locale,b=E.osLocale,p=k||e.LANGUAGE_DEFAULT,a=E._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var L;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(L=e.Platform||(e.Platform={}));function t(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let n=0;o?n=1:R?n=3:D&&(n=2),e.isWindows=R,e.isMacintosh=o,e.isLinux=D,e.isLinuxSnap=C,e.isNative=A,e.isElectron=g,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=y,e.isCI=I,e.platform=n,e.userAgent=f,e.language=p;var r;(function(u){function E(){return e.language}u.value=E;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=k;function O(){return e.language==="en"}u.isDefault=O})(r=e.Language||(e.Language={})),e.locale=m,e.platformLocale=b,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let O=0,B=u.length;O<B;O++){const q=u[O];if(q.id===k.data.vscodeScheduleAsyncWork){u.splice(O,1),q.callback();return}}});let E=0;return k=>{const O=++E;u.push({id:O,callback:k}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return u=>setTimeout(u)})();var i;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=o||T?2:R?1:3;let l=!0,c=!1;function s(){if(!c){c=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,l=new Uint16Array(u.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[28],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const o=w.globals.vscode.process;R={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(pe[7],ve([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,o=97,D=90,C=122,A=46,v=47,g=92,T=58,I=63;class y extends Error{constructor(n,r,i){let l;typeof r=="string"&&r.indexOf("not ")===0?(l="must not be",r=r.replace(/^not /,"")):l="must be";const c=n.indexOf(".")!==-1?"property":"argument";let s=`The "${n}" ${c} ${l} of type ${r}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,n){if(t===null||typeof t!="object")throw new y(n,"Object",t)}function p(t,n){if(typeof t!="string")throw new y(n,"string",t)}const b=w.platform==="win32";function a(t){return t===v||t===g}function f(t){return t===v}function h(t){return t>=R&&t<=D||t>=o&&t<=C}function d(t,n,r,i){let l="",c=0,s=-1,u=0,E=0;for(let k=0;k<=t.length;++k){if(k<t.length)E=t.charCodeAt(k);else{if(i(E))break;E=v}if(i(E)){if(!(s===k-1||u===1))if(u===2){if(l.length<2||c!==2||l.charCodeAt(l.length-1)!==A||l.charCodeAt(l.length-2)!==A){if(l.length>2){const O=l.lastIndexOf(r);O===-1?(l="",c=0):(l=l.slice(0,O),c=l.length-1-l.lastIndexOf(r)),s=k,u=0;continue}else if(l.length!==0){l="",c=0,s=k,u=0;continue}}n&&(l+=l.length>0?`${r}..`:"..",c=2)}else l.length>0?l+=`${r}${t.slice(s+1,k)}`:l=t.slice(s+1,k),c=k-s-1;s=k,u=0}else E===A&&u!==-1?++u:u=-1}return l}function S(t,n){m(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let n="",r="",i=!1;for(let l=t.length-1;l>=-1;l--){let c;if(l>=0){if(c=t[l],p(c,"path"),c.length===0)continue}else n.length===0?c=w.cwd():(c=w.env[`=${n}`]||w.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==n.toLowerCase()&&c.charCodeAt(2)===g)&&(c=`${n}\\`));const s=c.length;let u=0,E="",k=!1;const O=c.charCodeAt(0);if(s===1)a(O)&&(u=1,k=!0);else if(a(O))if(k=!0,a(c.charCodeAt(1))){let B=2,q=B;for(;B<s&&!a(c.charCodeAt(B));)B++;if(B<s&&B!==q){const le=c.slice(q,B);for(q=B;B<s&&a(c.charCodeAt(B));)B++;if(B<s&&B!==q){for(q=B;B<s&&!a(c.charCodeAt(B));)B++;(B===s||B!==q)&&(E=`\\\\${le}\\${c.slice(q,B)}`,u=B)}}}else u=1;else h(O)&&c.charCodeAt(1)===T&&(E=c.slice(0,2),u=2,s>2&&a(c.charCodeAt(2))&&(k=!0,u=3));if(E.length>0)if(n.length>0){if(E.toLowerCase()!==n.toLowerCase())continue}else n=E;if(i){if(n.length>0)break}else if(r=`${c.slice(u)}\\${r}`,i=k,k&&n.length>0)break}return r=d(r,!i,"\\",a),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){p(t,"path");const n=t.length;if(n===0)return".";let r=0,i,l=!1;const c=t.charCodeAt(0);if(n===1)return f(c)?"\\":t;if(a(c))if(l=!0,a(t.charCodeAt(1))){let u=2,E=u;for(;u<n&&!a(t.charCodeAt(u));)u++;if(u<n&&u!==E){const k=t.slice(E,u);for(E=u;u<n&&a(t.charCodeAt(u));)u++;if(u<n&&u!==E){for(E=u;u<n&&!a(t.charCodeAt(u));)u++;if(u===n)return`\\\\${k}\\${t.slice(E)}\\`;u!==E&&(i=`\\\\${k}\\${t.slice(E,u)}`,r=u)}}}else r=1;else h(c)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),r=2,n>2&&a(t.charCodeAt(2))&&(l=!0,r=3));let s=r<n?d(t.slice(r),!l,"\\",a):"";return s.length===0&&!l&&(s="."),s.length>0&&a(t.charCodeAt(n-1))&&(s+="\\"),i===void 0?l?`\\${s}`:s:l?`${i}\\${s}`:`${i}${s}`},isAbsolute(t){p(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return a(r)||n>2&&h(r)&&t.charCodeAt(1)===T&&a(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let c=0;c<t.length;++c){const s=t[c];p(s,"path"),s.length>0&&(n===void 0?n=r=s:n+=`\\${s}`)}if(n===void 0)return".";let i=!0,l=0;if(typeof r=="string"&&a(r.charCodeAt(0))){++l;const c=r.length;c>1&&a(r.charCodeAt(1))&&(++l,c>2&&(a(r.charCodeAt(2))?++l:i=!1))}if(i){for(;l<n.length&&a(n.charCodeAt(l));)l++;l>=2&&(n=`\\${n.slice(l)}`)}return e.win32.normalize(n)},relative(t,n){if(p(t,"from"),p(n,"to"),t===n)return"";const r=e.win32.resolve(t),i=e.win32.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let c=t.length;for(;c-1>l&&t.charCodeAt(c-1)===g;)c--;const s=c-l;let u=0;for(;u<n.length&&n.charCodeAt(u)===g;)u++;let E=n.length;for(;E-1>u&&n.charCodeAt(E-1)===g;)E--;const k=E-u,O=s<k?s:k;let B=-1,q=0;for(;q<O;q++){const de=t.charCodeAt(l+q);if(de!==n.charCodeAt(u+q))break;de===g&&(B=q)}if(q!==O){if(B===-1)return i}else{if(k>O){if(n.charCodeAt(u+q)===g)return i.slice(u+q+1);if(q===2)return i.slice(u+q)}s>O&&(t.charCodeAt(l+q)===g?B=q:q===2&&(B=3)),B===-1&&(B=0)}let le="";for(q=l+B+1;q<=c;++q)(q===c||t.charCodeAt(q)===g)&&(le+=le.length===0?"..":"\\..");return u+=B,le.length>0?`${le}${i.slice(u,E)}`:(i.charCodeAt(u)===g&&++u,i.slice(u,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===g){if(n.charCodeAt(1)===g){const r=n.charCodeAt(2);if(r!==I&&r!==A)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(h(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===g)return`\\\\?\\${n}`;return t},dirname(t){p(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const l=t.charCodeAt(0);if(n===1)return a(l)?t:".";if(a(l)){if(r=i=1,a(t.charCodeAt(1))){let u=2,E=u;for(;u<n&&!a(t.charCodeAt(u));)u++;if(u<n&&u!==E){for(E=u;u<n&&a(t.charCodeAt(u));)u++;if(u<n&&u!==E){for(E=u;u<n&&!a(t.charCodeAt(u));)u++;if(u===n)return t;u!==E&&(r=i=u+1)}}}}else h(l)&&t.charCodeAt(1)===T&&(r=n>2&&a(t.charCodeAt(2))?3:2,i=r);let c=-1,s=!0;for(let u=n-1;u>=i;--u)if(a(t.charCodeAt(u))){if(!s){c=u;break}}else s=!1;if(c===-1){if(r===-1)return".";c=r}return t.slice(0,c)},basename(t,n){n!==void 0&&p(n,"ext"),p(t,"path");let r=0,i=-1,l=!0,c;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let s=n.length-1,u=-1;for(c=t.length-1;c>=r;--c){const E=t.charCodeAt(c);if(a(E)){if(!l){r=c+1;break}}else u===-1&&(l=!1,u=c+1),s>=0&&(E===n.charCodeAt(s)?--s===-1&&(i=c):(s=-1,i=u))}return r===i?i=u:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=r;--c)if(a(t.charCodeAt(c))){if(!l){r=c+1;break}}else i===-1&&(l=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let n=0,r=-1,i=0,l=-1,c=!0,s=0;t.length>=2&&t.charCodeAt(1)===T&&h(t.charCodeAt(0))&&(n=i=2);for(let u=t.length-1;u>=n;--u){const E=t.charCodeAt(u);if(a(E)){if(!c){i=u+1;break}continue}l===-1&&(c=!1,l=u+1),E===A?r===-1?r=u:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||l===-1||s===0||s===1&&r===l-1&&r===i+1?"":t.slice(r,l)},format:S.bind(null,"\\"),parse(t){p(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,l=t.charCodeAt(0);if(r===1)return a(l)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(a(l)){if(i=1,a(t.charCodeAt(1))){let B=2,q=B;for(;B<r&&!a(t.charCodeAt(B));)B++;if(B<r&&B!==q){for(q=B;B<r&&a(t.charCodeAt(B));)B++;if(B<r&&B!==q){for(q=B;B<r&&!a(t.charCodeAt(B));)B++;B===r?i=B:B!==q&&(i=B+1)}}}}else if(h(l)&&t.charCodeAt(1)===T){if(r<=2)return n.root=n.dir=t,n;if(i=2,a(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let c=-1,s=i,u=-1,E=!0,k=t.length-1,O=0;for(;k>=i;--k){if(l=t.charCodeAt(k),a(l)){if(!E){s=k+1;break}continue}u===-1&&(E=!1,u=k+1),l===A?c===-1?c=k:O!==1&&(O=1):c!==-1&&(O=-1)}return u!==-1&&(c===-1||O===0||O===1&&c===u-1&&c===s+1?n.base=n.name=t.slice(s,u):(n.name=t.slice(s,c),n.base=t.slice(s,u),n.ext=t.slice(c,u))),s>0&&s!==i?n.dir=t.slice(0,s-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(b){const t=/\\/g;return()=>{const n=w.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>w.cwd()})();e.posix={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const l=i>=0?t[i]:L();p(l,"path"),l.length!==0&&(n=`${l}/${n}`,r=l.charCodeAt(0)===v)}return n=d(n,!r,"/",f),r?`/${n}`:n.length>0?n:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v,r=t.charCodeAt(t.length-1)===v;return t=d(t,!n,"/",f),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];p(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(p(t,"from"),p(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const r=1,i=t.length,l=i-r,c=1,s=n.length-c,u=l<s?l:s;let E=-1,k=0;for(;k<u;k++){const B=t.charCodeAt(r+k);if(B!==n.charCodeAt(c+k))break;B===v&&(E=k)}if(k===u)if(s>u){if(n.charCodeAt(c+k)===v)return n.slice(c+k+1);if(k===0)return n.slice(c+k)}else l>u&&(t.charCodeAt(r+k)===v?E=k:k===0&&(E=0));let O="";for(k=r+E+1;k<=i;++k)(k===i||t.charCodeAt(k)===v)&&(O+=O.length===0?"..":"/..");return`${O}${n.slice(c+E)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v;let r=-1,i=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===v){if(!i){r=l;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&p(n,"ext"),p(t,"path");let r=0,i=-1,l=!0,c;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let s=n.length-1,u=-1;for(c=t.length-1;c>=0;--c){const E=t.charCodeAt(c);if(E===v){if(!l){r=c+1;break}}else u===-1&&(l=!1,u=c+1),s>=0&&(E===n.charCodeAt(s)?--s===-1&&(i=c):(s=-1,i=u))}return r===i?i=u:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===v){if(!l){r=c+1;break}}else i===-1&&(l=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let n=-1,r=0,i=-1,l=!0,c=0;for(let s=t.length-1;s>=0;--s){const u=t.charCodeAt(s);if(u===v){if(!l){r=s+1;break}continue}i===-1&&(l=!1,i=s+1),u===A?n===-1?n=s:c!==1&&(c=1):n!==-1&&(c=-1)}return n===-1||i===-1||c===0||c===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:S.bind(null,"/"),parse(t){p(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===v;let i;r?(n.root="/",i=1):i=0;let l=-1,c=0,s=-1,u=!0,E=t.length-1,k=0;for(;E>=i;--E){const O=t.charCodeAt(E);if(O===v){if(!u){c=E+1;break}continue}s===-1&&(u=!1,s=E+1),O===A?l===-1?l=E:k!==1&&(k=1):l!==-1&&(k=-1)}if(s!==-1){const O=c===0&&r?1:c;l===-1||k===0||k===1&&l===s-1&&l===c+1?n.base=n.name=t.slice(O,s):(n.name=t.slice(O,l),n.base=t.slice(O,s),n.ext=t.slice(l,s))}return c>0?n.dir=t.slice(0,c-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(pe[57],ve([1,0,7]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(T){const I=(0,w.extname)(T),y=R[I.toLowerCase()];return y!==void 0?y:C(T)}e.getMediaOrTextMime=D;function C(T){const I=(0,w.extname)(T);return o[I.toLowerCase()]}e.getMediaMime=C;function A(T){for(const I in o)if(o[I]===T)return I}e.getExtensionForMimeType=A;const v=/^(.+)\/(.+?)(;.+)?$/;function g(T,I){const y=v.exec(T);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:I?void 0:T}e.normalizeMimeType=g}),define(pe[58],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var o;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(o=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(A,...v){const g=v.reduce((y,m)=>(y[m]=!0,y),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(y=>!g[y]).forEach(y=>{for(let m=0;m<T.length;m++)if(y.search(T[m])!==-1){delete A[y];break}})}e.sanitizeProcessEnvironment=D;function C(A){!A||(delete A.DEBUG,w.isMacintosh&&delete A.DYLD_LIBRARY_PATH,w.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(pe[96],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=w.globals.performance&&typeof w.globals.performance.now=="function";class o{static create(C=!0){return new o(C)}constructor(C){this.a=R&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?w.globals.performance.now():Date.now()}}e.StopWatch=o}),define(pe[6],ve([1,0,11,71,2,91,96]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,v=!1;var g;(function(c){c.None=()=>o.Disposable.None;function s(M){if(v){const{onDidAddListener:Y}=M,ie=p.create();let z=0;M.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),Y?.()}}}function u(M,Y){return ae(M,()=>{},0,void 0,!0,void 0,Y)}c.defer=u;function E(M){return(Y,ie=null,z)=>{let V=!1,J;return J=M(H=>{if(!V)return J?J.dispose():V=!0,Y.call(ie,H)},null,z),V&&J.dispose(),J}}c.once=E;function k(M,Y,ie){return ue((z,V=null,J)=>M(H=>z.call(V,Y(H)),null,J),ie)}c.map=k;function O(M,Y,ie){return ue((z,V=null,J)=>M(H=>{Y(H),z.call(V,H)},null,J),ie)}c.forEach=O;function B(M,Y,ie){return ue((z,V=null,J)=>M(H=>Y(H)&&z.call(V,H),null,J),ie)}c.filter=B;function q(M){return M}c.signal=q;function le(...M){return(Y,ie=null,z)=>(0,o.combinedDisposable)(...M.map(V=>V(J=>Y.call(ie,J),null,z)))}c.any=le;function de(M,Y,ie,z){let V=ie;return k(M,J=>(V=Y(V,J),V),z)}c.reduce=de;function ue(M,Y){let ie;const z={onWillAddFirstListener(){ie=M(V.fire,V)},onDidRemoveLastListener(){ie?.dispose()}};Y||s(z);const V=new a(z);return Y?.add(V),V.event}function ae(M,Y,ie=100,z=!1,V=!1,J,H){let X,G,Q,ce=0,Ee;const De={leakWarningThreshold:J,onWillAddFirstListener(){X=M(Ue=>{ce++,G=Y(G,Ue),z&&!Q&&(ke.fire(G),G=void 0),Ee=()=>{const $e=G;G=void 0,Q=void 0,(!z||ce>1)&&ke.fire($e),ce=0},typeof ie=="number"?(clearTimeout(Q),Q=setTimeout(Ee,ie)):Q===void 0&&(Q=0,queueMicrotask(Ee))})},onWillRemoveListener(){V&&ce>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,X.dispose()}};H||s(De);const ke=new a(De);return H?.add(ke),ke.event}c.debounce=ae;function _(M,Y=0,ie){return c.debounce(M,(z,V)=>z?(z.push(V),z):[V],Y,void 0,!0,void 0,ie)}c.accumulate=_;function ee(M,Y=(z,V)=>z===V,ie){let z=!0,V;return B(M,J=>{const H=z||!Y(J,V);return z=!1,V=J,H},ie)}c.latch=ee;function ne(M,Y,ie){return[c.filter(M,Y,ie),c.filter(M,z=>!Y(z),ie)]}c.split=ne;function te(M,Y=!1,ie=[]){let z=ie.slice(),V=M(X=>{z?z.push(X):H.fire(X)});const J=()=>{z?.forEach(X=>H.fire(X)),z=null},H=new a({onWillAddFirstListener(){V||(V=M(X=>H.fire(X)))},onDidAddFirstListener(){z&&(Y?setTimeout(J):J())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return H.event}c.buffer=te;class x{constructor(Y){this.event=Y,this.c=new o.DisposableStore}map(Y){return new x(k(this.event,Y,this.c))}forEach(Y){return new x(O(this.event,Y,this.c))}filter(Y){return new x(B(this.event,Y,this.c))}reduce(Y,ie){return new x(de(this.event,Y,ie,this.c))}latch(){return new x(ee(this.event,void 0,this.c))}debounce(Y,ie=100,z=!1,V=!1,J){return new x(ae(this.event,Y,ie,z,V,J,this.c))}on(Y,ie,z){return this.event(Y,ie,z)}once(Y,ie,z){return E(this.event)(Y,ie,z)}dispose(){this.c.dispose()}}function U(M){return new x(M)}c.chain=U;function Z(M,Y,ie=z=>z){const z=(...X)=>H.fire(ie(...X)),V=()=>M.on(Y,z),J=()=>M.removeListener(Y,z),H=new a({onWillAddFirstListener:V,onDidRemoveLastListener:J});return H.event}c.fromNodeEventEmitter=Z;function re(M,Y,ie=z=>z){const z=(...X)=>H.fire(ie(...X)),V=()=>M.addEventListener(Y,z),J=()=>M.removeEventListener(Y,z),H=new a({onWillAddFirstListener:V,onDidRemoveLastListener:J});return H.event}c.fromDOMEventEmitter=re;function me(M){return new Promise(Y=>E(M)(Y))}c.toPromise=me;function $(M,Y){return Y(void 0),M(ie=>Y(ie))}c.runAndSubscribe=$;function W(M,Y){let ie=null;function z(J){ie?.dispose(),ie=new o.DisposableStore,Y(J,ie)}z(void 0);const V=M(J=>z(J));return(0,o.toDisposable)(()=>{V.dispose(),ie?.dispose()})}c.runAndSubscribeWithStore=W;class N{constructor(Y,ie){this.obs=Y,this.c=0,this.d=!1;const z={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};ie||s(z),this.emitter=new a(z),ie&&ie.add(this.emitter)}beginUpdate(Y){this.c++}handleChange(Y,ie){this.d=!0}endUpdate(Y){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function P(M,Y){return new N(M,Y).emitter.event}c.fromObservable=P})(g=e.Event||(e.Event={}));class T{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${T.c++}`,T.all.add(this)}start(s){this.d=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}T.all=new Set,T.c=0,e.EventProfiling=T;let I=-1;function y(c){const s=I;return I=c,{dispose(){I=s}}}e.setGlobalLeakWarningThreshold=y;class m{constructor(s,u=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=u,this.d=0}dispose(){this.c?.clear()}check(s,u){const E=this.threshold;if(E<=0||u<E)return;this.c||(this.c=new Map);const k=this.c.get(s.value)||0;if(this.c.set(s.value,k+1),this.d-=1,this.d<=0){this.d=E*.5;let O,B=0;for(const[q,le]of this.c)(!O||B<le)&&(O=q,B=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${B}):`),console.warn(O)}return()=>{const O=this.c.get(s.value)||0;this.c.set(s.value,O-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(s,u,E){this.callback=s,this.callbackThis=u,this.stack=E,this.subscription=new o.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class a{constructor(s){this.j=!1,this.d=s,this.f=I>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const s=Array.from(this.q);queueMicrotask(()=>{for(const u of s)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,u,E)=>{if(this.q||(this.q=new D.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),o.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=p.create(),O=this.f.check(B,this.q.size+1)),A&&(B=B??p.create());const q=new b(s,u,B),le=this.q.push(q);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,u);const de=q.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),le(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return E instanceof o.DisposableStore?E.add(de):Array.isArray(E)&&E.push(de),de}),this.l}fire(s){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const u of this.q)this.m.push(this,u,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class f{constructor(s=w.onUnexpectedError){this.d=s,this.c=new D.LinkedList}get size(){return this.c.size}push(s,u,E){this.c.push(new d(s,u,E))}clear(s){const u=new D.LinkedList;for(const E of this.c)E.emitter!==s&&u.push(E);this.c=u}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(u){this.d(u)}}}}e.EventDeliveryQueue=f;class h extends f{clear(s){this.c.clear()}}class d{constructor(s,u,E){this.emitter=s,this.listener=u,this.event=E}}class S extends a{async fireAsync(s,u,E){if(!!this.q){this.c||(this.c=new D.LinkedList);for(const k of this.q)this.c.push([k,s]);for(;this.c.size>0&&!u.isCancellationRequested;){const[k,O]=this.c.shift(),B=[],q={...O,token:u,waitUntil:le=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");E&&(le=E(le,k.callback)),B.push(le)}};try{k.invoke(q)}catch(le){(0,w.onUnexpectedError)(le);continue}Object.freeze(B),await Promise.allSettled(B).then(le=>{for(const de of le)de.status==="rejected"&&(0,w.onUnexpectedError)(de.reason)})}}}}e.AsyncEmitter=S;class L extends a{constructor(s){super(s),this.h=0,this.s=new D.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=L;class t extends L{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class n extends a{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const u={event:s,listener:null};this.f.push(u),this.d&&this.j(u);const E=()=>{this.d&&this.k(u);const k=this.f.indexOf(u);this.f.splice(k,1)};return(0,o.toDisposable)((0,R.once)(E))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(u=>this.c.fire(u))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class i{constructor(){this.c=[]}wrapEvent(s){return(u,E,k)=>s(O=>{const B=this.c[this.c.length-1];B?B.push(()=>u.call(E,O)):u.call(E,O)},void 0,k)}bufferEvents(s){const u=[];this.c.push(u);const E=s();return this.c.pop(),u.forEach(k=>k()),E}}e.EventBufferer=i;class l{constructor(){this.c=!1,this.d=g.None,this.f=o.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(pe[156],ve([1,0,6,2,149]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class D extends R.Disposable{constructor(y,m="",p="",b=!0,a){super(),this.j=this.B(new w.Emitter),this.onDidChange=this.j.event,this.z=!0,this.m=y,this.n=m,this.w=p,this.z=b,this.D=a}get id(){return this.m}get label(){return this.n}set label(y){this.F(y)}F(y){this.n!==y&&(this.n=y,this.j.fire({label:y}))}get tooltip(){return this.u||""}set tooltip(y){this.G(y)}G(y){this.u!==y&&(this.u=y,this.j.fire({tooltip:y}))}get class(){return this.w}set class(y){this.H(y)}H(y){this.w!==y&&(this.w=y,this.j.fire({class:y}))}get enabled(){return this.z}set enabled(y){this.I(y)}I(y){this.z!==y&&(this.z=y,this.j.fire({enabled:y}))}get checked(){return this.C}set checked(y){this.J(y)}J(y){this.C!==y&&(this.C=y,this.j.fire({checked:y}))}async run(y,m){this.D&&await this.D(y)}}e.Action=D;class C extends R.Disposable{constructor(){super(...arguments),this.f=this.B(new w.Emitter),this.onWillRun=this.f.event,this.h=this.B(new w.Emitter),this.onDidRun=this.h.event}async run(y,m){if(!y.enabled)return;this.f.fire({action:y});let p;try{await this.k(y,m)}catch(b){p=b}this.h.fire({action:y,error:p})}async k(y,m){await y.run(m)}}e.ActionRunner=C;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...y){let m=[];for(const p of y)p.length&&(m.length?m=[...m,new A,...p]:m=p);return m}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class v{get actions(){return this.a}constructor(y,m,p,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=y,this.label=m,this.class=b,this.a=p}async run(){}}e.SubmenuAction=v;class g extends D{constructor(){super(g.ID,o.localize(0,null),void 0,!1)}}g.ID="vs.actions.empty",e.EmptySubmenuAction=g;function T(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=T}),define(pe[20],ve([1,0,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(A,v){const g=setTimeout(A.bind(v),0);return{dispose(){clearTimeout(g)}}});var o;(function(A){function v(g){return g===A.None||g===A.Cancelled||g instanceof D?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}A.isCancellationToken=v,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(o=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new w.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(v){this.a=void 0,this.b=void 0,this.b=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new D),this.a}cancel(){this.a?this.a instanceof D&&this.a.cancel():this.a=o.Cancelled}dispose(v=!1){v&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof D&&this.a.dispose():this.a=o.None}}e.CancellationTokenSource=C}),define(pe[157],ve([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new w.CancellationTokenSource,v=this.b(A.token);return this.a={promise:v,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=R;class o{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const v=JSON.stringify(A);return this.b!==v&&(this.b=v,this.a=this.c(A)),this.a}}e.LRUCachedFunction=o;class D{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const v=this.b(A);return this.a.set(A,v),v}}e.CachedFunction=D}),define(pe[17],ve([1,0,157,140]),function(oe,e,w,R){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=D;const C=/{(\d+)}/g;function A(he,...Ce){return Ce.length===0?he:he.replace(C,function(Te,Ne){const Re=parseInt(Ne,10);return isNaN(Re)||Re<0||Re>=Ce.length?Te:Ce[Re]})}e.format=A;const v=/{([^}]+)}/g;function g(he,Ce){return he.replace(v,(Te,Ne)=>Ce[Ne]??Te)}e.format2=g;function T(he){return he.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function I(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function y(he,Ce){let Te=0;const Ne=Ce.charCodeAt(0);for(let Re=he.length-1;Re>=0;Re--)he.charCodeAt(Re)===Ne&&Te++;return Te}e.count=y;function m(he,Ce,Te="\u2026"){return he.length<=Ce?he:`${he.substr(0,Ce)}${Te}`}e.truncate=m;function p(he,Ce=" "){const Te=b(he,Ce);return a(Te,Ce)}e.trim=p;function b(he,Ce){if(!he||!Ce)return he;const Te=Ce.length;if(Te===0||he.length===0)return he;let Ne=0;for(;he.indexOf(Ce,Ne)===Ne;)Ne=Ne+Te;return he.substring(Ne)}e.ltrim=b;function a(he,Ce){if(!he||!Ce)return he;const Te=Ce.length,Ne=he.length;if(Te===0||Ne===0)return he;let Re=Ne,ze=-1;for(;ze=he.lastIndexOf(Ce,Re-1),!(ze===-1||ze+Te!==Re);){if(ze===0)return"";Re=ze}return he.substring(0,Re)}e.rtrim=a;function f(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function h(he){return he.replace(/\*/g,"")}e.stripWildcards=h;function d(he,Ce,Te={}){if(!he)throw new Error("Cannot create regex from empty string");Ce||(he=I(he)),Te.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let Ne="";return Te.global&&(Ne+="g"),Te.matchCase||(Ne+="i"),Te.multiline&&(Ne+="m"),Te.unicode&&(Ne+="u"),new RegExp(he,Ne)}e.createRegExp=d;function S(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function L(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function t(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=t;function n(he){return he.split(/\r\n|\r|\n/)}e.splitLines=n;function r(he){for(let Ce=0,Te=he.length;Ce<Te;Ce++){const Ne=he.charCodeAt(Ce);if(Ne!==32&&Ne!==9)return Ce}return-1}e.firstNonWhitespaceIndex=r;function i(he,Ce=0,Te=he.length){for(let Ne=Ce;Ne<Te;Ne++){const Re=he.charCodeAt(Ne);if(Re!==32&&Re!==9)return he.substring(Ce,Ne)}return he.substring(Ce,Te)}e.getLeadingWhitespace=i;function l(he,Ce=he.length-1){for(let Te=Ce;Te>=0;Te--){const Ne=he.charCodeAt(Te);if(Ne!==32&&Ne!==9)return Te}return-1}e.lastNonWhitespaceIndex=l;function c(he,Ce,Te){const Ne=[];let Re=0;for(const ze of he.matchAll(Ce)){if(Ne.push(he.slice(Re,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Re=ze.index+ze[0].length,Ne.push(Te(ze[0],...ze.slice(1),ze.index,he,ze.groups))}return Ne.push(he.slice(Re)),Promise.all(Ne).then(ze=>ze.join(""))}e.replaceAsync=c;function s(he,Ce){return he<Ce?-1:he>Ce?1:0}e.compare=s;function u(he,Ce,Te=0,Ne=he.length,Re=0,ze=Ce.length){for(;Te<Ne&&Re<ze;Te++,Re++){const Ge=he.charCodeAt(Te),Xe=Ce.charCodeAt(Re);if(Ge<Xe)return-1;if(Ge>Xe)return 1}const qe=Ne-Te,Ve=ze-Re;return qe<Ve?-1:qe>Ve?1:0}e.compareSubstring=u;function E(he,Ce){return k(he,Ce,0,he.length,0,Ce.length)}e.compareIgnoreCase=E;function k(he,Ce,Te=0,Ne=he.length,Re=0,ze=Ce.length){for(;Te<Ne&&Re<ze;Te++,Re++){let Ge=he.charCodeAt(Te),Xe=Ce.charCodeAt(Re);if(Ge===Xe)continue;if(Ge>=128||Xe>=128)return u(he.toLowerCase(),Ce.toLowerCase(),Te,Ne,Re,ze);B(Ge)&&(Ge-=32),B(Xe)&&(Xe-=32);const Ye=Ge-Xe;if(Ye!==0)return Ye}const qe=Ne-Te,Ve=ze-Re;return qe<Ve?-1:qe>Ve?1:0}e.compareSubstringIgnoreCase=k;function O(he){return he>=48&&he<=57}e.isAsciiDigit=O;function B(he){return he>=97&&he<=122}e.isLowerAsciiLetter=B;function q(he){return he>=65&&he<=90}e.isUpperAsciiLetter=q;function le(he,Ce){return he.length===Ce.length&&k(he,Ce)===0}e.equalsIgnoreCase=le;function de(he,Ce){const Te=Ce.length;return Ce.length>he.length?!1:k(he,Ce,0,Te)===0}e.startsWithIgnoreCase=de;function ue(he,Ce){const Te=Math.min(he.length,Ce.length);let Ne;for(Ne=0;Ne<Te;Ne++)if(he.charCodeAt(Ne)!==Ce.charCodeAt(Ne))return Ne;return Te}e.commonPrefixLength=ue;function ae(he,Ce){const Te=Math.min(he.length,Ce.length);let Ne;const Re=he.length-1,ze=Ce.length-1;for(Ne=0;Ne<Te;Ne++)if(he.charCodeAt(Re-Ne)!==Ce.charCodeAt(ze-Ne))return Ne;return Te}e.commonSuffixLength=ae;function _(he){return 55296<=he&&he<=56319}e.isHighSurrogate=_;function ee(he){return 56320<=he&&he<=57343}e.isLowSurrogate=ee;function ne(he,Ce){return(he-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=ne;function te(he,Ce,Te){const Ne=he.charCodeAt(Te);if(_(Ne)&&Te+1<Ce){const Re=he.charCodeAt(Te+1);if(ee(Re))return ne(Ne,Re)}return Ne}e.getNextCodePoint=te;function x(he,Ce){const Te=he.charCodeAt(Ce-1);if(ee(Te)&&Ce>1){const Ne=he.charCodeAt(Ce-2);if(_(Ne))return ne(Ne,Te)}return Te}class U{get offset(){return this.e}constructor(Ce,Te=0){this.c=Ce,this.d=Ce.length,this.e=Te}setOffset(Ce){this.e=Ce}prevCodePoint(){const Ce=x(this.c,this.e);return this.e-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=te(this.c,this.d,this.e);return this.e+=Ce>=65536?2:1,Ce}eol(){return this.e>=this.d}}e.CodePointIterator=U;class Z{get offset(){return this.c.offset}constructor(Ce,Te=0){this.c=new U(Ce,Te)}nextGraphemeLength(){const Ce=Me.getInstance(),Te=this.c,Ne=Te.offset;let Re=Ce.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const ze=Te.offset,qe=Ce.getGraphemeBreakType(Te.nextCodePoint());if(Se(Re,qe)){Te.setOffset(ze);break}Re=qe}return Te.offset-Ne}prevGraphemeLength(){const Ce=Me.getInstance(),Te=this.c,Ne=Te.offset;let Re=Ce.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const ze=Te.offset,qe=Ce.getGraphemeBreakType(Te.prevCodePoint());if(Se(qe,Re)){Te.setOffset(ze);break}Re=qe}return Ne-Te.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function re(he,Ce){return new Z(he,Ce).nextGraphemeLength()}e.nextCharLength=re;function me(he,Ce){return new Z(he,Ce).prevGraphemeLength()}e.prevCharLength=me;function $(he,Ce){Ce>0&&ee(he.charCodeAt(Ce))&&Ce--;const Te=Ce+re(he,Ce);return[Te-me(he,Te),Te]}e.getCharContainingOffset=$;function W(he){const Ce=new Z(he);let Te=0;for(;!Ce.eol();)Te++,Ce.nextGraphemeLength();return Te}e.charCount=W;let N;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(he){return N||(N=P()),N.test(he)}e.containsRTL=M;const Y=/^[\t\n\r\x20-\x7E]*$/;function ie(he){return Y.test(he)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=z;function V(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=V;function J(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=J;function H(he,Ce){if(he.length<Ce)return he;const Te=/\b/g;let Ne=0;for(;Te.test(he)&&!(he.length-Te.lastIndex<Ce);)Ne=Te.lastIndex,Te.lastIndex+=1;return he.substring(Ne).replace(/^\s/,"")}e.lcut=H;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function G(he){return he&&(he=he.replace(X,"")),he}e.removeAnsiEscapeCodes=G,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function ce(he){return Q(he)?he.substr(1):he}e.stripUTF8BOM=ce;function Ee(he,Ce){if(!he||!Ce||he.length<Ce.length)return!1;const Te=Ce.length,Ne=he.toLowerCase();let Re=0,ze=-1;for(;Re<Te;){const qe=Ne.indexOf(Ce[Re],ze+1);if(qe<0)return!1;ze=qe,Re++}return!0}e.fuzzyContains=Ee;function De(he,Ce=!1){return he?(Ce&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=De;function ke(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=ke;function Ue(he,Ce=1){if(Ce===0)return"";let Te=-1;do Te=he.indexOf(`
`,Te+1),Ce--;while(Ce>0&&Te>=0);return Te===-1?he:(he[Te-1]==="\r"&&Te--,he.substr(0,Te))}e.getNLines=Ue;function $e(he){return he=he%(2*26),he<26?String.fromCharCode(97+he):String.fromCharCode(65+he-26)}e.singleLetterHash=$e;function ge(he){return Me.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=ge;function Se(he,Ce){return he===0?Ce!==5&&Ce!==7:he===2&&Ce===3?!1:he===4||he===2||he===3||Ce===4||Ce===2||Ce===3?!0:!(he===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(he===11||he===9)&&(Ce===9||Ce===10)||(he===12||he===10)&&Ce===10||Ce===5||Ce===13||Ce===7||he===1||he===13&&Ce===14||he===6&&Ce===6)}var ye;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Me{static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Fe()}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Te=this.d,Ne=Te.length/3;let Re=1;for(;Re<=Ne;)if(Ce<Te[3*Re])Re=2*Re;else if(Ce>Te[3*Re+1])Re=2*Re+1;else return Te[3*Re+2];return 0}}Me.c=null;function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function _e(he,Ce){if(he===0)return 0;const Te=He(he,Ce);if(Te!==void 0)return Te;const Ne=new U(Ce,he);return Ne.prevCodePoint(),Ne.offset}e.getLeftDeleteOffset=_e;function He(he,Ce){const Te=new U(Ce,he);let Ne=Te.prevCodePoint();for(;Je(Ne)||Ne===65039||Ne===8419;){if(Te.offset===0)return;Ne=Te.prevCodePoint()}if(!J(Ne))return;let Re=Te.offset;return Re>0&&Te.prevCodePoint()===8205&&(Re=Te.offset),Re}function Je(he){return 127995<=he&&he<=127999}var Qe;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class et{static getInstance(Ce){return et.d.get(Array.from(Ce))}static getLocales(){return et.e.value}constructor(Ce){this.f=Ce}isAmbiguous(Ce){return this.f.has(Ce)}getPrimaryConfusable(Ce){return this.f.get(Ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}o=et,et.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),et.d=new w.LRUCachedFunction(he=>{function Ce(Xe){const Ye=new Map;for(let st=0;st<Xe.length;st+=2)Ye.set(Xe[st],Xe[st+1]);return Ye}function Te(Xe,Ye){const st=new Map(Xe);for(const[ct,ot]of Ye)st.set(ct,ot);return st}function Ne(Xe,Ye){if(!Xe)return Ye;const st=new Map;for(const[ct,ot]of Xe)Ye.has(ct)&&st.set(ct,ot);return st}const Re=o.c.value;let ze=he.filter(Xe=>!Xe.startsWith("_")&&Xe in Re);ze.length===0&&(ze=["_default"]);let qe;for(const Xe of ze){const Ye=Ce(Re[Xe]);qe=Ne(qe,Ye)}const Ve=Ce(Re._common),Ge=Te(Ve,qe);return new et(Ge)}),et.e=new R.Lazy(()=>Object.keys(et.c.value).filter(he=>!he.startsWith("_"))),e.AmbiguousCharacters=et;class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(Ce){return Ke.e().has(Ce)}static get codePoints(){return Ke.e()}}Ke.d=void 0,e.InvisibleCharacters=Ke}),define(pe[39],ve([1,0,7,3,17,8]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function A(c){return c.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=A;function v(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=v;function g(c,s=w.posix.sep){if(!c)return"";const u=c.length,E=c.charCodeAt(0);if(C(E)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let O=3;const B=O;for(;O<u&&!C(c.charCodeAt(O));O++);if(B!==O&&!C(c.charCodeAt(O+1))){for(O+=1;O<u;O++)if(C(c.charCodeAt(O)))return c.slice(0,O+1).replace(/[\\/]/g,s)}}return s}else if(f(E)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+s:c.slice(0,2);let k=c.indexOf("://");if(k!==-1){for(k+=3;k<u;k++)if(C(c.charCodeAt(k)))return c.slice(0,k+1)}return""}e.getRoot=g;function T(c){if(!R.isWindows||!c||c.length<5)return!1;let s=c.charCodeAt(0);if(s!==92||(s=c.charCodeAt(1),s!==92))return!1;let u=2;const E=u;for(;u<c.length&&(s=c.charCodeAt(u),s!==92);u++);return!(E===u||(s=c.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=T;const I=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(c,s=R.isWindows){const u=s?I:y;return!(!c||c.length===0||/^\s+$/.test(c)||(u.lastIndex=0,u.test(c))||s&&m.test(c)||c==="."||c===".."||s&&c[c.length-1]==="."||s&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=p;function b(c,s,u){const E=c===s;return!u||E?E:!c||!s?!1:(0,o.equalsIgnoreCase)(c,s)}e.isEqual=b;function a(c,s,u,E=w.sep){if(c===s)return!0;if(!c||!s||s.length>c.length)return!1;if(u){if(!(0,o.startsWithIgnoreCase)(c,s))return!1;if(s.length===c.length)return!0;let O=s.length;return s.charAt(s.length-1)===E&&O--,c.charAt(O)===E}return s.charAt(s.length-1)!==E&&(s+=E),c.indexOf(s)===0}e.isEqualOrParent=a;function f(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=f;function h(c,s){return R.isWindows&&c.endsWith(":")&&(c+=w.sep),(0,w.isAbsolute)(c)||(c=(0,w.join)(s,c)),c=(0,w.normalize)(c),R.isWindows?(c=(0,o.rtrim)(c,w.sep),c.endsWith(":")&&(c+=w.sep)):(c=(0,o.rtrim)(c,w.sep),c||(c=w.sep)),c}e.sanitizeFilePath=h;function d(c){const s=(0,w.normalize)(c);return R.isWindows?c.length>3?!1:S(s)&&(c.length===2||s.charCodeAt(2)===92):s===w.posix.sep}e.isRootOrDriveLetter=d;function S(c,s=R.isWindows){return s?f(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function L(c){return S(c)?c[0]:void 0}e.getDriveLetter=L;function t(c,s,u){return s.length>c.length?-1:c===s?0:(u&&(c=c.toLowerCase(),s=s.toLowerCase()),c.indexOf(s))}e.indexOfPath=t;function n(c){const s=c.split(":");let u,E,k;for(const O of s){const B=Number(O);(0,D.isNumber)(B)?E===void 0?E=B:k===void 0&&(k=B):u=u?[u,O].join(":"):O}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(c,s,u=8){let E="";for(let O=0;O<u;O++){let B;O===0&&R.isWindows&&!s&&(u===3||u===4)?B=i:B=r,E+=B.charAt(Math.floor(Math.random()*B.length))}let k;return s?k=`${s}-${E}`:k=E,c?(0,w.join)(c,k):k}e.randomPath=l}),define(pe[158],ve([1,0,27,17]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function o(...G){return function(Q,ce){for(let Ee=0,De=G.length;Ee<De;Ee++){const ke=G[Ee](Q,ce);if(ke)return ke}return null}}e.or=o,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(G,Q,ce){if(!ce||ce.length<Q.length)return null;let Ee;return G?Ee=R.startsWithIgnoreCase(ce,Q):Ee=ce.indexOf(Q)===0,Ee?Q.length>0?[{start:0,end:Q.length}]:[]:null}function C(G,Q){const ce=Q.toLowerCase().indexOf(G.toLowerCase());return ce===-1?null:[{start:ce,end:ce+G.length}]}e.matchesContiguousSubString=C;function A(G,Q){return v(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=A;function v(G,Q,ce,Ee){if(ce===G.length)return[];if(Ee===Q.length)return null;if(G[ce]===Q[Ee]){let De=null;return(De=v(G,Q,ce+1,Ee+1))?f({start:Ee,end:Ee+1},De):null}return v(G,Q,ce,Ee+1)}function g(G){return 97<=G&&G<=122}function T(G){return 65<=G&&G<=90}e.isUpper=T;function I(G){return 48<=G&&G<=57}function y(G){return G===32||G===9||G===10||G===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>m.add(G.charCodeAt(0)));function p(G){return y(G)||m.has(G)}function b(G,Q){return G===Q||p(G)&&p(Q)}function a(G){return g(G)||T(G)||I(G)}function f(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function h(G,Q){for(let ce=Q;ce<G.length;ce++){const Ee=G.charCodeAt(ce);if(T(Ee)||I(Ee)||ce>0&&!a(G.charCodeAt(ce-1)))return ce}return G.length}function d(G,Q,ce,Ee){if(ce===G.length)return[];if(Ee===Q.length)return null;if(G[ce]!==Q[Ee].toLowerCase())return null;{let De=null,ke=Ee+1;for(De=d(G,Q,ce+1,Ee+1);!De&&(ke=h(Q,ke))<Q.length;)De=d(G,Q,ce+1,ke),ke++;return De===null?null:f({start:Ee,end:Ee+1},De)}}function S(G){let Q=0,ce=0,Ee=0,De=0,ke=0;for(let ye=0;ye<G.length;ye++)ke=G.charCodeAt(ye),T(ke)&&Q++,g(ke)&&ce++,a(ke)&&Ee++,I(ke)&&De++;const Ue=Q/G.length,$e=ce/G.length,ge=Ee/G.length,Se=De/G.length;return{upperPercent:Ue,lowerPercent:$e,alphaPercent:ge,numericPercent:Se}}function L(G){const{upperPercent:Q,lowerPercent:ce}=G;return ce===0&&Q>.6}function t(G){const{upperPercent:Q,lowerPercent:ce,alphaPercent:Ee,numericPercent:De}=G;return ce>.2&&Q<.8&&Ee>.6&&De<.2}function n(G){let Q=0,ce=0,Ee=0,De=0;for(let ke=0;ke<G.length;ke++)Ee=G.charCodeAt(ke),T(Ee)&&Q++,g(Ee)&&ce++,y(Ee)&&De++;return(Q===0||ce===0)&&De===0?G.length<=30:Q<=5}function r(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!n(G)||Q.length>60)return null;const ce=S(Q);if(!t(ce)){if(!L(ce))return null;Q=Q.toLowerCase()}let Ee=null,De=0;for(G=G.toLowerCase();De<Q.length&&(Ee=d(G,Q,0,De))===null;)De=h(Q,De+1);return Ee}e.matchesCamelCase=r;function i(G,Q,ce=!1){if(!Q||Q.length===0)return null;let Ee=null,De=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();De<Q.length&&(Ee=l(G,Q,0,De,ce))===null;)De=c(Q,De+1);return Ee}e.matchesWords=i;function l(G,Q,ce,Ee,De){if(ce===G.length)return[];if(Ee===Q.length)return null;if(b(G.charCodeAt(ce),Q.charCodeAt(Ee))){let ke=null,Ue=Ee+1;if(ke=l(G,Q,ce+1,Ee+1,De),!De)for(;!ke&&(Ue=c(Q,Ue))<Q.length;)ke=l(G,Q,ce+1,Ue,De),Ue++;return ke?G.charCodeAt(ce)!==Q.charCodeAt(Ee)?ke:f({start:Ee,end:Ee+1},ke):null}else return null}function c(G,Q){for(let ce=Q;ce<G.length;ce++)if(p(G.charCodeAt(ce))||ce>0&&p(G.charCodeAt(ce-1)))return ce;return G.length}const s=o(e.matchesPrefix,r,C),u=o(e.matchesPrefix,r,A),E=new w.LRUCache(1e4);function k(G,Q,ce=!1){if(typeof G!="string"||typeof Q!="string")return null;let Ee=E.get(G);Ee||(Ee=new RegExp(R.convertSimple2RegExpPattern(G),"i"),E.set(G,Ee));const De=Ee.exec(Q);return De?[{start:De.index,end:De.index+De[0].length}]:ce?u(G,Q):s(G,Q)}e.matchesFuzzy=k;function O(G,Q){const ce=Y(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?q(ce):null}e.matchesFuzzy2=O;function B(G,Q,ce,Ee,De,ke){const Ue=Math.min(13,G.length);for(;ce<Ue;ce++){const $e=Y(G,Q,ce,Ee,De,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if($e)return $e}return[0,ke]}e.anyScore=B;function q(G){if(typeof G>"u")return[];const Q=[],ce=G[1];for(let Ee=G.length-1;Ee>1;Ee--){const De=G[Ee]+ce,ke=Q[Q.length-1];ke&&ke.end===De?ke.end=De+1:Q.push({start:De,end:De+1})}return Q}e.createMatches=q;const le=128;function de(){const G=[],Q=[];for(let ce=0;ce<=le;ce++)Q[ce]=0;for(let ce=0;ce<=le;ce++)G.push(Q.slice(0));return G}function ue(G){const Q=[];for(let ce=0;ce<=G;ce++)Q[ce]=0;return Q}const ae=ue(2*le),_=ue(2*le),ee=de(),ne=de(),te=de(),x=!1;function U(G,Q,ce,Ee,De){function ke($e,ge,Se=" "){for(;$e.length<ge;)$e=Se+$e;return $e}let Ue=` |   |${Ee.split("").map($e=>ke($e,3)).join("|")}
`;for(let $e=0;$e<=ce;$e++)$e===0?Ue+=" |":Ue+=`${Q[$e-1]}|`,Ue+=G[$e].slice(0,De+1).map(ge=>ke(ge.toString(),3)).join("|")+`
`;return Ue}function Z(G,Q,ce,Ee){G=G.substr(Q),ce=ce.substr(Ee),console.log(U(ne,G,G.length,ce,ce.length)),console.log(U(te,G,G.length,ce,ce.length)),console.log(U(ee,G,G.length,ce,ce.length))}function re(G,Q){if(Q<0||Q>=G.length)return!1;const ce=G.codePointAt(Q);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ce)}}function me(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function $(G,Q,ce){return Q[G]!==ce[G]}function W(G,Q,ce,Ee,De,ke,Ue=!1){for(;Q<ce&&De<ke;)G[Q]===Ee[De]&&(Ue&&(ae[Q]=De),Q+=1),De+=1;return Q===ce}e.isPatternInWord=W;var N;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(N||(N={}));var P;(function(G){G.Default=[-100,0];function Q(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}G.isDefault=Q})(P=e.FuzzyScore||(e.FuzzyScore={}));class M{constructor(Q,ce){this.firstMatchCanBeWeak=Q,this.boostFullMatch=ce}}M.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=M;function Y(G,Q,ce,Ee,De,ke,Ue=M.default){const $e=G.length>le?le:G.length,ge=Ee.length>le?le:Ee.length;if(ce>=$e||ke>=ge||$e-ce>ge-ke||!W(Q,ce,$e,De,ke,ge,!0))return;ie($e,ge,ce,ke,Q,De);let Se=1,ye=1,Me=ce,Fe=ke;const _e=[!1];for(Se=1,Me=ce;Me<$e;Se++,Me++){const Ke=ae[Me],he=_[Me],Ce=Me+1<$e?_[Me+1]:ge;for(ye=Ke-ke+1,Fe=Ke;Fe<Ce;ye++,Fe++){let Te=Number.MIN_SAFE_INTEGER,Ne=!1;Fe<=he&&(Te=z(G,Q,Me,ce,Ee,De,Fe,ge,ke,ee[Se-1][ye-1]===0,_e));let Re=0;Te!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Re=Te+ne[Se-1][ye-1]);const ze=Fe>Ke,qe=ze?ne[Se][ye-1]+(ee[Se][ye-1]>0?-5:0):0,Ve=Fe>Ke+1&&ee[Se][ye-1]>0,Ge=Ve?ne[Se][ye-2]+(ee[Se][ye-2]>0?-5:0):0;if(Ve&&(!ze||Ge>=qe)&&(!Ne||Ge>=Re))ne[Se][ye]=Ge,te[Se][ye]=3,ee[Se][ye]=0;else if(ze&&(!Ne||qe>=Re))ne[Se][ye]=qe,te[Se][ye]=2,ee[Se][ye]=0;else if(Ne)ne[Se][ye]=Re,te[Se][ye]=1,ee[Se][ye]=ee[Se-1][ye-1]+1;else throw new Error("not possible")}}if(x&&Z(G,ce,Ee,ke),!_e[0]&&!Ue.firstMatchCanBeWeak)return;Se--,ye--;const He=[ne[Se][ye],ke];let Je=0,Qe=0;for(;Se>=1;){let Ke=ye;do{const he=te[Se][Ke];if(he===3)Ke=Ke-2;else if(he===2)Ke=Ke-1;else break}while(Ke>=1);Je>1&&Q[ce+Se-1]===De[ke+ye-1]&&!$(Ke+ke-1,Ee,De)&&Je+1>ee[Se][Ke]&&(Ke=ye),Ke===ye?Je++:Je=1,Qe||(Qe=Ke),Se--,ye=Ke-1,He.push(ye)}ge===$e&&Ue.boostFullMatch&&(He[0]+=2);const et=Qe-$e;return He[0]-=et,He}e.fuzzyScore=Y;function ie(G,Q,ce,Ee,De,ke){let Ue=G-1,$e=Q-1;for(;Ue>=ce&&$e>=Ee;)De[Ue]===ke[$e]&&(_[Ue]=$e,Ue--),$e--}function z(G,Q,ce,Ee,De,ke,Ue,$e,ge,Se,ye){if(Q[ce]!==ke[Ue])return Number.MIN_SAFE_INTEGER;let Me=1,Fe=!1;return Ue===ce-Ee?Me=G[ce]===De[Ue]?7:5:$(Ue,De,ke)&&(Ue===0||!$(Ue-1,De,ke))?(Me=G[ce]===De[Ue]?7:5,Fe=!0):re(ke,Ue)&&(Ue===0||!re(ke,Ue-1))?Me=5:(re(ke,Ue-1)||me(ke,Ue-1))&&(Me=5,Fe=!0),Me>1&&ce===Ee&&(ye[0]=!0),Fe||(Fe=$(Ue,De,ke)||re(ke,Ue-1)||me(ke,Ue-1)),ce===Ee?Ue>ge&&(Me-=Fe?3:5):Se?Me+=Fe?2:0:Me+=Fe?0:1,Ue+1===$e&&(Me-=Fe?3:5),Me}function V(G,Q,ce,Ee,De,ke,Ue){return H(G,Q,ce,Ee,De,ke,!0,Ue)}e.fuzzyScoreGracefulAggressive=V;function J(G,Q,ce,Ee,De,ke,Ue){return H(G,Q,ce,Ee,De,ke,!1,Ue)}e.fuzzyScoreGraceful=J;function H(G,Q,ce,Ee,De,ke,Ue,$e){let ge=Y(G,Q,ce,Ee,De,ke,$e);if(ge&&!Ue)return ge;if(G.length>=3){const Se=Math.min(7,G.length-1);for(let ye=ce+1;ye<Se;ye++){const Me=X(G,ye);if(Me){const Fe=Y(Me,Me.toLowerCase(),ce,Ee,De,ke,$e);Fe&&(Fe[0]-=3,(!ge||Fe[0]>ge[0])&&(ge=Fe))}}}return ge}function X(G,Q){if(Q+1>=G.length)return;const ce=G[Q],Ee=G[Q+1];if(ce!==Ee)return G.slice(0,Q)+Ee+ce+G.slice(Q+2)}}),define(pe[74],ve([1,0,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return o(f,0)}e.hash=R;function o(f,h){switch(typeof f){case"object":return f===null?D(349,h):Array.isArray(f)?v(f,h):g(f,h);case"string":return A(f,h);case"boolean":return C(f,h);case"number":return D(f,h);case"undefined":return D(937,h);default:return D(617,h)}}e.doHash=o;function D(f,h){return(h<<5)-h+f|0}e.numberHash=D;function C(f,h){return D(f?433:863,h)}function A(f,h){h=D(149417,h);for(let d=0,S=f.length;d<S;d++)h=D(f.charCodeAt(d),h);return h}e.stringHash=A;function v(f,h){return h=D(104579,h),f.reduce((d,S)=>o(S,d),h)}function g(f,h){return h=D(181387,h),Object.keys(f).sort().reduce((d,S)=>(d=A(S,d),o(f[S],d)),h)}class T{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=o(h,this.g),this.g}}e.Hasher=T;var I;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function y(f,h,d=32){const S=d-h,L=~((1<<S)-1);return(f<<h|(L&f)>>>S)>>>0}function m(f,h=0,d=f.byteLength,S=0){for(let L=0;L<d;L++)f[h+L]=S}function p(f,h,d="0"){for(;f.length<h;)f=d+f;return f}function b(f,h=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(d=>d.toString(16).padStart(2,"0")).join(""):p((f>>>0).toString(16),h/4)}e.toHexString=b;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const d=h.length;if(d===0)return;const S=this.p;let L=this.r,t=this.u,n,r;for(t!==0?(n=t,r=-1,t=0):(n=h.charCodeAt(0),r=0);;){let i=n;if(w.isHighSurrogate(n))if(r+1<d){const l=h.charCodeAt(r+1);w.isLowSurrogate(l)?(r++,i=w.computeCodePoint(n,l)):i=65533}else{t=n;break}else w.isLowSurrogate(n)&&(i=65533);if(L=this.w(S,L,i),r++,r<d)n=h.charCodeAt(r);else break}this.r=L,this.u=t}w(h,d,S){return S<128?h[d++]=S:S<2048?(h[d++]=192|(S&1984)>>>6,h[d++]=128|(S&63)>>>0):S<65536?(h[d++]=224|(S&61440)>>>12,h[d++]=128|(S&4032)>>>6,h[d++]=128|(S&63)>>>0):(h[d++]=240|(S&1835008)>>>18,h[d++]=128|(S&258048)>>>12,h[d++]=128|(S&4032)>>>6,h[d++]=128|(S&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=a.g,d=this.q;for(let s=0;s<64;s+=4)h.setUint32(s,d.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)h.setUint32(s,y(h.getUint32(s-12,!1)^h.getUint32(s-32,!1)^h.getUint32(s-56,!1)^h.getUint32(s-64,!1),1),!1);let S=this.h,L=this.l,t=this.m,n=this.n,r=this.o,i,l,c;for(let s=0;s<80;s++)s<20?(i=L&t|~L&n,l=1518500249):s<40?(i=L^t^n,l=1859775393):s<60?(i=L&t|L&n|t&n,l=2400959708):(i=L^t^n,l=3395469782),c=y(S,5)+i+r+l+h.getUint32(s*4,!1)&4294967295,r=n,n=t,t=y(L,30),L=S,S=c;this.h=this.h+S&4294967295,this.l=this.l+L&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}a.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=a}),define(pe[159],ve([1,0,158,17,93]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const D="$(",C=new RegExp(`\\$\\(${o.ThemeIcon.iconNameExpression}(?:${o.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function v(f){return f.replace(A,(h,d)=>d?h:`\\${h}`)}e.escapeIcons=v;const g=new RegExp(`\\\\${C.source}`,"g");function T(f){return f.replace(g,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=T;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function y(f){return f.indexOf(D)===-1?f:f.replace(I,(h,d,S,L)=>S?h:d||L||"")}e.stripIcons=y;function m(f){return f?f.replace(/\$\((.*?)\)/g,(h,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=m;const p=new RegExp(`\\$\\(${o.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(f){p.lastIndex=0;let h="";const d=[];let S=0;for(;;){const L=p.lastIndex,t=p.exec(f),n=f.substring(L,t?.index);if(n.length>0){h+=n;for(let r=0;r<n.length;r++)d.push(S)}if(!t)break;S+=t[0].length}return{text:h,iconOffsets:d}}e.parseLabelWithIcons=b;function a(f,h,d=!1){const{text:S,iconOffsets:L}=h;if(!L||L.length===0)return(0,w.matchesFuzzy)(f,S,d);const t=(0,R.ltrim)(S," "),n=S.length-t.length,r=(0,w.matchesFuzzy)(f,t,d);if(r)for(const i of r){const l=L[i.start+n]+n;i.start+=l,i.end+=l}return r}e.matchesFuzzyIconAware=a}),define(pe[59],ve([1,0,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(o){o[o.Ignore=0]="Ignore",o[o.Info=1]="Info",o[o.Warning=2]="Warning",o[o.Error=3]="Error"})(R||(R={})),function(o){const D="error",C="warning",A="warn",v="info",g="ignore";function T(y){return y?w.equalsIgnoreCase(D,y)?o.Error:w.equalsIgnoreCase(C,y)||w.equalsIgnoreCase(A,y)?o.Warning:w.equalsIgnoreCase(v,y)?o.Info:o.Ignore:o.Ignore}o.fromValue=T;function I(y){switch(y){case o.Error:return D;case o.Warning:return C;case o.Info:return v;default:return g}}o.toString=I}(R||(R={})),e.default=R}),define(pe[60],ve([1,0,18,17]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class o{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const p=m.charCodeAt(0),b=this.b.charCodeAt(this.c);return p-b}value(){return this.b[this.c]}}e.StringIterator=o;class D{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,R.compareSubstring)(m,this.b,0,m.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=D;class C{constructor(m=!0,p=!0){this.f=m,this.g=p}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let p=m.length-1;p>=0;p--,this.c--){const b=this.b.charCodeAt(p);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,R.compareSubstring)(m,this.b,0,m.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var A;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(A||(A={}));class v{constructor(m,p){this.f=m,this.g=p,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(m,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,R.compare)(m,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=v;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(T||(T={}));class I{static forUris(m=()=>!1,p=()=>!1){return new I(new v(m,p))}static forPaths(m=!1){return new I(new C(void 0,!m))}static forStrings(){return new I(new o)}static forConfigKeys(){return new I(new D)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,p){if(p){const b=p.slice(0);(0,w.shuffle)(b);for(const a of b)this.set(a,m)}else{const b=m.slice(0);(0,w.shuffle)(b);for(const a of b)this.set(a[0],a[1])}}set(m,p){const b=this.b.reset(m);let a;this.c||(this.c=new g,this.c.segment=b.value());const f=[];for(a=this.c;;){const d=b.cmp(a.segment);if(d>0)a.left||(a.left=new g,a.left.segment=b.value()),f.push([-1,a]),a=a.left;else if(d<0)a.right||(a.right=new g,a.right.segment=b.value()),f.push([1,a]),a=a.right;else if(b.hasNext())b.next(),a.mid||(a.mid=new g,a.mid.segment=b.value()),f.push([0,a]),a=a.mid;else break}const h=a.value;a.value=p,a.key=m;for(let d=f.length-1;d>=0;d--){const S=f[d][1];S.updateHeight();const L=S.balanceFactor();if(L<-1||L>1){const t=f[d][0],n=f[d+1][0];if(t===1&&n===1)f[d][1]=S.rotateLeft();else if(t===-1&&n===-1)f[d][1]=S.rotateRight();else if(t===1&&n===-1)S.right=f[d+1][1]=f[d+1][1].rotateRight(),f[d][1]=S.rotateLeft();else if(t===-1&&n===1)S.left=f[d+1][1]=f[d+1][1].rotateLeft(),f[d][1]=S.rotateRight();else throw new Error;if(d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}return h}get(m){return this.d(m)?.value}d(m){const p=this.b.reset(m);let b=this.c;for(;b;){const a=p.cmp(b.segment);if(a>0)b=b.left;else if(a<0)b=b.right;else if(p.hasNext())p.next(),b=b.mid;else break}return b}has(m){const p=this.d(m);return!(p?.value===void 0&&p?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,p){const b=this.b.reset(m),a=[];let f=this.c;for(;f;){const h=b.cmp(f.segment);if(h>0)a.push([-1,f]),f=f.left;else if(h<0)a.push([1,f]),f=f.right;else if(b.hasNext())b.next(),a.push([0,f]),f=f.mid;else break}if(!!f){if(p?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const h=this.f(f.right);if(h.key){const{key:d,value:S,segment:L}=h;this.e(h.key,!1),f.key=d,f.value=S,f.segment=L}}else{const h=f.left??f.right;if(a.length>0){const[d,S]=a[a.length-1];switch(d){case-1:S.left=h;break;case 0:S.mid=h;break;case 1:S.right=h;break}}else this.c=h}for(let h=a.length-1;h>=0;h--){const d=a[h][1];d.updateHeight();const S=d.balanceFactor();if(S>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),a[h][1]=d.rotateLeft()):S<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),a[h][1]=d.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this.c=a[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const p=this.b.reset(m);let b=this.c,a;for(;b;){const f=p.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(p.hasNext())p.next(),a=b.value||a,b=b.mid;else break}return b&&b.value||a}findSuperstr(m){return this.g(m,!1)}g(m,p){const b=this.b.reset(m);let a=this.c;for(;a;){const f=b.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(b.hasNext())b.next(),a=a.mid;else return a.mid?this.h(a.mid):p?a.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[p,b]of this)m(b,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const p=[];return this.j(m,p),p[Symbol.iterator]()}j(m,p){!m||(m.left&&this.j(m.left,p),m.value&&p.push([m.key,m.value]),m.mid&&this.j(m.mid,p),m.right&&this.j(m.right,p))}_isBalanced(){const m=p=>{if(!p)return!0;const b=p.balanceFactor();return b<-1||b>1?!1:m(p.left)&&m(p.right)};return m(this.c)}}e.TernarySearchTree=I}),define(pe[4],ve([1,0,7,3]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const o=/^\w[\w\d+.-]*$/,D=/^\//,C=/^\/\//;function A(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!o.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(r,i){return!r&&!i?"file":r}function g(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const T="",I="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,l,c,s,u,E=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=v(i,E),this.authority=l||T,this.path=g(this.scheme,c||T),this.query=s||T,this.fragment=u||T,A(this,E))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:l,authority:c,path:s,query:u,fragment:E}=i;return l===void 0?l=this.scheme:l===null&&(l=T),c===void 0?c=this.authority:c===null&&(c=T),s===void 0?s=this.path:s===null&&(s=T),u===void 0?u=this.query:u===null&&(u=T),E===void 0?E=this.fragment:E===null&&(E=T),l===this.scheme&&c===this.authority&&s===this.path&&u===this.query&&E===this.fragment?this:new b(l,c,s,u,E)}static parse(i,l=!1){const c=y.exec(i);return c?new b(c[2]||T,n(c[4]||T),n(c[5]||T),n(c[7]||T),n(c[9]||T),l):new b(T,T,T,T,T)}static file(i){let l=T;if(R.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const c=i.indexOf(I,2);c===-1?(l=i.substring(2),i=I):(l=i.substring(2,c),i=i.substring(c)||I)}return new b("file",l,i,T,T)}static from(i){const l=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return A(l,!0),l}static joinPath(i,...l){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return R.isWindows&&i.scheme==="file"?c=m.file(w.win32.join(d(i,!0),...l)).path:c=w.posix.join(i.path,...l),i.with({path:c})}toString(i=!1){return S(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const l=new b(i);return l._formatted=i.external,l._fsPath=i._sep===p?i.fsPath:null,l}}else return i}}e.URI=m;const p=R.isWindows?1:void 0;class b extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(r,i,l){let c,s=-1;for(let u=0;u<r.length;u++){const E=r.charCodeAt(u);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||i&&E===47||l&&E===91||l&&E===93||l&&E===58)s!==-1&&(c+=encodeURIComponent(r.substring(s,u)),s=-1),c!==void 0&&(c+=r.charAt(u));else{c===void 0&&(c=r.substr(0,u));const k=a[E];k!==void 0?(s!==-1&&(c+=encodeURIComponent(r.substring(s,u)),s=-1),c+=k):s===-1&&(s=u)}}return s!==-1&&(c+=encodeURIComponent(r.substring(s))),c!==void 0?c:r}function h(r){let i;for(let l=0;l<r.length;l++){const c=r.charCodeAt(l);c===35||c===63?(i===void 0&&(i=r.substr(0,l)),i+=a[c]):i!==void 0&&(i+=r[l])}return i!==void 0?i:r}function d(r,i){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,R.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=d;function S(r,i){const l=i?h:f;let c="",{scheme:s,authority:u,path:E,query:k,fragment:O}=r;if(s&&(c+=s,c+=":"),(u||s==="file")&&(c+=I,c+=I),u){let B=u.indexOf("@");if(B!==-1){const q=u.substr(0,B);u=u.substr(B+1),B=q.lastIndexOf(":"),B===-1?c+=l(q,!1,!1):(c+=l(q.substr(0,B),!1,!1),c+=":",c+=l(q.substr(B+1),!1,!0)),c+="@"}u=u.toLowerCase(),B=u.lastIndexOf(":"),B===-1?c+=l(u,!1,!0):(c+=l(u.substr(0,B),!1,!0),c+=u.substr(B))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const B=E.charCodeAt(1);B>=65&&B<=90&&(E=`/${String.fromCharCode(B+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const B=E.charCodeAt(0);B>=65&&B<=90&&(E=`${String.fromCharCode(B+32)}:${E.substr(2)}`)}c+=l(E,!0,!1)}return k&&(c+="?",c+=l(k,!1,!1)),O&&(c+="#",c+=i?O:f(O,!1,!1)),c}function L(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+L(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,i=>L(i)):r}}),define(pe[160],ve([1,0,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(g){const T=g;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=R;function o(g){const T=[];let I;try{const y=JSON.parse(g.arguments),m=y[y.length-1];m&&m.__$stack&&(y.pop(),I=m.__$stack),T.push(...y)}catch{T.push("Unable to log remote console arguments",g.arguments)}return{args:T,stack:I}}e.parse=o;function D(g){if(typeof g!="string")return D(o(g).stack);const T=g;if(T){const I=C(T),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(y&&y.length===4)return{uri:w.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=D;function C(g){if(!g)return g;const T=g.indexOf(`
`);return T===-1?g:g.substring(0,T)}function A(g,T){const{args:I,stack:y}=o(g),m=typeof I[0]=="string"&&I.length===1;let p=C(y);p&&(p=`(${p.trim()})`);let b=[];if(typeof I[0]=="string"?p&&m?b=[`%c[${T}] %c${I[0]} %c${p}`,v("blue"),v(""),v("grey")]:b=[`%c[${T}] %c${I[0]}`,v("blue"),v(""),...I.slice(1)]:b=[`%c[${T}]%`,v("blue"),...I],p&&!m&&b.push(p),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=A;function v(g){return`color: ${g}`}}),define(pe[61],ve([1,0,15,17,4]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(g){return JSON.stringify(g,A)}e.stringify=D;function C(g){let T=JSON.parse(g);return T=v(T),T}e.parse=C;function A(g,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,R.regExpFlags)(T)}:T}function v(g,T=0){if(!g||T>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return o.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof w.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let I=0;I<g.length;++I)g[I]=v(g[I],T+1);else for(const I in g)Object.hasOwnProperty.call(g,I)&&(g[I]=v(g[I],T+1))}return g}e.revive=v}),define(pe[13],ve([1,0,11,3,4]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${D.vscodeRemoteResource}`}set(T,I,y){this.a[T]=I,this.b[T]=y}setConnectionToken(T,I){this.c[T]=I}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(a){return w.onUnexpectedError(a),T}const I=T.authority;let y=this.a[I];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const m=this.b[I],p=this.c[I];let b=`path=${encodeURIComponent(T.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),o.URI.from({scheme:R.isWeb?this.d:D.vscodeRemoteResource,authority:`${y}:${m}`,path:this.f,query:b})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(T){const I=this.b(T,oe);return this.uriToBrowserUri(I)}uriToBrowserUri(T){return T.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===D.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${D.vscodeFileResource}://${A.a}`)?T.with({scheme:D.vscodeFileResource,authority:T.authority||A.a,query:null,fragment:null}):T}asFileUri(T){const I=this.b(T,oe);return this.uriToFileUri(I)}uriToFileUri(T){return T.scheme===D.vscodeFileResource?T.with({scheme:D.file,authority:T.authority!==A.a?T.authority:null,query:null,fragment:null}):T}b(T,I){return o.URI.isUri(T)?T:o.URI.parse(I.toUrl(T))}}A.a="vscode-app",e.FileAccess=new A;var v;(function(g){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(T.get("3"));const I="vscode-coi";function y(p){let b;typeof p=="string"?b=new URL(p).searchParams:p instanceof URL?b=p.searchParams:o.URI.isUri(p)&&(b=new URL(p.toString(!0)).searchParams);const a=b?.get(I);if(!!a)return T.get(a)}g.getHeadersFromQuery=y;function m(p,b,a){if(!globalThis.crossOriginIsolated)return;const f=b&&a?"3":a?"2":"1";p instanceof URLSearchParams?p.set(I,f):p[I]=f}g.addSearchParam=m})(v=e.COI||(e.COI={}))}),define(pe[19],ve([1,0,39,13,7,3,17,4]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=v;class g{constructor(p){this.a=p}compare(p,b,a=!1){return p===b?0:(0,C.compare)(this.getComparisonKey(p,a),this.getComparisonKey(b,a))}isEqual(p,b,a=!1){return p===b?!0:!p||!b?!1:this.getComparisonKey(p,a)===this.getComparisonKey(b,a)}getComparisonKey(p,b=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,b,a=!1){if(p.scheme===b.scheme){if(p.scheme===R.Schemas.file)return w.isEqualOrParent(v(p),v(b),this.a(p))&&p.query===b.query&&(a||p.fragment===b.fragment);if((0,e.isEqualAuthority)(p.authority,b.authority))return w.isEqualOrParent(p.path,b.path,this.a(p),"/")&&p.query===b.query&&(a||p.fragment===b.fragment)}return!1}joinPath(p,...b){return A.URI.joinPath(p,...b)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return o.posix.basename(p.path)}extname(p){return o.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let b;return p.scheme===R.Schemas.file?b=A.URI.file(o.dirname(v(p))).path:(b=o.posix.dirname(p.path),p.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),b="/")),p.with({path:b})}normalizePath(p){if(!p.path.length)return p;let b;return p.scheme===R.Schemas.file?b=A.URI.file(o.normalize(v(p))).path:b=o.posix.normalize(p.path),p.with({path:b})}relativePath(p,b){if(p.scheme!==b.scheme||!(0,e.isEqualAuthority)(p.authority,b.authority))return;if(p.scheme===R.Schemas.file){const h=o.relative(v(p),v(b));return D.isWindows?w.toSlashes(h):h}let a=p.path||"/";const f=b.path||"/";if(this.a(p)){let h=0;for(const d=Math.min(a.length,f.length);h<d&&!(a.charCodeAt(h)!==f.charCodeAt(h)&&a.charAt(h).toLowerCase()!==f.charAt(h).toLowerCase());h++);a=f.substr(0,h)+a.substr(h)}return o.posix.relative(a,f)}resolvePath(p,b){if(p.scheme===R.Schemas.file){const a=A.URI.file(o.resolve(v(p),b));return p.with({authority:a.authority,path:a.path})}return b=w.toPosixPath(b),p.with({path:o.posix.resolve(p.path,b)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,b){return p===b||p!==void 0&&b!==void 0&&(0,C.equalsIgnoreCase)(p,b)}hasTrailingPathSeparator(p,b=o.sep){if(p.scheme===R.Schemas.file){const a=v(p);return a.length>w.getRoot(a).length&&a[a.length-1]===b}else{const a=p.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,b=o.sep){return(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,b=o.sep){let a=!1;if(p.scheme===R.Schemas.file){const f=v(p);a=f!==void 0&&f.length===w.getRoot(f).length&&f[f.length-1]===b}else{b="/";const f=p.path;a=f.length===1&&f.charCodeAt(f.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path+"/"}):p}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(m=>m.scheme===R.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new g(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(m,p){const b=[];for(let a=0;a<m.length;a++){const f=p(m[a]);m.some((h,d)=>d===a?!1:(0,e.isEqualOrParent)(f,p(h)))||b.push(m[a])}return b}e.distinctParents=T;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function p(b){const a=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[S,L]=d.split(":");S&&L&&a.set(S,L)});const h=b.path.substring(0,b.path.indexOf(";"));return h&&a.set(m.META_DATA_MIME,h),a}m.parseMetaData=p})(I=e.DataUri||(e.DataUri={}));function y(m,p,b){if(p){let a=m.path;return a&&a[0]!==o.posix.sep&&(a=o.posix.sep+a),m.with({scheme:b,authority:p,path:a})}return m.with({scheme:b})}e.toLocalResource=y}),define(pe[14],ve([1,0,20,11,6,2,19,3,144]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(W){return!!W&&typeof W.then=="function"}e.isThenable=g;function T(W){const N=new w.CancellationTokenSource,P=W(N.token),M=new Promise((Y,ie)=>{const z=N.token.onCancellationRequested(()=>{z.dispose(),N.dispose(),ie(new R.CancellationError)});Promise.resolve(P).then(V=>{z.dispose(),N.dispose(),Y(V)},V=>{z.dispose(),N.dispose(),ie(V)})});return new class{cancel(){N.cancel()}then(Y,ie){return M.then(Y,ie)}catch(Y){return this.then(void 0,Y)}finally(Y){return M.finally(Y)}}}e.createCancelablePromise=T;function I(W,N,P){return new Promise((M,Y)=>{const ie=N.onCancellationRequested(()=>{ie.dispose(),M(P)});W.then(M,Y).finally(()=>ie.dispose())})}e.raceCancellation=I;function y(W,N){return new Promise((P,M)=>{const Y=N.onCancellationRequested(()=>{Y.dispose(),M(new R.CancellationError)});W.then(P,M).finally(()=>Y.dispose())})}e.raceCancellationError=y;async function m(W){let N=-1;const P=W.map((Y,ie)=>Y.then(z=>(N=ie,z))),M=await Promise.race(P);return W.forEach((Y,ie)=>{ie!==N&&Y.cancel()}),M}e.raceCancellablePromises=m;function p(W,N,P){let M;const Y=setTimeout(()=>{M?.(void 0),P?.()},N);return Promise.race([W.finally(()=>clearTimeout(Y)),new Promise(ie=>M=ie)])}e.raceTimeout=p;function b(W){return new Promise((N,P)=>{const M=W();g(M)?M.then(N,P):N(M)})}e.asPromise=b;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const P=()=>{this.b=null;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(P,P).then(M)})}return new Promise((P,M)=>{this.b.then(P,M)})}return this.a=N(),new Promise((P,M)=>{this.a.then(Y=>{this.a=null,P(Y)},Y=>{this.a=null,M(Y)})})}}e.Throttler=a;class f{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=f;class h{constructor(){this.a=new Map}queue(N,P){const Y=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.a.get(N)===Y&&this.a.delete(N)});return this.a.set(N,Y),Y}}e.SequencerByKey=h;const d=(W,N)=>{let P=!0;const M=setTimeout(()=>{P=!1,N()},W);return{isTriggered:()=>P,dispose:()=>{clearTimeout(M),P=!1}}},S=W=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,W())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class L{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,P=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((Y,ie)=>{this.d=Y,this.f=ie}).then(()=>{if(this.b=null,this.d=null,this.g){const Y=this.g;return this.g=null,Y()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=P===v.MicrotaskDelay?S(M):d(P,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=L;class t{constructor(N){this.a=new L(N),this.b=new a}trigger(N,P){return this.a.trigger(()=>this.b.queue(N),P)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this.a=!1,this.b=new Promise((N,P)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function i(W,N){return N?new Promise((P,M)=>{const Y=setTimeout(()=>{ie.dispose(),P()},W),ie=N.onCancellationRequested(()=>{clearTimeout(Y),ie.dispose(),M(new R.CancellationError)})}):T(P=>i(W,P))}e.timeout=i;function l(W,N=0){const P=setTimeout(W,N);return(0,D.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=l;function c(W){const N=[];let P=0;const M=W.length;function Y(){return P<M?W[P++]():null}function ie(z){z!=null&&N.push(z);const V=Y();return V?V.then(ie):Promise.resolve(N)}return Promise.resolve(null).then(ie)}e.sequence=c;function s(W,N=M=>!!M,P=null){let M=0;const Y=W.length,ie=()=>{if(M>=Y)return Promise.resolve(P);const z=W[M++];return Promise.resolve(z()).then(J=>N(J)?Promise.resolve(J):ie())};return ie()}e.first=s;function u(W,N=M=>!!M,P=null){if(W.length===0)return Promise.resolve(P);let M=W.length;const Y=()=>{M=-1;for(const ie of W)ie.cancel?.()};return new Promise((ie,z)=>{for(const V of W)V.then(J=>{--M>=0&&N(J)?(Y(),ie(J)):M===0&&ie(P)}).catch(J=>{--M>=0&&(Y(),z(J))})})}e.firstParallel=u;class E{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new o.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((P,M)=>{this.f.push({factory:N,c:P,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const P=N.factory();P.then(N.c,N.e),P.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=E;class k extends E{constructor(){super(1)}}e.Queue=k;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new x;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,P=C.extUri){const M=P.getComparisonKey(N);let Y=this.a.get(M);return Y||(Y=new k,o.Event.once(Y.onDrained)(()=>{Y?.dispose(),this.a.delete(M),this.f()}),this.a.set(M,Y)),Y}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class B{constructor(N,P){this.a=-1,typeof N=="function"&&typeof P=="number"&&this.setIfNotSet(N,P)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,P){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},P)}setIfNotSet(N,P){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},P))}}e.TimeoutTimer=B;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,P){this.cancel(),this.a=setInterval(()=>{N()},P)}}e.IntervalTimer=q;class le{constructor(N,P){this.b=-1,this.a=N,this.d=P,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=le;class de{constructor(N,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.a=N,this.b=P,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=de;class ue extends le{constructor(N,P){super(N,P),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ue;class ae extends D.Disposable{constructor(N,P){super(),this.g=N,this.h=P,this.a=[],this.b=this.B(new D.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const P of N)this.a.push(P);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,A.setTimeout0)(()=>{if(N)return;const P=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(W,N)=>{const P=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(P))}}}}();class _{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(P){this.g=P}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=_;async function ee(W,N,P){let M;for(let Y=0;Y<P;Y++)try{return await W()}catch(ie){M=ie,await i(N)}throw M}e.retry=ee;class ne{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,P,M){return this.a={taskId:N,cancel:()=>M?.(),promise:P},P.then(()=>this.d(N),()=>this.d(N)),P}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let P,M;const Y=new Promise((ie,z)=>{P=ie,M=z});this.b={run:N,promise:Y,promiseResolve:P,promiseReject:M}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ne;class te{constructor(N,P=()=>Date.now()){this.d=N,this.f=P,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=te;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,P)=>{this.a=N,this.b=P})}complete(N){return new Promise(P=>{this.a(N),this.f=!0,P()})}error(N){return new Promise(P=>{this.b(N),this.d=!0,P()})}cancel(){new Promise(N=>{this.b(new R.CancellationError),this.d=!0,N()})}}e.DeferredPromise=x;var U;(function(W){async function N(M){let Y;const ie=await Promise.all(M.map(z=>z.then(V=>V,V=>{Y||(Y=V)})));if(typeof Y<"u")throw Y;return ie}W.settled=N;function P(M){return new Promise(async(Y,ie)=>{try{await M(Y,ie)}catch(z){ie(z)}})}W.withAsyncBody=P})(U=e.Promises||(e.Promises={}));var Z;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(Z||(Z={}));class re{static fromArray(N){return new re(P=>{P.emitMany(N)})}static fromPromise(N){return new re(async P=>{P.emitMany(await N)})}static fromPromises(N){return new re(async P=>{await Promise.all(N.map(async M=>P.emitOne(await M)))})}static merge(N){return new re(async P=>{await Promise.all(N.map(async M=>{for await(const Y of M)P.emitOne(Y)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new o.Emitter,queueMicrotask(async()=>{const P={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(N(P)),this.j()}catch(M){this.k(M)}finally{P.emitOne=void 0,P.emitMany=void 0,P.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await o.Event.toPromise(this.f.event)}while(!0)}}}static map(N,P){return new re(async M=>{for await(const Y of N)M.emitOne(P(Y))})}map(N){return re.map(this,N)}static filter(N,P){return new re(async M=>{for await(const Y of N)P(Y)&&M.emitOne(Y)})}filter(N){return re.filter(this,N)}static coalesce(N){return re.filter(N,P=>!!P)}coalesce(){return re.coalesce(this)}static async toPromise(N){const P=[];for await(const M of N)P.push(M);return P}toPromise(){return re.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}re.EMPTY=re.fromArray([]),e.AsyncIterableObject=re;class me extends re{constructor(N,P){super(P),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=me;function $(W){const N=new w.CancellationTokenSource,P=W(N.token);return new me(N,async M=>{const Y=N.token.onCancellationRequested(()=>{Y.dispose(),N.dispose(),M.reject(new R.CancellationError)});try{for await(const ie of P){if(N.token.isCancellationRequested)return;M.emitOne(ie)}Y.dispose(),N.dispose()}catch(ie){Y.dispose(),N.dispose(),M.reject(ie)}})}e.createCancelableAsyncIterable=$}),define(pe[75],ve([1,0,18,14,39,27,7,3,17]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",I="[^/\\\\]",y=/\//g;function m(te,x){switch(te){case 0:return"";case 1:return`${I}*?`;default:return`(?:${T}|${I}+${T}${x?`|${T}${I}+`:""})*?`}}function p(te,x){if(!te)return[];const U=[];let Z=!1,re=!1,me="";for(const $ of te){switch($){case x:if(!Z&&!re){U.push(me),me="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":re=!0;break;case"]":re=!1;break}me+=$}return me&&U.push(me),U}e.splitGlobAware=p;function b(te){if(!te)return"";let x="";const U=p(te,e.GLOB_SPLIT);if(U.every(Z=>Z===e.GLOBSTAR))x=".*";else{let Z=!1;U.forEach((re,me)=>{if(re===e.GLOBSTAR){if(Z)return;x+=m(2,me===U.length-1)}else{let $=!1,W="",N=!1,P="";for(const M of re){if(M!=="}"&&$){W+=M;continue}if(N&&(M!=="]"||!P)){let Y;M==="-"?Y=M:(M==="^"||M==="!")&&!P?Y="^":M===e.GLOB_SPLIT?Y="":Y=(0,v.escapeRegExpCharacters)(M),P+=Y;continue}switch(M){case"{":$=!0;continue;case"[":N=!0;continue;case"}":{x+=`(?:${p(W,",").map(z=>b(z)).join("|")})`,$=!1,W="";break}case"]":{x+="["+P+"]",N=!1,P="";break}case"?":x+=I;continue;case"*":x+=m(1);continue;default:x+=(0,v.escapeRegExpCharacters)(M)}}me<U.length-1&&(U[me+1]!==e.GLOBSTAR||me+2<U.length)&&(x+=T)}Z=re===e.GLOBSTAR})}return x}const a=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),n=function(){return!1},r=function(){return null};function i(te,x){if(!te)return r;let U;typeof te!="string"?U=te.pattern:U=te,U=U.trim();const Z=`${U}_${!!x.trimForExclusions}`;let re=t.get(Z);if(re)return l(re,te);let me;return a.test(U)?re=s(U.substr(4),U):(me=f.exec(c(U,x)))?re=u(me[1],U):(x.trimForExclusions?d:h).test(U)?re=E(U,x):(me=S.exec(c(U,x)))?re=k(me[1].substr(1),U,!0):(me=L.exec(c(U,x)))?re=k(me[1],U,!1):re=O(U),t.set(Z,re),l(re,te)}function l(te,x){if(typeof x=="string")return te;const U=function(Z,re){return(0,o.isEqualOrParent)(Z,x.base,!A.isLinux)?te((0,v.ltrim)(Z.substr(x.base.length),C.sep),re):null};return U.allBasenames=te.allBasenames,U.allPaths=te.allPaths,U.basenames=te.basenames,U.patterns=te.patterns,U}function c(te,x){return x.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function s(te,x){return function(U,Z){return typeof U=="string"&&U.endsWith(te)?x:null}}function u(te,x){const U=`/${te}`,Z=`\\${te}`,re=function($,W){return typeof $!="string"?null:W?W===te?x:null:$===te||$.endsWith(U)||$.endsWith(Z)?x:null},me=[te];return re.basenames=me,re.patterns=[x],re.allBasenames=me,re}function E(te,x){const U=ee(te.slice(1,-1).split(",").map(W=>i(W,x)).filter(W=>W!==r),te),Z=U.length;if(!Z)return r;if(Z===1)return U[0];const re=function(W,N){for(let P=0,M=U.length;P<M;P++)if(U[P](W,N))return te;return null},me=U.find(W=>!!W.allBasenames);me&&(re.allBasenames=me.allBasenames);const $=U.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return $.length&&(re.allPaths=$),re}function k(te,x,U){const Z=C.sep===C.posix.sep,re=Z?te:te.replace(y,C.sep),me=C.sep+re,$=C.posix.sep+te;let W;return U?W=function(N,P){return typeof N=="string"&&(N===re||N.endsWith(me)||!Z&&(N===te||N.endsWith($)))?x:null}:W=function(N,P){return typeof N=="string"&&(N===re||!Z&&N===te)?x:null},W.allPaths=[(U?"*/":"./")+te],W}function O(te){try{const x=new RegExp(`^${b(te)}$`);return function(U){return x.lastIndex=0,typeof U=="string"&&x.test(U)?te:null}}catch{return r}}function B(te,x,U){return!te||typeof x!="string"?!1:q(te)(x,void 0,U)}e.match=B;function q(te,x={}){if(!te)return n;if(typeof te=="string"||le(te)){const U=i(te,x);if(U===r)return n;const Z=function(re,me){return!!U(re,me)};return U.allBasenames&&(Z.allBasenames=U.allBasenames),U.allPaths&&(Z.allPaths=U.allPaths),Z}return ae(te,x)}e.parse=q;function le(te){const x=te;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=le;function de(te){return te.allBasenames||[]}e.getBasenameTerms=de;function ue(te){return te.allPaths||[]}e.getPathTerms=ue;function ae(te,x){const U=ee(Object.getOwnPropertyNames(te).map(W=>_(W,te[W],x)).filter(W=>W!==r)),Z=U.length;if(!Z)return r;if(!U.some(W=>!!W.requiresSiblings)){if(Z===1)return U[0];const W=function(M,Y){let ie;for(let z=0,V=U.length;z<V;z++){const J=U[z](M,Y);if(typeof J=="string")return J;(0,R.isThenable)(J)&&(ie||(ie=[]),ie.push(J))}return ie?(async()=>{for(const z of ie){const V=await z;if(typeof V=="string")return V}return null})():null},N=U.find(M=>!!M.allBasenames);N&&(W.allBasenames=N.allBasenames);const P=U.reduce((M,Y)=>Y.allPaths?M.concat(Y.allPaths):M,[]);return P.length&&(W.allPaths=P),W}const re=function(W,N,P){let M,Y;for(let ie=0,z=U.length;ie<z;ie++){const V=U[ie];V.requiresSiblings&&P&&(N||(N=(0,C.basename)(W)),M||(M=N.substr(0,N.length-(0,C.extname)(W).length)));const J=V(W,N,M,P);if(typeof J=="string")return J;(0,R.isThenable)(J)&&(Y||(Y=[]),Y.push(J))}return Y?(async()=>{for(const ie of Y){const z=await ie;if(typeof z=="string")return z}return null})():null},me=U.find(W=>!!W.allBasenames);me&&(re.allBasenames=me.allBasenames);const $=U.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return $.length&&(re.allPaths=$),re}function _(te,x,U){if(x===!1)return r;const Z=i(te,U);if(Z===r)return r;if(typeof x=="boolean")return Z;if(x){const re=x.when;if(typeof re=="string"){const me=($,W,N,P)=>{if(!P||!Z($,W))return null;const M=re.replace("$(basename)",()=>N),Y=P(M);return(0,R.isThenable)(Y)?Y.then(ie=>ie?te:null):Y?te:null};return me.requiresSiblings=!0,me}}return Z}function ee(te,x){const U=te.filter(W=>!!W.basenames);if(U.length<2)return te;const Z=U.reduce((W,N)=>{const P=N.basenames;return P?W.concat(P):W},[]);let re;if(x){re=[];for(let W=0,N=Z.length;W<N;W++)re.push(x)}else re=U.reduce((W,N)=>{const P=N.patterns;return P?W.concat(P):W},[]);const me=function(W,N){if(typeof W!="string")return null;if(!N){let M;for(M=W.length;M>0;M--){const Y=W.charCodeAt(M-1);if(Y===47||Y===92)break}N=W.substr(M)}const P=Z.indexOf(N);return P!==-1?re[P]:null};me.basenames=Z,me.patterns=re,me.allBasenames=Z;const $=te.filter(W=>!W.basenames);return $.push(me),$}function ne(te,x){return(0,w.equals)(te,x,(U,Z)=>typeof U=="string"&&typeof Z=="string"?U===Z:typeof U!="string"&&typeof Z!="string"?U.base===Z.base&&U.pattern===Z.pattern:!1)}e.patternsEquals=ne}),define(pe[97],ve([1,0,11,159,19,17,4]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(f="",h=!1){if(this.value=f,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(f,h=0){return this.value+=y(this.supportThemeIcons?(0,R.escapeIcons)(f):f).replace(/([ \t]+)/g,(d,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,h){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(f,h,d){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(f),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(f,h){const d=new RegExp((0,D.escapeRegExpCharacters)(h),"g");return f.replace(d,(S,L)=>f.charAt(L-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=v;function g(a){return T(a)?!a.value:Array.isArray(a)?a.every(g):!0}e.isEmptyMarkdownString=g;function T(a){return a instanceof v?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function I(a,f){return a===f?!0:!a||!f?!1:a.value===f.value&&a.isTrusted===f.isTrusted&&a.supportThemeIcons===f.supportThemeIcons&&a.supportHtml===f.supportHtml&&(a.baseUri===f.baseUri||!!a.baseUri&&!!f.baseUri&&(0,o.isEqual)(C.URI.from(a.baseUri),C.URI.from(f.baseUri)))}e.markdownStringEqual=I;function y(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function m(a){return a.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=m;function p(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function b(a){const f=[],h=a.split("|").map(S=>S.trim());a=h[0];const d=h[1];if(d){const S=/height=(\d+)/.exec(d),L=/width=(\d+)/.exec(d),t=S?S[1]:"",n=L?L[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&f.push(`width="${n}"`),i&&f.push(`height="${t}"`)}return{href:a,dimensions:f}}e.parseHrefAndDimensions=b}),define(pe[161],ve([1,0,18,39,7,3,19,17]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function v(r,i){const{os:l,tildify:c,relative:s}=i;if(s){const k=g(r,s,l);if(typeof k=="string")return k}let u=r.fsPath;if(l===1&&!D.isWindows?u=u.replace(/\//g,"\\"):l!==1&&D.isWindows&&(u=u.replace(/\\/g,"/")),l!==1&&c?.userHome){const k=c.userHome.fsPath;let O;r.scheme!==c.userHome.scheme&&r.path.startsWith(o.posix.sep)?O=c.userHome.with({path:r.path}).fsPath:O=r.fsPath,u=y(O,k,l)}return(l===1?o.win32:o.posix).normalize(T(u,l===1))}e.getPathLabel=v;function g(r,i,l){const c=l===1?o.win32:o.posix,s=l===3?C.extUri:C.extUriIgnorePathCase,u=i.getWorkspace(),E=(0,w.firstOrDefault)(u.folders);if(!E)return;r.scheme!==E.uri.scheme&&r.path.startsWith(o.posix.sep)&&(r=E.uri.with({path:r.path}));const k=i.getWorkspaceFolder(r);if(!k)return;let O;if(s.isEqual(k.uri,r)?O="":O=s.relativePath(k.uri,r)??"",O&&(O=c.normalize(O)),u.folders.length>1&&!i.noPrefix){const B=k.name?k.name:s.basenameOrAuthority(k.uri);O=O?`${B} \u2022 ${O}`:B}return O}function T(r,i=D.isWindows){return(0,R.hasDriveLetter)(r,i)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=T;let I=Object.create(null);function y(r,i,l=D.OS){if(l===1||!r||!i)return r;let c=I.original===i?I.normalized:void 0;c||(c=i,D.isWindows&&(c=(0,R.toSlashes)(c)),c=`${(0,A.rtrim)(c,o.posix.sep)}${o.posix.sep}`,I={original:i,normalized:c});let s=r;return D.isWindows&&(s=(0,R.toSlashes)(s)),(l===3?s.startsWith(c):(0,A.startsWithIgnoreCase)(s,c))?`~/${s.substr(c.length)}`:r}e.tildify=y;function m(r,i){return r.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=m;const p="\u2026",b="\\\\",a="~";function f(r,i=o.sep){const l=new Array(r.length);let c=!1;for(let s=0;s<r.length;s++){const u=r[s];if(u===""){l[s]=`.${i}`;continue}if(!u){l[s]=u;continue}c=!0;let E="",k=u;k.indexOf(b)===0?(E=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(i)===0?(E=k.substr(0,k.indexOf(i)+i.length),k=k.substr(k.indexOf(i)+i.length)):k.indexOf(a)===0&&(E=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length));const O=k.split(i);for(let B=1;c&&B<=O.length;B++)for(let q=O.length-B;c&&q>=0;q--){c=!1;let le=O.slice(q,q+B).join(i);for(let de=0;!c&&de<r.length;de++)if(de!==s&&r[de]&&r[de].indexOf(le)>-1){const ue=q+B===O.length,ae=q>0&&r[de].indexOf(i)>-1?i+le:le,_=r[de].endsWith(ae);c=!ue||_}if(!c){let de="";(O[0].endsWith(":")||E!=="")&&(q===1&&(q=0,B++,le=O[0]+i+le),q>0&&(de=O[0]+i),de=E+de),q>0&&(de=de+p+i),de=de+le,q+B<O.length&&(de=de+i+p),l[s]=de}}c&&(l[s]=u)}return l}e.shorten=f;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function d(r,i=Object.create(null)){const l=[];let c=!1,s="";for(const u of r)if(u==="$"||c&&u==="{")s&&l.push({value:s,type:h.TEXT}),s="",c=!0;else if(u==="}"&&c){const E=i[s];if(typeof E=="string")E.length&&l.push({value:E,type:h.VARIABLE});else if(E){const k=l[l.length-1];(!k||k.type!==h.SEPARATOR)&&l.push({value:E.label,type:h.SEPARATOR})}s="",c=!1}else s+=u;return s&&!c&&l.push({value:s,type:h.TEXT}),l.filter((u,E)=>{if(u.type===h.SEPARATOR){const k=l[E-1],O=l[E+1];return[k,O].every(B=>B&&(B.type===h.VARIABLE||B.type===h.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=d;function S(r,i){return D.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function L(r,i){return D.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=L;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(r){const i=r.indexOf("/")!==-1?o.posix:o.win32,l=i.basename(r),c=i.dirname(r);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(pe[49],ve([1,0,15,4]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function o(I){return I.toJSON()}class D{constructor(y){this.a=y}transformIncoming(y){const m=this.a.transformIncoming(y);return m===y?y:o(R.URI.from(m))}transformOutgoing(y){const m=this.a.transformOutgoing(y);return m===y?y:o(R.URI.from(m))}transformOutgoingURI(y){const m=this.a.transformOutgoing(y);return m===y?y:R.URI.from(m)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function C(I,y,m){if(!I||m>200)return null;if(typeof I=="object"){if(I instanceof R.URI)return y.transformOutgoing(I);for(const p in I)if(Object.hasOwnProperty.call(I,p)){const b=C(I[p],y,m+1);b!==null&&(I[p]=b)}}return null}function A(I,y){const m=C(I,y,0);return m===null?I:m}e.transformOutgoingURIs=A;function v(I,y,m,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return m?R.URI.revive(y.transformIncoming(I)):y.transformIncoming(I);if(I instanceof w.VSBuffer)return null;for(const b in I)if(Object.hasOwnProperty.call(I,b)){const a=v(I[b],y,m,p+1);a!==null&&(I[b]=a)}}return null}function g(I,y){const m=v(I,y,!1,0);return m===null?I:m}e.transformIncomingURIs=g;function T(I,y){const m=v(I,y,!0,0);return m===null?I:m}e.transformAndReviveIncomingURIs=T}),define(pe[98],ve([1,0,33,60,22,147]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(g){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,T=0;const I=(0,w.networkInterfaces)();for(const y in I){const m=I[y];if(m)for(const{mac:p,internal:b}of m)b||(T+=1,this.c(p.toUpperCase())&&(g+=1))}this.b=T>0?g/T:0}return this.b}};let C;async function A(g){return C||(C=(async()=>await v(g)||o.generateUuid())()),C}e.getMachineId=A;async function v(g){try{const T=await new Promise((y,m)=>{oe(["crypto"],y,m)}),I=(0,D.getMac)();return T.createHash("sha256").update(I,"utf8").digest("hex")}catch(T){g(T);return}}}),define(pe[23],ve([1,0,32,33,290,14,39,92,7,3,19,4]),function(oe,e,w,R,o,D,C,A,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function m(ae,_=y.UNLINK){if((0,C.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");return _===y.UNLINK?b(ae):p(ae)}async function p(ae){try{const _=(0,C.randomPath)((0,R.tmpdir)());try{await w.promises.rename(ae,_)}catch(ee){return ee.code==="ENOENT"?void 0:b(ae)}b(_).catch(ee=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function b(ae){return(0,o.promisify)(w.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function a(ae){if((0,C.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function f(ae,_){return S(await(_?h(ae):(0,o.promisify)(w.readdir)(ae)))}async function h(ae){try{return await(0,o.promisify)(w.readdir)(ae,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const _=[],ee=await f(ae);for(const ne of ee){let te=!1,x=!1,U=!1;try{const Z=await e.Promises.lstat((0,v.join)(ae,ne));te=Z.isFile(),x=Z.isDirectory(),U=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}_.push({name:ne,isFile:()=>te,isDirectory:()=>x,isSymbolicLink:()=>U})}return _}function d(ae){return S(w.readdirSync(ae))}e.readdirSync=d;function S(ae){return ae.map(_=>typeof _=="string"?g.isMacintosh?(0,A.normalizeNFC)(_):_:(_.name=g.isMacintosh?(0,A.normalizeNFC)(_.name):_.name,_))}async function L(ae){const _=await f(ae),ee=[];for(const ne of _)await n.existsDirectory((0,v.join)(ae,ne))&&ee.push(ne);return ee}function t(ae,_=1e3){return new Promise(ee=>{let ne=!1;const te=setInterval(()=>{ne||(ne=!0,w.access(ae,x=>{ne=!1,x&&(clearInterval(te),ee(void 0))}))},_)})}e.whenDeleted=t;var n;(function(ae){async function _(te){let x;try{if(x=await e.Promises.lstat(te),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(g.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw Z}throw U}}ae.stat=_;async function ee(te){try{const{stat:x,symbolicLink:U}=await ae.stat(te);return x.isFile()&&U?.dangling!==!0}catch{}return!1}ae.existsFile=ee;async function ne(te){try{const{stat:x,symbolicLink:U}=await ae.stat(te);return x.isDirectory()&&U?.dangling!==!0}catch{}return!1}ae.existsDirectory=ne})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function i(ae,_,ee){return r.queueFor(I.URI.file(ae),T.extUriBiasedIgnorePathCase).queue(()=>{const ne=E(ee);return new Promise((te,x)=>s(ae,_,ne,U=>U?x(U):te()))})}let l=!0;function c(ae){l=ae}e.configureFlushOnWrite=c;function s(ae,_,ee,ne){if(!l)return w.writeFile(ae,_,{mode:ee.mode,flag:ee.flag},ne);w.open(ae,ee.flag,ee.mode,(te,x)=>{if(te)return ne(te);w.writeFile(x,_,U=>{if(U)return w.close(x,()=>ne(U));w.fdatasync(x,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),c(!1)),w.close(x,re=>ne(re))))})})}function u(ae,_,ee){const ne=E(ee);if(!l)return w.writeFileSync(ae,_,{mode:ne.mode,flag:ne.flag});const te=w.openSync(ae,ne.flag,ne.mode);try{w.writeFileSync(te,_);try{w.fdatasyncSync(te)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),c(!1)}}finally{w.closeSync(te)}}e.writeFileSync=u;function E(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function k(ae,_){if(ae!==_)try{await e.Promises.rename(ae,_)}catch(ee){if(ae.toLowerCase()!==_.toLowerCase()&&ee.code==="EXDEV"||ae.endsWith("."))await O(ae,_,{preserveSymlinks:!1}),await m(ae,y.MOVE);else throw ee}}async function O(ae,_,ee){return q(ae,_,{root:{source:ae,target:_},options:ee,handledSourcePaths:new Set})}const B=511;async function q(ae,_,ee){if(ee.handledSourcePaths.has(ae))return;ee.handledSourcePaths.add(ae);const{stat:ne,symbolicLink:te}=await n.stat(ae);if(te){if(ee.options.preserveSymlinks)try{return await ue(ae,_,ee)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(te.dangling)return}return ne.isDirectory()?le(ae,_,ne.mode&B,ee):de(ae,_,ne.mode&B)}async function le(ae,_,ee,ne){await e.Promises.mkdir(_,{recursive:!0,mode:ee});const te=await f(ae);for(const x of te)await q((0,v.join)(ae,x),(0,v.join)(_,x),ne)}async function de(ae,_,ee){await e.Promises.copyFile(ae,_),await e.Promises.chmod(_,ee)}async function ue(ae,_,ee){let ne=await e.Promises.readlink(ae);(0,C.isEqualOrParent)(ne,ee.root.source,!g.isLinux)&&(ne=(0,v.join)(ee.root.target,ne.substr(ee.root.source.length+1))),await e.Promises.symlink(ne,_)}e.Promises=new class{get access(){return(0,o.promisify)(w.access)}get stat(){return(0,o.promisify)(w.stat)}get lstat(){return(0,o.promisify)(w.lstat)}get utimes(){return(0,o.promisify)(w.utimes)}get read(){return(ae,_,ee,ne,te)=>new Promise((x,U)=>{w.read(ae,_,ee,ne,te,(Z,re,me)=>Z?U(Z):x({bytesRead:re,buffer:me}))})}get readFile(){return(0,o.promisify)(w.readFile)}get write(){return(ae,_,ee,ne,te)=>new Promise((x,U)=>{w.write(ae,_,ee,ne,te,(Z,re,me)=>Z?U(Z):x({bytesWritten:re,buffer:me}))})}get appendFile(){return(0,o.promisify)(w.appendFile)}get fdatasync(){return(0,o.promisify)(w.fdatasync)}get truncate(){return(0,o.promisify)(w.truncate)}get rename(){return(0,o.promisify)(w.rename)}get copyFile(){return(0,o.promisify)(w.copyFile)}get open(){return(0,o.promisify)(w.open)}get close(){return(0,o.promisify)(w.close)}get symlink(){return(0,o.promisify)(w.symlink)}get readlink(){return(0,o.promisify)(w.readlink)}get chmod(){return(0,o.promisify)(w.chmod)}get mkdir(){return(0,o.promisify)(w.mkdir)}get unlink(){return(0,o.promisify)(w.unlink)}get rmdir(){return(0,o.promisify)(w.rmdir)}get realpath(){return(0,o.promisify)(w.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return L}get writeFile(){return i}get rm(){return m}get move(){return k}get copy(){return O}}}),define(pe[162],ve([1,0,32,7,3,17,23]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(y){if(o.isLinux)return y;const m=(0,R.dirname)(y);if(y===m)return y;const p=((0,R.basename)(y)||y).toLowerCase();try{const a=(0,C.readdirSync)(m).filter(f=>f.toLowerCase()===p);if(a.length===1){const f=A(m);if(f)return(0,R.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(p);if(f>=0){const h=A(m);if(h)return(0,R.join)(h,a[f])}}}catch{}return null}e.realcaseSync=A;async function v(y){if(o.isLinux)return y;const m=(0,R.dirname)(y);if(y===m)return y;const p=((0,R.basename)(y)||y).toLowerCase();try{const a=(await C.Promises.readdir(m)).filter(f=>f.toLowerCase()===p);if(a.length===1){const f=await v(m);if(f)return(0,R.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(p);if(f>=0){const h=await v(m);if(h)return(0,R.join)(h,a[f])}}}catch{}return null}e.realcase=v;async function g(y){try{return await C.Promises.realpath(y)}catch{const p=I(y);return await C.Promises.access(p,w.constants.R_OK),p}}e.realpath=g;function T(y){try{return w.realpathSync(y)}catch{const p=I(y);return w.accessSync(p,w.constants.R_OK),p}}e.realpathSync=T;function I(y){return(0,D.rtrim)((0,R.normalize)(y),R.sep)}}),define(pe[99],ve([1,0,33,7,23]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var v;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(v||(v={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class I{constructor(L,t,n){this.exePath=L,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await o.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:S=!1}={}){return S?g===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:S=!1,findPreview:L=!1}={}){const t=y({useAlternateBitness:S});if(!t)return null;const n=R.join(t,"PowerShell");if(!await o.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const s of await o.Promises.readdir(n)){let u=-1;if(L){const k=s.indexOf("-");if(k<0)continue;const O=s.substring(0,k);if(!D.test(O)||s.substring(k+1)!=="preview")continue;u=parseInt(O,10)}else{if(!D.test(s))continue;u=parseInt(s,10)}if(u<=r)continue;const E=R.join(n,s,"pwsh.exe");!await o.SymlinkSupport.existsFile(E)||(i=E,r=u)}if(!i)return null;const l=t.includes("x86")?" (x86)":"",c=L?" Preview":"";return new I(i,`PowerShell${c}${l}`,!0)}async function p({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const L=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await o.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=S?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await o.Promises.readdir(L))if(t.test(r)){const i=R.join(L,r,"pwsh.exe");return new I(i,n)}return null}function b(){const S=R.join(w.homedir(),".dotnet","tools","pwsh.exe");return new I(S,".NET Core PowerShell Global Tool")}function a(){const S=R.join(process.env.windir,g===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(S,"Windows PowerShell",!0)}async function*f(){let S=await m();S&&(yield S),S=await m({useAlternateBitness:!0}),S&&(yield S),S=await p(),S&&(yield S),S=b(),S&&(yield S),S=await m({findPreview:!0}),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await m({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=a(),S&&(yield S)}async function*h(){for await(const S of f())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=h;async function d(){for await(const S of h())return S;return null}e.getFirstAvailablePowerShellInstallation=d}),define(pe[100],ve([1,0,7,3,28,58,8,23]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function v(I=o.env){return I.comspec||"cmd.exe"}e.getWindowsShell=v;function g(I){let y=[],m=!1;const p=function(b){if(m){y.push(b);return}(!I.send(b,f=>{if(f&&console.error(f),m=!1,y.length>0){const h=y.slice(0);y=[],h.forEach(d=>p(d))}})||R.isWindows)&&(m=!0)};return{send:p}}e.createQueuedSender=g;var T;(function(I){async function y(m,p,b){if(w.isAbsolute(m))return m;if(p===void 0&&(p=o.cwd()),w.dirname(m)!=="."||(b===void 0&&C.isString(o.env.PATH)&&(b=o.env.PATH.split(w.delimiter)),b===void 0||b.length===0))return w.join(p,m);async function f(h){if(await A.Promises.exists(h)){let d;try{d=await A.Promises.stat(h)}catch(S){S.message.startsWith("EACCES")&&(d=await A.Promises.lstat(h))}return d?!d.isDirectory():!1}return!1}for(const h of b){let d;if(w.isAbsolute(h)?d=w.join(h,m):d=w.join(p,h,m),await f(d))return d;let S=d+".com";if(await f(S)||(S=d+".exe",await f(S)))return S}return w.join(p,m)}I.findExecutable=y})(T=e.win32||(e.win32={}))}),define(pe[101],ve([1,0,50,13]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function o(C){return new Promise((A,v)=>{let g;const T=new Map;function I(m,p,b,a,f){const h=T.get(p);if(m===C||h){const d={name:y(b),cmd:b,pid:m,ppid:p,load:a,mem:f};T.set(m,d),m===C&&(g=d),h&&(h.children||(h.children=[]),h.children.push(d),h.children.length>1&&(h.children=h.children.sort((S,L)=>S.pid-L.pid)))}}function y(m){const p=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,h=/conhost\.exe/i,d=/--type=([a-zA-Z-]+)/;if(a.exec(m))return"electron-crash-reporter";if(f.exec(m))return"winpty-process";if(h.exec(m))return"console-window-host (Windows internal process)";let S=d.exec(m);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?p.exec(m)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const L=/[a-zA-Z-]+\.js/g;let t="";do S=L.exec(m),S&&(t+=S+" ");while(S);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(m)?`electron-nodejs (${m})`:m}if(process.platform==="win32"){const m=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,b)=>{oe(["windows-process-tree"],p,b)}).then(p=>{p.getProcessList(C,b=>{if(!b){v(new Error(`Root process ${C} not found`));return}p.getProcessCpuUsage(b,a=>{const f=new Map;a.forEach(h=>{const d=m(h.commandLine||"");f.set(h.pid,{name:y(d),cmd:d,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),g=f.get(C),g?(f.forEach(h=>{const d=f.get(h.ppid);d&&(d.children||(d.children=[]),d.children.push(h))}),f.forEach(h=>{h.children&&(h.children=h.children.sort((d,S)=>d.pid-S.pid))}),A(g)):v(new Error(`Root process ${C} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let m=function(){let p=[g];const b=[];for(;p.length;){const f=p.shift();f&&(b.push(f.pid),f.children&&(p=p.concat(f.children)))}let a=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+b.join(" "),(0,w.exec)(a,{},(f,h,d)=>{if(f||d)v(f||new Error(d.toString()));else{const S=h.toString().split(`
`);for(let L=0;L<b.length;L++){const t=T.get(b[L]);t.load=parseFloat(S[L])}if(!g){v(new Error(`Root process ${C} not found`));return}A(g)}})};(0,w.exec)("which ps",{},(p,b,a)=>{if(p||a)if(process.platform!=="linux")v(p||new Error(a.toString()));else{const f=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(f,{},(h,d,S)=>{h||S?v(h||new Error(S.toString())):(D(d,I),m())})}else{const f=b.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${f} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,S,L)=>{d||L&&!L.includes("screen size is bogus")?v(d||new Error(L.toString())):(D(S,I),process.platform==="linux"?m():g?A(g):v(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=o;function D(C,A){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=C.toString().split(`
`);for(const T of g){const I=v.exec(T.trim());I&&I.length===6&&A(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(pe[163],ve([1,0,33,3,99,100]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(I,y){return I===1?R.isWindows?T():D.getWindowsShell(y):v(I,y)}e.getSystemShell=C;let A=null;function v(I,y){if(R.isLinux&&I===2||R.isMacintosh&&I===3)return"/bin/bash";if(!A){let m;if(R.isWindows)m="/bin/bash";else{if(m=y.SHELL,!m)try{m=(0,w.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}A=m}return A}let g=null;async function T(){return g||(g=(await(0,o.getFirstAvailablePowerShellInstallation)()).exePath),g}});var Le=this&&this.__decorate||function(oe,e,w,R){var o=arguments.length,D=o<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(oe,e,w,R);else for(var A=oe.length-1;A>=0;A--)(C=oe[A])&&(D=(o<3?C(D):o>3?C(e,w,D):C(e,w))||D);return o>3&&D&&Object.defineProperty(e,w,D),D};define(pe[42],ve([1,0,18,14,15,20,89,11,6,2,61,17,8]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(m||(m={}));function p(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(b||(b={}));function a(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(f||(f={}));function h(x){let U=0;for(let Z=0;;Z+=7){const re=x.read(1);if(U|=(re.buffer[0]&127)<<Z,!(re.buffer[0]&128))return U}}const d=r(0);function S(x,U){if(U===0){x.write(d);return}let Z=0;for(let me=U;me!==0;me=me>>>7)Z++;const re=o.VSBuffer.alloc(Z);for(let me=0;U!==0;me++)re.buffer[me]=U&127,U=U>>>7,U>0&&(re.buffer[me]|=128);x.write(re)}class L{constructor(U){this.b=U,this.a=0}read(U){const Z=this.b.slice(this.a,this.a+U);return this.a+=Z.byteLength,Z}}e.BufferReader=L;class t{constructor(){this.a=[]}get buffer(){return o.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var n;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(n||(n={}));function r(x){const U=o.VSBuffer.alloc(1);return U.writeUInt8(x,0),U}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},l=typeof Buffer<"u";function c(x,U){if(typeof U>"u")x.write(i.Undefined);else if(typeof U=="string"){const Z=o.VSBuffer.fromString(U);x.write(i.String),S(x,Z.byteLength),x.write(Z)}else if(l&&Buffer.isBuffer(U)){const Z=o.VSBuffer.wrap(U);x.write(i.Buffer),S(x,Z.byteLength),x.write(Z)}else if(U instanceof o.VSBuffer)x.write(i.VSBuffer),S(x,U.byteLength),x.write(U);else if(Array.isArray(U)){x.write(i.Array),S(x,U.length);for(const Z of U)c(x,Z)}else if(typeof U=="number"&&(U|0)===U)x.write(i.Uint),S(x,U);else{const Z=o.VSBuffer.fromString(JSON.stringify(U));x.write(i.Object),S(x,Z.byteLength),x.write(Z)}}e.serialize=c;function s(x){switch(x.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return x.read(h(x)).toString();case n.Buffer:return x.read(h(x)).buffer;case n.VSBuffer:return x.read(h(x));case n.Array:{const Z=h(x),re=[];for(let me=0;me<Z;me++)re.push(s(x));return re}case n.Object:return JSON.parse(x.read(h(x)).toString());case n.Int:return h(x)}}e.deserialize=s;class u{constructor(U,Z,re=null,me=1e3){this.h=U,this.j=Z,this.k=re,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($=>this.q($)),this.m({type:200})}registerChannel(U,Z){this.b.set(U,Z),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const Z=this.o([U.type]);this.k?.logOutgoing(Z,0,1,a(U.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([U.type,U.id],U.data);this.k?.logOutgoing(Z,U.id,1,a(U.type),U.data);return}}}o(U,Z=void 0){const re=new t;return c(re,U),c(re,Z),this.p(re.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const Z=new L(U),re=s(Z),me=s(Z),$=re[0];switch($){case 100:return this.k?.logIncoming(U.byteLength,re[1],1,`${p($)}: ${re[2]}.${re[3]}`,me),this.s({type:$,id:re[1],channelName:re[2],name:re[3],arg:me});case 102:return this.k?.logIncoming(U.byteLength,re[1],1,`${p($)}: ${re[2]}.${re[3]}`,me),this.t({type:$,id:re[1],channelName:re[2],name:re[3],arg:me});case 101:return this.k?.logIncoming(U.byteLength,re[1],1,`${p($)}`),this.u({type:$,id:re[1]});case 103:return this.k?.logIncoming(U.byteLength,re[1],1,`${p($)}`),this.u({type:$,id:re[1]})}}s(U){const Z=this.b.get(U.channelName);if(!Z){this.v(U);return}const re=new D.CancellationTokenSource;let me;try{me=Z.call(this.j,U.name,U.arg,re.token)}catch(N){me=Promise.reject(N)}const $=U.id;me.then(N=>{this.m({id:$,data:N,type:201}),this.d.delete(U.id)},N=>{N instanceof Error?this.m({id:$,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:$,data:N,type:203}),this.d.delete(U.id)});const W=(0,g.toDisposable)(()=>re.cancel());this.d.set(U.id,W)}t(U){const Z=this.b.get(U.channelName);if(!Z){this.v(U);return}const re=U.id,$=Z.listen(this.j,U.name,U.arg)(W=>this.m({id:re,data:W,type:204}));this.d.set(U.id,$)}u(U){const Z=this.d.get(U.id);Z&&(Z.dispose(),this.d.delete(U.id))}v(U){let Z=this.g.get(U.channelName);Z||(Z=[],this.g.set(U.channelName,Z));const re=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:U,timeoutTimer:re})}w(U){const Z=this.g.get(U);if(Z){for(const re of Z)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var E;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(U,Z=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=Z}getChannel(U){const Z=this;return{call(re,me,$){return Z.a?Promise.reject(new A.CancellationError):Z.m(U,re,me,$)},listen(re,me){return Z.a?v.Event.None:Z.o(U,re,me)}}}m(U,Z,re,me=D.CancellationToken.None){const $=this.g++,N={id:$,type:100,channelName:U,name:Z,arg:re};if(me.isCancellationRequested)return Promise.reject(new A.CancellationError);let P;return new Promise((Y,ie)=>{if(me.isCancellationRequested)return ie(new A.CancellationError);const z=()=>{const X=G=>{switch(G.type){case 201:this.f.delete($),Y(G.data);break;case 202:{this.f.delete($);const Q=new Error(G.data.message);Q.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,Q.name=G.data.name,ie(Q);break}case 203:this.f.delete($),ie(G.data);break}};this.f.set($,X),this.p(N)};let V=null;this.b===f.Idle?z():(V=(0,R.createCancelablePromise)(X=>this.u()),V.then(()=>{V=null,z()}));const J=()=>{V?(V.cancel(),V=null):this.p({id:$,type:101}),ie(new A.CancellationError)},H=me.onCancellationRequested(J);P=(0,g.combinedDisposable)((0,g.toDisposable)(J),H),this.d.add(P)}).finally(()=>{this.d.delete(P)})}o(U,Z,re){const me=this.g++,W={id:me,type:102,channelName:U,name:Z,arg:re};let N=null;const P=new v.Emitter({onWillAddFirstListener:()=>{N=(0,R.createCancelablePromise)(Y=>this.u()),N.then(()=>{N=null,this.d.add(P),this.p(W)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(P),this.p({id:me,type:103}))}}),M=Y=>P.fire(Y.data);return this.f.set(me,M),P.event}p(U){switch(U.type){case 100:case 102:{const Z=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(Z,U.id,0,`${p(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const Z=this.q([U.type,U.id]);this.j?.logOutgoing(Z,U.id,0,p(U.type));return}}}q(U,Z=void 0){const re=new t;return c(re,U),c(re,Z),this.r(re.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const Z=new L(U),re=s(Z),me=s(Z),$=re[0];switch($){case 200:return this.j?.logIncoming(U.byteLength,0,0,a($)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,re[1],0,a($),me),this.t({type:re[0],id:re[1],data:me})}}t(U){if(U.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}Le([C.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class O{get connections(){const U=[];return this.f.forEach(Z=>U.push(Z)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new v.Emitter,this.onDidAddConnection=this.g.event,this.h=new v.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:Z,onDidClientDisconnect:re})=>{v.Event.once(Z.onMessage)($=>{const W=new L($),N=s(W),P=new u(Z,N),M=new k(Z);this.a.forEach((ie,z)=>P.registerChannel(z,ie));const Y={channelServer:P,channelClient:M,ctx:N};this.f.add(Y),this.g.fire(Y),re(()=>{P.dispose(),M.dispose(),this.f.delete(Y),this.h.fire(Y)})})})}getChannel(U,Z){const re=this;return{call(me,$,W){let N;if((0,y.isFunction)(Z)){const M=(0,w.getRandomElement)(re.connections.filter(Z));N=M?Promise.resolve(M):v.Event.toPromise(v.Event.filter(re.onDidAddConnection,Z))}else N=Z.routeCall(re,me,$);const P=N.then(M=>M.channelClient.getChannel(U));return q(P).call(me,$,W)},listen(me,$){if((0,y.isFunction)(Z))return re.j(U,Z,me,$);const W=Z.routeEvent(re,me,$).then(N=>N.channelClient.getChannel(U));return q(W).listen(me,$)}}}j(U,Z,re,me){const $=this;let W=new g.DisposableStore;const N=new v.Emitter({onWillAddFirstListener:()=>{W=new g.DisposableStore;const P=new v.EventMultiplexer,M=new Map,Y=z=>{const J=z.channelClient.getChannel(U).listen(re,me),H=P.add(J);M.set(z,H)},ie=z=>{const V=M.get(z);!V||(V.dispose(),M.delete(z))};$.connections.filter(Z).forEach(Y),v.Event.filter($.onDidAddConnection,Z)(Y,void 0,W),$.onDidRemoveConnection(ie,void 0,W),P.event(N.fire,N,W),W.add(P)},onDidRemoveLastListener:()=>{W.dispose()}});return N.event}registerChannel(U,Z){this.a.set(U,Z),this.f.forEach(re=>{re.channelServer.registerChannel(U,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class B{constructor(U,Z,re=null){const me=new t;c(me,Z),U.send(me.buffer),this.a=new k(U,re),this.d=new u(U,Z,re)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,Z){this.d.registerChannel(U,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function q(x){return{call(U,Z,re){return x.then(me=>me.call(U,Z,re))},listen(U,Z){const re=new v.Relay;return x.then(me=>re.input=me.listen(U,Z)),re.event}}}e.getDelayedChannel=q;function le(x){let U=!1;return{call(Z,re,me){return U?x.call(Z,re,me):(0,R.timeout)(0).then(()=>U=!0).then(()=>x.call(Z,re,me))},listen(Z,re){if(U)return x.listen(Z,re);const me=new v.Relay;return(0,R.timeout)(0).then(()=>U=!0).then(()=>me.input=x.listen(Z,re)),me.event}}}e.getNextTickChannel=le;class de{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const Z of U.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await v.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=de;var ue;(function(x){function U($,W){const N=$,P=W&&W.disableMarshalling,M=new Map;for(const Y in N)re(Y)&&M.set(Y,v.Event.buffer(N[Y],!0));return new class{listen(Y,ie,z){const V=M.get(ie);if(V)return V;if(me(ie)){const J=N[ie];if(typeof J=="function")return J.call(N,z)}throw new Error(`Event not found: ${ie}`)}call(Y,ie,z){const V=N[ie];if(typeof V=="function"){if(!P&&Array.isArray(z))for(let J=0;J<z.length;J++)z[J]=(0,T.revive)(z[J]);return V.apply(N,z)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=U;function Z($,W){const N=W&&W.disableMarshalling;return new Proxy({},{get(P,M){if(typeof M=="string")return W?.properties?.has(M)?W.properties.get(M):me(M)?function(Y){return $.listen(M,Y)}:re(M)?$.listen(M):async function(...Y){let ie;W&&!(0,y.isUndefinedOrNull)(W.context)?ie=[W.context,...Y]:ie=Y;const z=await $.call(M,ie);return N?z:(0,T.revive)(z)};throw new Error(`Property not found: ${String(M)}`)}})}x.toService=Z;function re($){return $[0]==="o"&&$[1]==="n"&&I.isUpperAsciiLetter($.charCodeAt(2))}function me($){return/^onDynamic/.test($)&&I.isUpperAsciiLetter($.charCodeAt(9))}})(ue=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const U=x.toString();if(U!=="[object Object]")return U}return x}function ee(x){return Array.isArray(x)?x.map(_):_(x)}function ne(x,U,Z,re,me,$,W){W=ee(W);const N=ae[me],P=N[re%N.length];let M=[`%c[${x}]%c[${String(U).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test($)?(M=M.concat(W),M.push(")")):M.push(W),console.log.apply(console,M)}class te{constructor(U,Z){this.d=U,this.f=Z,this.a=0,this.b=0}logOutgoing(U,Z,re,me,$){this.b+=U,ne(this.d,this.b,U,Z,re,me,$)}logIncoming(U,Z,re,me,$){this.a+=U,ne(this.f,this.a,U,Z,re,me,$)}}e.IPCLogger=te}),define(pe[102],ve([1,0,14,15,6,2,42]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(k){k.Created="created",k.Read="read",k.Write="write",k.Open="open",k.Error="error",k.Close="close",k.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",k.NodeEndReceived="nodeEndReceived",k.NodeEndSent="nodeEndSent",k.NodeDrainBegin="nodeDrainBegin",k.NodeDrainEnd="nodeDrainEnd",k.zlibInflateError="zlibInflateError",k.zlibInflateData="zlibInflateData",k.zlibInflateInitialWrite="zlibInflateInitialWrite",k.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",k.zlibInflateWrite="zlibInflateWrite",k.zlibInflateFlushFired="zlibInflateFlushFired",k.zlibDeflateError="zlibDeflateError",k.zlibDeflateData="zlibDeflateData",k.zlibDeflateWrite="zlibDeflateWrite",k.zlibDeflateFlushFired="zlibDeflateFlushFired",k.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",k.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",k.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",k.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",k.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",k.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",k.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",k.ProtocolHeaderRead="protocolHeaderRead",k.ProtocolMessageRead="protocolMessageRead",k.ProtocolHeaderWrite="protocolHeaderWrite",k.ProtocolMessageWrite="protocolMessageWrite",k.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var v;(function(k){k.enableDiagnostics=!1,k.records=[];const O=new WeakMap;let B=0;function q(de,ue){if(!O.has(de)){const ae=String(++B);O.set(de,ae)}return O.get(de)}function le(de,ue,ae,_){if(!k.enableDiagnostics)return;const ee=q(de,ue);if(_ instanceof R.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const ne=R.VSBuffer.alloc(_.byteLength);ne.set(_),k.records.push({timestamp:Date.now(),id:ee,label:ue,type:ae,buff:ne})}else k.records.push({timestamp:Date.now(),id:ee,label:ue,type:ae,data:_})}k.traceSocketEvent=le})(v=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(k){k[k.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",k[k.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function I(){return T||(T=R.VSBuffer.alloc(0)),T}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,B){if(O===0)return I();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ue=this.a[0];return B&&(this.a.shift(),this.b-=O),ue}if(this.a[0].byteLength>O){const ue=this.a[0].slice(0,O);return B&&(this.a[0]=this.a[0].slice(O),this.b-=O),ue}const q=R.VSBuffer.alloc(O);let le=0,de=0;for(;O>0;){const ue=this.a[de];if(ue.byteLength>O){const ae=ue.slice(0,O);q.set(ae,le),le+=O,B&&(this.a[de]=ue.slice(O),this.b-=O),O-=O}else q.set(ue,le),le+=ue.byteLength,B?(this.a.shift(),this.b-=ue.byteLength):de++,O-=ue.byteLength}return q}}e.ChunkStream=y;var m;(function(k){k[k.None=0]="None",k[k.Regular=1]="Regular",k[k.Control=2]="Control",k[k.Ack=3]="Ack",k[k.Disconnect=5]="Disconnect",k[k.ReplayRequest=6]="ReplayRequest",k[k.Pause=7]="Pause",k[k.Resume=8]="Resume",k[k.KeepAlive=9]="KeepAlive",k[k.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",k[k.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(m||(m={}));function p(k){switch(k){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(k){k[k.HeaderLength=13]="HeaderLength",k[k.AcknowledgeTime=2e3]="AcknowledgeTime",k[k.TimeoutTime=2e4]="TimeoutTime",k[k.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",k[k.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",k[k.KeepAliveSendTime=5e3]="KeepAliveSendTime",k[k.LatencySampleTime=6e4]="LatencySampleTime",k[k.LatencySampleCount=5]="LatencySampleCount",k[k.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",k[k.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(O,B,q,le){this.type=O,this.id=B,this.ack=q,this.data=le,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends D.Disposable{constructor(O){super(),this.f=this.B(new o.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new y,this.B(this.a.onData(B=>this.acceptChunk(B))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const B=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=B.readUInt32BE(9),this.g.messageType=B.readUInt8(0),this.g.id=B.readUInt32BE(1),this.g.ack=B.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const q=this.g.messageType,le=this.g.id,de=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",B),this.f.fire(new a(q,le,de,B)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const B=R.VSBuffer.alloc(13);B.writeUInt8(O.type,0),B.writeUInt32BE(O.id,1),B.writeUInt32BE(O.ack,5),B.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(B,O.data)}g(O,B){const q=this.f===0;return this.d.push(O,B),this.f+=O.byteLength+B.byteLength,q}h(){const O=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,B){this.g(O,B)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class d extends D.Disposable{constructor(O){super(),this.f=new o.Emitter,this.onMessage=this.f.event,this.g=new o.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new h(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(B=>{B.type===1&&this.f.fire(B.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new a(1,0,0,O))}}e.Protocol=d;class S extends C.IPCClient{static fromSocket(O,B){return new S(new d(O),B)}get onDidDispose(){return this.b.onDidDispose}constructor(O,B,q=null){super(O,B,q),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=S;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class t{constructor(O){this.data=O,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let O=0,B=this.a;for(;B;)B=B.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let B=0,q=this.a;for(;q;)O[B++]=q.data,q=q.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const B=new t(O);if(!this.a){this.a=B,this.b=B;return}this.b.next=B,this.b=B}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const O=Date.now();for(let B=0;B<r.a;B++)this.c[B]=O-1e3*B;setInterval(()=>{for(let B=r.a;B>=1;B--)this.c[B]=this.c[B-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),B=(1+r.a)*1e3;let q=0;for(let le=0;le<r.a;le++)O-this.c[le]<=B&&q++;return 1-q/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var i;(function(k){k[k.Good=0]="Good",k[k.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function l(k){switch(k){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class c{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=c;class s{constructor(O,B){this.roundTripTime=O,this.recentHighRoundTripCount=B}}e.HighRoundTripTimeEvent=s;class u{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??r.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new D.DisposableStore,this.o=O.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(B=>this.E(B))),this.t.add(this.o.onClose(B=>this.A.fire(B))),this.r=this.t.add(new E),this.t.add(this.r.onSendLatencyRequest(B=>this.J(B))),this.t.add(this.r.onHighRoundTripTime(B=>this.C.fire(B))),this.t.add(this.r.onDidChangeConnectionHealth(B=>this.D.fire(B))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new a(5,0,0,I());this.p.write(O),this.p.flush()}sendPause(){const O=new a(7,0,0,I());this.p.write(O)}sendResume(){const O=new a(8,0,0,I());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,B){this.a=!0,this.t.dispose(),this.t=new D.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(q=>this.E(q))),this.t.add(this.o.onClose(q=>this.A.fire(q))),this.r=this.t.add(new E),this.t.add(this.r.onSendLatencyRequest(q=>this.J(q))),this.t.add(this.r.onHighRoundTripTime(q=>this.C.fire(q))),this.t.add(this.r.onDidChangeConnectionHealth(q=>this.D.fire(q))),this.q.acceptChunk(B)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new a(3,0,this.h,I());this.p.write(O);const B=this.b.toArray();for(let q=0,le=B.length;q<le;q++)this.p.write(B[q]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const B=this.b.peek();if(B&&B.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const B=Date.now();B-this.m>1e4&&(this.m=B,this.p.write(new a(6,0,0,I())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const B=this.b.toArray();for(let q=0,le=B.length;q<le;q++)this.p.write(B[q]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const B=++this.c;this.h=this.g;const q=new a(1,B,this.h,O);this.b.push(q),this.a||(this.p.write(q),this.G())}sendControl(O){const B=new a(2,0,0,O);this.p.write(B)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),B=Date.now()-O.writtenTime,q=Date.now()-this.q.lastReadTime,le=Date.now()-this.n;if(B>=2e4&&q>=2e4&&le>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:B,timeSinceLastReceivedSomeData:q});return}const de=Math.max(2e4-B,2e4-q,2e4-le,500);this.f=setTimeout(()=>{this.f=null,this.G()},de)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new a(3,0,this.h,I());this.p.write(O)}I(){this.h=this.g;const O=new a(9,0,this.h,I());this.p.write(O)}J(O){this.h=this.g;const B=new a(10,0,this.h,O);this.p.write(B)}K(O){this.h=this.g;const B=new a(11,0,this.h,O);this.p.write(B)}}e.PersistentProtocol=u;class E extends D.Disposable{constructor(){super(),this.a=this.B(new o.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new o.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new o.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new w.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,B=R.VSBuffer.alloc(4);B.writeUInt32BE(O,0),this.a.fire(B)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const B=O.readUInt32BE(0);if(this.g<=0||B!==this.h)return;const q=Date.now()-this.g,le=this.k++;this.j[le%this.j.length]=q;const de=this.l,ue=this.j.filter(ae=>ae>=1e3).length;this.l=ue>=3?1:0,q>1e3&&this.b.fire(new s(q,ue)),de!==this.l&&this.c.fire(this.l)}}}),define(pe[103],ve([1,0,50,14,15,20,160,11,6,2,21,100,58,42]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends m.ChannelServer{constructor(f){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",h=>o.VSBuffer.wrap(Buffer.from(h,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=p;class b{constructor(f,h){this.i=f,this.j=h,this.c=new Set,this.g=new Map,this.h=new v.Emitter,this.onDidProcessExit=this.h.event;const d=h&&h.timeout?h.timeout:6e4;this.b=new R.Delayer(d),this.d=null,this.f=null}getChannel(f){const h=this;return{call(d,S,L){return h.k(f,d,S,L)},listen(d,S){return h.l(f,d,S)}}}k(f,h,d,S=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(A.canceled());this.b.cancel();const L=this.n(f),t=(0,R.createCancelablePromise)(i=>L.call(h,d,i)),n=S.onCancellationRequested(()=>t.cancel()),r=(0,g.toDisposable)(()=>t.cancel());return this.c.add(r),t.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,h,d){if(!this.b)return v.Event.None;this.b.cancel();let S;const L=new v.Emitter({onWillAddFirstListener:()=>{S=this.n(f).listen(h,d)(L.fire,L),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(h.env),this.d=(0,w.fork)(this.i,f,h);const d=new v.Emitter;v.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,C.isRemoteConsoleLog)(l)){(0,C.log)(l,`IPC Library: ${this.j.serverName}`);return}d.fire(o.VSBuffer.wrap(Buffer.from(l,"base64")))});const L=this.j.useQueue?(0,I.createQueuedSender)(this.d):this.d,t=l=>this.d&&this.d.connected&&L.send(l.buffer.toString("base64")),n=d.event,r={send:t,onMessage:n};this.f=new m.ChannelClient(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,c)=>{process.removeListener("exit",i),this.c.forEach(s=>(0,g.dispose)(s)),this.c.clear(),l!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:c})})}return this.f}n(f){let h=this.g.get(f);return h||(h=this.m.getChannel(f),this.g.set(f,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(pe[62],ve([1,0,15,11,6,2,7,3,22,42,102]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(s,u){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,u)}constructor(s,u=""){this.f=!0,this.debugLabel=u,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,R.onUnexpectedError)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const u=E=>{this.traceSocketEvent("read",E),s(w.VSBuffer.wrap(E))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(s){const u=E=>{s({type:0,hadError:E,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(s){const u=()=>{s()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,R.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,R.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=y;var m;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize",c[c.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var p;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(p||(p={}));class b extends D.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,u){this.socket.traceSocketEvent(s,u)}constructor(s,u,E,k){super(),this.f=this.B(new o.Emitter),this.g=this.B(new o.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:E?.byteLength||0,recordInflateBytes:k}),this.a=this.B(new a(this,u,E,k,this.f,(O,B)=>this.k(O,B))),this.B(this.a.onError(O=>{console.error(O),(0,R.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new T.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await o.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){let u=0;for(;u<s.byteLength;)this.a.writeMessage(s.slice(u,Math.min(u+262144,s.byteLength))),u+=262144}k(s,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let E=2;s.byteLength<126?E+=0:s.byteLength<2**16?E+=2:E+=8;const k=w.VSBuffer.alloc(E);if(u?k.writeUInt8(194,0):k.writeUInt8(130,0),s.byteLength<126)k.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){k.writeUInt8(126,1);let O=1;k.writeUInt8(s.byteLength>>>8&255,++O),k.writeUInt8(s.byteLength>>>0&255,++O)}else{k.writeUInt8(127,1);let O=1;k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(s.byteLength>>>24&255,++O),k.writeUInt8(s.byteLength>>>16&255,++O),k.writeUInt8(s.byteLength>>>8&255,++O),k.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(w.VSBuffer.concat([k,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),E=u.readUInt8(0),k=(E&128)>>>7,O=(E&64)>>>6,B=u.readUInt8(1),q=(B&128)>>>7,le=B&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=k,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(k),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),E=u.readUInt8(1),k=(E&128)>>>7;let O=E&127,B=1;O===126?O=u.readUInt8(++B)*2**8+u.readUInt8(++B):O===127&&(O=u.readUInt8(++B)*0+u.readUInt8(++B)*0+u.readUInt8(++B)*0+u.readUInt8(++B)*0+u.readUInt8(++B)*2**24+u.readUInt8(++B)*2**16+u.readUInt8(++B)*2**8+u.readUInt8(++B));let q=0;k&&(q=u.readUInt8(++B)*2**24+u.readUInt8(++B)*2**16+u.readUInt8(++B)*2**8+u.readUInt8(++B)),this.j.state=3,this.j.readLen=O,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),d(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await o.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class a extends D.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:w.VSBuffer.alloc(0)}constructor(s,u,E,k,O,B){super(),this.l=s,this.m=O,this.n=B,this.a=this.B(new o.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new o.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new o.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,u?(this.b=this.B(new f(this.l,k,E,{windowBits:15})),this.f=this.B(new h(this.l,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const u=await this.s(this.f,s);this.n(u,!0)}else this.n(s,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(s,u){return new Promise((E,k)=>{s.write(u),s.flush(O=>E(O))})}acceptFrame(s,u,E){this.h.push({data:s,isCompressed:u,isLastFrameOfMessage:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const u=await this.w(this.b,s.data,s.isLastFrameOfMessage);this.m.fire(u)}else this.m.fire(s.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(s,u,E){return new Promise((k,O)=>{s.write(u),E&&s.write(w.VSBuffer.fromByteArray([0,0,255,255])),s.flush(B=>k(B))})}}class f extends D.Disposable{get recordedInflateBytes(){return this.j?w.VSBuffer.concat(this.f):w.VSBuffer.alloc(0)}constructor(s,u,E,k){super(),this.h=s,this.j=u,this.a=this.B(new o.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=I().zlib.createInflateRaw(k),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(w.VSBuffer.wrap(O))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=w.VSBuffer.concat(this.g);this.g.length=0,s(u)})}}class h extends D.Disposable{constructor(s,u){super(),this.g=s,this.a=this.B(new o.Emitter),this.onError=this.a.event,this.f=[],this.b=I().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(w.VSBuffer.wrap(E))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=w.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),s(u)})}}function d(c,s){if(s===0)return;const u=c.byteLength>>>2;for(let le=0;le<u;le++){const de=c.readUInt32BE(le*4);c.writeUInt32BE(de^s,le*4)}const E=u*4,k=c.byteLength-E,O=s>>>24&255,B=s>>>16&255,q=s>>>8&255;k>=1&&c.writeUInt8(c.readUInt8(E)^O,E),k>=2&&c.writeUInt8(c.readUInt8(E+1)^B,E+1),k>=3&&c.writeUInt8(c.readUInt8(E+2)^q,E+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function L(){const c=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;const s=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:I().os.tmpdir(),u=(0,C.join)(s,`vscode-ipc-${c}.sock`);return n(u),u}e.createRandomIPCHandle=L;function t(c,s,u){const E=I().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${u}-${s}-sock`;const k=u.substr(0,4),O=s.substr(0,6),B=E.substr(0,8);let q;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${B}-${k}-${O}.sock`):q=(0,C.join)(c,`${k}-${O}.sock`),n(q),q}e.createStaticIPCHandle=t;function n(c){const s=S[A.platform];typeof s=="number"&&c.length>=s&&console.warn(`WARNING: IPC handle "${c}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends g.IPCServer{static b(s){const u=o.Event.fromNodeEventEmitter(s,"connection");return o.Event.map(u,E=>({protocol:new T.Protocol(new y(E,"ipc-server-connection")),onDidClientDisconnect:o.Event.once(o.Event.fromNodeEventEmitter(E,"close"))}))}constructor(s){super(r.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function i(c){return new Promise((s,u)=>{const E=I().net.createServer();E.on("error",u),E.listen(c,()=>{E.removeListener("error",u),s(new r(E))})})}e.serve=i;function l(c,s){return new Promise((u,E)=>{const k=I().net.createConnection(c,()=>{k.removeListener("error",E),u(T.Client.fromSocket(new y(k,`ipc-client${s}`),s))});k.once("error",E)})}e.connect=l}),define(pe[164],ve([1,0,14,6,2,8]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",I[I.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function A(I){const y=I;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=A;var v;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class g extends o.Disposable{constructor(y,m=Object.create(null)){super(),this.m=y,this.n=m,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=new w.ThrottledDelayer(g.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((m,p)=>this.s(p,m)),y.deleted?.forEach(m=>this.s(m,void 0))}s(y,m){if(this.c===v.Closed)return;let p=!1;(0,D.isUndefinedOrNull)(m)?p=this.f.delete(y):this.f.get(y)!==m&&(this.f.set(y,m),p=!0),p&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,m){const p=this.f.get(y);return(0,D.isUndefinedOrNull)(p)?m:p}getBoolean(y,m){const p=this.get(y);return(0,D.isUndefinedOrNull)(p)?m:p==="true"}getNumber(y,m){const p=this.get(y);return(0,D.isUndefinedOrNull)(p)?m:parseInt(p,10)}async set(y,m){if(this.c===v.Closed)return;if((0,D.isUndefinedOrNull)(m))return this.delete(y);const p=String(m);if(this.f.get(y)!==p)return this.f.set(y,p),this.j.set(y,p),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===v.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=v.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}g.a=100,e.Storage=g;class T{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((m,p)=>this.a.set(p,m)),y.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.InMemoryStorageDatabase=T}),define(pe[165],ve([1,0,6,2]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class o{constructor(){this.a=new Map,this.b=new Map,this.c=new w.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,v){return this.a.set(A,v),this.handleChange([A]),(0,R.toDisposable)(()=>{this.a.get(A)===v&&(this.a.delete(A),this.handleChange([A]))})}get(A){return this.a.get(A)||null}registerFactory(A,v){this.b.get(A)?.dispose();const g=new D(this,A,v);return this.b.set(A,g),(0,R.toDisposable)(()=>{const T=this.b.get(A);!T||T!==g||(this.b.delete(A),T.dispose())})}async getOrCreate(A){const v=this.get(A);if(v)return v;const g=this.b.get(A);return!g||g.isResolved?null:(await g.resolve(),this.get(A))}isResolved(A){if(this.get(A))return!0;const g=this.b.get(A);return!!(!g||g.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=o;class D extends R.Disposable{get isResolved(){return this.c}constructor(A,v,g){super(),this.f=A,this.g=v,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await this.h.tokenizationSupport;this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(pe[166],ve([1,0,47,4,48,165]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(k,O,B){this.offset=k,this.type=O,this.language=B,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class A{constructor(k,O){this.tokens=k,this.endState=O,this._tokenizationResultBrand=void 0}}e.TokenizationResult=A;class v{constructor(k,O){this.tokens=k,this.endState=O,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=v;var g;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(E){const k=new Map;k.set(0,w.Codicon.symbolMethod),k.set(1,w.Codicon.symbolFunction),k.set(2,w.Codicon.symbolConstructor),k.set(3,w.Codicon.symbolField),k.set(4,w.Codicon.symbolVariable),k.set(5,w.Codicon.symbolClass),k.set(6,w.Codicon.symbolStruct),k.set(7,w.Codicon.symbolInterface),k.set(8,w.Codicon.symbolModule),k.set(9,w.Codicon.symbolProperty),k.set(10,w.Codicon.symbolEvent),k.set(11,w.Codicon.symbolOperator),k.set(12,w.Codicon.symbolUnit),k.set(13,w.Codicon.symbolValue),k.set(15,w.Codicon.symbolEnum),k.set(14,w.Codicon.symbolConstant),k.set(15,w.Codicon.symbolEnum),k.set(16,w.Codicon.symbolEnumMember),k.set(17,w.Codicon.symbolKeyword),k.set(27,w.Codicon.symbolSnippet),k.set(18,w.Codicon.symbolText),k.set(19,w.Codicon.symbolColor),k.set(20,w.Codicon.symbolFile),k.set(21,w.Codicon.symbolReference),k.set(22,w.Codicon.symbolCustomColor),k.set(23,w.Codicon.symbolFolder),k.set(24,w.Codicon.symbolTypeParameter),k.set(25,w.Codicon.account),k.set(26,w.Codicon.issues);function O(le){let de=k.get(le);return de||(console.info("No codicon found for CompletionItemKind "+le),de=w.Codicon.symbolProperty),de}E.toIcon=O;const B=new Map;B.set("method",0),B.set("function",1),B.set("constructor",2),B.set("field",3),B.set("variable",4),B.set("class",5),B.set("struct",6),B.set("interface",7),B.set("module",8),B.set("property",9),B.set("event",10),B.set("operator",11),B.set("unit",12),B.set("value",13),B.set("constant",14),B.set("enum",15),B.set("enum-member",16),B.set("enumMember",16),B.set("keyword",17),B.set("snippet",27),B.set("text",18),B.set("color",19),B.set("file",20),B.set("reference",21),B.set("customcolor",22),B.set("folder",23),B.set("type-parameter",24),B.set("typeParameter",24),B.set("account",25),B.set("issue",26);function q(le,de){let ue=B.get(le);return typeof ue>"u"&&!de&&(ue=9),ue}E.fromString=q})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(E){E[E.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var y;(function(E){E[E.None=0]="None",E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(y=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var p;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(p=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function h(E){return E&&R.URI.isUri(E.uri)&&o.Range.isIRange(E.range)&&(o.Range.isIRange(E.originSelectionRange)||o.Range.isIRange(E.targetSelectionRange))}e.isLocationLink=h;var d;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(d=e.SymbolKind||(e.SymbolKind={}));var S;(function(E){E[E.Deprecated=1]="Deprecated"})(S=e.SymbolTag||(e.SymbolTag={}));var L;(function(E){const k=new Map;k.set(0,w.Codicon.symbolFile),k.set(1,w.Codicon.symbolModule),k.set(2,w.Codicon.symbolNamespace),k.set(3,w.Codicon.symbolPackage),k.set(4,w.Codicon.symbolClass),k.set(5,w.Codicon.symbolMethod),k.set(6,w.Codicon.symbolProperty),k.set(7,w.Codicon.symbolField),k.set(8,w.Codicon.symbolConstructor),k.set(9,w.Codicon.symbolEnum),k.set(10,w.Codicon.symbolInterface),k.set(11,w.Codicon.symbolFunction),k.set(12,w.Codicon.symbolVariable),k.set(13,w.Codicon.symbolConstant),k.set(14,w.Codicon.symbolString),k.set(15,w.Codicon.symbolNumber),k.set(16,w.Codicon.symbolBoolean),k.set(17,w.Codicon.symbolArray),k.set(18,w.Codicon.symbolObject),k.set(19,w.Codicon.symbolKey),k.set(20,w.Codicon.symbolNull),k.set(21,w.Codicon.symbolEnumMember),k.set(22,w.Codicon.symbolStruct),k.set(23,w.Codicon.symbolEvent),k.set(24,w.Codicon.symbolOperator),k.set(25,w.Codicon.symbolTypeParameter);function O(B){let q=k.get(B);return q||(console.info("No codicon found for SymbolKind "+B),q=w.Codicon.symbolProperty),q}E.toIcon=O})(L=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(k){switch(k){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(k)}constructor(k){this.value=k}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var n;(function(E){function k(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}E.is=k})(n=e.Command||(e.Command={}));var r;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(E){E[E.Unresolved=0]="Unresolved",E[E.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(E){E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={}));class s{constructor(k){this.b=k,this.a=null}dispose(){this.a&&this.a.then(k=>{k&&k.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=s,e.TokenizationRegistry=new D.TokenizationRegistry;var u;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(u=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[167],ve([9,10]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(pe[168],ve([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[169],ve([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[170],ve([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(pe[171],ve([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(pe[172],ve([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(pe[173],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[174],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[175],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[176],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[177],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[178],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[179],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[180],ve([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[181],ve([9,10]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(pe[182],ve([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(pe[183],ve([9,10]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(pe[184],ve([9,10]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[185],ve([9,10]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[186],ve([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(pe[187],ve([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(pe[188],ve([9,10]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(pe[189],ve([9,10]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[190],ve([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[191],ve([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[192],ve([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[193],ve([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(pe[194],ve([9,10]),function(oe,e){return oe.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[195],ve([9,10]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(pe[196],ve([9,10]),function(oe,e){return oe.create("vs/server/node/serverServices",e)}),define(pe[197],ve([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[198],ve([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(pe[199],ve([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[200],ve([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[201],ve([1,0,11,170]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var o;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(o=e.TokenType||(e.TokenType={}));function D(...g){switch(g.length){case 1:return(0,R.localize)(0,null,g[0]);case 2:return(0,R.localize)(1,null,g[0],g[1]);case 3:return(0,R.localize)(2,null,g[0],g[1],g[2]);default:return}}const C=(0,R.localize)(3,null),A=(0,R.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const I=this.d,y=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:y};this.g.push({offset:I,lexeme:y,additionalInfo:T}),this.f.push(m)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const I=this.c.substring(this.d,this.e),y=v.b.get(I);y?this.k(y):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,I=!1,y=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(A);return}const p=this.c.charCodeAt(T);if(I)I=!1;else if(p===47&&!y){T++;break}else p===91?y=!0:p===92?I=!0:p===93&&(y=!1);T++}for(;T<this.c.length&&v.a.has(this.c.charCodeAt(T));)T++;this.e=T;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}v.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=v}),define(pe[202],ve([1,0,6,2]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class o{constructor(){this.a=new w.Emitter,this.b=new w.Emitter,this.c=new w.Emitter,this.d=new w.Emitter}call(A,v,g){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(A,v,g){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}o.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=o;class D extends R.Disposable{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,v,g){this.b.call("attach",[A,v,g])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,v){this.b.call("terminate",[A,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,v){return this.b.call("openExtensionDevelopmentHostWindow",[A,v])}}e.ExtensionHostDebugChannelClient=D}),define(pe[203],ve([1,0,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class R{constructor(C){this.a=C}listen(C,A,v){throw new Error("Invalid listen")}call(C,A,v){switch(A){case"download":return this.a.download(w.URI.revive(v[0]),w.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=R;class o{constructor(C,A){this.a=C,this.b=A}async download(C,A){const v=this.b();v&&(C=v.transformOutgoingURI(C),A=v.transformOutgoingURI(A)),await this.a.call("download",[C,A])}}e.DownloadServiceChannelClient=o}),define(pe[204],ve([1,0,151,89,13,7,28,19,4]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,D.dirname)(o.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,A.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",m)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(v.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=C.env.VSCODE_PORTABLE;return m?v.URI.file((0,D.join)(m,"argv.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.resolve)(m):(0,D.normalize)((0,D.join)(o.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?v.URI.file((0,D.resolve)(m)):v.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.resolve)(m);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const b=C.env.VSCODE_PORTABLE;return b?(0,D.join)(b,"extensions"):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(p=>/^[^:/?#]+?:\/\//.test(p)?v.URI.parse(p):v.URI.file((0,D.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?v.URI.parse(m):v.URI.file((0,D.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const p of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);b&&b[1]&&b[2]&&m.push([b[1],b[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,A.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=C.env.VSCODE_PORTABLE;return m?v.URI.file((0,D.join)(m,"policy.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,p,b){this.a=m,this.b=p,this.c=b,this.editSessionId=this.args.editSessionId}}Le([R.memoize],g.prototype,"appRoot",null),Le([R.memoize],g.prototype,"userHome",null),Le([R.memoize],g.prototype,"userDataPath",null),Le([R.memoize],g.prototype,"appSettingsHome",null),Le([R.memoize],g.prototype,"tmpDir",null),Le([R.memoize],g.prototype,"cacheHome",null),Le([R.memoize],g.prototype,"stateResource",null),Le([R.memoize],g.prototype,"userRoamingDataHome",null),Le([R.memoize],g.prototype,"userDataSyncHome",null),Le([R.memoize],g.prototype,"sync",null),Le([R.memoize],g.prototype,"machineSettingsResource",null),Le([R.memoize],g.prototype,"workspaceStorageHome",null),Le([R.memoize],g.prototype,"localHistoryHome",null),Le([R.memoize],g.prototype,"keyboardLayoutResource",null),Le([R.memoize],g.prototype,"argvResource",null),Le([R.memoize],g.prototype,"isExtensionDevelopment",null),Le([R.memoize],g.prototype,"untitledWorkspacesHome",null),Le([R.memoize],g.prototype,"builtinExtensionsPath",null),Le([R.memoize],g.prototype,"extensionsPath",null),Le([R.memoize],g.prototype,"extensionDevelopmentLocationURI",null),Le([R.memoize],g.prototype,"extensionDevelopmentKind",null),Le([R.memoize],g.prototype,"extensionTestsLocationURI",null),Le([R.memoize],g.prototype,"debugExtensionHost",null),Le([R.memoize],g.prototype,"logLevel",null),Le([R.memoize],g.prototype,"extensionLogLevel",null),Le([R.memoize],g.prototype,"serviceMachineIdResource",null),Le([R.memoize],g.prototype,"disableTelemetry",null),Le([R.memoize],g.prototype,"disableWorkspaceTrust",null),Le([R.memoize],g.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=g;function T(y,m){return I(y["inspect-extensions"],y["inspect-brk-extensions"],5870,m,y.debugId,y.extensionEnvironment)}e.parseExtensionHostDebugPort=T;function I(y,m,p,b,a,f){const d=Number(m||y)||(b?null:p),S=d?Boolean(!!m):!1;let L;if(f)try{L=JSON.parse(f)}catch{}return{port:d,break:S,debugId:a,env:L}}e.parseDebugParams=I}),define(pe[63],ve([1,0,291,3,171]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,o.localize)(0,null),e:(0,o.localize)(1,null),t:(0,o.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,o.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,o.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,o.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,o.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,o.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,o.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,o.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,o.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,o.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,o.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,o.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,o.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,o.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,o.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,o.localize)(17,null)},category:{type:"string",cat:"e",description:(0,o.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,o.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,o.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,o.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,o.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,o.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,o.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,o.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,o.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,o.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,o.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,o.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,o.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,o.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,o.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,o.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,o.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,o.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(b,a,f=C){const h=b.find(c=>c.length>0&&c[0]!=="-"),d={},S=["_"],L=[],t={};let n;for(const c in a){const s=a[c];s.type==="subcommand"?c===h&&(n=s):(s.alias&&(d[c]=s.alias),s.type==="string"||s.type==="string[]"?(S.push(c),s.deprecates&&S.push(...s.deprecates)):s.type==="boolean"&&(L.push(c),s.deprecates&&L.push(...s.deprecates)),s.global&&(t[c]=s))}if(n&&h){const c=t;for(const k in n.options)c[k]=n.options[k];const s=b.filter(k=>k!==h),u=f.getSubcommandReporter?f.getSubcommandReporter(h):void 0,E=A(s,c,u);return{[h]:E,_:[]}}const r=w(b,{string:S,boolean:L,alias:d}),i={},l=r;i._=r._.map(c=>String(c)).filter(c=>c.length>0),delete l._;for(const c in a){const s=a[c];if(s.type==="subcommand")continue;s.alias&&delete l[s.alias];let u=l[c];if(s.deprecates)for(const E of s.deprecates)l.hasOwnProperty(E)&&(u||(u=l[E],u&&f.onDeprecatedOption(E,s.deprecationMessage||(0,o.localize)(36,null,c))),delete l[E]);if(typeof u<"u"){if(s.type==="string[]"){if(Array.isArray(u)||(u=[u]),!s.allowEmptyValue){const E=u.filter(k=>k.length>0);E.length!==u.length&&(f.onEmptyValue(c),u=E.length>0?E:void 0)}}else s.type==="string"&&(Array.isArray(u)?(u=u.pop(),f.onMultipleValues(c,u)):!u&&!s.allowEmptyValue&&(f.onEmptyValue(c),u=void 0));i[c]=u,s.deprecationMessage&&f.onDeprecatedOption(c,s.deprecationMessage)}delete l[c]}for(const c in l)f.onUnknownOption(c);return i}e.parseArgs=A;function v(b,a){let f="";return a.args&&(Array.isArray(a.args)?f=` <${a.args.join("> <")}>`:f=` <${a.args}>`),a.alias?`-${a.alias} --${b}${f}`:`--${b}${f}`}function g(b,a){const f=[];for(const h in b){const d=b[h],S=v(h,d);f.push([S,d.description])}return T(f,a)}e.formatOptions=g;function T(b,a){const h=b.reduce((L,t)=>Math.max(L,t[0].length),12)+2+1;if(a-h<25)return b.reduce((L,t)=>L.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=a-h-1,S=[];for(const L of b){const t=L[0],n=y(L[1],d),r=I(h-t.length-2);S.push("  "+t+r+n[0]);for(let i=1;i<n.length;i++)S.push(I(h)+n[i])}return S}function I(b){return" ".repeat(b)}function y(b,a){const f=[];for(;b.length;){const h=b.length<a?b.length:b.lastIndexOf(" ",a),d=b.slice(0,h).trim();b=b.slice(h),f.push(d)}return f}function m(b,a,f,h,d){const S=process.stdout.isTTY&&process.stdout.columns||80,L=d?.noInputFiles!==!0?`[${(0,o.localize)(37,null)}...]`:"",t=[`${b} ${f}`];t.push(""),t.push(`${(0,o.localize)(38,null)}: ${a} [${(0,o.localize)(39,null)}]${L}`),t.push(""),d?.noPipe!==!0&&(R.isWindows?t.push((0,o.localize)(40,null,a)):t.push((0,o.localize)(41,null,a)),t.push(""));const n={},r=[];for(const i in h){const l=h[i];if(l.type==="subcommand")l.description&&r.push({command:i,description:l.description});else if(l.description&&l.cat){let c=n[l.cat];c||(n[l.cat]=c={}),c[i]=l}}for(const i in n){const l=i,c=n[l];c&&(t.push(D[l]),t.push(...g(c,S)),t.push(""))}return r.length&&(t.push((0,o.localize)(42,null)),t.push(...T(r.map(i=>[i.command,i.description]),S)),t.push("")),t.join(`
`)}e.buildHelpMessage=m;function p(b,a){return`${b||(0,o.localize)(43,null)}
${a||(0,o.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(pe[205],ve([1,0,292,172,63]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function C(y,m){const p=(S,L)=>{console.warn((0,R.localize)(0,null,S,L))},b=S=>{console.warn((0,R.localize)(1,null,S))},a=(S,L)=>{console.warn((0,R.localize)(2,null,S,L))},f=S=>({onUnknownOption:L=>{S!=="tunnel"&&console.warn((0,R.localize)(3,null,L,S))},onMultipleValues:p,onEmptyValue:b,onDeprecatedOption:a,getSubcommandReporter:S!=="tunnel"?f:void 0}),h={onUnknownOption:S=>{console.warn((0,R.localize)(4,null,S))},onMultipleValues:p,onEmptyValue:b,onDeprecatedOption:a,getSubcommandReporter:f},d=(0,o.parseArgs)(y,o.OPTIONS,m?h:void 0);return d.goto&&d._.forEach(S=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,R.localize)(5,null))),d["max-memory"]&&w(parseInt(d["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),d}function A(y){const m=y.findIndex(p=>!/^-/.test(p));if(m>-1)return[...y.slice(0,m),...y.slice(m+1)]}function v(y){let[,...m]=y;process.env.VSCODE_DEV&&(m=A(m)||[]);const p=!I(process.env);return C(m,p)}e.parseMainProcessArgv=v;function g(y){let[,,...m]=y;return process.env.VSCODE_DEV&&(m=A(m)||[]),C(m,!0)}e.parseCLIProcessArgv=g;function T(y,...m){const p=y.indexOf("--");return p===-1?y.push(...m):y.splice(p,0,...m),y}e.addArg=T;function I(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function oe(e,w,R){function o(C,A){const v=D(C,A),g=[v];return e.isAbsolute(v)||g.unshift(R),e.resolve(...g)}function D(C,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,A);const T=C["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(I,"AppData","Roaming")}break;case"darwin":g=e.join(w.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,A)}return{getUserDataPath:o}}if(typeof define=="function")define(pe[206],ve([73,33,28]),function(e,w,R){return oe(e,w,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=oe(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[104],ve([1,0,33,204,206]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class D extends R.AbstractNativeEnvironmentService{constructor(g,T){super(g,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,o.getUserDataPath)(g,T.nameShort)},T)}}e.NativeEnvironmentService=D;function C(v,g){return(0,R.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,g,v.extensionEnvironment)}e.parsePtyHostDebugPort=C;function A(v,g){return(0,R.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,g,v.extensionEnvironment)}e.parseSharedProcessDebugPort=A}),define(pe[207],ve([1,0,8,176]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function o(C,A,v){try{D(C,A,v)}catch(g){console.error(g?.message??g)}return C}e.localizeManifest=o;function D(C,A,v){const g=(T,I,y)=>{const m=T[I];if((0,w.isString)(m)){const p=m,b=p.length;if(b>1&&p[0]==="%"&&p[b-1]==="%"){const a=p.substr(1,b-2);let f=A[a];f===void 0&&v&&(f=v[a]);const h=typeof f=="string"?f:f?.message,d=v?.[a],S=typeof d=="string"?d:d?.message;if(!h){S||console.warn(`[${C.name}]: ${(0,R.localize)(0,null,a)}`);return}if(y&&(I==="title"||I==="category")&&S&&S!==h){const L={value:h,original:S};T[I]=L}else T[I]=h}}else if((0,w.isObject)(m))for(const p in m)m.hasOwnProperty(p)&&(p==="commands"?g(m,p,!0):g(m,p,y));else if(Array.isArray(m))for(let p=0;p<m.length;p++)g(m,p,y)};for(const T in C)C.hasOwnProperty(T)&&g(C,T)}}),define(pe[76],ve([1,0,19,59,180,51]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function v(f){return f=f.trim(),f==="*"||C.test(f)}e.isValidVersionStr=v;function g(f){if(!v(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=f.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=g;function T(f){if(!f)return null;const h=f.majorBase,d=f.majorMustEqual,S=f.minorBase;let L=f.minorMustEqual;const t=f.patchBase;let n=f.patchMustEqual;f.hasCaret&&(h===0||(L=!1),n=!1);let r=0;if(f.preRelease){const i=A.exec(f.preRelease);if(i){const[,l,c,s]=i;r=Date.UTC(Number(l),Number(c)-1,Number(s))}}return{majorBase:h,majorMustEqual:d,minorBase:S,minorMustEqual:L,patchBase:t,patchMustEqual:n,isMinimum:f.hasGreaterEquals,notBefore:r}}e.normalizeVersion=T;function I(f,h,d){let S;typeof f=="string"?S=T(g(f)):S=f;let L;h instanceof Date?L=h.getTime():typeof h=="string"&&(L=new Date(h).getTime());let t;if(typeof d=="string"?t=T(g(d)):t=d,!S||!t)return!1;const n=S.majorBase,r=S.minorBase,i=S.patchBase;let l=t.majorBase,c=t.minorBase,s=t.patchBase;const u=t.notBefore;let E=t.majorMustEqual,k=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?n>l?!0:n<l?!1:r>c?!0:r<c||L&&L<u?!1:i>=s:(n===1&&l===0&&(!E||!k||!O)&&(l=1,c=0,s=0,E=!0,k=!1,O=!1),n<l?!1:n>l?!E:r<c?!1:r>c?!k:i<s?!1:i>s?!O:!(L&&L<u))}e.isValidVersion=I;function y(f,h,d,S,L){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([R.default.Error,o.localize(0,null)]),t;if(typeof S.name!="string")return t.push([R.default.Error,o.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([R.default.Error,o.localize(2,null,"version")]),t;if(!S.engines)return t.push([R.default.Error,o.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([R.default.Error,o.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!a(S.extensionDependencies))return t.push([R.default.Error,o.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!a(S.activationEvents))return t.push([R.default.Error,o.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([R.default.Error,o.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([R.default.Warning,o.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([R.default.Error,o.localize(9,null,"main")]),t;{const i=(0,w.joinPath)(d,S.main);(0,w.isEqualOrParent)(i,d)||t.push([R.default.Warning,o.localize(10,null,i.path,d.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([R.default.Error,o.localize(11,null,"browser")]),t;{const i=(0,w.joinPath)(d,S.browser);(0,w.isEqualOrParent)(i,d)||t.push([R.default.Warning,o.localize(12,null,i.path,d.path)])}}if(!D.valid(S.version))return t.push([R.default.Error,o.localize(13,null)]),t;const n=[];if(!m(f,h,S,L,n))for(const i of n)t.push([R.default.Error,i]);return t}e.validateExtensionManifest=y;function m(f,h,d,S,L){return S||typeof d.main>"u"&&typeof d.browser>"u"?!0:b(f,h,d.engines.vscode,L)}e.isValidExtensionVersion=m;function p(f,h,d){return f==="*"||b(h,d,f)}e.isEngineValid=p;function b(f,h,d,S=[]){const L=T(g(d));if(!L)return S.push(o.localize(14,null,d)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return S.push(o.localize(15,null,d)),!1}else if(!L.majorMustEqual)return S.push(o.localize(16,null,d)),!1;return I(f,h,L)?!0:(S.push(o.localize(17,null,f,d)),!1)}function a(f){if(!Array.isArray(f))return!1;for(let h=0,d=f.length;h<d;h++)if(typeof f[h]!="string")return!1;return!0}}),define(pe[208],ve([1,0,15,22]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function o(D,C,A){let v=A&&A.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const T=(await C.readFile(D.serviceMachineIdResource)).value.toString();v=(0,R.isUUID)(T)?T:null}catch{v=null}if(!v){v=(0,R.generateUuid)();try{await C.writeFile(D.serviceMachineIdResource,w.VSBuffer.fromString(v))}catch{}}return A?.store("storage.serviceMachineId",v,-1,1),v}e.getServiceMachineId=o}),define(pe[64],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(o,D=[],C=!1){this.ctor=o,this.staticArguments=D,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=w}),define(pe[209],ve([1,0,64]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var o;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(o=e.InstantiationType||(e.InstantiationType={}));function D(A,v,g){v instanceof w.SyncDescriptor||(v=new w.SyncDescriptor(v,[],Boolean(g))),R.push([A,v])}e.registerSingleton=D;function C(){return R}e.getSingletonServiceDescriptors=C}),define(pe[210],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(D,C){this.key=D,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class R{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const C of this.a.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const A=this.lookupOrInsertNode(D),v=this.lookupOrInsertNode(C);A.outgoing.set(v.key,v),v.incoming.set(A.key,A)}removeNode(D){const C=this.b(D);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(D){const C=this.b(D);let A=this.a.get(C);return A||(A=new w(C,D),this.a.set(C,A)),A}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[C,A]of this.a)D.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,C]of this.a){const A=new Set([D]),v=this.c(C,A);if(v)return v}}c(D,C){for(const[A,v]of D.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const g=this.c(v,C);if(g)return g;C.delete(A)}}}e.Graph=R}),define(pe[5],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(v){return v[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(w=e._util||(e._util={})),e.IInstantiationService=o("instantiationService");function R(C,A,v){A[w.DI_TARGET]===A?A[w.DI_DEPENDENCIES].push({id:C,index:v}):(A[w.DI_DEPENDENCIES]=[{id:C,index:v}],A[w.DI_TARGET]=A)}function o(C){if(w.serviceIds.has(C))return w.serviceIds.get(C);const A=function(v,g,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(A,v,T)};return A.toString=()=>C,w.serviceIds.set(C,A),A}e.createDecorator=o;function D(C){return C}e.refineServiceDecorator=D}),define(pe[25],ve([1,0,8,4,5]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,o.createDecorator)("configurationService");function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationOverrides=D;function C(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=C;var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=v;function g(a,f){const h=Object.create(null);for(const d in a)T(h,d,a[d],f);return h}e.toValuesTree=g;function T(a,f,h,d){const S=f.split("."),L=S.pop();let t=a;for(let n=0;n<S.length;n++){const r=S[n];let i=t[r];switch(typeof i){case"undefined":i=t[r]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[L]=h}catch{d(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(t)}`)}else d(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function I(a,f){const h=f.split(".");y(a,h)}e.removeFromValueTree=I;function y(a,f){const h=f.shift();if(f.length===0){delete a[h];return}if(Object.keys(a).indexOf(h)!==-1){const d=a[h];typeof d=="object"&&!Array.isArray(d)&&(y(d,f),Object.keys(d).length===0&&delete a[h])}}function m(a,f,h){function d(t,n){let r=t;for(const i of n){if(typeof r!="object"||r===null)return;r=r[i]}return r}const S=f.split("."),L=d(a,S);return typeof L>"u"?h:L}e.getConfigurationValue=m;function p(a,f,h){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in a?w.isObject(a[d])&&w.isObject(f[d])?p(a[d],f[d],h):h&&(a[d]=f[d]):a[d]=f[d])})}e.merge=p;function b(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(pe[65],ve([1,0,3,17,201,5,169,11]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",w.isMacintosh),v.set("isLinux",w.isLinux),v.set("isWindows",w.isWindows),v.set("isWeb",w.isWeb),v.set("isMacNative",w.isMacintosh&&!w.isWeb),v.set("isEdge",w.isEdge),v.set("isFirefox",w.isFirefox),v.set("isChrome",w.isChrome),v.set("isSafari",w.isSafari);function g(N,P){if(v.get(N)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(N,P)}e.setConstant=g;const T=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));const y={regexParsingWithErrorRecovery:!0},m=(0,C.localize)(0,null),p=(0,C.localize)(1,null),b=(0,C.localize)(2,null),a=(0,C.localize)(3,null),f=(0,C.localize)(4,null),h=(0,C.localize)(5,null),d=(0,C.localize)(6,null),S=(0,C.localize)(7,null);class L{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=y){this.k=P,this.d=new o.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const Y=this.D(),ie=Y.type===17?h:void 0;throw this.h.push({message:f,offset:Y.offset,lexeme:o.Scanner.getLexeme(Y),additionalInfo:ie}),L.c}return M}catch(M){if(M!==L.c)throw M;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const M=this.o();P.push(M)}return P.length===1?P[0]:t.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const M=this.s();P.push(M)}return P.length===1?P[0]:t.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,a),M?.negate()}case 17:return this.z(),B.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const M=this.l();return this.A(1,a),M}case 17:{const M=P.lexeme;if(this.z(),this.y(9)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==10)throw this.B("REGEX",ie);const z=ie.lexeme,V=z.lastIndexOf("/"),J=V===z.length-1?void 0:this.w(z.substring(V+1));let H;try{H=new RegExp(z.substring(1,V),J)}catch{throw this.B("REGEX",ie)}return _.create(M,H)}switch(ie.type){case 10:case 19:{const z=[ie.lexeme];this.z();let V=this.D(),J=0;for(let ce=0;ce<ie.lexeme.length;ce++)ie.lexeme.charCodeAt(ce)===40?J++:ie.lexeme.charCodeAt(ce)===41&&J--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let ce=0;ce<V.lexeme.length;ce++)V.lexeme.charCodeAt(ce)===40?J++:ie.lexeme.charCodeAt(ce)===41&&J--}if(J<0)break;z.push(o.Scanner.getLexeme(V)),this.z(),V=this.D()}const H=z.join(""),X=H.lastIndexOf("/"),G=X===H.length-1?void 0:this.w(H.substring(X+1));let Q;try{Q=new RegExp(H.substring(1,X),G)}catch{throw this.B("REGEX",ie)}return t.regex(M,Q)}case 18:{const z=ie.lexeme;this.z();let V=null;if(!(0,R.isFalsyOrWhitespace)(z)){const J=z.indexOf("/"),H=z.lastIndexOf("/");if(J!==H&&J>=0){const X=z.slice(J+1,H),G=z[H+1]==="i"?"i":"";try{V=new RegExp(X,G)}catch{throw this.B("REGEX",ie)}}}if(V===null)throw this.B("REGEX",ie);return _.create(M,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const ie=this.u();return t.notIn(M,ie)}switch(this.D().type){case 3:{this.z();const ie=this.u();if(this.x().type===18)return t.equals(M,ie);switch(ie){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,ie)}}case 4:{this.z();const ie=this.u();if(this.x().type===18)return t.notEquals(M,ie);switch(ie){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,ie)}}case 5:return this.z(),ue.create(M,this.u());case 6:return this.z(),ae.create(M,this.u());case 7:return this.z(),le.create(M,this.u());case 8:return this.z(),de.create(M,this.u());case 13:return this.z(),t.in(M,this.u());default:return t.has(M)}}case 20:throw this.h.push({message:d,offset:P.offset,lexeme:"",additionalInfo:S}),L.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,M){if(this.C(P))return this.z();throw this.B(M,this.D())}B(P,M,Y){const ie=(0,C.localize)(8,null,P,o.Scanner.getLexeme(M)),z=M.offset,V=o.Scanner.getLexeme(M);return this.h.push({message:ie,offset:z,lexeme:V,additionalInfo:Y}),L.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}L.c=new Error,e.Parser=L;class t{static false(){return l.INSTANCE}static true(){return c.INSTANCE}static has(P){return s.create(P)}static equals(P,M){return u.create(P,M)}static notEquals(P,M){return O.create(P,M)}static regex(P,M){return _.create(P,M)}static in(P,M){return E.create(P,M)}static notIn(P,M){return k.create(P,M)}static not(P){return B.create(P)}static and(...P){return te.create(P,null,!0)}static or(...P){return x.create(P,null,!0)}static greater(P,M){return le.create(P,M)}static greaterEquals(P,M){return de.create(P,M)}static smaller(P,M){return ue.create(P,M)}static smallerEquals(P,M){return ae.create(P,M)}static deserialize(P){return P==null?void 0:this.c.parse(P)}}t.c=new L({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function n(N){const P=new L({regexParsingWithErrorRecovery:!1});return N.map(M=>(P.parse(M),P.lexingErrors.length>0?P.lexingErrors.map(Y=>({errorMessage:Y.additionalInfo?(0,C.localize)(9,null,Y.additionalInfo):(0,C.localize)(10,null),offset:Y.offset,length:Y.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(Y=>({errorMessage:Y.additionalInfo?`${Y.message}. ${Y.additionalInfo}`:Y.message,offset:Y.offset,length:Y.lexeme.length})):[]))}e.validateWhenClauses=n;function r(N,P){const M=N?N.substituteConstants():void 0,Y=P?P.substituteConstants():void 0;return!M&&!Y?!0:!M||!Y?!1:M.equals(Y)}e.expressionsAreEqualWithConstantSubstitution=r;function i(N,P){return N.cmp(P)}class l{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return c.INSTANCE}}l.INSTANCE=new l,e.ContextKeyFalseExpr=l;class c{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return l.INSTANCE}}c.INSTANCE=new c,e.ContextKeyTrueExpr=c;class s{static create(P,M=null){const Y=v.get(P);return typeof Y=="boolean"?Y?c.INSTANCE:l.INSTANCE:new s(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:Z(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=v.get(this.key);return typeof P=="boolean"?P?c.INSTANCE:l.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=s;class u{static create(P,M,Y=null){if(typeof M=="boolean")return M?s.create(P,Y):B.create(P,Y);const ie=v.get(P);return typeof ie=="boolean"?M===(ie?"true":"false")?c.INSTANCE:l.INSTANCE:new u(P,M,Y)}constructor(P,M,Y){this.c=P,this.d=M,this.f=Y,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:re(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=v.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?c.INSTANCE:l.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class E{static create(P,M){return new E(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:re(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),Y=P.getValue(this.d);return Array.isArray(M)?M.includes(Y):typeof Y=="string"&&typeof M=="object"&&M!==null?T.call(M,Y):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=E;class k{static create(P,M){return new k(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=E.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=k;class O{static create(P,M,Y=null){if(typeof M=="boolean")return M?B.create(P,Y):s.create(P,Y);const ie=v.get(P);return typeof ie=="boolean"?M===(ie?"true":"false")?l.INSTANCE:c.INSTANCE:new O(P,M,Y)}constructor(P,M,Y){this.c=P,this.d=M,this.f=Y,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:re(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=v.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?l.INSTANCE:c.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=O;class B{static create(P,M=null){const Y=v.get(P);return typeof Y=="boolean"?Y?l.INSTANCE:c.INSTANCE:new B(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:Z(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=v.get(this.c);return typeof P=="boolean"?P?l.INSTANCE:c.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=s.create(this.c,this)),this.d}}e.ContextKeyNotExpr=B;function q(N,P){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?P(N):l.INSTANCE}class le{static create(P,M,Y=null){return q(M,ie=>new le(P,ie,Y))}constructor(P,M,Y){this.c=P,this.d=M,this.f=Y,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:re(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=le;class de{static create(P,M,Y=null){return q(M,ie=>new de(P,ie,Y))}constructor(P,M,Y){this.c=P,this.d=M,this.f=Y,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:re(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=de;class ue{static create(P,M,Y=null){return q(M,ie=>new ue(P,ie,Y))}constructor(P,M,Y){this.c=P,this.d=M,this.f=Y,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:re(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ue;class ae{static create(P,M,Y=null){return q(M,ie=>new ae(P,ie,Y))}constructor(P,M,Y){this.c=P,this.d=M,this.f=Y,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:re(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ae;class _{static create(P,M){return new _(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",Y=P.f?P.f.source:"";return M<Y?-1:M>Y?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",Y=P.f?P.f.source:"";return this.d===P.d&&M===Y}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.ContextKeyRegexExpr=_;class ee{static create(P){return new ee(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new ee(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=ee;function ne(N){let P=null;for(let M=0,Y=N.length;M<Y;M++){const ie=N[M].substituteConstants();if(N[M]!==ie&&P===null){P=[];for(let z=0;z<M;z++)P[z]=N[z]}P!==null&&(P[M]=ie)}return P===null?N:P}class te{static create(P,M,Y){return te.d(P,M,Y)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,Y=this.expr.length;M<Y;M++){const ie=i(this.expr[M],P.expr[M]);if(ie!==0)return ie}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,Y=this.expr.length;M<Y;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=ne(this.expr);return P===this.expr?this:te.create(P,this.c,!1)}evaluate(P){for(let M=0,Y=this.expr.length;M<Y;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,Y){const ie=[];let z=!1;for(const V of P)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return l.INSTANCE;if(V.type===6){ie.push(...V.expr);continue}ie.push(V)}if(ie.length===0&&z)return c.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(i);for(let V=1;V<ie.length;V++)ie[V-1].equals(ie[V])&&(ie.splice(V,1),V--);if(ie.length===1)return ie[0];for(;ie.length>1;){const V=ie[ie.length-1];if(V.type!==9)break;ie.pop();const J=ie.pop(),H=ie.length===0,X=x.create(V.expr.map(G=>te.create([G,J],null,Y)),null,H);X&&(ie.push(X),ie.sort(i))}if(ie.length===1)return ie[0];if(Y){for(let V=0;V<ie.length;V++)for(let J=V+1;J<ie.length;J++)if(ie[V].negate().equals(ie[J]))return l.INSTANCE;if(ie.length===1)return ie[0]}return new te(ie,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new te(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=x.create(P,this,!0)}return this.c}}e.ContextKeyAndExpr=te;class x{static create(P,M,Y){return x.d(P,M,Y)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,Y=this.expr.length;M<Y;M++){const ie=i(this.expr[M],P.expr[M]);if(ie!==0)return ie}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,Y=this.expr.length;M<Y;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=ne(this.expr);return P===this.expr?this:x.create(P,this.c,!1)}evaluate(P){for(let M=0,Y=this.expr.length;M<Y;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,Y){let ie=[],z=!1;if(P){for(let V=0,J=P.length;V<J;V++){const H=P[V];if(!!H){if(H.type===0){z=!0;continue}if(H.type===1)return c.INSTANCE;if(H.type===9){ie=ie.concat(H.expr);continue}ie.push(H)}}if(ie.length===0&&z)return l.INSTANCE;ie.sort(i)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let V=1;V<ie.length;V++)ie[V-1].equals(ie[V])&&(ie.splice(V,1),V--);if(ie.length===1)return ie[0];if(Y){for(let V=0;V<ie.length;V++)for(let J=V+1;J<ie.length;J++)if(ie[V].negate().equals(ie[J]))return c.INSTANCE;if(ie.length===1)return ie[0]}return new x(ie,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new x(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),Y=P.shift(),ie=[];for(const z of W(M))for(const V of W(Y))ie.push(te.create([z,V],null,!1));P.unshift(x.create(ie,null,!1))}this.c=x.create(P,this,!0)}return this.c}}e.ContextKeyOrExpr=x;class U extends s{static all(){return U.d.values()}constructor(P,M,Y){super(P,null),this.f=M,typeof Y=="object"?U.d.push({...Y,key:P}):Y!==!0&&U.d.push({key:P,description:Y,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return u.create(this.key,P)}notEqualsTo(P){return O.create(this.key,P)}}U.d=[],e.RawContextKey=U,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function Z(N,P){return N<P?-1:N>P?1:0}function re(N,P,M,Y){return N<M?-1:N>M?1:P<Y?-1:P>Y?1:0}function me(N,P){if(N.type===0||P.type===1)return!0;if(N.type===9)return P.type===9?$(N.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(me(N,M))return!0;return!1}if(N.type===6){if(P.type===6)return $(P.expr,N.expr);for(const M of N.expr)if(me(M,P))return!0;return!1}return N.equals(P)}e.implies=me;function $(N,P){let M=0,Y=0;for(;M<N.length&&Y<P.length;){const ie=N[M].cmp(P[Y]);if(ie<0)return!1;ie===0&&M++,Y++}return M===N.length}function W(N){return N.type===9?N.expr:[N]}}),define(pe[77],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class R{constructor(){this.a={}}async getPassword(D,C){return this.a[D]?.[C]??null}async setPassword(D,C,A){this.a[D]=this.a[D]??{},this.a[D][C]=A}async deletePassword(D,C){return this.a[D]?.[C]?(delete this.a[D][C],Object.keys(this.a[D]).length===0&&delete this.a[D],!0):!1}async findPassword(D){return JSON.stringify(this.a[D])??null}async findCredentials(D){const C=[];for(const A of Object.keys(this.a[D]||{}))C.push({account:A,password:this.a[D][A]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=R}),define(pe[211],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R;class o{async getPerformanceInfo(C,A){return{}}async getSystemInfo(C,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,A){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=o}),define(pe[78],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,w.createDecorator)("downloadService")}),define(pe[212],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(pe[24],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[29],ve([1,0,174,5]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function o(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=o;function D(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function C(h,d){switch(h){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function A(h,d){return d==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function v(h,d,S){return A(d,S)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===S?!0:g(S).includes(h)}e.isTargetPlatformCompatible=v;function g(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var m;(function(h){h.Install="install",h.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var p;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var a;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class f extends Error{constructor(d,S){super(d),this.code=S,this.name=S}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(pe[213],ve([1,0,6,2,21,4,49,29]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(a,f){return a?D.URI.revive(f?f.transformIncoming(a):a):void 0}function g(a,f){return f?f.transformOutgoingURI(a):a}function T(a,f){f=f||C.DefaultURITransformer;const h=a.manifest;return{...(0,C.transformAndReviveIncomingURIs)({...a,manifest:void 0},f),manifest:h}}function I(a,f){return a?.profileLocation?(0,C.transformAndReviveIncomingURIs)(a,f??C.DefaultURITransformer):a}function y(a,f){return f?(0,o.cloneAndChange)(a,h=>h instanceof D.URI?f.transformOutgoingURI(h):void 0):a}class m{constructor(f,h){this.a=f,this.b=h,this.onInstallExtension=w.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=w.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=w.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=w.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=w.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,h){const d=this.b(f);switch(h){case"onInstallExtension":return w.Event.map(this.onInstallExtension,S=>({...S,profileLocation:S.profileLocation?g(S.profileLocation,d):S.profileLocation}));case"onDidInstallExtensions":return w.Event.map(this.onDidInstallExtensions,S=>S.map(L=>({...L,local:L.local?y(L.local,d):L.local,profileLocation:L.profileLocation?g(L.profileLocation,d):L.profileLocation})));case"onUninstallExtension":return w.Event.map(this.onUninstallExtension,S=>({...S,profileLocation:S.profileLocation?g(S.profileLocation,d):S.profileLocation}));case"onDidUninstallExtension":return w.Event.map(this.onDidUninstallExtension,S=>({...S,profileLocation:S.profileLocation?g(S.profileLocation,d):S.profileLocation}));case"onDidUpdateExtensionMetadata":return w.Event.map(this.onDidUpdateExtensionMetadata,S=>y(S,d))}throw new Error("Invalid listen")}async call(f,h,d){const S=this.b(f);switch(h){case"zip":{const L=T(d[0],S),t=await this.a.zip(L);return g(t,S)}case"unzip":return this.a.unzip(v(d[0],S));case"install":return this.a.install(v(d[0],S),I(d[1],S));case"installFromLocation":return this.a.installFromLocation(v(d[0],S),v(d[1],S));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],v(d[1],S),v(d[2],S));case"getManifest":return this.a.getManifest(v(d[0],S));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],I(d[1],S));case"uninstall":return this.a.uninstall(T(d[0],S),I(d[1],S));case"reinstallFromGallery":return this.a.reinstallFromGallery(T(d[0],S));case"getInstalled":return(await this.a.getInstalled(d[0],v(d[1],S))).map(t=>y(t,S));case"copyExtensions":return this.a.copyExtensions(v(d[0],S),v(d[1],S));case"updateMetadata":{const L=await this.a.updateMetadata(T(d[0],S),d[1],v(d[2],S));return y(L,S)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class p extends R.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.k=f,this.c=this.B(new w.Emitter),this.f=this.B(new w.Emitter),this.g=this.B(new w.Emitter),this.h=this.B(new w.Emitter),this.j=this.B(new w.Emitter),this.B(this.k.listen("onInstallExtension")(h=>this.l(this.c,{...h,source:this.m(h.source)?D.URI.revive(h.source):h.source,profileLocation:D.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(h=>this.l(this.f,h.map(d=>({...d,local:d.local?T(d.local,null):d.local,source:this.m(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(h=>this.l(this.g,{...h,profileLocation:D.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(h=>this.l(this.h,{...h,profileLocation:D.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(T(h,null))))}l(f,h){f.fire(h)}m(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(f){const h=await this.getTargetPlatform();return f.allTargetPlatforms.some(d=>(0,A.isTargetPlatformCompatible)(d,f.allTargetPlatforms,h))}zip(f){return Promise.resolve(this.k.call("zip",[f]).then(h=>D.URI.revive(h)))}unzip(f){return Promise.resolve(this.k.call("unzip",[f]))}install(f,h){return Promise.resolve(this.k.call("install",[f,h])).then(d=>T(d,null))}installFromLocation(f,h){return Promise.resolve(this.k.call("installFromLocation",[f,h])).then(d=>T(d,null))}async installExtensionsFromProfile(f,h,d){return(await this.k.call("installExtensionsFromProfile",[f,h,d])).map(L=>T(L,null))}getManifest(f){return Promise.resolve(this.k.call("getManifest",[f]))}installFromGallery(f,h){return Promise.resolve(this.k.call("installFromGallery",[f,h])).then(d=>T(d,null))}uninstall(f,h){return Promise.resolve(this.k.call("uninstall",[f,h]))}reinstallFromGallery(f){return Promise.resolve(this.k.call("reinstallFromGallery",[f])).then(h=>T(h,null))}getInstalled(f=null,h){return Promise.resolve(this.k.call("getInstalled",[f,h])).then(d=>d.map(S=>T(S,null)))}updateMetadata(f,h,d){return Promise.resolve(this.k.call("updateMetadata",[f,h,d])).then(S=>T(S,null))}copyExtensions(f,h){return this.k.call("copyExtensions",[f,h])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(f,h,d){const S=await this.k.call("download",[f,h,d]);return D.URI.revive(S)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class b{constructor(f){this.a=f}listen(f,h){throw new Error("Invalid listen")}call(f,h,d){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(pe[79],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,w.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((D,C)=>oe(["node-vsce-sign"],async A=>D(A),C))),this.a}async verify(D,C,A){let v;try{v=await this.b()}catch{return!1}return v.verify(D,C,A)}}e.ExtensionSignatureVerificationService=R}),define(pe[16],ve([1,0,60,7,17,8,4,182,5,3,13]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,v.createDecorator)("fileService");function I(U){return U.create===!0}e.isFileOpenForWriteOptions=I;var y;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var m;(function(U){U[U.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var p;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=b;function a(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=a;function f(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=f;function h(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;function S(U){return b(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var L;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(L=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(Z,re){const me=new t(Z.toString(),re);return i(me,re),me}constructor(Z,re){super(Z),this.code=re}}e.FileSystemProviderError=t;function n(U,Z){return t.create(U,Z)}e.createFileSystemProviderError=n;function r(U){return U||n((0,A.localize)(0,null),L.Unknown)}e.ensureFileSystemProviderError=r;function i(U,Z){return U.name=Z?`${Z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function l(U){if(!U)return L.Unknown;if(U instanceof t)return U.code;const Z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!Z)return L.Unknown;switch(Z[1]){case L.FileExists:return L.FileExists;case L.FileIsADirectory:return L.FileIsADirectory;case L.FileNotADirectory:return L.FileNotADirectory;case L.FileNotFound:return L.FileNotFound;case L.FileExceedsMemoryLimit:return L.FileExceedsMemoryLimit;case L.FileTooLarge:return L.FileTooLarge;case L.FileWriteLocked:return L.FileWriteLocked;case L.NoPermissions:return L.NoPermissions;case L.Unavailable:return L.Unavailable}return L.Unknown}e.toFileSystemProviderErrorCode=l;function c(U){if(U instanceof B)return U.fileOperationResult;switch(l(U)){case L.FileNotFound:return 1;case L.FileIsADirectory:return 0;case L.FileNotADirectory:return 10;case L.FileWriteLocked:return 5;case L.NoPermissions:return 6;case L.FileExists:return 4;case L.FileExceedsMemoryLimit:return 9;case L.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(Z,re,me){this.resource=Z,this.operation=re,this.target=me}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=u;var E;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(E=e.FileChangeType||(e.FileChangeType={}));class k{constructor(Z,re){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const me=new Map;for(const $ of Z){const W=me.get($.type);switch(W?W.push([$.resource,$]):me.set($.type,[[$.resource,$]]),$.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}}for(const[$,W]of me)switch($){case 1:this.a=w.TernarySearchTree.forUris(()=>re),this.a.fill(W);break;case 0:this.b=w.TernarySearchTree.forUris(()=>re),this.b.fill(W);break;case 2:this.c=w.TernarySearchTree.forUris(()=>re),this.c.fill(W);break}}contains(Z,...re){return this.d(Z,{includeChildren:!1},...re)}affects(Z,...re){return this.d(Z,{includeChildren:!0},...re)}d(Z,re,...me){if(!Z)return!1;const $=me.length>0;return!!((!$||me.includes(1))&&(this.a?.get(Z)||re.includeChildren&&this.a?.findSuperstr(Z))||(!$||me.includes(0))&&(this.b?.get(Z)||re.includeChildren&&this.b?.findSuperstr(Z))||(!$||me.includes(2))&&(this.c?.findSubstr(Z)||re.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=k;function O(U,Z,re){return!U||!Z||U===Z||Z.length>U.length?!1:(Z.charAt(Z.length-1)!==R.sep&&(Z+=R.sep),re?(0,o.startsWithIgnoreCase)(U,Z):U.indexOf(Z)===0)}e.isParent=O;class B extends Error{constructor(Z,re,me){super(Z),this.fileOperationResult=re,this.options=me}}e.FileOperationError=B;class q extends B{constructor(Z,re,me,$){super(Z,re,$),this.fileOperationResult=re,this.size=me}}e.TooLargeFileOperationError=q;class le extends B{constructor(Z,re,me){super(Z,2,me),this.stat=re}}e.NotModifiedSinceFileOperationError=le;var de;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(de=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ue;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=ae;async function _(U,Z){if(!Z.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(re=>{const me=Z.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===U.scheme&&$.added&&(me.dispose(),re())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ee{static formatSize(Z){return(0,D.isNumber)(Z)||(Z=0),Z<ee.KB?(0,A.localize)(1,null,Z.toFixed(0)):Z<ee.MB?(0,A.localize)(2,null,(Z/ee.KB).toFixed(2)):Z<ee.GB?(0,A.localize)(3,null,(Z/ee.MB).toFixed(2)):Z<ee.TB?(0,A.localize)(4,null,(Z/ee.GB).toFixed(2)):(0,A.localize)(5,null,(Z/ee.TB).toFixed(2))}}ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB,e.ByteSize=ee;var ne;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function te(U){return{maxFileSize:U===0?300*ee.MB:16*ee.GB,maxHeapSize:U===0?700*ee.MB:2*700*ee.MB}}e.getPlatformFileLimits=te;function x(U){const Z=typeof U=="string"||U?.scheme===T.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===T.Schemas.file?1024*ee.MB:Z?10*ee.MB:g.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=x}),define(pe[214],ve([1,0,15,38,11,6,2,46,4,22,16]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends C.Disposable{constructor(m,p){super(),this.a=m,this.b=p,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.h=(0,g.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,p){const{buffer:b}=await this.a.call("readFile",[m,p]);return b}readFileStream(m,p,b){const a=(0,A.newWriteableStream)(h=>w.VSBuffer.concat(h.map(d=>w.VSBuffer.wrap(d))).buffer),f=this.a.listen("readFileStream",[m,p])(h=>{if(h instanceof w.VSBuffer)a.write(h.buffer);else{if(h==="end")a.end();else{let d;if(h instanceof Error)d=h;else{const S=h;d=(0,T.createFileSystemProviderError)(S.message??(0,R.toErrorMessage)(S),S.code??T.FileSystemProviderErrorCode.Unknown)}a.error(d),a.end()}f.dispose()}});return b.onCancellationRequested(()=>{a.error((0,o.canceled)()),a.end(),f.dispose()}),a}writeFile(m,p,b){return this.a.call("writeFile",[m,w.VSBuffer.wrap(p),b])}open(m,p){return this.a.call("open",[m,p])}close(m){return this.a.call("close",[m])}async read(m,p,b,a,f){const[h,d]=await this.a.call("read",[m,p,f]);return b.set(h.buffer.slice(0,d),a),d}write(m,p,b,a,f){return this.a.call("write",[m,p,w.VSBuffer.wrap(b),a,f])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,p){return this.a.call("delete",[m,p])}rename(m,p,b){return this.a.call("rename",[m,p,b])}copy(m,p,b){return this.a.call("copy",[m,p,b])}cloneFile(m,p){return this.a.call("cloneFile",[m,p])}i(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const p=m;this.f.fire(p.map(b=>({resource:v.URI.revive(b.resource),type:b.type})))}else{const p=m;this.g.fire(p)}}))}watch(m,p){const b=(0,g.generateUuid)();return this.a.call("watch",[this.h,b,m,p]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,b]))}}e.DiskFileSystemProviderClient=I}),define(pe[105],ve([1,0,15,11,183,16]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(T,I,y,m,p,b){let a;try{await A(T,I,y,m,p,b)}catch(f){a=f}finally{a&&p.errorTransformer&&(a=p.errorTransformer(a)),typeof a<"u"&&y.error(a),y.end()}}e.readFileIntoStream=C;async function A(T,I,y,m,p,b){v(b);const a=await T.open(I,{create:!1});try{v(b);let f=0,h=0,d=p&&typeof p.length=="number"?p.length:void 0,S=w.VSBuffer.alloc(Math.min(p.bufferSize,typeof d=="number"?d:p.bufferSize)),L=p&&typeof p.position=="number"?p.position:0,t=0;do h=await T.read(a,L,S.buffer,t,S.byteLength-t),L+=h,t+=h,f+=h,typeof d=="number"&&(d-=h),t===S.byteLength&&(await y.write(m(S)),S=w.VSBuffer.alloc(Math.min(p.bufferSize,typeof d=="number"?d:p.bufferSize)),t=0);while(h>0&&(typeof d!="number"||d>0)&&v(b)&&g(f,p));if(t>0){let n=t;typeof d=="number"&&(n=Math.min(t,d)),y.write(m(S.slice(0,n)))}}catch(f){throw(0,D.ensureFileSystemProviderError)(f)}finally{await T.close(a)}}function v(T){if(T.isCancellationRequested)throw(0,R.canceled)();return!0}function g(T,I){if(I?.limits){if(typeof I.limits.memory=="number"&&T>I.limits.memory)throw(0,D.createFileSystemProviderError)((0,o.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&T>I.limits.size)throw(0,D.createFileSystemProviderError)((0,o.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(pe[66],ve([1,0,75,2,7,3,4,16]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(f){return f.recursive===!0}e.isRecursiveWatchRequest=v;class g extends R.Disposable{constructor(h,d,S,L){super(),this.h=h,this.i=d,this.j=S,this.k=L,this.c=this.B(new R.MutableDisposable),this.f=void 0,this.g=0}m(){const h=new R.DisposableStore;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(d=>this.h(d))),h.add(this.b.onDidLogMessage(d=>this.i(d))),h.add(this.b.onDidError(d=>this.n(d)))}n(h){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${h}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${h}`):this.r(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}r(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}s(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}g.a=5,e.AbstractWatcherClient=g;class T extends g{constructor(h,d,S){super(h,d,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class I extends g{constructor(h,d,S){super(h,d,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function y(f){return f.map(h=>({type:h.type,resource:C.URI.file(h.path)}))}e.toFileChanges=y;function m(f){const h=new a;for(const d of f)h.processEvent(d);return h.coalesce()}e.coalesceEvents=m;function p(f,h){return typeof h=="string"&&!h.startsWith(w.GLOBSTAR)&&!(0,o.isAbsolute)(h)?{base:f,pattern:h}:h}e.normalizeWatcherPattern=p;function b(f,h){const d=[];for(const S of h)d.push((0,w.parse)(p(f,S)));return d}e.parseWatcherPatterns=b;class a{constructor(){this.a=new Set,this.b=new Map}c(h){return D.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const d=this.b.get(this.c(h));let S=!1;if(d){const L=d.type,t=h.type;d.path!==h.path&&(h.type===2||h.type===1)?S=!0:L===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(d)):L===2&&t===1?d.type=0:L===1&&t===0||(d.type=t)}else S=!0;S&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],d=[];return Array.from(this.a).filter(S=>S.type!==2?(h.push(S),!1):!0).sort((S,L)=>S.path.length-L.path.length).filter(S=>d.some(L=>(0,A.isParent)(S.path,L,!D.isLinux))?!1:(d.push(S.path),!0)).concat(h)}}}),define(pe[215],ve([1,0,32,14,20,39,2,92,7,3,162,23,66]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends C.Disposable{constructor(a,f,h,d){super(),this.j=a,this.k=f,this.l=h,this.m=d,this.c=this.B(new R.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new R.RunOnceWorker(S=>this.u(S),m.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new o.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const f=await I.Promises.stat(a);this.B(await this.s(a,f.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let f=a.path;try{f=await I.Promises.realpath(a.path),a.path===f&&(f=await(0,T.realcase)(a.path)??a.path),a.path!==f&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${f})`)}catch{}return f}async s(a,f){if(g.isMacintosh&&(0,D.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const h=new o.CancellationTokenSource(this.i.token),d=new C.DisposableStore;try{const S=(0,v.basename)(a),L=(0,w.watch)(a);d.add((0,C.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.z(`Started watching: '${a}'`);const t=new Set;if(f)try{for(const r of await I.Promises.readdir(a))t.add(r)}catch(r){this.w(r)}const n=new Map;d.add((0,C.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),L.on("error",(r,i)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),L.on("change",(r,i)=>{if(h.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${i}`);let l="";if(i&&(l=i.toString(),g.isMacintosh&&(l=(0,A.normalizeNFC)(l))),!(!l||r!=="change"&&r!=="rename"))if(f)if(r==="rename"){n.get(l)?.dispose();const c=setTimeout(async()=>{if(n.delete(l),l===S&&!await I.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,v.join)(a,l));if(h.token.isCancellationRequested)return;let u;s?t.has(l)?u=0:(u=1,t.add(l)):(t.delete(l),u=2),this.t({path:(0,v.join)(this.j.path,l),type:u})},m.a);n.set(l,(0,C.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(l)?c=0:(c=1,t.add(l)),this.t({path:(0,v.join)(this.j.path,l),type:c})}else if(r==="rename"||l!==S){const c=setTimeout(async()=>{const s=await I.Promises.exists(a);h.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),d.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},m.a);d.clear(),d.add((0,C.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await I.Promises.exists(a)&&!h.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${S.toString()})`)}return(0,C.toDisposable)(()=>{h.dispose(!0),d.dispose()})}t(a,f=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!f&&this.g.some(h=>h(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(h=>h(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const f=(0,y.coalesceEvents)(a);if(f.length>0){if(this.m)for(const d of f)this.z(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(f)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(g.isLinux)return I.Promises.exists(a);try{const f=(0,v.basename)(a);return(await I.Promises.readdir((0,v.dirname)(a))).some(d=>d===f)}catch(f){return this.z(f),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}m.a=100,m.b=75,e.NodeJSFileWatcherLibrary=m;async function p(b,a,f,h,d=512){const S=await I.Promises.open(b,"r"),L=Buffer.allocUnsafe(d),t=new o.CancellationTokenSource(h);let n,r=!1;const i={path:b,excludes:[],recursive:!1},l=new m(i,c=>{(async()=>{for(const{type:s}of c)if(s===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:u}=await I.Promises.read(S,L,0,d,null);if(!u||t.token.isCancellationRequested)break;a(L.slice(0,u))}}catch(u){n=new Error(u),t.dispose(!0)}finally{r=!1}}})()});return await l.ready,f(),new Promise((c,s)=>{t.token.onCancellationRequested(async()=>{l.dispose();try{await I.Promises.close(S)}catch(u){n=new Error(u)}n?s(n):c()})})}e.watchFileContents=p}),define(pe[216],ve([1,0,6,75,2,3,215]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class A extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new w.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new w.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=w.Event.None,this.c=new Map,this.f=!1}async watch(g){const T=this.i(g),I=T.filter(m=>{const p=this.c.get(m.path);return p?!(0,R.patternsEquals)(p.request.excludes,m.excludes)||!(0,R.patternsEquals)(p.request.includes,m.includes):!0}),y=Array.from(this.c.values()).filter(({request:m})=>!T.find(p=>p.path===m.path&&(0,R.patternsEquals)(p.excludes,m.excludes)&&(0,R.patternsEquals)(p.includes,m.includes))).map(({request:m})=>m.path);I.length&&this.j(`Request to start watching: ${I.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const m of y)this.h(m);for(const m of I)this.g(m)}g(g){const T=new C.NodeJSFileWatcherLibrary(g,y=>this.a.fire(y),y=>this.b.fire(y),this.f),I={request:g,instance:T};this.c.set(g.path,I)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const T=this.c.get(g);T&&(this.c.delete(g),T.instance.dispose())}i(g){const T=new Map;for(const I of g){const y=D.isLinux?I.path:I.path.toLowerCase();T.set(y,I)}return Array.from(T.values())}async setVerboseLogging(g){this.f=g;for(const[,T]of this.c)T.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,T){return T?`[File Watcher (node.js)] ${g} (path: ${T.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=A}),define(pe[217],ve([1,0,66,216]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class o extends w.AbstractNonRecursiveWatcherClient{constructor(C,A,v){super(C,A,v),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=o}),define(pe[218],ve([1,0,13,42,103,66]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends D.AbstractUniversalWatcherClient{constructor(v,g,T){super(v,g,T),this.m()}l(v){const g=v.add(new o.Client(w.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(g.onDidProcessExit(({code:T,signal:I})=>this.n(`terminated by itself with code ${T}, signal: ${I}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(pe[80],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...o){this.a=new Map;for(const[D,C]of o)this.set(D,C)}set(o,D){const C=this.a.get(o);return this.a.set(o,D),C}has(o){return this.a.has(o)}get(o){return this.a.get(o)}}e.ServiceCollection=w}),define(pe[106],ve([1,0,14,11,2,64,210,5,80,91]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class I extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class y{constructor(a=new v.ServiceCollection,f=!1,h,d=T){this.f=a,this.g=f,this.h=h,this.i=d,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=d?h?._globalGraph??new C.Graph(S=>S):void 0}createChild(a){return new y(a,this.g,this,this.i)}invokeFunction(a,...f){const h=p.traceInvocation(this.i,a);let d=!1;try{return a({get:L=>{if(d)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(L,h);if(!t)throw new Error(`[invokeFunction] unknown service '${L}'`);return t}},...f)}finally{d=!0,h.stop()}}createInstance(a,...f){let h,d;return a instanceof D.SyncDescriptor?(h=p.traceCreation(this.i,a.ctor),d=this.j(a.ctor,a.staticArguments.concat(f),h)):(h=p.traceCreation(this.i,a),d=this.j(a,f,h)),h.stop(),d}j(a,f=[],h){const d=A._util.getServiceDependencies(a).sort((t,n)=>t.index-n.index),S=[];for(const t of d){const n=this.m(t.id,h);n||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(n)}const L=d.length>0?d[0].index:f.length;if(f.length!==L){console.trace(`[createInstance] First service dependency of ${a.name} at position ${L+1} conflicts with ${f.length} static arguments`);const t=L-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,L)}return Reflect.construct(a,f.concat(S))}k(a,f){if(this.f.get(a)instanceof D.SyncDescriptor)this.f.set(a,f);else if(this.h)this.h.k(a,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const f=this.f.get(a);return!f&&this.h?this.h.l(a):f}m(a,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const h=this.l(a);return h instanceof D.SyncDescriptor?this.q(a,h,f.branch(a,!0)):(f.branch(a,!1),h)}q(a,f,h){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,f,h)}finally{this.o.delete(a)}}r(a,f,h){const d=new C.Graph(t=>t.id.toString());let S=0;const L=[{id:a,desc:f,_trace:h}];for(;L.length;){const t=L.pop();if(d.lookupOrInsertNode(t),S++>1e3)throw new I(d);for(const n of A._util.getServiceDependencies(t.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${a} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof D.SyncDescriptor){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};d.insertEdge(t,i),L.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new I(d);break}for(const{data:n}of t){if(this.l(n.id)instanceof D.SyncDescriptor){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}d.removeNode(n)}}return this.l(a)}s(a,f,h=[],d,S){if(this.f.get(a)instanceof D.SyncDescriptor)return this.t(a,f,h,d,S);if(this.h)return this.h.s(a,f,h,d,S);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(a,f,h=[],d,S){if(d){const L=new y(void 0,this.g,this,this.i);L.c=String(a);const t=new Map,n=new w.IdleValue(()=>{const r=L.j(f,h,S);for(const[i,l]of t){const c=r[i];if(typeof c=="function")for(const s of l)c.apply(r,s)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let s=t.get(i);return s||(s=new g.LinkedList,t.set(i,s)),(E,k,O)=>{const B=s.push([E,k,O]);return(0,o.toDisposable)(B)}}if(i in r)return r[i];const l=n.value;let c=l[i];return typeof c!="function"||(c=c.bind(l),r[i]=c),c},set(r,i,l){return n.value[i]=l,!0},getPrototypeOf(r){return f.prototype}})}else return this.j(f,h,S)}u(a,f){if(f&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=y;var m;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(m||(m={}));class p{static traceInvocation(a,f){return a?new p(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(a,f){return a?new p(1,f.name):p.c}constructor(a,f){this.type=a,this.name=f,this.g=Date.now(),this.h=[]}branch(a,f){const h=new p(3,a.toString());return this.h.push([a,f,h]),h}stop(){const a=Date.now()-this.g;p.f+=a;let f=!1;function h(S,L){const t=[],n=new Array(S+1).join("	");for(const[r,i,l]of L.h)if(i&&l){f=!0,t.push(`${n}CREATES -> ${r}`);const c=h(S+1,l);c&&t.push(c)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(a>2||f)&&p.all.add(d.join(`
`))}}p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0,e.Trace=p}),define(pe[219],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,w.createDecorator)("labelService");var R;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(R=e.Verbosity||(e.Verbosity={}))});var Ae=this&&this.__param||function(oe,e){return function(w,R){e(w,R,oe)}};define(pe[81],ve([1,0,20,2,3,185,29,5]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function v(T){return T.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=v,e.ILanguagePackService=(0,A.createDecorator)("languagePackService");let g=class extends R.Disposable{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new w.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const p=y.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(a=>a.startsWith("lp-"))).map(b=>{const a=b.properties.localizedLanguages?.[0],f=v(b);return{...this.f(f,a,b),extensionId:b.identifier.id,galleryExtension:b}});return p.push(this.f("en","English")),p}f(I,y,m){const p=y??I;let b;if(p!==I&&(b=`(${I})`),I.toLowerCase()===o.language.toLowerCase()&&(b??="",b+=(0,D.localize)(0,null)),m?.installCount){b??="";const a=m.installCount;let f;a>1e6?f=`${Math.floor(a/1e5)/10}M`:a>1e3?f=`${Math.floor(a/1e3)}K`:f=String(a),b+=` $(cloud-download) ${f}`}return{id:I,label:p,description:b}}};g=Le([Ae(0,C.IExtensionGalleryService)],g),e.LanguagePackBaseService=g}),define(pe[12],ve([1,0,38,6,74,2,27,3,19,8,4,65,5]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function m(){return new Date().toISOString()}function p(E){return(0,g.isNumber)(E)}e.isLogLevel=p;var b;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function a(E,k,O){switch(k){case b.Trace:E.trace(O);break;case b.Debug:E.debug(O);break;case b.Info:E.info(O);break;case b.Warning:E.warn(O);break;case b.Error:E.error(O);break;case b.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=a;function f(E,k=!1){let O="";for(let B=0;B<E.length;B++){let q=E[B];if(q instanceof Error&&(q=(0,w.toErrorMessage)(q,k)),typeof q=="object")try{q=JSON.stringify(q)}catch{}O+=(B>0?" ":"")+q}return O}class h extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==b.Off&&this.b<=k}}e.AbstractLogger=h;class d extends h{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...O){this.f(b.Trace)&&this.g(b.Trace,f([k,...O],!0))}debug(k,...O){this.f(b.Debug)&&this.g(b.Debug,f([k,...O]))}info(k,...O){this.f(b.Info)&&this.g(b.Info,f([k,...O]))}warn(k,...O){this.f(b.Warning)&&this.g(b.Warning,f([k,...O]))}error(k,...O){if(this.f(b.Error))if(k instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=k.stack,this.g(b.Error,f(B))}else this.g(b.Error,f([k,...O]))}flush(){}}e.AbstractMessageLogger=d;class S extends h{constructor(k=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(k),this.g=!A.isWindows}trace(k,...O){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,k,...O):console.log(`[main ${m()}]`,k,...O))}debug(k,...O){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,k,...O):console.log(`[main ${m()}]`,k,...O))}info(k,...O){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,k,...O):console.log(`[main ${m()}]`,k,...O))}warn(k,...O){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,k,...O):console.warn(`[main ${m()}]`,k,...O))}error(k,...O){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,k,...O):console.error(`[main ${m()}]`,k,...O))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class L extends h{constructor(k=e.DEFAULT_LOG_LEVEL,O=!0){super(),this.g=O,this.setLevel(k)}trace(k,...O){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...O):console.log(k,...O))}debug(k,...O){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...O):console.log(k,...O))}info(k,...O){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...O):console.log(k,...O))}warn(k,...O){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...O):console.log(k,...O))}error(k,...O){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...O):console.error(k,...O))}dispose(){}flush(){}}e.ConsoleLogger=L;class t extends h{constructor(k,O=e.DEFAULT_LOG_LEVEL){super(),this.g=k,this.setLevel(O)}trace(k,...O){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(k),...O])}debug(k,...O){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(k),...O])}info(k,...O){this.f(b.Info)&&this.g.log(b.Info,[this.h(k),...O])}warn(k,...O){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(k),...O])}error(k,...O){this.f(b.Error)&&this.g.log(b.Error,[this.h(k),...O])}h(k){return typeof k=="string"?k:(0,w.toErrorMessage)(k,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends h{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const O of this.g)O.setLevel(k);super.setLevel(k)}trace(k,...O){for(const B of this.g)B.trace(k,...O)}debug(k,...O){for(const B of this.g)B.debug(k,...O)}info(k,...O){for(const B of this.g)B.info(k,...O)}warn(k,...O){for(const B of this.g)B.warn(k,...O)}error(k,...O){for(const B of this.g)B.error(k,...O)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.MultiplexLogger=n;class r extends D.Disposable{constructor(k,O,B){if(super(),this.h=k,this.j=O,this.b=new C.ResourceMap,this.c=this.B(new R.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeVisibility=this.g.event,B)for(const q of B)this.b.set(q.resource,{logger:void 0,info:q})}k(k){return(0,g.isString)(k)?[...this.b.values()].find(O=>O.info.id===k):this.b.get(k)}getLogger(k){return this.k(k)?.logger}createLogger(k,O){const B=this.l(k),q=(0,g.isString)(k)?k:O?.id??(0,o.hash)(B.toString()).toString(16);let le=this.b.get(B)?.logger;const de=O?.logLevel==="always"?b.Trace:O?.logLevel;le||(le=this.m(B,de??this.getLogLevel(B)??this.h,{...O,id:q}));const ue={logger:le,info:{resource:B,id:q,logLevel:de,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(ue.info),this.b.set(B,ue),le}l(k){return(0,g.isString)(k)?(0,v.joinPath)(this.j,`${k}.log`):k}setLogLevel(k,O){if(T.URI.isUri(k)){const B=k,q=O,le=this.b.get(B);le&&q!==le.info.logLevel&&(le.info.logLevel=q===this.h?void 0:q,le.logger?.setLevel(q),this.b.set(le.info.resource,le),this.f.fire([B,q]))}else{this.h=k;for(const[B,q]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,O){const B=this.k(k);B&&O!==!B.info.hidden&&(B.info.hidden=!O,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,O]))}getLogLevel(k){let O;return k&&(O=this.b.get(k)?.info.logLevel),O??this.h}registerLogger(k){const O=this.b.get(k.resource);O?O.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const O=this.b.get(k);O&&(O.logger&&O.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class i{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(k){}getLevel(){return b.Info}trace(k,...O){}debug(k,...O){}info(k,...O){}warn(k,...O){}error(k,...O){}critical(k,...O){}dispose(){}flush(){}}e.NullLogger=i;class l extends i{}e.NullLogService=l;function c(E){if(E.verbose)return b.Trace;if(typeof E.logLevel=="string"){const k=u(E.logLevel.toLowerCase());if(k!==void 0)return k}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function s(E){switch(E){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=s;function u(E){switch(E){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",s(b.Info))}),define(pe[220],ve([1,0,77,6,2,12,3,14]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=class Yt extends o.Disposable{constructor(T){super(),this.h=T,this.c=this.B(new R.Emitter),this.onDidChangePassword=this.c.event,this.g=new A.SequencerByKey}async getPassword(T,I){this.h.trace("Getting password from keytar:",T,I);let y;try{y=await this.i()}catch{return null}return await this.g.queue(T+I,()=>this.k(y,T,I))}async k(T,I,y){const m=await(0,A.retry)(()=>T.getPassword(I,y),50,3);if(!m)return this.h.trace("Did not get a password from keytar for account:",y),m;let p,b;try{const a=JSON.parse(m);p=a.content,b=a.hasNextChunk}catch{}if(!p||!b)return this.h.trace("Got password from keytar for account:",y),m;try{let a=1;for(;b;){const f=await(0,A.retry)(()=>T.getPassword(I,`${y}-${a}`),50,3),h=JSON.parse(f);p+=h.content,b=h.hasNextChunk,a++}return this.h.trace(`Got ${a}-chunked password from keytar for account:`,y),p}catch(a){return this.h.error(a),m}}async setPassword(T,I,y){this.h.trace("Setting password using keytar:",T,I);let m;try{m=await this.i()}catch(p){throw this.j?.(p),p}await this.g.queue(T+I,()=>this.l(m,T,I,y)),this.c.fire({service:T,account:I})}async l(T,I,y,m){if(!C.isWindows){await(0,A.retry)(()=>T.setPassword(I,y,m),50,3),this.h.trace("Set password from keytar for account:",y);return}if(await this.m(T,I,y),m.length<=Yt.b){await(0,A.retry)(()=>T.setPassword(I,y,m),50,3),this.h.trace("Set password from keytar for account:",y);return}let p=0,b=0,a=!0;const f=[];for(;a;){const h=m.substring(p,p+Yt.b);p+=Yt.b,a=m.length-p>0;const d={content:h,hasNextChunk:a};f.push((0,A.retry)(()=>T.setPassword(I,b?`${y}-${b}`:y,JSON.stringify(d)),50,3)),b++}await Promise.all(f),this.h.trace(`Set${b?` ${b}-chunked`:""} password from keytar for account:`,y)}async deletePassword(T,I){this.h.trace("Deleting password using keytar:",T,I);let y;try{y=await this.i()}catch(p){throw this.j?.(p),p}const m=await this.g.queue(T+I,()=>this.m(y,T,I));return m&&this.c.fire({service:T,account:I}),m}async m(T,I,y){const m=await T.getPassword(I,y);if(!m)return this.h.trace("Did not get a password to delete from keytar for account:",y),!1;let p,b;try{const f=JSON.parse(m);p=f.content,b=f.hasNextChunk}catch{}let a=0;if(p&&b)try{for(a++;b;){const f=`${y}-${a}`,h=await T.getPassword(I,f);await T.deletePassword(I,f),b=JSON.parse(h).hasNextChunk,a++}}catch(f){this.h.error(f)}return await T.deletePassword(I,y)?(this.h.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,y),!0):(this.h.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,y),!1)}async findPassword(T){let I;try{I=await this.i()}catch{return null}return await I.findPassword(T)}async findCredentials(T){let I;try{I=await this.i()}catch{return[]}return await I.findCredentials(T)}clear(){return this.f instanceof w.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};v.a=2500,v.b=v.a-100,v=Le([Ae(0,D.ILogService)],v),e.BaseCredentialsMainService=v}),define(pe[221],ve([1,0,12]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let R=class{constructor(D,C){this.a=D,this.b=C}c(){return new Promise((D,C)=>oe(["vscode-encrypt"],D,C))}async encrypt(D){let C;try{C=await this.c()}catch{return D}try{return C.encrypt(this.a,D)}catch(A){return this.b.error(A),D}}async decrypt(D){let C;try{C=await this.c()}catch{return D}try{return C.decrypt(this.a,D)}catch(A){return this.b.error(A),D}}};R=Le([Ae(1,w.ILogService)],R),e.EncryptionMainService=R}),define(pe[222],ve([1,0,18,14,11,6,2,7,66,12]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends C.Disposable{constructor(y,m){super(),this.a=y,this.b=m,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(y,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(y,m):this.u(y,m)}l(y,m){const p={path:this.C(y),excludes:m.excludes,includes:m.includes,recursive:m.recursive},b=(0,w.insert)(this.j,p);return this.m(),(0,C.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,o.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,v.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const m of this.j)(0,v.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const m of this.j)(0,v.isRecursiveWatchRequest)(m)&&y.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,m){const p={path:this.C(y),excludes:m.excludes,includes:m.includes,recursive:!1},b=(0,w.insert)(this.s,p);return this.v(),(0,C.toDisposable)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,o.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,v.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,A.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(pe[107],ve([1,0,18,14,15,20,6,74,56,2,60,13,41,19,46,181,16,105,12,11]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends g.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,n){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const r=new g.DisposableStore;return this.h.set(t,n),this.c.fire({added:!0,scheme:t,provider:n}),r.add(n.onDidChangeFile(i=>this.R.fire(new a.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:t}))),(0,g.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:n}),this.h.delete(t),(0,g.dispose)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const n=[];this.f.fire({scheme:t,join(r){n.push(r)}}),!this.h.has(t)&&await R.Promises.settled(n)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,n){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([t,n])=>({scheme:t,capabilities:n.capabilities}))}async j(t){if(!(0,m.isAbsolutePath)(t))throw new a.FileOperationError((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const n=this.h.get(t.scheme);if(!n){const r=new d.ErrorNoTelemetry;throw r.message=(0,b.localize)(1,null,t.toString()),r}return n}async k(t){const n=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasReadWriteCapability)(n)||(0,a.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const n=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,n){try{return await this.n(t,n)}catch(r){throw(0,a.toFileSystemProviderErrorCode)(r)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,b.localize)(2,null,this.nb(t)),1):(0,a.ensureFileSystemProviderError)(r)}}async n(t,n){const r=await this.j(t),i=this.O(r),l=n?.resolveTo,c=n?.resolveSingleChildDescendants,s=n?.resolveMetadata,u=await r.stat(t);let E;return this.p(r,t,u,void 0,!!s,(k,O)=>(E||(E=T.TernarySearchTree.forUris(()=>!i),E.set(t,!0),l&&E.fill(!0,l)),E.get(k.resource)||E.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&c?O===1:!1))}async p(t,n,r,i,l,c){const{providerExtUri:s}=this.N(t),u={resource:n,name:s.basename(n),isFile:(r.type&a.FileType.File)!==0,isDirectory:(r.type&a.FileType.Directory)!==0,isSymbolicLink:(r.type&a.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&a.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,a.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(u.isDirectory&&c(u,i)){try{const E=await t.readdir(n),k=await R.Promises.settled(E.map(async([O,B])=>{try{const q=s.joinPath(n,O),le=l?await t.stat(q):{type:B};return await this.p(t,q,le,E.length,l,c)}catch(q){return this.b.trace(q),null}}));u.children=(0,w.coalesce)(k)}catch(E){this.b.trace(E),u.children=[]}return u}return u}async resolveAll(t){return R.Promises.settled(t.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const n=await this.j(t),r=await n.stat(t);return this.p(n,t,r,void 0,!0,()=>!1)}async exists(t){const n=await this.j(t);try{return!!await n.stat(t)}catch{return!1}}async canCreateFile(t,n){try{await this.r(t,n)}catch(r){return r}return!0}async r(t,n){if(!n?.overwrite&&await this.exists(t))throw new a.FileOperationError((0,b.localize)(3,null,this.nb(t)),3,n)}async createFile(t,n=o.VSBuffer.fromString(""),r){await this.r(t,r);const i=await this.writeFile(t,n);return this.m.fire(new a.FileOperationEvent(t,0,i)),i}async writeFile(t,n,r){const i=this.lb(await this.l(t),t),{providerExtUri:l}=this.N(i);try{await this.s(i,t,r)||await this.P(i,l.dirname(t));let s;if((0,a.hasReadWriteCapability)(i)&&!(n instanceof o.VSBuffer))if((0,p.isReadableStream)(n)){const u=await(0,p.peekStream)(n,3);u.ended?s=o.VSBuffer.concat(u.buffer):s=u}else s=(0,p.peekReadable)(n,u=>o.VSBuffer.concat(u),3);else s=n;!(0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasReadWriteCapability)(i)&&s instanceof o.VSBuffer?await this.cb(i,t,r,s):await this.Y(i,t,r,s instanceof o.VSBuffer?(0,o.bufferToReadable)(s):s),this.m.fire(new a.FileOperationEvent(t,4))}catch(c){throw new a.FileOperationError((0,b.localize)(4,null,this.nb(t),(0,a.ensureFileSystemProviderError)(c).toString()),(0,a.toFileOperationResult)(c),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,n,r){if(!!r?.unlock&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(n)));let l;try{l=await t.stat(n)}catch{return}if((l.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,b.localize)(6,null,this.nb(n)),0,r);if(this.mb(n,l),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==a.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&r.mtime<l.mtime&&r.etag!==(0,a.etag)({mtime:r.mtime,size:l.size}))throw new a.FileOperationError((0,b.localize)(7,null),3,r);return l}async readFile(t,n,r){const i=await this.k(t);return n?.atomic?this.t(i,t,n,r):this.u(i,t,n,r)}async t(t,n,r,i){return new Promise((l,c)=>{this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,n,r,i);l(s)}catch(s){c(s)}})})}async u(t,n,r,i){const l=await this.v(t,n,{...r,preferUnbuffered:!0},i);return{...l,value:await(0,o.streamToBuffer)(l.value)}}async readFileStream(t,n,r){const i=await this.k(t);return this.v(i,t,n,r)}async v(t,n,r,i){const l=new D.CancellationTokenSource(i),c=this.F(n,r).then(u=>u,u=>{throw l.cancel(),u});let s;try{return typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&await c,r?.atomic&&(0,a.hasFileAtomicReadCapability)(t)||!((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasFileReadStreamCapability)(t))||(0,a.hasReadWriteCapability)(t)&&r?.preferUnbuffered?s=this.D(t,n,r):(0,a.hasFileReadStreamCapability)(t)?s=this.z(t,n,l.token,r):s=this.C(t,n,l.token,r),{...await c,value:s}}catch(u){throw s&&await(0,p.consumeStream)(s),this.w(u,n,r)}}w(t,n,r){const i=(0,b.localize)(8,null,this.nb(n),(0,a.ensureFileSystemProviderError)(t).toString());return t instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(i,t.stat,r):t instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new a.FileOperationError(i,(0,a.toFileOperationResult)(t),r)}z(t,n,r,i=Object.create(null)){const l=t.readFileStream(n,i,r);return(0,p.transform)(l,{data:c=>c instanceof o.VSBuffer?c:o.VSBuffer.wrap(c),error:c=>this.w(c,n,i)},c=>o.VSBuffer.concat(c))}C(t,n,r,i=Object.create(null)){const l=(0,o.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,n,l,c=>c,{...i,bufferSize:this.a,errorTransformer:c=>this.w(c,n,i)},r),l}D(t,n,r){const i=(0,p.newWriteableStream)(l=>o.VSBuffer.concat(l));return(async()=>{try{let l;r?.atomic&&(0,a.hasFileAtomicReadCapability)(t)?l=await t.readFile(n,{atomic:!0}):l=await t.readFile(n),typeof r?.position=="number"&&(l=l.slice(r.position)),typeof r?.length=="number"&&(l=l.slice(0,r.length)),this.G(n,l.byteLength,r),i.end(o.VSBuffer.wrap(l))}catch(l){i.error(l),i.end()}})(),i}async F(t,n){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new a.FileOperationError((0,b.localize)(9,null,this.nb(t)),0,n);if(typeof n?.etag=="string"&&n.etag!==a.ETAG_DISABLED&&n.etag===r.etag)throw new a.NotModifiedSinceFileOperationError((0,b.localize)(10,null),r,n);return this.G(t,r.size,n),r}G(t,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new a.TooLargeFileOperationError((0,b.localize)(11,null,this.nb(t)),i,n,r)}}async canMove(t,n,r){return this.H(t,n,"move",r)}async canCopy(t,n,r){return this.H(t,n,"copy",r)}async H(t,n,r,i){if(t.toString()!==n.toString())try{const l=r==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(n),n);await this.M(l,t,c,n,r,i)}catch(l){return l}return!0}async move(t,n,r){const i=this.lb(await this.l(t),t),l=this.lb(await this.l(n),n),c=await this.I(i,t,l,n,"move",!!r),s=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,c==="move"?2:3,s)),s}async copy(t,n,r){const i=await this.k(t),l=this.lb(await this.l(n),n),c=await this.I(i,t,l,n,"copy",!!r),s=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,c==="copy"?3:2,s)),s}async I(t,n,r,i,l,c){if(n.toString()===i.toString())return l;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.M(t,n,r,i,l,c);if(s&&!u&&c&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),l==="copy"){if(t===r&&(0,a.hasFileFolderCopyCapability)(t))await t.copy(n,i,{overwrite:c});else{const E=await this.resolve(n);E.isDirectory?await this.L(t,E,r,i):await this.J(t,n,r,i)}return l}else return t===r?(await t.rename(n,i,{overwrite:c}),l):(await this.I(t,n,r,i,"copy",c),await this.del(n,{recursive:!0}),"copy")}async J(t,n,r,i){if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.eb(t,n,r,i);if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasReadWriteCapability)(r))return this.kb(t,n,r,i);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.ib(t,n,r,i);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasReadWriteCapability)(r))return this.gb(t,n,r,i)}async L(t,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await R.Promises.settled(n.children.map(async l=>{const c=this.N(r).providerExtUri.joinPath(i,l.name);return l.isDirectory?this.L(t,await this.resolve(l.resource),r,c):this.J(t,l.resource,r,c)}))}async M(t,n,r,i,l,c){let s=!1;if(t===r){const{providerExtUri:E,isPathCaseSensitive:k}=this.N(t);if(k||(s=E.isEqual(n,i)),s&&l==="copy")throw new Error((0,b.localize)(12,null,this.nb(n),this.nb(i)));if(!s&&E.isEqualOrParent(i,n))throw new Error((0,b.localize)(13,null,this.nb(n),this.nb(i)))}const u=await this.exists(i);if(u&&!s){if(!c)throw new a.FileOperationError((0,b.localize)(14,null,this.nb(n),this.nb(i)),4);if(t===r){const{providerExtUri:E}=this.N(t);if(E.isEqualOrParent(n,i))throw new Error((0,b.localize)(15,null,this.nb(n),this.nb(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}N(t){const n=this.O(t);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const n=this.lb(await this.j(t),t);await this.P(n,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,0,r)),r}async P(t,n){const r=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(n,i.dirname(n));)try{if(((await t.stat(n)).type&a.FileType.Directory)===0)throw new Error((0,b.localize)(16,null,this.nb(n)));break}catch(l){if((0,a.toFileSystemProviderErrorCode)(l)!==a.FileSystemProviderErrorCode.FileNotFound)throw l;r.push(i.basename(n)),n=i.dirname(n)}for(let l=r.length-1;l>=0;l--){n=i.joinPath(n,r[l]);try{await t.mkdir(n)}catch(c){if((0,a.toFileSystemProviderErrorCode)(c)!==a.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,n){try{await this.Q(t,n)}catch(r){return r}return!0}async Q(t,n){const r=this.lb(await this.j(t),t);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,b.localize)(17,null,this.nb(t)));let l;try{l=await r.stat(t)}catch{}if(l)this.mb(t,l);else throw new a.FileOperationError((0,b.localize)(18,null,this.nb(t)),1);if(!!!n?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,b.localize)(19,null,this.nb(t)))}return r}async del(t,n){const r=await this.Q(t,n),i=!!n?.useTrash,l=!!n?.recursive;await r.delete(t,{recursive:l,useTrash:i}),this.m.fire(new a.FileOperationEvent(t,1))}async cloneFile(t,n){const r=await this.j(t),i=this.lb(await this.l(n),n);if(r===i&&this.N(r).providerExtUri.isEqual(t,n))return;if(r===i&&(0,a.hasFileCloneCapability)(r))return r.cloneFile(t,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const l=this.X.queueFor(t,this.N(r).providerExtUri);return r===i&&(0,a.hasFileFolderCopyCapability)(r)?l.queue(()=>r.copy(t,n,{overwrite:!0})):l.queue(()=>this.J(r,t,i,n))}watch(t,n={recursive:!1,excludes:[]}){const r=new g.DisposableStore;let i=!1,l=()=>{i=!0};return r.add((0,g.toDisposable)(()=>l())),(async()=>{try{const c=await this.W(t,n);i?(0,g.dispose)(c):l=()=>(0,g.dispose)(c)}catch(c){this.b.error(c)}})(),r}async W(t,n){const r=await this.j(t),i=(0,A.hash)([this.N(r).providerExtUri.getComparisonKey(t),n]);let l=this.U.get(i);return l||(l={count:0,disposable:r.watch(t,n)},this.U.set(i,l)),l.count+=1,(0,g.toDisposable)(()=>{l&&(l.count--,l.count===0&&((0,g.dispose)(l.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,g.dispose)(t.disposable);this.U.clear()}async Y(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{const l=await t.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.Z(t,l,i):await this.ab(t,l,i)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await t.close(l)}})}async Z(t,n,r){let i=0,l;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const c=o.VSBuffer.concat(r.buffer);await this.bb(t,n,c,c.byteLength,i,0),i+=c.byteLength}if(r.ended)return;l=r.stream}else l=r;return new Promise((c,s)=>{(0,p.listenStream)(l,{onData:async u=>{l.pause();try{await this.bb(t,n,u,u.byteLength,i,0)}catch(E){return s(E)}i+=u.byteLength,setTimeout(()=>l.resume())},onError:u=>s(u),onEnd:()=>c()})})}async ab(t,n,r){let i=0,l;for(;(l=r.read())!==null;)await this.bb(t,n,l,l.byteLength,i,0),i+=l.byteLength}async bb(t,n,r,i,l,c){let s=0;for(;s<i;)s+=await t.write(n,l+s,r.buffer,c+s,i-s)}async cb(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.db(t,n,r,i))}async db(t,n,r,i){let l;i instanceof o.VSBuffer?l=i:(0,p.isReadableStream)(i)?l=await(0,o.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?l=await(0,o.bufferedStreamToBuffer)(i):l=(0,o.readableToBuffer)(i),await t.writeFile(n,l.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async eb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.fb(t,n,r,i))}async fb(t,n,r,i){let l,c;try{l=await t.open(n,{create:!1}),c=await r.open(i,{create:!0,unlock:!1});const s=o.VSBuffer.alloc(this.a);let u=0,E=0,k=0;do k=await t.read(l,u,s.buffer,E,s.byteLength-E),await this.bb(r,c,s,k,u,E),u+=k,E+=k,E===s.byteLength&&(E=0);while(k>0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await R.Promises.settled([typeof l=="number"?t.close(l):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async gb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.hb(t,n,r,i))}async hb(t,n,r,i){return r.writeFile(i,await t.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async ib(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.jb(t,n,r,i))}async jb(t,n,r,i){const l=await r.open(i,{create:!0,unlock:!1});try{const c=await t.readFile(n);await this.bb(r,l,o.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await r.close(l)}}async kb(t,n,r,i){const l=await(0,o.streamToBuffer)(this.C(t,n,D.CancellationToken.None));await this.cb(r,i,void 0,l)}lb(t,n){if(t.capabilities&2048)throw new a.FileOperationError((0,b.localize)(20,null,this.nb(n)),6);return t}mb(t,n){if((n.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,b.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===I.Schemas.file?t.fsPath:t.toString(!0)}};S=Le([Ae(0,h.ILogService)],S),e.FileService=S}),define(pe[67],ve([1,0,32,293,14,27,15,6,39,2,7,3,19,46,23,184,16,105,222,38,218,217]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(w)}catch(n){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(n)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i),this.onDidChangeCapabilities=A.Event.None,this.H=new D.ResourceMap(l=>y.extUriBiasedIgnorePathCase.getComparisonKey(l)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,I.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:i,symbolicLink:l}=await p.SymlinkSupport.stat(this.C(r));return{type:this.G(i,l),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(r){try{const i=await p.Promises.readdir(this.C(r),{withFileTypes:!0}),l=[];return await Promise.all(i.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,y.joinPath)(r,c.name))).type:s=this.G(c),l.push([c.name,s])}catch(s){this.a.trace(s)}})),l}catch(i){throw this.Y(i)}}G(r,i){let l;return i?.dangling?l=a.FileType.Unknown:r.isFile()?l=a.FileType.File:r.isDirectory()?l=a.FileType.Directory:l=a.FileType.Unknown,i&&(l|=a.FileType.SymbolicLink),l}async I(r){const i=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let l;for(;l=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await l.wait();const c=new o.Barrier;return this.H.set(r,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(r)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(r,i){let l;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),l=await this.I(r));const c=this.C(r);return await p.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{l?.dispose()}}J(r){t.D&&this.a.trace(r)}readFileStream(r,i,l){const c=(0,m.newWriteableStream)(s=>C.VSBuffer.concat(s.map(u=>C.VSBuffer.wrap(u))).buffer);return(0,f.readFileIntoStream)(this,r,c,s=>s.buffer,{...i,bufferSize:256*1024},l),c}async writeFile(r,i,l){let c;try{const s=this.C(r);if(!l.create||!l.overwrite){if(await p.Promises.exists(s)){if(!l.overwrite)throw(0,a.createFileSystemProviderError)((0,b.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,a.createFileSystemProviderError)((0,b.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(s){throw await this.Z(r,s)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){t.O=r}async open(r,i){const l=this.C(r);let c;(0,a.isFileOpenForWriteOptions)(i)&&(c=await this.I(r));let s;try{if((0,a.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:E}=await p.SymlinkSupport.stat(l);E.mode&128||await p.Promises.chmod(l,E.mode|128)}catch(E){this.a.trace(E)}let u;if((0,a.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await p.Promises.truncate(l,0),u="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}u||(u="w")}else u="r";s=await p.Promises.open(l,u)}catch(u){throw c?.dispose(),(0,a.isFileOpenForWriteOptions)(i)?await this.Z(r,u):this.Y(u)}if(this.L.set(s,0),(0,a.isFileOpenForWriteOptions)(i)&&this.N.set(s,r),c){const u=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${l})`),this.M.set(s,c),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${l})`),u.dispose())}return s}async close(r){const i=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&t.O)try{await p.Promises.fdatasync(r)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await p.Promises.close(r)}catch(l){throw this.Y(l)}finally{i&&(this.M.get(r)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,l,c,s){const u=this.P(r,i);let E=null;try{E=(await p.Promises.read(r,l,c,s,u)).bytesRead}catch(k){throw this.Y(k)}finally{this.Q(r,u,E)}return E}P(r,i){return i===this.L.get(r)?null:i}Q(r,i,l){const c=this.L.get(r);typeof c=="number"&&(typeof i=="number"||(typeof l=="number"?this.L.set(r,c+l):this.L.delete(r)))}async write(r,i,l,c,s){return(0,o.retry)(()=>this.R(r,i,l,c,s),100,3)}async R(r,i,l,c,s){const u=this.P(r,i);let E=null;try{E=(await p.Promises.write(r,l,c,s,u)).bytesWritten}catch(k){throw await this.Z(this.N.get(r),k)}finally{this.Q(r,u,E)}return E}async mkdir(r){try{await p.Promises.mkdir(this.C(r))}catch(i){throw this.Y(i)}}async delete(r,i){try{const l=this.C(r);i.recursive?await p.Promises.rm(l,p.RimRafMode.MOVE):await p.Promises.unlink(l)}catch(l){throw this.Y(l)}}async rename(r,i,l){const c=this.C(r),s=this.C(i);if(c!==s)try{await this.S(r,i,"move",l.overwrite),await p.Promises.move(c,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,b.localize)(2,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(s)),u.toString()))),this.Y(u)}}async copy(r,i,l){const c=this.C(r),s=this.C(i);if(c!==s)try{await this.S(r,i,"copy",l.overwrite),await p.Promises.copy(c,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,b.localize)(3,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(s)),u.toString()))),this.Y(u)}}async S(r,i,l,c){const s=this.C(r),u=this.C(i);let E=!1;if(!!(this.capabilities&1024)||(E=(0,v.isEqual)(s,u,!0)),E&&l==="copy")throw(0,a.createFileSystemProviderError)((0,b.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!E&&await p.Promises.exists(u)){if(!c)throw(0,a.createFileSystemProviderError)((0,b.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(r,i){return this.U(r,i,!1)}async U(r,i,l){const c=this.C(r),s=this.C(i),u=!!(this.capabilities&1024);if((0,v.isEqual)(c,s,!u))return;const E=new g.DisposableStore;try{const[k,O]=await Promise.all([this.I(r),this.I(i)]);E.add(k),E.add(O),l&&await p.Promises.mkdir((0,T.dirname)(s),{recursive:!0}),await p.Promises.copyFile(c,s)}catch(k){if(k.code==="ENOENT"&&!l)return this.U(r,i,!0);throw this.Y(k)}finally{E.dispose()}}p(r,i,l){return new S.UniversalWatcherClient(c=>r(c),c=>i(c),l)}y(r,i,l){return new L.NodeJSWatcherClient(c=>r(c),c=>i(c),l)}Y(r){if(r instanceof a.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=a.FileSystemProviderErrorCode.NoPermissions;break;default:i=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(r,i)}async Z(r,i){let l=this.Y(i);if(r&&l.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await p.SymlinkSupport.stat(this.C(r));c.mode&128||(l=(0,a.createFileSystemProviderError)(i,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return l}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(pe[223],ve([1,0,6,67,2,15,46,20]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends o.Disposable{constructor(I,y){super(),this.a=I,this.b=y,this.w=new Map,this.y=new Map}call(I,y,m){const p=this.c(I);switch(y){case"stat":return this.g(p,m[0]);case"readdir":return this.h(p,m[0]);case"open":return this.l(p,m[0],m[1]);case"close":return this.m(m[0]);case"read":return this.n(m[0],m[1],m[2]);case"readFile":return this.i(p,m[0],m[1]);case"write":return this.p(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.k(p,m[0],m[1],m[2]);case"rename":return this.t(p,m[0],m[1],m[2]);case"copy":return this.u(p,m[0],m[1],m[2]);case"cloneFile":return this.v(p,m[0],m[1]);case"mkdir":return this.r(p,m[0]);case"delete":return this.s(p,m[0],m[1]);case"watch":return this.C(p,m[0],m[1],m[2],m[3]);case"unwatch":return this.D(m[0],m[1])}throw new Error(`IPC Command ${y} not found`)}listen(I,y,m){const p=this.c(I);switch(y){case"fileChange":return this.z(p,m[0]);case"readFileStream":return this.j(p,m[0],m[1])}throw new Error(`Unknown event ${y}`)}g(I,y){const m=this.f(I,y,!0);return this.a.stat(m)}h(I,y){const m=this.f(I,y);return this.a.readdir(m)}async i(I,y,m){const p=this.f(I,y,!0),b=await this.a.readFile(p,m);return D.VSBuffer.wrap(b)}j(I,y,m){const p=this.f(I,y,!0),b=new A.CancellationTokenSource,a=new w.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),f=this.a.readFileStream(p,m,b.token);return(0,C.listenStream)(f,{onData:h=>a.fire(D.VSBuffer.wrap(h)),onError:h=>a.fire(h),onEnd:()=>{a.fire("end"),a.dispose(),b.dispose()}}),a.event}k(I,y,m,p){const b=this.f(I,y);return this.a.writeFile(b,m.buffer,p)}l(I,y,m){const p=this.f(I,y,!0);return this.a.open(p,m)}m(I){return this.a.close(I)}async n(I,y,m){const p=D.VSBuffer.alloc(m),b=0,a=await this.a.read(I,y,p.buffer,b,m);return[p,a]}p(I,y,m,p,b){return this.a.write(I,y,m.buffer,p,b)}r(I,y){const m=this.f(I,y);return this.a.mkdir(m)}s(I,y,m){const p=this.f(I,y);return this.a.delete(p,m)}t(I,y,m,p){const b=this.f(I,y),a=this.f(I,m);return this.a.rename(b,a,p)}u(I,y,m,p){const b=this.f(I,y),a=this.f(I,m);return this.a.copy(b,a,p)}v(I,y,m){const p=this.f(I,y),b=this.f(I,m);return this.a.cloneFile(p,b)}z(I,y){const m=new w.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(I,m))},onDidRemoveLastListener:()=>{(0,o.dispose)(this.w.get(y)),this.w.delete(y)}});return m.event}async C(I,y,m,p,b){const a=this.w.get(y);if(a){const f=this.f(I,p),h=a.watch(m,f,b);this.y.set(y+m,h)}}async D(I,y){const m=I+y,p=this.y.get(m);p&&((0,o.dispose)(p),this.y.delete(m))}dispose(){super.dispose();for(const[,I]of this.y)I.dispose();this.y.clear();for(const[,I]of this.w)I.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class g extends o.Disposable{constructor(I,y,m,p){super(),this.c=I,this.f=m,this.g=p,this.a=new Map,this.b=this.B(new R.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(I){const y=this.B(new w.Emitter);this.B(y.event(m=>{I.fire(m.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(m=>y.fire(m))),this.B(this.b.onDidWatchError(m=>I.fire(m)))}i(I){}j(I){}watch(I,y,m){const p=this.j(this.g);return Array.isArray(p)&&(m.excludes=[...m.excludes,...p]),this.a.set(I,this.b.watch(y,m)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.a.get(I)),this.a.delete(I)})}dispose(){super.dispose();for(const[,I]of this.a)I.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=g}),define(pe[108],ve([1,0,4,6,12,2]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class C extends o.AbstractLoggerService{constructor(I,y,m,p,b){super(y,m,p),this.n=I,this.p=b,this.B(b.listen("onDidChangeLogLevel",I)(a=>{(0,o.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(w.URI.revive(a[0]),a[1])})),this.B(b.listen("onDidChangeVisibility",I)(([a,f])=>super.setVisibility(w.URI.revive(a),f))),this.B(b.listen("onDidChangeLoggers",I)(({added:a,removed:f})=>{for(const h of a)super.registerLogger({...h,resource:w.URI.revive(h.resource)});for(const h of f)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new o.AdapterLogger({log:(I,y)=>{this.p.call("consoleLog",[I,y])}})}registerLogger(I){super.registerLogger(I),this.p.call("registerLogger",[I,this.n])}deregisterLogger(I){super.deregisterLogger(I),this.p.call("deregisterLogger",[I,this.n])}setLogLevel(I,y){super.setLogLevel(I,y),this.p.call("setLogLevel",[I,y])}setVisibility(I,y){super.setVisibility(I,y),this.p.call("setVisibility",[this.l(I),y])}m(I,y,m){return new A(this.p,I,y,m,this.n)}static setLogLevel(I,y,m){return I.call("setLogLevel",[y,m])}}e.LoggerChannelClient=C;class A extends o.AbstractMessageLogger{constructor(I,y,m,p,b){super(p?.logLevel==="always"),this.m=I,this.n=y,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[y,p,b]).then(()=>{this.r(this.l),this.k=!0})}g(I,y){const m=[[I,y]];this.k?this.r(m):this.l.push(...m)}r(I){this.m.call("log",[this.n,I])}}class v{constructor(I,y){this.a=I,this.b=y}listen(I,y){const m=this.b(I);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(b=>this.c(b,m)),removed:[...p.removed].map(b=>this.c(b,m))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,p=>[m.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,p=>(0,o.isLogLevel)(p)?p:[m.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${y}`)}async call(I,y,m){const p=this.b(I);switch(y){case"setLogLevel":return(0,o.isLogLevel)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(w.URI.revive(p.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,p)))}throw new Error(`Call not found: ${y}`)}c(I,y){return{...I,resource:y.transformOutgoingURI(I.resource)}}}e.LoggerChannel=v;class g extends D.Disposable{constructor(I,y){super(),y.call("setLogLevel",[I.getLogLevel()]),this.B(I.onDidChangeLogLevel(m=>y.call("setLogLevel",[m]))),y.call("getRegisteredLoggers").then(m=>{for(const p of m)I.registerLogger({...p,resource:w.URI.revive(p.resource)})}),this.B(y.listen("onDidChangeVisibility")(([m,p])=>I.setVisibility(w.URI.revive(m),p))),this.B(y.listen("onDidChangeLoggers")(({added:m,removed:p})=>{for(const b of m)I.registerLogger({...b,resource:w.URI.revive(b.resource)});for(const b of p)I.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=g}),define(pe[109],ve([1,0,2,12]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class o extends w.Disposable{constructor(C,A=[]){super(),this.a=new R.MultiplexLogger([C,...A]),this.B(C.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...A){this.a.trace(C,...A)}debug(C,...A){this.a.debug(C,...A)}info(C,...A){this.a.info(C,...A)}warn(C,...A){this.a.warn(C,...A)}error(C,...A){this.a.error(C,...A)}flush(){this.a.flush()}}e.LogService=o}),define(pe[224],ve([1,0,16,12]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var o;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(o||(o={}));async function D(g,T,I,y,m){try{const p=await new Promise((a,f)=>{oe(["spdlog"],a,f)});p.setFlushOn(o.Trace);const b=await p.createAsyncRotatingLogger(g,T,I,y);return m?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(p){console.error(p)}return null}function C(g,T,I){switch(T){case R.LogLevel.Trace:g.trace(I);break;case R.LogLevel.Debug:g.debug(I);break;case R.LogLevel.Info:g.info(I);break;case R.LogLevel.Warning:g.warn(I);break;case R.LogLevel.Error:g.error(I);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function A(g,T){switch(T){case R.LogLevel.Trace:g.setLevel(o.Trace);break;case R.LogLevel.Debug:g.setLevel(o.Debug);break;case R.LogLevel.Info:g.setLevel(o.Info);break;case R.LogLevel.Warning:g.setLevel(o.Warning);break;case R.LogLevel.Error:g.setLevel(o.Error);break;case R.LogLevel.Off:g.setLevel(o.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class v extends R.AbstractMessageLogger{constructor(T,I,y,m,p){super(),this.k=[],this.setLevel(p),this.l=this.n(T,I,y,m),this.B(this.onDidChangeLogLevel(b=>{this.m&&A(this.m,b)}))}async n(T,I,y,m){const p=y?6:1,b=30/p*w.ByteSize.MB,a=await D(T,I,b,p,m);if(a){this.m=a,A(this.m,this.getLevel());for(const{level:f,message:h}of this.k)C(this.m,f,h);this.k=[]}}g(T,I){this.m?C(this.m,T,I):this.getLevel()<=T&&this.k.push({level:T,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=v}),define(pe[110],ve([1,0,22,12,224]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class D extends R.AbstractLoggerService{m(A,v,g){return new o.SpdLogLogger((0,w.generateUuid)(),A.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,v)}}e.LoggerService=D}),define(pe[225],ve([1,0,59,186,5]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var C;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function g(p,b){return b-p}v.compare=g;const T=Object.create(null);T[v.Error]=(0,R.localize)(0,null),T[v.Warning]=(0,R.localize)(1,null),T[v.Info]=(0,R.localize)(2,null);function I(p){return T[p]||""}v.toString=I;function y(p){switch(p){case w.default.Error:return v.Error;case w.default.Warning:return v.Warning;case w.default.Info:return v.Info;case w.default.Ignore:return v.Hint}}v.fromSeverity=y;function m(p){switch(p){case v.Error:return w.default.Error;case v.Warning:return w.default.Warning;case v.Info:return w.default.Info;case v.Hint:return w.default.Ignore}}v.toSeverity=m}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(v){const g="";function T(y){return I(y,!0)}v.makeKey=T;function I(y,m){const p=[g];return y.source?p.push(y.source.replace("\xA6","\\\xA6")):p.push(g),y.code?typeof y.code=="string"?p.push(y.code.replace("\xA6","\\\xA6")):p.push(y.code.value.replace("\xA6","\\\xA6")):p.push(g),y.severity!==void 0&&y.severity!==null?p.push(C.toString(y.severity)):p.push(g),y.message&&m?p.push(y.message.replace("\xA6","\\\xA6")):p.push(g),y.startLineNumber!==void 0&&y.startLineNumber!==null?p.push(y.startLineNumber.toString()):p.push(g),y.startColumn!==void 0&&y.startColumn!==null?p.push(y.startColumn.toString()):p.push(g),y.endLineNumber!==void 0&&y.endLineNumber!==null?p.push(y.endLineNumber.toString()):p.push(g),y.endColumn!==void 0&&y.endColumn!==null?p.push(y.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}v.makeKeyOptionalMessage=I})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,o.createDecorator)("markerService")}),define(pe[68],ve([1,0,6,56,2,5]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class C extends o.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new w.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const T=Object.keys(this.f).length;return this.f={...g,...this.f},T!==Object.keys(this.f).length&&await this.i(g),R.Iterable.reduce(this.g.entries(),(I,[y,m])=>({...I,[y]:m}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(g,[T,I])=>({...g,[T]:{definition:I,value:this.g.get(T)}}),{})}}e.AbstractPolicyService=C;class A{constructor(){this.onDidChange=w.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=A}),define(pe[52],ve([1,0,3,28]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.context<"u"){const D=w.globals.vscode.context.configuration();if(D)o=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:D.version})}}else o={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},extensionRecommendations:{"ms-dotnettools.csharp":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"python-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*\\])|("black\\s*["[(<=>!~;@])'}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",showInStartEntry:!0}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows"]},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",showInStartEntry:!0},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",showInStartEntry:!0},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",showInStartEntry:!0}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testContinuousRun"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","testObserver","envShellEvent","quickPickItemTooltip"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditorLineNumberMenu","contribEditorGutterMenu","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribEditorLineNumberMenu","contribEditorGutterMenu","contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","contribCommentPeekContext","treeItemCheckbox","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.77.2",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],walkthroughMetadata:[{id:"Setup",steps:[{id:"copilotInstall",title:"Supercharge your coding with AI-based suggestions",description:`Throw that rubber duck away! Code more efficiently with AI at your fingertips. Try [GitHub Copilot](command:extension.open?"github.copilot") free for 60 days.
[Install Copilot](command:workbench.extensions.installExtension?%22github.copilot%22)`,media:{type:"image",altText:"Copilot Statistics",path:"copilotStep.png"}}]}],featuredExtensions:[{id:"github.copilot",title:"GitHub Copilot",description:"Supercharge your coding experience for as little as $10/month with cutting edge AI code generation."}],version:"1.77.1",commit:"b7886d7461186a5eac768481578c1d7ca80e2d21",date:"2023-04-04T22:56:39.743Z"},Object.keys(o).length===0&&Object.assign(o,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(pe[26],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(pe[226],ve([1,0,77,12,24,26,220]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let A=class extends C.BaseCredentialsMainService{constructor(g,T,I){super(g),this.p=T,this.r=I}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new w.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((g,T)=>{oe(["keytar"],g,T)}),await this.f.findCredentials("test-keytar-loads")}catch(g){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${g.message??g}`),this.f=new w.InMemoryCredentialsProvider}return this.f}};A=Le([Ae(0,R.ILogService),Ae(1,o.INativeEnvironmentService),Ae(2,D.IProductService)],A),e.CredentialsWebMainService=A}),define(pe[40],ve([1,0,90,8]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class o{constructor(){this.a=new Map}add(C,A){w.ok(R.isString(C)),w.ok(R.isObject(A)),w.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new o}),define(pe[227],ve([1,0,6,40]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function o(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class D{constructor(){this.b=new w.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,g){this.a[o(v)]=g,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const C=new D;R.Registry.add(e.Extensions.JSONContribution,C)}),define(pe[53],ve([1,0,18,6,8,168,25,227,40]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=v.Registry.as(A.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.n(t,n,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.o(n,r),this.n(t,!1,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const r=[];for(const{overrides:i,source:l}of t)for(const c in i)if(n.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const s=this.a.get(c),u=s?.valuesSources??new Map;if(l)for(const B of Object.keys(i[c]))u.set(B,l);const E={...s?.value||{},...i[c]};this.a.set(c,{source:l,value:E,valuesSources:u});const k=(0,C.getLanguageTagSettingPlainKey)(c),O={type:"object",default:E,description:D.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:o.isString(l)?void 0:l,defaultValueSource:l};r.push(...b(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:i[c],source:l});const s=this.d[c];s&&(this.w(c,s),this.r(c,s))}this.m(r)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:r,source:i}of t)for(const l in r){const c=this.a.get(l),s=o.isString(i)?i:i?.id,u=o.isString(c?.source)?c?.source:c?.source?.id;if(s===u)if(n.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const E=this.d[l];E&&(this.w(l,E),this.r(l,E))}}this.u()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,r){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,n){const r=i=>{if(i.properties)for(const l in i.properties){n.add(l);const c=this.d[l];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[l],this.s(l,i.properties[l])}i.allOf?.forEach(l=>r(l))};for(const i of t){r(i);const l=this.c.indexOf(i);l!==-1&&this.c.splice(l,1)}}p(t,n=!0,r,i,l=3,c){l=o.isUndefinedOrNull(t.scope)?l:t.scope;const s=t.properties;if(s)for(const E in s){const k=s[E];if(n&&d(E,k)){delete s[E];continue}if(k.source=r,k.defaultDefaultValue=s[E].default,this.w(E,k),e.OVERRIDE_PROPERTY_REGEX.test(E)?k.scope=void 0:(k.scope=o.isUndefinedOrNull(k.scope)?l:k.scope,k.restricted=o.isUndefinedOrNull(k.restricted)?!!i?.includes(E):k.restricted),s[E].hasOwnProperty("included")&&!s[E].included){this.f[E]=s[E],delete s[E];continue}else this.d[E]=s[E],s[E].policy?.name&&this.e.set(s[E].policy.name,E);!s[E].deprecationMessage&&s[E].markdownDeprecationMessage&&(s[E].deprecationMessage=s[E].markdownDeprecationMessage),c.add(E)}const u=t.allOf;if(u)for(const E of u)this.p(E,n,r,i,l,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=r=>{const i=r.properties;if(i)for(const c in i)this.r(c,i[c]);r.allOf?.forEach(n)};n(t)}r(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,r={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,n){const r=this.a.get(t);let i=r?.value,l=r?.source;o.isUndefined(i)&&(i=n.defaultDefaultValue,l=void 0),o.isUndefined(i)&&(i=f(n.type)),n.default=i,n.defaultValueSource=l}}const m="\\[([^\\]]+)\\]",p=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(L){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let n=p.exec(L);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=p.exec(L)}}return(0,w.distinct)(t)}e.overrideIdentifiersFromKey=b;function a(L){return L.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=a;function f(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const h=new y;v.Registry.add(e.Extensions.Configuration,h);function d(L,t){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?D.localize(7,null,L):h.getConfigurationProperties()[L]!==void 0?D.localize(8,null,L):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,L,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=d;function S(){const L=[],t=h.getConfigurationProperties();for(const n of Object.keys(t))L.push([n,t[n].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=S}),define(pe[111],ve([1,0,18,6,72,2,27,21,8,4,25,53,40]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(n){return Object.isFrozen(n)?n:A.deepFreeze(n)}class p{constructor(r={},i=[],l=[],c){this.b=r,this.c=i,this.d=l,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof p)return i;const l=new b("");return l.parseRaw(i),l.configurationModel});this.f=r.reduce((i,l)=>l===i?l:i.merge(l),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const l=this.rawConfiguration.getValue(r),c=i?this.rawConfiguration.getOverrideValue(r,i):void 0,s=i?this.rawConfiguration.override(i).getValue(r):l;return{value:l,override:c,merged:s}}getOverrideValue(r,i){const l=this.i(i);return l?r?(0,T.getConfigurationValue)(l,r):l:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const l of this.overrides)l.identifiers.includes(r)&&i.push(...l.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),l=A.deepClone(this.overrides),c=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const u of r)if(s.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(i,u.contents);for(const E of u.overrides){const[k]=l.filter(O=>w.equals(O.identifiers,E.identifiers));k?(this.h(k.contents,E.contents),k.keys.push(...E.keys),k.keys=w.distinct(k.keys)):l.push(A.deepClone(E))}for(const E of u.keys)c.indexOf(E)===-1&&c.push(E)}return new p(i,c,l,s.every(u=>u instanceof p)?void 0:s)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const l={};for(const c of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[c];const u=i[c];u&&(typeof s=="object"&&typeof u=="object"?(s=A.deepClone(s),this.h(s,u)):s=u),l[c]=s}return new p(l,this.keys,this.overrides)}h(r,i){for(const l of Object.keys(i)){if(l in r&&v.isObject(r[l])&&v.isObject(i[l])){this.h(r[l],i[l]);continue}r[l]=A.deepClone(i[l])}}i(r){let i=null,l=null;const c=s=>{s&&(l?this.h(l,s):l=A.deepClone(s))};for(const s of this.overrides)w.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&c(s.contents);return c(i),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(l=>w.equals(l.identifiers,(0,I.overrideIdentifiersFromKey)(r))),1))}j(r,i,l){(0,T.addToValueTree)(this.contents,r,i,c=>console.error(c)),l=l||this.keys.indexOf(r)===-1,l&&this.keys.push(r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],c=>console.error(c))})}}e.ConfigurationModel=p;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!v.isUndefinedOrNull(r)){const l=this.g(r);this.parseRaw(l,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:l,keys:c,overrides:s,restricted:u,hasExcludedProperties:E}=this.h(r,i);this.b=new p(l,c,s,E?[r]:void 0),this.c=u||[]}g(r){let i={},l=null,c=[];const s=[],u=[];function E(O){Array.isArray(c)?c.push(O):l!==null&&(c[l]=O)}const k={onObjectBegin:()=>{const O={};E(O),s.push(c),c=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const O=[];E(O),s.push(c),c=O,l=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:E,onError:(O,B,q)=>{u.push({error:O,offset:B,length:q})}};if(r)try{o.visit(r,k),i=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(r,i){const l=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=this.i(r,l,!0,i);r=c.raw;const s=(0,T.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),u=Object.keys(r),E=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:s,keys:u,overrides:E,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,i,l,c){let s=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const u={},E=[];for(const k in r)if(I.OVERRIDE_PROPERTY_REGEX.test(k)&&l){const O=this.i(r[k],i,!1,c);u[k]=O.raw,s=s||O.hasExcludedProperties,E.push(...O.restricted)}else{const O=i[k],B=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&E.push(k),(B===void 0||c.scopes===void 0||c.scopes.includes(B))&&!(c.skipRestricted&&O?.restricted)?u[k]=r[k]:s=!0}return{raw:u,restricted:E,hasExcludedProperties:s}}j(r,i){const l=[];for(const c of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(c)){const s={};for(const u in r[c])s[u]=r[c][u];l.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(s),contents:(0,T.toValuesTree)(s,i)})}return l}}e.ConfigurationModelParser=b;class a extends D.Disposable{constructor(r,i,l,c){super(),this.f=r,this.g=i,this.h=c,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(l.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&l.isEqual(s.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class f{constructor(r,i,l,c,s,u,E,k,O,B,q,le,de){this.a=r,this.b=i,this.c=l,this.overrideIdentifiers=c,this.d=s,this.f=u,this.g=E,this.h=k,this.i=O,this.j=B,this.k=q,this.l=le,this.m=de}get value(){return m(this.c)}n(r,i,l){const c=r.inspect(i,l);return{get value(){return m(c.value)},get override(){return m(c.override)},get merged(){return m(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,l,c,s=new p,u=new p,E=new C.ResourceMap,k=new p,O=new C.ResourceMap){this.c=r,this.d=i,this.f=l,this.g=c,this.h=s,this.i=u,this.j=E,this.l=k,this.m=O,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(r,i,l){return this.q(r,i,l).getValue(r)}updateValue(r,i,l={}){let c;l.resource?(c=this.m.get(l.resource),c||(c=new p,this.m.set(l.resource,c))):c=this.l,i===void 0?c.removeValue(r):c.setValue(r,i),l.resource||(this.a=null)}inspect(r,i,l){const c=this.q(r,i,l),s=this.u(i.resource,l),u=i.resource?this.m.get(i.resource)||this.l:this.l,E=new Set;for(const k of c.overrides)for(const O of k.identifiers)c.getOverrideValue(r,O)!==void 0&&E.add(O);return new f(r,i,c.getValue(r),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,s||void 0,u)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const l=[];if(!i){const{added:c,updated:s,removed:u}=L(this.c,r);i=[...c,...s,...u]}for(const c of i)for(const s of(0,I.overrideIdentifiersFromKey)(c)){const u=this.c.getKeysForOverrideIdentifier(s),E=r.getKeysForOverrideIdentifier(s),k=[...E.filter(O=>u.indexOf(O)===-1),...u.filter(O=>E.indexOf(O)===-1),...u.filter(O=>!A.equals(this.c.override(s).getValue(O),r.override(s).getValue(O)))];l.push([s,k])}return this.updateDefaultConfiguration(r),{keys:i,overrides:l}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:l,removed:c}=L(this.d,r),s=[...i,...l,...c];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.applicationConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateApplicationConfiguration(r),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.localUserConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.remoteUserConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.workspaceConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const l=this.p.get(r),{added:c,updated:s,removed:u,overrides:E}=L(l,i),k=[...c,...s,...u];return(k.length||!l)&&this.updateFolderConfiguration(r,i),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:l,updated:c,removed:s,overrides:u}=L(i,void 0);return{keys:[...l,...c,...s],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,l){let c=this.r(i,l);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}r({resource:r},i){let l=this.s();if(i&&r){const c=i.getFolder(r);c&&(l=this.t(c.uri)||l);const s=this.m.get(r);s&&(l=l.merge(s))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const l=this.s(),c=this.j.get(r);c?(i=l.merge(c),this.b.set(r,i)):i=l}return i}u(r,i){if(i&&r){const l=i.getFolder(r);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:l,overrides:c,keys:s}=this.j.get(i);return r.push([i,{contents:l,overrides:c,keys:s}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(l=>r.add(l))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(l=>r.add(l))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.i.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.x(r.defaults),l=this.x(r.policy),c=this.x(r.application),s=this.x(r.user),u=this.x(r.workspace),E=r.folders.reduce((k,O)=>(k.set(g.URI.revive(O[0]),this.x(O[1])),k),new C.ResourceMap);return new h(i,l,c,s,new p,u,E,new p,new C.ResourceMap)}static x(r){return new p(r.contents,r.keys,r.overrides)}}e.Configuration=h;function d(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const c of n)c.keys.forEach(s=>r.add(s)),c.overrides.forEach(([s,u])=>{const E=(0,C.getOrSet)(i,s,new Set);u.forEach(k=>E.add(k))});const l=[];return i.forEach((c,s)=>l.push([s,[...c.values()]])),{keys:[...r.values()],overrides:l}}e.mergeChanges=d;class S{constructor(r,i,l,c){this.change=r,this.f=i,this.g=l,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of r.keys)this.affectedKeys.add(s);for(const[,s]of r.overrides)for(const u of s)this.affectedKeys.add(u);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const l=this.a+r,c=this.d.indexOf(l);if(c<0)return!1;const s=c+l.length;if(s>=this.d.length)return!1;const u=this.d.charCodeAt(s);if(u!==this.b&&u!==this.c)return!1;if(i){const E=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,k=this.g.getValue(r,i,this.h);return!A.equals(E,k)}return!0}}e.ConfigurationChangeEvent=S;function L(n,r){const{added:i,removed:l,updated:c}=t(r?.rawConfiguration,n?.rawConfiguration),s=[],u=n?.getAllOverrideIdentifiers()||[],E=r?.getAllOverrideIdentifiers()||[];if(r){const k=E.filter(O=>!u.includes(O));for(const O of k)s.push([O,r.getKeysForOverrideIdentifier(O)])}if(n){const k=u.filter(O=>!E.includes(O));for(const O of k)s.push([O,n.getKeysForOverrideIdentifier(O)])}if(r&&n){for(const k of u)if(E.includes(k)){const O=t({contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});s.push([k,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:l,updated:c,overrides:s}}function t(n,r){const i=n?r?n.keys.filter(s=>r.keys.indexOf(s)===-1):[...n.keys]:[],l=r?n?r.keys.filter(s=>n.keys.indexOf(s)===-1):[...r.keys]:[],c=[];if(n&&r){for(const s of r.keys)if(n.keys.indexOf(s)!==-1){const u=(0,T.getConfigurationValue)(r.contents,s),E=(0,T.getConfigurationValue)(n.contents,s);A.equals(u,E)||c.push(s)}}return{added:i,removed:l,updated:c}}}),define(pe[228],ve([1,0,18,6,2,21,8,111,53,12,68,40]),function(oe,e,w,R,o,D,C,A,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new A.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:f})=>this.c(Array.from(a),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,f){this.h(a,I.Registry.as(v.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new A.ConfigurationModel;const a=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,f){const h=this.f();for(const d of a){const S=h[d],L=f[d];S!==void 0?this.b.addValue(d,S):L?this.b.addValue(d,L.default):this.b.removeValue(d)}}}e.DefaultConfiguration=y;class m{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new A.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let p=class extends o.Disposable{get configurationModel(){return this.b}constructor(a,f,h){super(),this.c=a,this.f=f,this.g=h,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new A.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const f={},h=[],d=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const S of a){const L=d[S];if(!L){h.push(S);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}h.push(S),f[L.policy.name]={type:L.type}}}return(0,C.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),h}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const f=I.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),h=(0,w.coalesce)(a.map(d=>f.get(d)));this.j(h,!0)}j(a,f){this.g.trace("PolicyConfiguration#update",a);const h=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),d=[],S=this.b.isEmpty();for(const L of a){const t=h[L]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(S?n!==void 0:!(0,D.equals)(this.b.getValue(L),n))&&d.push([L,n])}else this.b.getValue(L)!==void 0&&d.push([L,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const L=this.b;this.b=new A.ConfigurationModel;for(const t of L.keys)this.b.setValue(t,L.getValue(t));for(const[t,n]of d)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);f&&this.a.fire(this.b)}}};p=Le([Ae(1,T.IPolicyService),Ae(2,g.ILogService)],p),e.PolicyConfiguration=p}),define(pe[112],ve([1,0,14,6,2,19,25,111,228,68]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends o.Disposable{constructor(y,m,p,b){super(),this.i=y,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.DefaultConfiguration),this.c=p instanceof g.NullPolicyService?new v.NullPolicyConfiguration:this.B(new v.PolicyConfiguration(this.b,p,b)),this.f=this.B(new A.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,m)),this.a=new A.Configuration(this.b.configurationModel,this.c.configurationModel,new A.ConfigurationModel,new A.ConfigurationModel),this.g=this.B(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:f})=>this.k(a,f))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,m,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new A.Configuration(y,m,new A.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(y,m){const p=typeof y=="string"?y:void 0,b=(0,C.isConfigurationOverrides)(y)?y:(0,C.isConfigurationOverrides)(m)?m:{};return this.a.getValue(p,b,void 0)}updateValue(y,m,p,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const m=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(p,m,2)}k(y,m){const p=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(y,m);this.m(b,p,7)}l(y){const m=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(y);this.m(p,m,7)}m(y,m,p){const b=new A.ConfigurationChangeEvent(y,{data:m},this.a);b.source=p,b.sourceConfig=this.n(p),this.h.fire(b)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(pe[113],ve([1,0,11,5]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var o;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(o=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends w.ErrorNoTelemetry{static isNotAvailable(v){return v instanceof D&&v._code===o.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof D&&v._code===o.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof D&&v._code===o.NoResolverFound}static isHandled(v){return v instanceof D&&v.isHandled}constructor(v,g=o.Unknown,T){super(v),this._message=v,this._code=g,this._detail=T,this.isHandled=g===o.NotAvailable&&T===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function C(A){const v=A.indexOf("+");return v===-1?A:A.substring(0,v)}e.getRemoteAuthorityPrefix=C}),define(pe[229],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,w.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(pe[54],ve([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=R;function o(g){if(!g)return;const T=g.indexOf("+");return T<0?g:g.substr(0,T)}e.getRemoteName=o;function D(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=D;function C(g){const{host:T,port:I}=v(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:I}}e.parseAuthorityWithPort=C;function A(g,T){let{host:I,port:y}=v(g);return typeof y>"u"&&(y=T),{host:I,port:y}}e.parseAuthorityWithOptionalPort=A;function v(g){const T=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(pe[36],ve([1,0,17,5,54]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var A;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class v{constructor(a){this.value=a,this.c=a.toLowerCase()}static equals(a,f){if(typeof a>"u"||a===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof a=="string"||typeof f=="string"){const h=typeof a=="string"?a:a.value,d=typeof f=="string"?f:f.value;return w.equalsIgnoreCase(h,d)}return a.c===f.c}static toKey(a){return typeof a=="string"?a.toLowerCase():a.c}}e.ExtensionIdentifier=v;class g{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const f of a)this.add(f)}add(a){this.c.add(v.toKey(a))}delete(a){return this.c.delete(v.toKey(a))}has(a){return this.c.has(v.toKey(a))}}e.ExtensionIdentifierSet=g;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(v.toKey(a))}get(a){return this.c.get(v.toKey(a))}has(a){return this.c.has(v.toKey(a))}set(a,f){this.c.set(v.toKey(a),f)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function I(b){return y(b)}e.isApplicationScopedExtension=I;function y(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function m(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function p(b,a){if(a){const f=`onResolveRemoteAuthority:${(0,o.getRemoteName)(a)}`;return!!b.activationEvents?.includes(f)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[230],ve([1,0,11,36]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class o{constructor(){this.a=new Map,this.b=new WeakMap}register(C,A){this.a.set(C,A)}readActivationEvents(C){return this.b.has(C)||this.b.set(C,this.c(C)),this.b.get(C)}createActivationEventsMap(C){const A=Object.create(null);for(const v of C){const g=this.readActivationEvents(v);g.length>0&&(A[R.ExtensionIdentifier.toKey(v.identifier)]=g)}return A}c(C){if(typeof C.main>"u"&&typeof C.browser>"u")return[];const A=Array.isArray(C.activationEvents)?C.activationEvents.slice(0):[];if(!C.contributes)return A;for(const v in C.contributes){const g=this.a.get(v);if(!g)continue;const T=C.contributes[v],I=Array.isArray(T)?T:[T];try{g(I,A)}catch(y){(0,w.onUnexpectedError)(y)}}return A}}e.ImplicitActivationEventsImpl=o,e.ImplicitActivationEvents=new o}),define(pe[231],ve([1,0,2,36,16]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends w.Disposable{constructor(A,v,g,T,I){super(),this.a=A,this.b=v,this.c=g,this.f=I,this.B(T.onDidInstallExtensions(y=>this.g(y))),this.B(T.onDidUninstallExtension(y=>this.h(y)))}g(A){for(const v of A)v.local&&this.invalidate(v.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,A)&&await this.i(v);else await this.i(this.a.defaultProfile)}async i(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,R.USER_MANIFEST_CACHE_FILE))}catch(v){(0,o.toFileOperationResult)(v)!==1&&this.f.error(v)}}}e.ExtensionsManifestCache=D}),define(pe[43],ve([1,0,15,11,2,187,53,5,12,40]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");class T{constructor(L){this.b=L}toJSON(){if(!this.a){const L=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?L[t]="*****":L[t]=this.b[t];this.a=L}return this.a}}class I extends o.Disposable{constructor(L,t){super(),this.b=0,this.a=t.createLogger(L?"remotenetwork":"network",{name:L?(0,D.localize)(0,null):(0,D.localize)(1,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async c(L,t,n){const r=`${L} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new T(t.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.getErrorMessage)(i)),i}}}e.AbstractRequestService=I;function y(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=y;function m(S){return S.res.statusCode===204}async function p(S){return m(S)?null:(await(0,w.streamToBuffer)(S.stream)).toString()}e.asText=p;async function b(S){if(!y(S))throw new Error("Server returned "+S.res.statusCode);return p(S)}e.asTextOrError=b;async function a(S){if(!y(S))throw new Error("Server returned "+S.res.statusCode);if(m(S))return null;const t=(await(0,w.streamToBuffer)(S.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}e.asJson=a;function f(S){d(S)}e.updateProxyConfigurationsScope=f;let h;function d(S){const L=g.Registry.as(C.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,D.localize)(2,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0}}},L.updateConfigurations({add:[h],remove:t?[t]:[]})}d(1)}),define(pe[232],ve([1,0,20,13,16,43]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let C=class{constructor(v,g){this.a=v,this.b=g}async download(v,g,T=w.CancellationToken.None){if(v.scheme===R.Schemas.file||v.scheme===R.Schemas.vscodeRemote){await this.b.copy(v,g);return}const I={type:"GET",url:v.toString(!0)},y=await this.a.request(I,T);if(y.res.statusCode===200)await this.b.writeFile(g,y.stream);else{const m=await(0,D.asTextOrError)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${m}`)}}};C=Le([Ae(0,D.IRequestService),Ae(1,o.IFileService)],C),e.DownloadService=C}),define(pe[233],ve([1,0,15,20]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class o{constructor(A){this.a=A}listen(A,v){throw new Error("Invalid listen")}call(A,v,g,T=R.CancellationToken.None){switch(v){case"request":return this.a.request(g[0],T).then(async({res:I,stream:y})=>{const m=await(0,w.streamToBuffer)(y);return[{statusCode:I.statusCode,headers:I.headers},m]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.RequestChannel=o;class D{constructor(A){this.a=A}async request(A,v){const[g,T]=await this.a.call("request",[A],v);return{res:g,stream:(0,w.bufferToStream)(T)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}}e.RequestChannelClient=D}),define(pe[234],ve([1,0,82,8]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function o(C,A){return C.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:C.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function D(C,A,v={}){const g=(0,w.parse)(C),T=v.proxyUrl||o(g,A);if(!T)return null;const I=(0,w.parse)(T);if(!/^https?:$/.test(I.protocol||""))return null;const y={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,R.isBoolean)(v.strictSSL)?v.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((m,p)=>{oe(["http-proxy-agent"],m,p)}))(y):new(await new Promise((m,p)=>{oe(["https-proxy-agent"],m,p)}))(y)}e.getProxyAgent=D}),define(pe[83],ve([1,0,50,7,188,20,38,11,3,22,163,205,14,142]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function b(f,h,d,S){return d["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(S)&&!d["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(S)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=y.Promises.withAsyncBody(async(L,t)=>{const n=new D.CancellationTokenSource;let r=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,m.clamp)(i,1,120)*1e3);const l=setTimeout(()=>{n.dispose(!0),t(new Error((0,o.localize)(0,null)))},r);try{L(await a(h,n.token))}catch(c){!(0,A.isCancellationError)(c)&&!n.token.isCancellationRequested?t(new Error((0,o.localize)(1,null,(0,C.toErrorMessage)(c)))):L({})}finally{clearTimeout(l),n.dispose()}})),p)}e.getResolvedShellEnv=b;async function a(f,h){const d=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",d);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",S);const L=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(L+"({.*})"+L),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",n);const r=await(0,T.getSystemShell)(v.OS,n);return f.trace("getUnixShellEnvironment#shell",r),new Promise((i,l)=>{if(h.isCancellationRequested)return l(new A.CancellationError);const c=(0,R.basename)(r);let s,u;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(s=`& '${process.execPath}' ${E} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,u=["-Login","-Command"]):(s=`'${process.execPath}' ${E} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,c==="tcsh"||c==="csh"?u=["-ic"]:u=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),s);const k=(0,w.spawn)(r,[...u,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});h.onCancellationRequested(()=>(k.kill(),l(new A.CancellationError))),k.on("error",q=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(q)),l(q)});const O=[];k.stdout.on("data",q=>O.push(q));const B=[];k.stderr.on("data",q=>B.push(q)),k.on("close",(q,le)=>{const de=Buffer.concat(O).toString("utf8");f.trace("getUnixShellEnvironment#raw",de);const ue=Buffer.concat(B).toString("utf8");if(ue.trim()&&f.trace("getUnixShellEnvironment#stderr",ue),q||le)return l(new Error((0,o.localize)(2,null,q,le)));const ae=t.exec(de),_=ae?ae[1]:"{}";try{const ee=JSON.parse(_);d?ee.ELECTRON_RUN_AS_NODE=d:delete ee.ELECTRON_RUN_AS_NODE,S?ee.ELECTRON_NO_ATTACH_CONSOLE=S:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.VSCODE_RESOLVING_ENVIRONMENT,delete ee.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",ee),i(ee)}catch(ee){f.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(ee)),l(ee)}})})}}),define(pe[235],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,w.createDecorator)("stateReadService"),e.IStateService=(0,w.createDecorator)("stateService")}),define(pe[236],ve([1,0,14,15,8,24,16,12]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var v;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(v=e.SaveStrategy||(e.SaveStrategy={}));class g{constructor(m,p,b,a){this.f=m,this.g=b,this.h=a,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=p===0?void 0:new w.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.g.error(m)}}getItem(m,p){const b=this.a[m];return(0,o.isUndefinedOrNull)(b)?p:b}setItem(m,p){this.setItems([{key:m,data:p}])}setItems(m){let p=!1;for(const{key:b,data:a}of m)this.a[b]!==a&&((0,o.isUndefinedOrNull)(a)?(0,o.isUndefined)(this.a[b])||(this.a[b]=void 0,p=!0):(this.a[b]=a,p=!0));p&&this.j()}removeItem(m){(0,o.isUndefined)(this.a[m])||(this.a[m]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(m)),this.b=m}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=g;let T=class{constructor(m,p,b,a){this.a=new g(p.stateResource,m,b,a)}async init(){await this.a.init()}getItem(m,p){return this.a.getItem(m,p)}};T=Le([Ae(1,D.IEnvironmentService),Ae(2,A.ILogService),Ae(3,C.IFileService)],T),e.StateReadonlyService=T;class I extends T{setItem(m,p){this.a.setItem(m,p)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.StateService=I}),define(pe[114],ve([1,0,3,28,22]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(v){if(w.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function C(v,g,T,I,y,m,p,b){const a=Object.create(null);a["common.machineId"]=m,a.sessionID=(0,o.generateUuid)()+Date.now(),a.commitHash=I,a.version=y,a["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,w.PlatformToString)(w.platform),a["common.nodePlatform"]=R.platform,a["common.nodeArch"]=T,a["common.product"]=b||"desktop",p&&(a["common.msftInternal"]=p);let f=0;const h=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),w.isLinuxSnap&&(a["common.snap"]="true");const d=D(g);return d&&(a["common.platformDetail"]=d),a}e.resolveCommonProperties=C;function A(v){const g=R.env.USERDNSDOMAIN;if(!g)return!1;const T=g.toLowerCase();return v.some(I=>T===I)}e.verifyMicrosoftInternalDomain=A}),define(pe[237],ve([1,0,18,11,2,21,16]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(g){function T(I,y){return I.callstack<y.callstack?-1:I.callstack>y.callstack?1:0}g.compare=T})(A=e.ErrorEvent||(e.ErrorEvent={}));class v{constructor(T,I=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new o.DisposableStore,this.c=T,this.d=I;const y=R.errorHandler.addListener(m=>this.j(m));this.h.add((0,o.toDisposable)(y)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),R.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof C.FileOperationError||T?.message?.includes("Unable to read file")))return;const I=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,y=T.message?T.message:(0,D.safeStringify)(T);!I||this.k({msg:y,callstack:I})}k(T){const I=(0,w.binarySearch)(this.g,T,A.compare);I<0?(T.count=1,this.g.splice(~I,0,T)):(this.g[I].count||(this.g[I].count=0),this.g[I].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const T of this.g)this.c.publicLogError2("UnhandledError",T);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(pe[238],ve([1,0,2]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class R extends w.Disposable{constructor(D,C){super(),this.a=D,this.b=C}async call(D,C,A){switch(C){case"updateTelemetryLevel":{const{telemetryLevel:v}=A;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:g}=A;return this.b?this.b.log(v,g):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${C} not found`)}listen(D,C,A){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=R}),define(pe[30],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var o;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(o=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(pe[239],ve([1,0,33,14,72,13,7,3,4,98,23,101,211,16,26,30]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function f(t,n){const r=`${t}::${n.join(":")}`,i=a.get(r);if(i)return i;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,s=new Map,u=2e4;function E(O,B,q,le){const de=B.substring(O.length+1);return R.Promises.withAsyncBody(async ue=>{let ae;try{ae=await T.Promises.readdir(B,{withFileTypes:!0})}catch{ue();return}if(le.count>=u){le.count+=ae.length,le.maxReached=!0,ue();return}let _=ae.length;if(_===0){ue();return}let ee=ae;le.count+ae.length>u&&(le.maxReached=!0,_=u-le.count,ee=ae.slice(0,_)),le.count+=ae.length;for(const ne of ee)if(ne.isDirectory()){if(q.includes(ne.name)||await E(O,(0,C.join)(B,ne.name),q,le),--_===0){ue();return}}else{const te=ne.name.lastIndexOf(".");if(te>=0){const x=ne.name.substring(te+1);x&&c.set(x,(c.get(x)??0)+1)}for(const x of l)x.relativePathPattern?.test(de)!==!1&&x.filePattern.test(ne.name)&&s.set(x.tag,(s.get(x.tag)??0)+1);if(--_===0){ue();return}}})}const k=R.Promises.withAsyncBody(async O=>{const B={count:0,maxReached:!1};await E(t,t,n,B);const q=await S(t);O({configFiles:h(s),fileTypes:h(c),fileCount:B.count,maxFilesReached:B.maxReached,launchConfigFiles:q})});return a.set(r,k),k}e.collectWorkspaceStats=f;function h(t){return Array.from(t.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function d(){const t={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.virtualMachineHint.value()*100)}%`},n=w.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=d;async function S(t){try{const n=new Map,r=(0,C.join)(t,".vscode","launch.json"),i=await T.Promises.readFile(r),l=[],c=(0,o.parse)(i.toString(),l);if(l.length)return console.log(`Unable to parse ${r}`),[];if((0,o.getNodeType)(c)==="object"&&c.configurations)for(const s of c.configurations){const u=s.type;u&&(n.has(u)?n.set(u,n.get(u)+1):n.set(u,1))}return h(n)}catch{return[]}}e.collectLaunchConfigs=S;let L=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),A.isWindows||r.push(`Load (avg):       ${w.loadavg().map(l=>Math.round(l)).join(", ")}`),r.push(`VM:               ${Math.round(g.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,I.listProcesses)(n.mainPID),this.k(n)]).then(async i=>{let[l,c]=i,s=this.m(n,l);return r.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))s+=`
${u.errorMessage}`,c+=`
${u.errorMessage}`;else if(s+=`

Remote: ${u.hostName}`,u.processes&&(s+=`
${this.m(n,u.processes)}`),u.workspaceMetadata){c+=`
|  Remote: ${u.hostName}`;for(const E of Object.keys(u.workspaceMetadata)){const k=u.workspaceMetadata[E];let O=`${k.fileCount} files`;k.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${E}): ${O}`,c+=this.h(k)}}}),{processInfo:s,workspaceInfo:c}})}async getSystemInfo(n,r){const{memory:i,vmHint:l,os:c,cpus:s}=d(),u={os:c,memory:i,cpus:s,vmHint:l,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return A.isWindows||(u.load=`${w.loadavg().map(E=>Math.round(E)).join(", ")}`),A.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(n,r){const i=[];return(0,I.listProcesses)(n.mainPID).then(async l=>(i.push(""),i.push(this.g(n)),i.push(""),i.push(this.m(n,l)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(n))),r.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(n,c.processes)),c.workspaceMetadata)for(const s of Object.keys(c.workspaceMetadata)){const u=c.workspaceMetadata[s];let E=`${u.fileCount} files`;u.maxFilesReached&&(E=`more than ${E}`),i.push(`Folder (${s}): ${E}`),i.push(this.h(u))}}),i.push(""),i.push(""),i.join(`
`)))}h(n){const r=[];let l=0;const c=(k,O)=>{const B=` ${k}(${O})`;l+B.length>60?(r.push(s),s="|                 ",l=s.length):l+=B.length,s+=B};let s="|      File types:";const u=10,E=n.fileTypes.length>u?u:n.fileTypes.length;for(let k=0;k<E;k++){const O=n.fileTypes[k];c(O.name,O.count)}if(r.push(s),n.configFiles.length>=0&&(s="|      Conf files:",l=0,n.configFiles.forEach(k=>{c(k.name,k.count)}),r.push(s)),n.launchConfigFiles.length>0){let k="|      Launch Configs:";n.launchConfigFiles.forEach(O=>{k+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),r.push(k)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(i=>i.length));return Object.keys(n).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${n[i]}`).join(`
                  `)}k(n){const r=[],i=[];return n.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(r.push(`|  Window (${l.title})`),l.folderURIs.forEach(c=>{const s=v.URI.revive(c);if(s.scheme===D.Schemas.file){const u=s.fsPath;i.push(f(u,["node_modules",".git"]).then(E=>{let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,C.basename)(u)}): ${k}`),r.push(this.h(E))}).catch(E=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${E.toString()})`)}))}else r.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(l=>r.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}m(n,r){const i=new Map;n.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),n.pidToNames.forEach(({pid:c,name:s})=>i.set(c,s));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,i,l,r,0),l.join(`
`)}n(n,r,i,l,c){const s=c===0;let u;s?u=l.pid===n?`${this.d.applicationName} main`:"remote agent":r.has(l.pid)?u=r.get(l.pid):u=`${"  ".repeat(c)} ${l.name}`;const E=process.platform==="win32"?l.mem:w.totalmem()*(l.mem/100);i.push(`${l.load.toFixed(0).padStart(5," ")}	${(E/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(l.children)&&l.children.forEach(k=>this.n(n,r,i,k,c+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:i}of n.folders){const l=v.URI.revive(i);if(l.scheme!==D.Schemas.file)continue;const c=l.fsPath;try{(await f(c,["node_modules",".git"])).fileTypes.forEach(u=>r.add(u.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const i=v.URI.revive(r);if(i.scheme!==D.Schemas.file)continue;const l=i.fsPath;try{const c=await f(l,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),c.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),c.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};L=Le([Ae(0,b.ITelemetryService),Ae(1,p.IProductService)],L),e.DiagnosticsService=L}),define(pe[37],ve([1,0,21,8,6,25,54,114,30]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(l){this.value=l}}e.TelemetryTrustedValue=g;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class I{async publicLog(l,c,s){}async publicLogError(l,c,s){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,l){return o.Event.debounce(l.onDidChangeConfiguration,(s,u)=>{const E=s?new Set([...s.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:E}},1e3,!0)(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(s.source),configurationKeys:Array.from(s.affectedKeys)})})}e.configurationTelemetry=y;function m(i,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!i.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=m;function p(i,l){return!(l.isBuilt||l.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=p;function b(i){const l=i.getValue(v.TELEMETRY_SETTING_ID),c=i.getValue(v.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function a(i){const l={},c={},s={};d(i,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const E=s[u];typeof E=="number"?c[u]=E:typeof E=="boolean"?c[u]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${E.length}`),l[u]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(l[u]=E)}return{properties:l,measurements:c}}e.validateTelemetryData=a;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const l=(0,C.getRemoteName)(i);return f.has(l)?l:"other"}e.cleanRemoteAuthority=h;function d(i,l,c=0,s){if(!!i)for(const u of Object.getOwnPropertyNames(i)){const E=i[u],k=s?s+u:u;Array.isArray(E)?l[k]=(0,w.safeStringify)(E):E instanceof Date?l[k]=E.toISOString():(0,R.isObject)(E)?c<2?d(E,l,c+1,k+"."):l[k]=(0,w.safeStringify)(E):l[k]=E}}function S(i,l){const c=i.msftInternalDomains||[],s=l.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(c)||s}e.isInternalTelemetry=S;function L(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=L;function t(i,l){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let c=i;const s=[];for(const O of l)for(;;){const B=O.exec(i);if(!B)break;s.push([B.index,O.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(c="";;){const O=E.exec(i);if(!O)break;const B=s.some(([q,le])=>O.index<le&&q<E.lastIndex);!u.test(O[0])&&!B&&(c+=i.substring(k,O.index)+"<REDACTED: user-file-path>",k=E.lastIndex)}return k<i.length&&(c+=i.substr(k)),c}function n(i){if(!i)return i;const l=i.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of c)if(s.regex.test(l))return`<REDACTED: ${s.label}>`;return i}function r(i,l){return(0,w.cloneAndChange)(i,c=>{if(c instanceof g)return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=t(s,l);for(const u of l)s=s.replace(u,"");return s=n(s),s}})}e.cleanData=r}),define(pe[34],ve([1,0,17,29,36,3,4,11,28,37]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,w.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=T;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const l=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,l,c)}static parse(i){const l=I.exec(i);return l&&l[1]&&l[2]?new y({id:l[1]},l[2],l[4]||void 0):null}constructor(i,l,c="undefined"){this.version=l,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=y;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const i=m.exec(r);return i&&i[1]?[a(i[1]),i[2]]:[a(r),void 0]}e.getIdAndVersion=p;function b(r,i){return`${r}.${i}`}e.getExtensionId=b;function a(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function f(r,i){return a(b(r??o.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=f;function h(r,i){const l=[],c=s=>{for(const u of l)if(u.some(E=>T(i(E),i(s))))return u;return null};for(const s of r){const u=c(s);u?u.push(s):l.push([s])}return l}e.groupByExtension=h;function d(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function S(r){return{id:new g.TelemetryTrustedValue(r.identifier.id),name:new g.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new o.ExtensionIdentifier("pprice.better-merge");function L(r,i){const l=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const s=c.shift();if(s&&l.every(u=>!T(u.identifier,{id:s}))){const u=r.filter(E=>T(E.identifier,{id:s}));u.length===1&&(l.push(u[0]),c.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=L;async function t(r,i){if(!D.isLinux)return!1;let l;try{l=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(s))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const l=await t(r,i),c=(0,R.getTargetPlatform)(l?"alpine":D.platform,v.arch);return i.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=n}),define(pe[115],ve([1,0,20,11,13,19,51,4,175,29,34,36]),function(oe,e,w,R,o,D,C,A,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const y=a=>(0,v.localize)(0,null,a),m=(0,v.localize)(1,null,"ms-dotnettools.csharp");function p(a,f){return f?`${a.publisher}.${a.name}@${a.version}`:`${a.publisher}.${a.name}`}let b=class{constructor(f,h,d){this.a=f,this.b=h,this.d=d}get f(){}async listExtensions(f,h,d){let S=await this.b.getInstalled(1,d);const L=I.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(h&&h!==""){if(L.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}S=S.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),L.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),S=S.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let t;for(const n of S)t!==n.identifier.id&&(t=n.identifier.id,this.a.info(p(n.manifest,f)))}async installExtensions(f,h,d,S){const L=[],t=[];f.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const n=[];let r=[];const i=(c,s,u)=>{r.push({id:c,version:s!=="prerelease"?s:void 0,installOptions:{...d,isBuiltin:u,installPreReleaseVersion:s==="prerelease"||d.installPreReleaseVersion}})};for(const c of f)if(c instanceof A.URI)n.push({vsix:c,installOptions:d});else{const[s,u]=(0,T.getIdAndVersion)(c);i(s,u,!1)}for(const c of h)if(c instanceof A.URI)n.push({vsix:c,installOptions:{...d,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,u]=(0,T.getIdAndVersion)(c);i(s,u,!0)}const l=await this.b.getInstalled(1,d.profileLocation);if(n.length&&await Promise.all(n.map(async({vsix:c,installOptions:s})=>{try{const u=await this.g(c,s,S,l);u&&t.push(u)}catch(u){this.a.error(u),L.push(c.toString())}})),r.length&&(r=r.filter(({id:c,version:s})=>{const u=l.find(E=>(0,T.areSameExtensions)(E.identifier,{id:c}));if(u){if(!S&&(!s||s==="prerelease"&&u.preRelease))return this.a.info((0,v.localize)(5,null,c,u.manifest.version,c)),!1;if(s&&u.manifest.version===s)return this.a.info((0,v.localize)(6,null,`${c}@${s}`)),!1}return!0}),r.length)){const c=await this.h(r);await Promise.all(r.map(async s=>{const u=c.get(s.id.toLowerCase());if(u)try{const E=await this.j(s,u,l);E&&t.push(E)}catch(E){this.a.error(E.message||E.stack||E),L.push(s.id)}else this.a.error(`${y(s.version?`${s.id}@${s.version}`:s.id)}
${m}`),L.push(s.id)}))}if(L.length)throw new Error((0,v.localize)(7,null,L.join(", ")))}async g(f,h,d,S){const L=await this.b.getManifest(f);if(!L)throw new Error("Invalid vsix");if(await this.l(L,d,h.profileLocation,S))try{return await this.b.install(f,h),this.a.info((0,v.localize)(8,null,(0,D.basename)(f))),L}catch(n){if((0,R.isCancellationError)(n))return this.a.info((0,v.localize)(9,null,(0,D.basename)(f))),null;throw n}return null}async h(f){const h=new Map,d=f.some(t=>t.installOptions.installPreReleaseVersion),S=await this.b.getTargetPlatform(),L=await this.d.getExtensions(f.map(t=>({...t,preRelease:d})),{targetPlatform:S},w.CancellationToken.None);for(const t of L)h.set(t.identifier.id.toLowerCase(),t);return h}async j({id:f,version:h,installOptions:d},S,L){const t=await this.d.getManifest(S,w.CancellationToken.None);if(t&&!this.k(t))return null;const n=L.find(r=>(0,T.areSameExtensions)(r.identifier,S.identifier));if(n){if(S.version===n.manifest.version)return this.a.info((0,v.localize)(10,null,h?`${f}@${h}`:f)),null;this.a.info((0,v.localize)(11,null,f,S.version))}try{d.isBuiltin?this.a.info(h?(0,v.localize)(12,null,f,h):(0,v.localize)(13,null,f)):this.a.info(h?(0,v.localize)(14,null,f,h):(0,v.localize)(15,null,f));const r=await this.b.installFromGallery(S,{...d,installGivenVersion:!!h});return this.a.info((0,v.localize)(16,null,f,r.manifest.version)),t}catch(r){if((0,R.isCancellationError)(r))return this.a.info((0,v.localize)(17,null,f)),null;throw r}}k(f){return!0}async l(f,h,d,S){if(!h){const L={id:(0,T.getGalleryExtensionId)(f.publisher,f.name)},t=S.find(n=>(0,T.areSameExtensions)(L,n.identifier)&&(0,C.gt)(n.manifest.version,f.version));if(t)return this.a.info((0,v.localize)(18,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,h,d){const S=async t=>{if(t instanceof A.URI){const n=await this.b.getManifest(t);return p(n)}return t},L=[];for(const t of f){const n=await S(t),i=(await this.b.getInstalled(void 0,d)).filter(l=>(0,T.areSameExtensions)(l.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${m}`);if(i.some(l=>l.type===0)){this.a.info((0,v.localize)(19,null,n));return}if(!h&&i.some(l=>l.isBuiltin)){this.a.info((0,v.localize)(20,null,n));return}this.a.info((0,v.localize)(21,null,n));for(const l of i)await this.b.uninstall(l,{profileLocation:d}),L.push(l);this.f?this.a.info((0,v.localize)(22,null,n,this.f)):this.a.info((0,v.localize)(23,null,n))}}async locateExtension(f){const h=await this.b.getInstalled();f.forEach(d=>{h.forEach(S=>{if(S.identifier.id===d&&S.location.scheme===o.Schemas.file){this.a.info(S.location.fsPath);return}})})}m(f){return this.f?(0,v.localize)(24,null,f,this.f):(0,v.localize)(25,null,f)}};b=Le([Ae(1,g.IExtensionManagementService),Ae(2,g.IExtensionGalleryService)],b),e.ExtensionManagementCLI=b}),define(pe[240],ve([1,0,6,2,27,34,36]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class A extends R.Disposable{constructor(g,T,I,y,m,p,b){super(),this.f=g,this.g=T,this.h=I,this.i=y,this.j=m,this.k=p,this.l=b,this.a=this.B(new w.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,a=>b.error(a))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(g=>this.p(g.added,g.removed))),this.B(this.i.onAddExtensions(g=>this.r(g))),this.B(this.i.onDidAddExtensions(g=>this.s(g))),this.B(this.i.onRemoveExtensions(g=>this.t(g))),this.B(this.i.onDidRemoveExtensions(g=>this.u(g))),this.B(this.k.onDidFilesChange(g=>this.v(g)))}async p(g,T){try{await Promise.all(T.map(I=>(this.c.deleteAndDispose(I.id),this.z(I.extensionsResource)))),g.length&&await Promise.all(g.map(I=>(this.c.set(I.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(I.extensionsResource)),this.k.watch(I.extensionsResource))),this.y(I.extensionsResource))))}catch(I){throw this.l.error(I),I}}async r(g){for(const T of g.extensions)this.D(this.G(T.identifier,T.version),g.profileLocation)}async s(g){for(const T of g.extensions){const I=this.G(T.identifier,T.version);g.error?this.F(I,g.profileLocation):this.D(I,g.profileLocation)}}async t(g){for(const T of g.extensions)this.F(this.G(T.identifier,T.version),g.profileLocation)}async u(g){const T=[],I=[];for(const y of g.extensions){const m=this.G(y.identifier,y.version);g.error?this.D(m,g.profileLocation):(this.F(m,g.profileLocation),this.b.has(m)||(this.l.debug("Extension is removed from all profiles",y.identifier.id,y.version),I.push(this.f.scanInstalledExtensionAtLocation(y.location).then(p=>{p?T.push(p):this.l.info("Extension not found at the location",y.location.toString())},p=>this.l.error(p)))))}try{await Promise.all(I),T.length&&await this.C(T)}catch(y){this.l.error(y)}}v(g){for(const T of this.h.profiles)g.contains(T.extensionsResource,0,1)&&this.w(T.extensionsResource)}async w(g){const T=[],I=[],y=await this.i.scanProfileExtensions(g),m=new Set,p=new Set;for(const[b,a]of this.b)a.has(g)&&p.add(b);for(const b of y){const a=this.G(b.identifier,b.version);m.add(a),p.has(a)||(T.push(b.identifier),this.D(a,g))}for(const b of p)if(!m.has(b)){const a=this.H(b);a&&(I.push(a.identifier),this.F(b,g))}(T.length||I.length)&&this.a.fire({added:T.length?{extensions:T,profileLocation:g}:void 0,removed:I.length?{extensions:I,profileLocation:g}:void 0})}async y(g){const T=await this.i.scanProfileExtensions(g);for(const I of T)this.D(this.G(I.identifier,I.version),g)}async z(g){for(const T of[...this.b.keys()])this.F(T,g);await this.C()}async C(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.G(I.identifier,I.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}D(g,T){let I=this.b.get(g);I||this.b.set(g,I=new o.ResourceSet(y=>this.j.extUri.getComparisonKey(y))),I.add(T)}F(g,T){const I=this.b.get(g);I&&I.delete(T),I?.size||this.b.delete(g)}G(g,T){return`${C.ExtensionIdentifier.toKey(g.id)}@${T}`}H(g){const[T,I]=(0,D.getIdAndVersion)(g);return I?{identifier:{id:T},version:I}:void 0}}e.ExtensionsWatcher=A}),define(pe[241],ve([1,0,208,37]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function o(D,C,A,v,g,T,I){const y={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${C.nameShort})`};if((0,R.supportsTelemetry)(C,A)&&(0,R.getTelemetryLevel)(v)===3){const m=await(0,w.getServiceMachineId)(A,g,T);y["X-Market-User-Id"]=m,y["VSCode-SessionId"]=I.machineId||m}return y}e.resolveMarketplaceHeaders=o}),define(pe[116],ve([1,0,117,18,14,2,13,7,23,24,29,34,12,81,4]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let b=class extends m.LanguagePackBaseService{constructor(d,S,L,t){super(L),this.h=d,this.i=t,this.g=this.B(new a(S,t)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(d,S){const t=(await this.g.getLanguagePacks())[S];if(!t){this.i.warn(`No language pack found for ${S}`);return}const n=t.translations[d];return n?p.URI.file(n):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),S=Object.keys(d).map(L=>{const t=d[L];return{...this.f(L,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return S.push(this.f("en","English")),S.sort((L,t)=>L.label.localeCompare(t.label)),S}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const S=await this.g.getLanguagePacks();Object.keys(S).some(L=>S[L]&&S[L].extensions.some(t=>(0,I.areSameExtensions)(t.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,S]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),L=await this.g.update(S);return!(0,R.equals)(Object.keys(d),Object.keys(L))}};b=Le([Ae(0,T.IExtensionManagementService),Ae(1,g.INativeEnvironmentService),Ae(2,T.IExtensionGalleryService),Ae(3,y.ILogService)],b),e.NativeLanguagePackService=b;let a=class extends D.Disposable{constructor(d,S){super(),this.i=S,this.c={},this.f=(0,A.join)(d.userDataPath,"languagepacks.json"),this.g=new o.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(S=>{Object.keys(S).forEach(L=>delete S[L]),this.j(S,...d)}).then(()=>this.c)}j(d,...S){for(const L of S)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.k(d,L);Object.keys(d).forEach(L=>this.l(d[L]))}k(d,S){const L=S.identifier,t=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const n of t)if(S.location.scheme===C.Schemas.file&&f(n)){let r=d[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},d[n.languageId]=r);const i=r.extensions.filter(l=>(0,I.areSameExtensions)(l.extensionIdentifier,L))[0];i?i.version=S.manifest.version:r.extensions.push({extensionIdentifier:L,version:S.manifest.version});for(const l of n.translations)r.translations[l.id]=(0,A.join)(S.location.fsPath,l.path)}}l(d){if(d){const S=(0,w.createHash)("md5");for(const L of d.extensions)S.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);d.hash=S.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let S=null;return v.Promises.readFile(this.f,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(S=d(L),L)).then(L=>{for(const n of Object.keys(L))L[n]||delete L[n];this.c=L,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>S,L=>this.i.error(L))})}};a=Le([Ae(0,g.INativeEnvironmentService),Ae(1,y.ILogService)],a);function f(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const d of h.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(pe[242],ve([1,0,11,21,37]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function A(g,T,I){const y=await new Promise((f,h)=>{oe(["@microsoft/1ds-core-js"],f,h)}),m=await new Promise((f,h)=>{oe(["@microsoft/1ds-post-js"],f,h)}),p=new y.AppInsightsCore,b=new m.PostChannel,a={instrumentationKey:g,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(I){a.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:I};a.extensionConfig[b.identifier]=f}return p.initialize(a,[]),p.addTelemetryInitializer(f=>{T&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),p}class v{constructor(T,I,y,m,p){this.e=T,this.f=I,this.g=y,this.h=p,this.c=D,this.d=C,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(T){if(!!this.a){if(typeof this.a!="string"){T(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(I=>{T(I)},I=>{(0,w.onUnexpectedError)(I),console.error(I)})}}log(T,I){if(!this.a)return;I=(0,R.mixin)(I,this.g),I=(0,o.validateTelemetryData)(I);const y=this.f+"/"+T;try{this.i(m=>{m.pluginVersionString=I?.properties.version??"Unknown",m.track({name:y,baseData:{name:y,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this.a?new Promise(T=>{this.i(I=>{I.unload(!0,()=>{this.a=void 0,T(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(pe[243],ve([1,0,2,21,3,17,189,25,53,52,26,40,30,37]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(f,h,d){this.k=h,this.l=d,this.d={},this.i=new w.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(y.TELEMETRY_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,h){this.d[f]=h}m(){let f=(0,m.getTelemetryLevel)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const d=h.usage?3:h.error?2:0;f=Math.min(f,d)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,h,d){this.g<h||(d=(0,R.mixin)(d,this.d),d=(0,m.cleanData)(d,this.j),d=(0,R.mixin)(d,this.c),this.b.forEach(S=>S.log(f,d)))}publicLog(f,h){this.n(f,3,h)}publicLog2(f,h){this.publicLog(f,h)}publicLogError(f,h){!this.h||this.n(f,2,h)}publicLogError2(f,h){this.publicLogError(f,h)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=Le([Ae(1,A.IConfigurationService),Ae(2,T.IProductService)],p),e.TelemetryService=p;function b(){const a=(0,C.localize)(0,null,g.default.nameLong),f=g.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=o.isWeb?"":(0,C.localize)(3,null),d=(0,C.localize)(4,null),S=(0,C.localize)(5,null),L=(0,C.localize)(6,null),t=(0,C.localize)(7,null),n=`
|       | ${d} | ${S} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${a} ${f} ${h}

&nbsp;

${t}
${n}

&nbsp;

${r}
`}I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,C.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,C.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[244],ve([1,0,25,5,26,30,243,37]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends C.TelemetryService{constructor(T,I,y,m){super(T,y,m),this.o=I}publicLog(T,I){if(!(this.o<3))return super.publicLog(T,I)}publicLog2(T,I){return this.publicLog(T,I)}publicLogError(T,I){return this.o<2?Promise.resolve(void 0):super.publicLogError(T,I)}publicLogError2(T,I){return this.publicLogError(T,I)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,T):T,this.o===0&&this.dispose()}};v=Le([Ae(2,w.IConfigurationService),Ae(3,o.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends A.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,R.refineServiceDecorator)(D.ITelemetryService)}),define(pe[245],ve([1,0,294,242]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class o extends R.AbstractOneDataSystemAppender{constructor(C,A,v,g){const T={sendPOST:(I,y)=>{const m={method:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data)}};try{const p=w.request(I.urlString,m,b=>{b.on("data",function(a){y(b.statusCode??200,b.headers,a.toString())}),b.on("error",function(a){y(0,{})})});p.write(I.data),p.end()}catch{y(0,{})}}};super(C,A,v,g,T)}}e.OneDataSystemAppender=o}),define(pe[246],ve([1,0,11,237]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class o extends R.default{i(){(0,w.setUnexpectedErrorHandler)(A=>console.error(A));const C=[];process.on("unhandledRejection",(A,v)=>{C.push(v),setTimeout(()=>{const g=C.indexOf(v);g>=0&&v.catch(T=>{C.splice(g,1),(0,w.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),A&&(0,w.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const v=C.indexOf(A);v>=0&&C.splice(v,1)}),process.on("uncaughtException",A=>{(0,w.isSigPipeError)(A)||(0,w.onUnexpectedError)(A)})}}e.default=o}),define(pe[118],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(w=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(pe[119],ve([1,0,3,118]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class o{constructor(v){this.collections=v,this.map=new Map,v.forEach((g,T)=>{const I=g.map.entries();let y=I.next();for(;!y.done;){const m=y.value[0];let p=this.map.get(m);if(p||(p=[],this.map.set(m,p)),p.length>0&&p[0].type===R.EnvironmentVariableMutatorType.Replace){y=I.next();continue}const b=y.value[1];p.unshift({extensionIdentifier:T,value:b.value,type:b.type}),y=I.next()}})}async applyToProcessEnvironment(v,g){let T;w.isWindows&&(T={},Object.keys(v).forEach(I=>T[I.toLowerCase()]=I));for(const[I,y]of this.map){const m=w.isWindows&&T[I.toLowerCase()]||I;for(const p of y){const b=g?await g(p.value):p.value;switch(p.type){case R.EnvironmentVariableMutatorType.Append:v[m]=(v[m]||"")+b;break;case R.EnvironmentVariableMutatorType.Prepend:v[m]=b+(v[m]||"");break;case R.EnvironmentVariableMutatorType.Replace:v[m]=b;break}}}}diff(v){const g=new Map,T=new Map,I=new Map;if(v.map.forEach((y,m)=>{const p=this.map.get(m),b=D(y,p);b&&g.set(m,b)}),this.map.forEach((y,m)=>{const p=v.map.get(m),b=D(y,p);b&&I.set(m,b)}),this.map.forEach((y,m)=>{const p=v.map.get(m),b=C(y,p);b&&T.set(m,b)}),!(g.size===0&&T.size===0&&I.size===0))return{added:g,changed:T,removed:I}}}e.MergedEnvironmentVariableCollection=o;function D(A,v){if(!v)return A;const g=new Set;v.forEach(I=>g.add(I.extensionIdentifier));const T=[];return A.forEach(I=>{g.has(I.extensionIdentifier)||T.push(I)}),T.length===0?void 0:T}function C(A,v){if(!v)return;const g=new Map;v.forEach(I=>g.set(I.extensionIdentifier,I));const T=[];return A.forEach(I=>{const y=g.get(I.extensionIdentifier);y&&(I.type!==y.type||I.value!==y.value)&&T.push(y)}),T.length===0?void 0:T}}),define(pe[84],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=w;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R;function o(C){return Array.from(C.entries()).map(A=>[A[0],w(A[1].map)])}e.serializeEnvironmentVariableCollections=o;function D(C){return new Map(C.map(A=>[A[0],{map:R(A[1])}]))}e.deserializeEnvironmentVariableCollections=D}),define(pe[247],ve([1,0,14,20,6,2,12]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let A=class extends D.Disposable{constructor(g,T){super(),this.h=T,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new o.Emitter),this.onCreateRequest=this.g.event,this.b=g===void 0?15e3:g}createRequest(g){return new Promise((T,I)=>{const y=++this.a;this.c.set(y,T),this.g.fire({requestId:y,...g});const m=new R.CancellationTokenSource;(0,w.timeout)(this.b,m.token).then(()=>I(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,D.toDisposable)(()=>m.cancel())])})}acceptReply(g,T){const I=this.c.get(g);I?(this.c.delete(g),(0,D.dispose)(this.f.get(g)||[]),this.f.delete(g),I(T)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${g}`)}};A=Le([Ae(1,C.ILogService)],A),e.RequestStore=A}),define(pe[120],ve([1,0,5,65]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new R.RawContextKey("terminalTabFocusMode",!1,!0);var o;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(o=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.TabFocusMode="terminal.integrated.tabFocusMode",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(C=e.PosixShellType||(e.PosixShellType={}));var A;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var v;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(v=e.TitleEventSource||(e.TitleEventSource={}));var g;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Logger="logger",d.Heartbeat="heartbeat"})(g=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,w.createDecorator)("ptyService");var T;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var y;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(y=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(d){d.TerminalView="view",d.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var p;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var b;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(b=e.FlowControlConstants||(e.FlowControlConstants={}));var a;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(a=e.ProfileSource||(e.ProfileSource={}));var f;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(f=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var h;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(h=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(pe[248],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function R(C){let A=C;A.includes("\\")&&(A=A.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return A=A.replace(v,""),`'${A}'`}e.escapeNonWindowsPath=R;function o(C,A,v){if(!C)return"";if(!A)return C;A.match(/[\/\\]$/)&&(A=A.slice(0,A.length-1));const g=C.replace(/\\/g,"/").toLowerCase(),T=A.replace(/\\/g,"/").toLowerCase();return g.includes(T)?`~${v}${C.slice(A.length+1)}`:C}e.collapseTildePath=o;function D(C){return C.match(/^['"].*['"]$/)&&(C=C.substring(1,C.length-1)),w.OS===1&&C&&C[1]===":"?C[0].toUpperCase()+C.substring(1):C}e.sanitizeCwd=D}),define(pe[249],ve([1,0,47,4,191,93]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function C(y,m){const p=[{name:null,description:(0,o.localize)(0,null)}];return p.push(...y.map(b=>({name:b.profileName,description:A(b)}))),m&&p.push(...m.map(b=>({name:b.title,description:v(b)}))),{values:p.map(b=>b.name),markdownDescriptions:p.map(b=>b.description)}}e.createProfileSchemaEnums=C;function A(y){let m=`$(${D.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:w.Codicon.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?m+=`
- args: "${y.args}"`:m+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(m+=`
- overrideName: ${y.overrideName}`),y.color&&(m+=`
- color: ${y.color}`),y.env&&(m+=`
- env: ${JSON.stringify(y.env)}`),m}function v(y){return`$(${D.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:w.Codicon.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function g(y,m){if(!y&&!m)return!0;if(typeof y=="string"&&typeof m=="string")return y===m;if(Array.isArray(y)&&Array.isArray(m)){if(y.length!==m.length)return!1;for(let p=0;p<y.length;p++)if(y[p]!==m[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=g;function T(y,m){if(!y&&!m)return!0;if(!y||!m)return!1;if(D.ThemeIcon.isThemeIcon(y)&&D.ThemeIcon.isThemeIcon(m))return y.id===m.id&&y.color===m.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof m=="object"&&"light"in m&&"dark"in m){const p=y,b=m;if((R.URI.isUri(p.light)||I(p.light))&&(R.URI.isUri(p.dark)||I(p.dark))&&(R.URI.isUri(b.light)||I(b.light))&&(R.URI.isUri(b.dark)||I(b.dark)))return p.light.path===b.light.path&&p.dark.path===b.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(m)||I(y)||I(m)){const p=y,b=m;return p.path===b.path&&p.scheme===b.scheme}return!1}e.terminalIconsEqual=T;function I(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.isUriComponents=I}),define(pe[250],ve([1,0,47,190,53,40,249]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,w.getAllCodicons)(),S=>S.id),markdownEnumDescriptions:Array.from((0,w.getAllCodicons)(),S=>`$(${S.id})`)};const A={args:{description:(0,R.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,R.localize)(1,null),type:"boolean"},icon:{description:(0,R.localize)(2,null),...e.terminalIconSchema},color:{description:(0,R.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,R.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,R.localize)(5,null),type:["string","array"],items:{type:"string"}},...A}},g={type:"object",required:["path"],properties:{path:{description:(0,R.localize)(6,null),type:["string"],items:{type:"string"}},...A}},T=(0,R.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,R.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,R.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,R.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,R.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,R.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),a={id:"terminal",order:100,title:(0,R.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,R.localize)(26,null)}},{type:"string",markdownDescription:(0,R.localize)(27,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,R.localize)(29,null),enum:["PowerShell","Git Bash"]},...A}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(30,null),type:"string"},id:{description:(0,R.localize)(31,null),type:"string"},title:{description:(0,R.localize)(32,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(34,null),type:"string"},id:{description:(0,R.localize)(35,null),type:"string"},title:{description:(0,R.localize)(36,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(38,null),type:"string"},id:{description:(0,R.localize)(39,null),type:"string"},title:{description:(0,R.localize)(40,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,R.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,R.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,R.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,R.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,R.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){D.Registry.as(o.Extensions.Configuration).registerConfiguration(a),d()}e.registerTerminalPlatformConfiguration=f;let h;function d(S,L){const t=D.Registry.as(o.Extensions.Configuration);let n;S&&(n=(0,C.createProfileSchemaEnums)(S?.profiles,L));const r=h;h={id:"terminal",order:100,title:(0,R.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?n?.values:void 0,markdownEnumDescriptions:S?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?n?.values:void 0,markdownEnumDescriptions:S?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?n?.values:void 0,markdownEnumDescriptions:S?.os===1?n?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[h],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(pe[251],ve([1,0,33,13,21,7,3,28,17,8,23,118,84,119]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let l=0;return i&&i.length===4&&(l=parseInt(i[3])),l}e.getWindowsBuildNumber=p;async function b(i,l,c,s=A.env,u=T.Promises.exists){if(D.isAbsolute(i))return await u(i)?i:void 0;if(l===void 0&&(l=A.cwd()),D.dirname(i)!=="."){const B=D.join(l,i);return await u(B)?B:void 0}const k=(0,o.getCaseInsensitive)(s,"PATH");if(c===void 0&&(0,g.isString)(k)&&(c=k.split(D.delimiter)),c===void 0||c.length===0){const B=D.join(l,i);return await u(B)?B:void 0}for(const B of c){let q;if(D.isAbsolute(B)?q=D.join(B,i):q=D.join(l,B,i),await u(q))return q;if(C.isWindows){let le=q+".com";if(await u(le)||(le=q+".exe",await u(le)))return le}}const O=D.join(l,i);return await u(O)?O:void 0}e.findExecutable=b;function a(i,l,c,s,u){const E=C.isWindows&&(!l.windowsEnableConpty||p()<18309);if(!l.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||E)return;const k=i.args,O=A.platform==="win32"?D.basename(i.executable).toLowerCase():D.basename(i.executable),B=D.dirname(R.FileAccess.asFileUri("").fsPath);let q;const le={VSCODE_INJECTION:"1"};if(C.isWindows){if(O==="pwsh.exe"||O==="powershell.exe")return!k||n(k)?q=d.get(h.WindowsPwsh):t(k)&&(q=d.get(h.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B,""),l.shellIntegration.suggestEnabled&&(le.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:le}):void 0;s.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(O){case"bash":return!k||k.length===0?q=d.get(h.Bash):r(k)&&(le.VSCODE_SHELL_LOGIN="1",f(l,le),q=d.get(h.Bash)),q?(q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B),{newArgs:q,envMixin:le}):void 0;case"fish":{const de=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ue=D.join(B,"out/vs/workbench/contrib/xdg_data");return le.XDG_DATA_DIRS=`${de}:${ue}`,f(l,le),{newArgs:void 0,envMixin:le}}case"pwsh":return!k||n(k)?q=d.get(h.Pwsh):t(k)&&(q=d.get(h.PwshLogin)),q?(l.shellIntegration.suggestEnabled&&(le.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B,""),{newArgs:q,envMixin:le}):void 0;case"zsh":{if(!k||k.length===0?q=d.get(h.Zsh):r(k)?(q=d.get(h.ZshLogin),f(l,le)):(k===d.get(h.Zsh)||k===d.get(h.ZshLogin))&&(q=k),!q)return;q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B);let de;try{de=w.userInfo().username}catch{de="unknown"}const ue=D.join(w.tmpdir(),`${de}-${u.applicationName}-zsh`);le.ZDOTDIR=ue;const ae=c?.ZDOTDIR??w.homedir()??"~";le.USER_ZDOTDIR=ae;const _=[];return _.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.join(ue,".zshrc")}),_.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.join(ue,".zprofile")}),_.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.join(ue,".zshenv")}),_.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.join(ue,".zlogin")}),{newArgs:q,envMixin:le,filesToCopy:_}}}s.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=a;function f(i,l){if(C.isMacintosh&&i.environmentVariableCollections){const c=(0,y.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),u=new m.MergedEnvironmentVariableCollection(c).map.get("PATH"),E=[];if(u)for(const k of u)k.type===I.EnvironmentVariableMutatorType.Prepend&&E.push(k.value);E.length>0&&(l.VSCODE_PATH_PREFIX=E.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const d=new Map;d.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(h.Zsh,["-i"]),d.set(h.ZshLogin,["-il"]),d.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],L=["-nol","-nologo"];function t(i){return typeof i=="string"?S.includes(i.toLowerCase()):i.length===1&&S.includes(i[0].toLowerCase())||i.length===2&&(S.includes(i[0].toLowerCase())||S.includes(i[1].toLowerCase()))&&(L.includes(i[0].toLowerCase())||L.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?L.includes(i.toLowerCase()):i.length===0||i?.length===1&&L.includes(i[0].toLowerCase())}function r(i){return i==="string"&&S.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&S.includes(i[0].toLowerCase())}}),define(pe[252],ve([1,0,50,47,7,3,8,23,99,251,73]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,y=!0;function m(i,l,c,s,u=process.env,E,k,O,B){return E=E||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},D.isWindows?p(c,E,u,k,s.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:s.getValue("terminal.integrated.profiles.windows"),typeof l=="string"?l:s.getValue("terminal.integrated.defaultProfile.windows"),B,O):t(E,k,c,i&&typeof i=="object"?{...i}:s.getValue(D.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof l=="string"?l:s.getValue(D.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),B,O,u)}e.detectAvailableProfiles=m;async function p(i,l,c,s,u,E,k,O,B){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),le=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let de=!1;(0,g.getWindowsBuildNumber)()>=16299&&(de=!0),await f(O);const ue=new Map;if(i){ue.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${le}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${le}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.Codicon.terminalBash,isAutoDetected:!0});const _=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${le}\\cmd.exe`,args:["/K",_],requiresPath:process.env.CMDER_ROOT?_:{path:_,isUnsafe:!0},isAutoDetected:!0})}n(E,ue);const ae=await b(ue.entries(),k,l,c,s,B);if(i||u)try{const _=await S(`${le}\\${de?"wsl":"bash"}.exe`,k);for(const ee of _)(!E||!(ee.profileName in E))&&ae.push(ee)}catch{y&&(s?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return ae}async function b(i,l,c,s=process.env,u,E){const k=[];for(const[O,B]of i){if(B===null)continue;let q,le,de;if("source"in B){const ee=I?.get(B.source);if(!ee)continue;q=ee.paths,le=B.args||ee.args,B.icon?de=a(B.icon):ee.icon&&(de=ee.icon)}else q=Array.isArray(B.path)?B.path:[B.path],le=D.isWindows||Array.isArray(B.args)?B.args:void 0,de=a(B.icon);let ue;if(E){const ee=q.map(te=>typeof te=="string"?te:te.path),ne=await E(ee);ue=new Array(q.length);for(let te=0;te<q.length;te++)typeof q[te]=="string"?ue[te]=ne[te]:ue[te]={path:ne[te],isUnsafe:!0}}else ue=q.slice();let ae;if(B.requiresPath){let ee;if((0,C.isString)(B.requiresPath)?ee=B.requiresPath:(ee=B.requiresPath.path,B.requiresPath.isUnsafe&&(ae=ee)),!await c.existsFile(ee))continue}const _=await r(O,l,ue,c,s,le,B.env,B.overrideName,B.isAutoDetected,ae);_?(_.isAutoDetected=B.isAutoDetected,_.icon=de,_.color=B.color,k.push(_)):u?.debug("Terminal profile not validated",O,q)}return u?.debug("Validated terminal profiles",k),k}function a(i){return typeof i=="string"?{id:i}:i}async function f(i){if(I&&!i)return;const[l,c]=await Promise.all([h(),i||d()]);I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:l,args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:c,icon:R.Codicon.terminalPowershell})}async function h(){const i=new Set,l=await(0,g.findExecutable)("git.exe");if(l){const u=(0,T.dirname)(l);i.add((0,T.resolve)(u,"../.."))}function c(u,E){E&&u.add(E)}c(i,process.env.ProgramW6432),c(i,process.env.ProgramFiles),c(i,process.env["ProgramFiles(X86)"]),c(i,`${process.env.LocalAppData}\\Program`);const s=[];for(const u of i)s.push(`${u}\\Git\\bin\\bash.exe`,`${u}\\Git\\usr\\bin\\bash.exe`,`${u}\\usr\\bin\\bash.exe`);return s.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),s}async function d(){const i=[];for await(const l of(0,v.enumeratePowerShellInstallations)())i.push(l.exePath);return i}async function S(i,l){const c=[],s=await new Promise((k,O)=>{w.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(B,q)=>{if(B)return O("Problem occurred when getting wsl distros");k(q)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),E=s.split(u).filter(k=>k.trim().length>0&&k!=="");for(const k of E){if(k===""||k.startsWith("docker-desktop"))continue;const O=`${k} (WSL)`,B={profileName:O,path:i,args:["-d",`${k}`],isDefault:O===l,icon:L(k),isAutoDetected:!1};c.push(B)}return c}function L(i){return i.includes("Ubuntu")?R.Codicon.terminalUbuntu:i.includes("Debian")?R.Codicon.terminalDebian:R.Codicon.terminalLinux}async function t(i,l,c,s,u,E,k,O){const B=new Map;if(c){const q=(await i.readFile("/etc/shells")).toString(),le=E||q.split(`
`).filter(ue=>ue.trim().includes("#")&&ue.trim().length>0),de=new Map;for(const ue of le){let ae=(0,o.basename)(ue),_=de.get(ae)||0;_++,_>1&&(ae=`${ae} (${_})`),de.set(ae,_),B.set(ae,{path:ue,isAutoDetected:!0})}}return n(s,B),await b(B.entries(),u,i,O,l,k)}function n(i,l){if(!!i)for(const[c,s]of Object.entries(i))s===null||typeof s!="object"||!("path"in s)&&!("source"in s)?l.delete(c):(s.icon=s.icon||l.get(c)?.icon,l.set(c,s))}async function r(i,l,c,s,u,E,k,O,B,q){if(c.length===0)return Promise.resolve(void 0);const le=c.shift();if(le==="")return r(i,l,c,s,u,E,k,O,B);const de=typeof le!="string"&&le.isUnsafe,ue=typeof le=="string"?le:le.path,ae={profileName:i,path:ue,args:E,env:k,overrideName:O,isAutoDetected:B,isDefault:i===l,isUnsafePath:de,requiresUnsafePath:q};if((0,o.basename)(ue)===ue){const ee=u.PATH?u.PATH.split(o.delimiter):void 0,ne=await(0,g.findExecutable)(ue,void 0,ee,void 0,s.existsFile);return ne?(ae.path=ne,ae.isFromPath=!0,ae):r(i,l,c,s,u,E)}return await s.existsFile((0,o.normalize)(ue))?ae:r(i,l,c,s,u,E,k,O,B)}}),define(pe[253],ve([1,0,6,2,13,3,42,103,25,24,104,83,12,247,120,250,252,108]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(L){L[L.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let d=0,S=class extends R.Disposable{constructor(t,n,r,i,l,c){super(),this.C=t,this.D=n,this.F=r,this.G=i,this.H=l,this.I=c,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new w.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new w.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new w.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new w.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new w.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new w.Emitter),this.onProcessData=this.s.event,this.t=this.B(new w.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new w.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new w.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new w.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new w.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new w.Emitter),this.onProcessExit=this.z.event,(0,b.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,R.toDisposable)(()=>this.O())),this.f=this.B(new m.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(D.isWindows)return process.env;try{return await(0,I.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:d,VSCODE_PTY_REMOTE:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},n=(0,T.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);n&&(n.break&&n.port?t.debugBrk=n.port:!n.break&&n.port&&(t.debug=n.port));const r=new A.Client(o.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),C.ProxyChannel.toService(r.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(r.onDidProcessExit(c=>{this.l.fire(c.code),this.i||(this.g<=h.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))})),this.B(new f.RemoteLoggerChannelClient(this.I,r.getChannel(p.TerminalIpcChannels.Logger)));const l=C.ProxyChannel.toService(r.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(c=>this.s.fire(c))),this.B(l.onProcessReady(c=>this.t.fire(c))),this.B(l.onProcessExit(c=>this.z.fire(c))),this.B(l.onDidChangeProperty(c=>this.y.fire(c))),this.B(l.onProcessReplay(c=>this.u.fire(c))),this.B(l.onProcessOrphanQuestion(c=>this.v.fire(c))),this.B(l.onDidRequestDetach(c=>this.w.fire(c))),[r,l]}dispose(){this.i=!0,super.dispose()}async createProcess(t,n,r,i,l,c,s,u,E,k,O){const B=setTimeout(()=>this.S(),p.HeartbeatConstants.CreateProcessTimeout),q=await this.b.createProcess(t,n,r,i,l,c,s,u,E,k,O);return clearTimeout(B),d=Math.max(d,q),q}updateTitle(t,n,r){return this.b.updateTitle(t,n,r)}updateIcon(t,n,r,i){return this.b.updateIcon(t,n,r,i)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,n){return this.b.detachFromProcess(t,n)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,n){return this.b.shutdown(t,n)}input(t,n){return this.b.input(t,n)}processBinary(t,n){return this.b.processBinary(t,n)}resize(t,n,r){return this.b.resize(t,n,r)}acknowledgeDataEvent(t,n){return this.b.acknowledgeDataEvent(t,n)}setUnicodeVersion(t,n){return this.b.setUnicodeVersion(t,n)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,n){return this.b.installAutoReply(t,n)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,n,r,i=!1){const l=await this.c;return(0,a.detectAvailableProfiles)(n,r,i,this.F,l,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,n){return this.b.getWslPath(t,n)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,n){return this.b.requestDetachInstance(t,n)}async acceptDetachInstanceReply(t,n){return this.b.acceptDetachInstanceReply(t,n)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,n){return this.b.reviveTerminalProcesses(t,n)}async refreshProperty(t,n){return this.b.refreshProperty(t,n)}async updateProperty(t,n,r){return this.b.updateProperty(t,n,r)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,n){return this.f.createRequest({workspaceId:t,originalText:n})}async acceptPtyHostResolvedVariables(t,n){this.f.acceptReply(t,n)}};S=Le([Ae(2,v.IConfigurationService),Ae(3,g.IEnvironmentService),Ae(4,y.ILogService),Ae(5,y.ILoggerService)],S),e.PtyHostService=S}),define(pe[35],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(pe[121],ve([1,0,35,209,16,19,143,6,2]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class g{constructor(y){this.uri=y,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let T=class{constructor(y){this.g=y,this.c=new v.DisposableStore,this.f=2**16;const m=new Map,p=b=>{let a=m.get(b.scheme);return a===void 0&&(a=y.hasProvider(b)&&!this.g.hasCapability(b,1024),m.set(b.scheme,a)),a};this.c.add(A.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{m.delete(b.scheme)})),this.extUri=new D.ExtUri(p),this.d=new C.SkipList((b,a)=>this.extUri.compare(b,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,D.normalizePath)(y));const m=this.d.get(y);return m?m.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new g(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((p,b)=>p[1].time<b[1].time?1:p[1].time>b[1].time?-1:0);g._clock=0,this.d.clear();const m=this.f*.5;for(let p=0;p<m;p++)this.d.set(y[p][0],y[p][1].touch())}};T=Le([Ae(0,o.IFileService)],T),e.UriIdentityService=T,(0,R.registerSingleton)(w.IUriIdentityService,T,1)}),define(pe[85],ve([1,0,193,7,60,19,4,5,13]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function g(i){const l=i;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=g;function T(i){return typeof i?.id=="string"&&!g(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(i,l){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=I;function y(i){const l=i;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=y;function m(i){const l=i;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function b(i){const l=i;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=b;function a(i){const l=i;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=a;class f{constructor(l,c,s,u,E){this.h=l,this.j=s,this.k=u,this.l=E,this.c=o.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=o.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class h{constructor(l,c){this.raw=c,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,D.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function d(i){return new h({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,l){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,l.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function L(i){let l;return C.URI.isUri(i)?l=i:l=i.configuration,l?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,l){return!S(i,l)&&!L(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,R.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(pe[31],ve([1,0,74,6,2,19,4,192,24,16,5,12,85,27,35,14,22,17,8]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function d(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&C.URI.isUri(i.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function S(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:C.URI.revive(r.location).with({scheme:i}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:i}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=S;function L(r,i,l,c,s){return{id:r,name:i,location:l,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,D.joinPath)(l,"globalStorage"),settingsResource:(0,D.joinPath)(l,"settings.json"),keybindingsResource:(0,D.joinPath)(l,"keybindings.json"),tasksResource:(0,D.joinPath)(l,"tasks.json"),snippetsHome:(0,D.joinPath)(l,"snippets"),extensionsResource:(0,D.joinPath)(l,"extensions.json"),cacheHome:(0,D.joinPath)(c,r),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=L;let t=class extends o.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,l,c,s){super(),this.n=i,this.r=l,this.s=c,this.t=s,this.f=!0,this.h=this.B(new R.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new R.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new R.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new R.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,D.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const u of this.J()){if(!u.name||!(0,h.isString)(u.name)||!u.location){this.t.warn("Skipping the invalid stored profile",u.location||u.name);continue}i.push(L((0,D.basename)(u.location),u.name,u.location,this.g,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}}catch(u){this.t.error(u)}const l=new m.ResourceMap,c=new Map,s=this.w();if(i.unshift({...s,extensionsResource:this.O()??s.extensionsResource,isDefault:!0}),i.length)try{const u=this.M();if(u.workspaces)for(const[E,k]of Object.entries(u.workspaces)){const O=C.URI.parse(E),B=i.find(q=>q.id===k);B&&l.set(O,B)}if(u.emptyWindows)for(const[E,k]of Object.entries(u.emptyWindows)){const O=i.find(B=>B.id===k);O&&c.set(E,O)}}catch(u){this.t.error(u)}this.u={profiles:i,workspaces:l,emptyWindows:c}}return this.u}w(){return L("__default__profile__",(0,A.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const l="Temp",c=new RegExp(`${(0,f.escapeRegExpCharacters)(l)}\\s(\\d+)`);let s=0;for(const E of this.profiles){const k=c.exec(E.name),O=k?parseInt(k[1]):0;s=O>s?O:s}const u=`${l} ${s+1}`;return this.createProfile((0,w.hash)((0,a.generateUuid)()).toString(16),u,{transient:!0},i)}async createNamedProfile(i,l,c){return this.createProfile((0,w.hash)((0,a.generateUuid)()).toString(16),i,l,c)}async createProfile(i,l,c,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=await this.y(i,l,c);return s&&await this.setProfileForWorkspace(s,u),u}async y(i,l,c){if(!(0,h.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.l.get(l);return s||(s=(async()=>{try{const u=this.profiles.find(O=>O.name===l||O.id===i);if(u)return u;const E=L(i,l,(0,D.joinPath)(this.profilesHome,i),this.g,c);await this.r.createFolder(E.location);const k=[];return this.i.fire({profile:E,join(O){k.push(O)}}),await b.Promises.settled(k),this.D([E],[],[]),E}finally{this.l.delete(l)}})(),this.l.set(l,s)),s}async updateProfile(i,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(s=>s.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=L(c.id,l.name??c.name,c.location,this.g,{shortName:l.shortName??c.shortName,transient:l.transient??c.isTransient,useDefaultFlags:l.useDefaultFlags??c.useDefaultFlags}),this.D([],[],[c]),c}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(s=>s.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this.j.fire({profile:l,join(s){c.push(s)}});try{await Promise.allSettled(c)}catch(s){this.t.error(s)}for(const s of[...this.v.emptyWindows.keys()])l.id===this.v.emptyWindows.get(s)?.id&&this.v.emptyWindows.delete(s);for(const s of[...this.v.workspaces.keys()])l.id===this.v.workspaces.get(s)?.id&&this.v.workspaces.delete(s);this.H(),this.D([],[l],[]);try{await this.r.del(l.cacheHome,{recursive:!0})}catch(s){(0,g.toFileOperationResult)(s)!==1&&this.t.error(s)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(l.location,{recursive:!0})}catch(s){this.t.error(s)}}async setProfileForWorkspace(i,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(s=>s.id===l.id);if(!c)throw new Error(`Profile '${l.name}' does not exist`);this.G(i,c)}unsetWorkspace(i,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,l)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(!!this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(l=>l.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,l.resource))).map(l=>this.r.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(l=>!this.C(l));await Promise.allSettled(i.map(l=>this.removeProfile(l)))}getProfileForWorkspace(i){const l=this.z(i);return C.URI.isUri(l)?this.m.workspaces.get(l)??this.v.workspaces.get(l):this.m.emptyWindows.get(l)??this.v.emptyWindows.get(l)}z(i){return(0,y.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,y.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(l=>this.s.extUri.isEqual(l.location,i.location))||[...this.m.workspaces.values()].some(l=>this.s.extUri.isEqual(l.location,i.location))||[...this.v.emptyWindows.values()].some(l=>this.s.extUri.isEqual(l.location,i.location))||[...this.v.workspaces.values()].some(l=>this.s.extUri.isEqual(l.location,i.location)))}D(i,l,c){const s=[...this.profiles,...i],u=[];this.m.profiles=[];for(let E of s)E.isDefault||l.some(k=>E.id===k.id)||(E=c.find(k=>E.id===k.id)??E,E.isTransient?this.m.profiles.push(E):u.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.L(u),this.u=void 0,this.F(i,l,c)}F(i,l,c){this.h.fire({added:i,removed:l,updated:c,all:this.profiles})}G(i,l,c){c=l?.isTransient?!0:c,c||this.G(i,void 0,!0);const s=this.z(i),u=c?this.m:this.v;C.URI.isUri(s)?(u.workspaces.delete(s),l&&u.workspaces.set(s,l)):(u.emptyWindows.delete(s),l&&u.emptyWindows.set(s,l)),c||this.H()}H(){const i={};for(const[c,s]of this.v.workspaces.entries())i[c.toString()]=s.id;const l={};for(const[c,s]of this.v.emptyWindows.entries())l[c.toString()]=s.id;this.N({workspaces:i,emptyWindows:l}),this.u=void 0}I(i){const l={},c=this.w();if(i.workspaces)for(const[u,E]of Object.entries(i.workspaces)){const k=C.URI.parse(E);l[u]=this.s.extUri.isEqual(k,c.location)?c.id:this.s.extUri.basename(k)}const s={};if(i.emptyWindows)for(const[u,E]of Object.entries(i.emptyWindows)){const k=C.URI.parse(E);s[u]=this.s.extUri.isEqual(k,c.location)?c.id:this.s.extUri.basename(k)}return{workspaces:l,emptyWindows:s}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",t=Le([Ae(0,v.IEnvironmentService),Ae(1,g.IFileService),Ae(2,p.IUriIdentityService),Ae(3,I.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=n}),define(pe[254],ve([1,0,18,14,20,11,6,2,3,8,4,173,29,34,36,12,26,30,31]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends A.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,l,c,s,u){super(),this.t=i,this.u=l,this.v=c,this.w=s,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new C.Emitter),this.m=this.B(new C.Emitter),this.n=this.B(new C.Emitter),this.p=this.B(new C.Emitter),this.s=[],this.B((0,A.toDisposable)(()=>{this.j.forEach(({task:E})=>E.cancel()),this.k.forEach(E=>E.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const l=await this.getTargetPlatform();return i.allTargetPlatforms.some(c=>(0,y.isTargetPlatformCompatible)(c,i.allTargetPlatforms,l))}async installFromGallery(i,l={}){try{if(!this.t.isEnabled())throw new y.ExtensionManagementError(I.localize(0,null),y.ExtensionManagementErrorCode.Internal);const c=await this.G(i,!!l.installGivenVersion,!!l.installPreReleaseVersion);return await this.z(c.manifest,c.extension,l)}catch(c){throw t(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:c}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(c),L(c)}}async uninstall(i,l={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,l)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,l,c){const s=c.isApplicationScoped||c.isBuiltin||(0,p.isApplicationScopedExtension)(i),u={...c,installOnlyNewlyAddedFromExtensionPack:T.URI.isUri(l)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:s,profileLocation:s?this.y.defaultProfile.extensionsResource:c.profileLocation??this.P()},E=de=>`${m.ExtensionKey.create(de).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!T.URI.isUri(l)){const de=this.j.get(E(l));if(de)return this.v.info("Extensions is already requested to install",l.identifier.id),de.task.waitUntilTaskIsFinished()}const k=[],O=[],B=[],q=this.Q(i,l,u);T.URI.isUri(l)||this.j.set(E(l),{task:q,waitingTasks:[]}),this.l.fire({identifier:q.identifier,source:l,profileLocation:u.profileLocation}),this.v.info("Installing extension:",q.identifier.id),k.push({task:q,manifest:i});let le=!1;try{if(u.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const ue=await this.F(q.identifier,i,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),ae=await this.getInstalled(void 0,u.profileLocation);for(const{gallery:_,manifest:ee}of(0,w.distinct)(ue,({gallery:ne})=>ne.identifier.id)){le=le||!!ee.extensionDependencies?.some(x=>(0,m.areSameExtensions)({id:x},q.identifier));const ne=E(_),te=this.j.get(ne);if(te){if(this.C(q,te.task)){const x=te.task.identifier;this.v.info("Waiting for already requested installing extension",x.id,q.identifier.id),te.waitingTasks.push(q),O.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,U=>U.some(Z=>(0,m.areSameExtensions)(Z.identifier,x)))).then(U=>{if(this.v.info("Finished waiting for already requested installing extension",x.id,q.identifier.id),!U.find(re=>(0,m.areSameExtensions)(re.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!ae.some(({identifier:x})=>(0,m.areSameExtensions)(x,_.identifier))){const x=this.Q(ee,_,{...u,donotIncludePackAndDependencies:!0});this.j.set(ne,{task:x,waitingTasks:[q]}),this.l.fire({identifier:x.identifier,source:_,profileLocation:u.profileLocation}),this.v.info("Installing extension:",x.identifier.id,q.identifier.id),k.push({task:x,manifest:ee})}}}catch(ue){if(T.URI.isUri(q.source))(0,w.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",q.identifier.id,ue.message),(0,w.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",q.identifier.id,ue.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),ue}const de=k.reduce((ue,{task:ae,manifest:_})=>(ue.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:_}),ue),new Map);for(;de.size;){let ue;const ae=[...de.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(ee=>de.has(ee.toLowerCase())));ae.length?ue=de.size===1?ae:ae.filter(({task:_})=>!(_===q&&!le)):(this.v.info("Found extensions with circular dependencies",ae.map(({task:_})=>_.identifier.id)),ue=[...de.values()]),await this.D(ue.map(async({task:_})=>{const ee=new Date().getTime();try{const ne=await _.run();if(await this.D(this.s.map(te=>te.postInstall(ne,_.source,u,o.CancellationToken.None))),!T.URI.isUri(_.source)){const te=_.operation===3,x=te?void 0:(new Date().getTime()-_.source.lastUpdated)/1e3;if(t(this.u,te?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(_.source),verificationStatus:_.verificationStatus,duration:new Date().getTime()-ee,durationSinceUpdate:x}),v.isWeb&&_.operation!==3)try{await this.t.reportStatistic(ne.manifest.publisher,ne.manifest.name,ne.manifest.version,"install")}catch{}}B.push({local:ne,identifier:_.identifier,operation:_.operation,source:_.source,context:u.context,profileLocation:_.profileLocation,applicationScoped:ne.isApplicationScoped})}catch(ne){throw T.URI.isUri(_.source)||t(this.u,_.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(_.source),verificationStatus:_.verificationStatus,duration:new Date().getTime()-ee,error:ne}),this.v.error("Error while installing the extension:",_.identifier.id),ne}finally{de.delete(_.identifier.id.toLowerCase())}}))}return O.length&&await this.D(O),B.forEach(({identifier:ue})=>this.v.info("Extension installed successfully:",ue.id)),this.m.fire(B),B.filter(({identifier:ue})=>(0,m.areSameExtensions)(ue,q.identifier))[0].local}catch(de){if(k.forEach(({task:ue})=>ue.cancel()),B.length)try{const ue=await Promise.allSettled(B.map(({local:ae})=>this.R(ae,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let ae=0;ae<ue.length;ae++){const _=ue[ae],{identifier:ee}=B[ae];_.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ee.id):this.v.warn("Rollback: Error while uninstalling extension",ee.id,(0,D.getErrorMessage)(_.reason))}}catch(ue){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ue),B.map(({identifier:ae})=>ae.id))}throw this.m.fire(k.map(({task:ue})=>({identifier:ue.identifier,operation:2,source:ue.source,context:u.context,profileLocation:u.profileLocation}))),de}finally{for(const{task:de}of k)de.source&&!T.URI.isUri(de.source)&&this.j.delete(E(de.source))}}C(i,l){for(const[,{task:c,waitingTasks:s}]of this.j.entries())if(c===i&&(s.includes(l)||s.some(u=>this.C(u,l)))||c===l&&s[0]&&!this.C(i,s[0]))return!1;return!0}async D(i){const l=[],c=[],s=await Promise.allSettled(i);for(const u of s)u.status==="fulfilled"?l.push(u.value):c.push(u.reason);if(c.length)throw S(c);return l}async F(i,l,c,s,u){if(!this.t.isEnabled())return[];const E=await this.getInstalled(void 0,u),k=[],O=[],B=async(q,le)=>{k.push(q);const de=le.extensionDependencies||[],ue=[...de];if(le.extensionPack){const ae=c?E.find(_=>(0,m.areSameExtensions)(_.identifier,q)):void 0;for(const _ of le.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(ee=>(0,m.areSameExtensions)({id:ee},{id:_}))||ue.every(ee=>!(0,m.areSameExtensions)({id:ee},{id:_}))&&ue.push(_)}if(ue.length){const ae=ue.filter(_=>k.every(ee=>!(0,m.areSameExtensions)(ee,{id:_})));if(ae.length){const _=await this.t.getExtensions(ae.map(ee=>({id:ee,preRelease:s})),o.CancellationToken.None);for(const ee of _){if(k.find(x=>(0,m.areSameExtensions)(x,ee.identifier)))continue;const ne=de.some(x=>(0,m.areSameExtensions)({id:x},ee.identifier));let te;try{te=await this.G(ee,!1,s)}catch(x){if(x instanceof y.ExtensionManagementError&&x.code===y.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ne){this.v.info("Skipping the packed extension as it cannot be installed",ee.identifier.id);continue}else throw x}O.push({gallery:te.extension,manifest:te.manifest}),await B(te.extension.identifier,te.manifest)}}}};return await B(i,l),O}async G(i,l,c){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,m.areSameExtensions)(i.identifier,k)))throw new y.ExtensionManagementError(I.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const k=await this.getTargetPlatform();throw new y.ExtensionManagementError(I.localize(2,null,i.identifier.id,this.w.nameLong,(0,y.TargetPlatformToString)(k)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(i,l,c);if(u){if(c&&!l&&i.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new y.ExtensionManagementError(I.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],o.CancellationToken.None))[0]?new y.ExtensionManagementError(I.localize(4,null,i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(I.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const E=await this.t.getManifest(u,o.CancellationToken.None);if(E===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(E.version!==u.version)throw new y.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:E}}async H(i,l,c){const s=await this.getTargetPlatform();let u=null;return!l&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==c&&(u=(await this.t.getExtensions([{...i.identifier,preRelease:c}],{targetPlatform:s,compatible:!0},o.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(i,c,s)&&(u=i),u||(l?u=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:s,compatible:!0},o.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(i,c,s)),u}async I(i,l){const c={...l,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:l.profileLocation??this.P()},s=q=>`${q.id.toLowerCase()}${c.versionOnly?`-${i.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,u=this.k.get(s(i.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),u.waitUntilTaskIsFinished();const E=q=>{const le=this.R(q,c);return this.k.set(s(le.extension.identifier),le),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${q.identifier.id}@${q.manifest.version}`),this.n.fire({identifier:q.identifier,profileLocation:c.profileLocation,applicationScoped:q.isApplicationScoped}),le},k=(q,le)=>{le?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,c.profileLocation.toString(),le.message):this.v.error("Failed to uninstall extension:",`${q.identifier.id}@${q.manifest.version}`,le.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${q.identifier.id}@${q.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${q.identifier.id}@${q.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(q),error:le}),this.p.fire({identifier:q.identifier,error:le?.code,profileLocation:c.profileLocation,applicationScoped:q.isApplicationScoped})},O=[],B=[];try{O.push(E(i));const q=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const le=this.M(i,q);for(const de of le)this.k.has(s(de.identifier))?this.v.info("Extensions is already requested to uninstall",de.identifier.id):O.push(E(de))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(O.map(le=>le.extension),q,i),await this.D(O.map(async le=>{try{if(await le.run(),await this.D(this.s.map(de=>de.postUninstall(le.extension,c,o.CancellationToken.None))),le.extension.identifier.uuid)try{await this.t.reportStatistic(le.extension.manifest.publisher,le.extension.manifest.name,le.extension.manifest.version,"uninstall")}catch{}k(le.extension)}catch(de){const ue=de instanceof y.ExtensionManagementError?de:new y.ExtensionManagementError((0,D.getErrorMessage)(de),y.ExtensionManagementErrorCode.Internal);throw k(le.extension,ue),ue}finally{B.push(le)}}))}catch(q){const le=q instanceof y.ExtensionManagementError?q:new y.ExtensionManagementError((0,D.getErrorMessage)(q),y.ExtensionManagementErrorCode.Internal);for(const de of O){try{de.cancel()}catch{}B.includes(de)||k(de.extension,le)}throw le}finally{for(const q of O)this.k.delete(s(q.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",q.extension.identifier.id)}}J(i,l,c){for(const s of i){const u=this.N(s,l);if(u.length){const E=u.filter(k=>!i.some(O=>(0,m.areSameExtensions)(O.identifier,k.identifier)));if(E.length)throw new Error(this.L(s,E,c))}}}L(i,l,c){return c===i?l.length===1?I.localize(6,null,c.manifest.displayName||c.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?I.localize(7,null,c.manifest.displayName||c.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):I.localize(8,null,c.manifest.displayName||c.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?I.localize(9,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?I.localize(10,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):I.localize(11,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}M(i,l,c=[]){if(c.indexOf(i)!==-1)return[];c.push(i);const s=i.manifest.extensionPack?i.manifest.extensionPack:[];if(s.length){const u=l.filter(k=>!k.isBuiltin&&s.some(O=>(0,m.areSameExtensions)({id:O},k.identifier))),E=[];for(const k of u)E.push(...this.M(k,l,c));return[...u,...E]}return[]}N(i,l){return l.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(s=>(0,m.areSameExtensions)({id:s},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=Le([Ae(0,y.IExtensionGalleryService),Ae(1,f.ITelemetryService),Ae(2,b.ILogService),Ae(3,a.IProductService),Ae(4,h.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function S(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((l,c)=>new Error(`${l.message}${l.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=S;function L(r){if(r instanceof y.ExtensionManagementError)return r;const i=new y.ExtensionManagementError(r.message,y.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function t(r,i,{extensionData:l,verificationStatus:c,duration:s,error:u,durationSinceUpdate:E}){let k,O;(0,g.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(k=y.ExtensionManagementErrorCode.Signature,O=c),c="Unverified")),u&&(u instanceof y.ExtensionManagementError?(k=u.code,u.code===y.ExtensionManagementErrorCode.Signature&&(O=u.message)):k=y.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...l,verificationStatus:c,success:!u,duration:s,errorcode:k,errorcodeDetail:O,durationSinceUpdate:E})}class n{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(i=>new Promise((l,c)=>{const s=i.onCancellationRequested(()=>{s.dispose(),c(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(pe[44],ve([1,0,14,15,2,6,27,4,29,34,16,5,12,31,35,8,11,30]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class d extends Error{constructor(r,i){super(r),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let S=class extends o.Disposable{constructor(r,i,l,c,s,u){super(),this.i=r,this.j=i,this.k=l,this.l=c,this.m=s,this.n=u,this.b=this.B(new D.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(r,i){return this.p(r,void 0,i)}async addExtensionsToProfile(r,i){const l=[],c=[];try{return await this.p(i,s=>{const u=[];for(const E of s)r.some(([k])=>(0,g.areSameExtensions)(k.identifier,E.identifier)&&k.manifest.version!==E.version)?l.push(E):u.push(E);for(const[E,k]of r)if(!u.some(O=>(0,g.areSameExtensions)(O.identifier,E.identifier)&&O.version===E.manifest.version)){const O={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:k};c.push(O),u.push(O)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),u}),c.length&&this.c.fire({extensions:c,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),c}catch(s){throw c.length&&this.c.fire({extensions:c,error:s,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:s,profileLocation:i}),s}}async updateMetadata(r,i){const l=[];return await this.p(i,c=>{const s=[];for(const u of c){const E=r.find(([k])=>(0,g.areSameExtensions)(k.identifier,u.identifier)&&k.manifest.version===u.version);E&&(u.metadata={...u.metadata,...E[1]},l.push(u)),s.push(u)}return s}),l}async removeExtensionFromProfile(r,i){const l=[];this.f.fire({extensions:l,profileLocation:i});try{await this.p(i,c=>{const s=[];for(const u of c)(0,g.areSameExtensions)(u.identifier,r.identifier)?l.push(u):s.push(u);return l.length&&this.f.fire({extensions:l,profileLocation:i}),s}),l.length&&this.g.fire({extensions:l,profileLocation:i})}catch(c){throw l.length&&this.g.fire({extensions:l,error:c,profileLocation:i}),c}}async p(r,i,l){return this.w(r).queue(async()=>{let c=[],s;try{const u=await this.j.readFile(r);s=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,T.toFileOperationResult)(u)!==1)throw u;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(s=await this.v()),!s&&l?.bailOutWhenFileNotFound)throw new d((0,a.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.r(r);let u=!1;for(const E of s){L(E)||this.r(r);let k;if((0,b.isString)(E.relativeLocation)&&E.relativeLocation)k=this.t(E.relativeLocation);else if((0,b.isString)(E.location))k=this.t(E.location),u=!0,E.relativeLocation=E.location,E.location=k.toJSON();else{k=A.URI.revive(E.location);const O=this.s(k);O&&(u=!0,E.relativeLocation=O)}c.push({identifier:E.identifier,location:k,version:E.version,metadata:E.metadata})}u&&await this.j.writeFile(r,R.VSBuffer.fromString(JSON.stringify(s)))}if(i){c=i(c);const u=c.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.s(E.location),metadata:E.metadata}));await this.j.writeFile(r,R.VSBuffer.fromString(JSON.stringify(u)))}return c})}r(r){const i=new d(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let l;try{l=(await this.j.readFile(r)).value.toString()}catch(s){if((0,T.toFileOperationResult)(s)===1)return;throw s}this.n.info("Migrating extensions from old default profile location",r.toString());let c;try{const s=JSON.parse(l);Array.isArray(s)&&s.every(u=>L(u))?c=s:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.n.error(s)}if(c)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(s){if((0,T.toFileOperationResult)(s)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw s}try{await this.j.del(r)}catch(s){(0,T.toFileOperationResult)(s)!==1&&this.n.error(s)}try{await this.j.del(i)}catch(s){(0,T.toFileOperationResult)(s)!==1&&this.n.error(s)}return c})()),this.u}w(r){let i=this.h.get(r);return i||(i=new w.Queue,this.h.set(r,i)),i}};S=Le([Ae(1,T.IFileService),Ae(2,m.IUserDataProfilesService),Ae(3,p.IUriIdentityService),Ae(4,f.ITelemetryService),Ae(5,y.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function L(n){return(0,b.isObject)(n)&&(0,v.isIExtensionIdentifier)(n.identifier)&&(t(n.location)||(0,b.isString)(n.location)&&n.location)&&((0,b.isUndefined)(n.relativeLocation)||(0,b.isString)(n.relativeLocation))&&n.version&&(0,b.isString)(n.version)}function t(n){return n?(0,b.isString)(n.path)&&(0,b.isString)(n.scheme):!1}}),define(pe[55],ve([1,0,18,14,21,15,11,72,154,2,13,7,3,19,51,59,8,4,177,24,34,36,76,16,5,12,26,6,61,44,31,35,207]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t,n,r,i,l,c,s,u,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var B;(function(ee){function ne(te,x){if(te===x)return!0;const U=Object.keys(te),Z=new Set;for(const re of Object.keys(x))Z.add(re);if(U.length!==Z.size)return!1;for(const re of U){if(te[re]!==x[re])return!1;Z.delete(re)}return Z.size===0}ee.equals=ne})(B=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let q=class extends g.Disposable{constructor(ne,te,x,U,Z,re,me,$,W,N,P,M){super(),this.systemExtensionsLocation=ne,this.userExtensionsLocation=te,this.l=x,this.m=U,this.n=Z,this.r=re,this.s=me,this.t=$,this.u=W,this.v=N,this.w=P,this.y=M,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ue,this.m,this.h)),this.j=this.B(this.y.createInstance(ue,this.m,this.h)),this.k=this.B(this.y.createInstance(de,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,S.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(ne,te,x){const[U,Z]=await Promise.all([this.scanSystemExtensions(ne),this.scanUserExtensions(te)]),re=x?await this.scanExtensionsUnderDevelopment(ne,[...U,...Z]):[];return this.G(U,Z,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(ne){const te=[];te.push(this.H(!!ne.useCache,ne.language)),te.push(this.I(ne.language,!!ne.checkControlFile));const[x,U]=await Promise.all(te);return this.F([...x,...U],0,ne,!1)}async scanUserExtensions(ne){const te=ne.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",te);const x=this.w.extUri.isEqual(ne.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(te,!!ne.profileLocation,1,!ne.includeUninstalled,ne.language,!0,x),Z=ne.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let re;try{re=await Z.scanExtensions(U)}catch(me){if(me instanceof u.ExtensionsProfileScanningError&&me.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),re=await Z.scanExtensions(U);else throw me}return re=await this.F(re,1,ne,!0),this.t.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(ne,te){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const x=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===T.Schemas.file).map(async U=>{const Z=await this.L(U,!1,1,!0,ne.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Z)).map(me=>(me.type=te.find($=>(0,S.areSameExtensions)($.identifier,me.identifier))?.type??me.type,this.k.validate(me,Z)))}))).flat();return this.F(x,"development",ne,!0)}return[]}async scanExistingExtension(ne,te,x){const U=await this.L(ne,!1,te,!0,x.language,!0,void 0),Z=await this.k.scanExtension(U);return!Z||!x.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(ne,te,x){const U=await this.L(ne,!1,te,!0,x.language,!0,void 0),Z=await this.k.scanOneOrMultipleExtensions(U);return this.F(Z,te,x,!0)}async scanMetadata(ne){const te=(0,m.joinPath)(ne,"package.json"),x=(await this.s.readFile(te)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(ne,te){const x=(0,m.joinPath)(ne,"package.json"),U=(await this.s.readFile(x)).value.toString(),Z=JSON.parse(U);te.isMachineScoped=te.isMachineScoped||void 0,te.isBuiltin=te.isBuiltin||void 0,Z.__metadata={...Z.__metadata,...te},await this.s.writeFile((0,m.joinPath)(ne,"package.json"),D.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(ne){if(ne instanceof u.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw ne}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ne=await this.scanUserExtensions({includeInvalid:!0});if(ne.length)await this.r.addExtensionsToProfile(ne.map(te=>[te,te.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(te){(0,n.toFileOperationResult)(te)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(te))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(ne){this.t.error(ne)}finally{this.C=void 0}})()),this.C}async F(ne,te,x,U){return x.includeAllVersions||(ne=this.G(te===0?ne:void 0,te===1?ne:void 0,te==="development"?ne:void 0,await this.getTargetPlatform(),U)),x.includeInvalid||(ne=ne.filter(Z=>Z.isValid)),ne.sort((Z,re)=>{const me=I.basename(Z.location.fsPath),$=I.basename(re.location.fsPath);return me<$?-1:me>$?1:0})}G(ne,te,x,U,Z){const re=($,W,N)=>{if($.isValid&&!W.isValid)return!1;if($.isValid===W.isValid){if(Z&&p.gt($.manifest.version,W.manifest.version))return this.t.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(p.eq($.manifest.version,W.manifest.version)){if($.type===0)return this.t.debug(`Skipping extension ${W.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===U)return this.t.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return N?this.t.warn(`Overwriting user extension ${$.location.path} with ${W.location.path}.`):this.t.debug(`Overwriting user extension ${$.location.path} with ${W.location.path}.`),!0},me=new L.ExtensionIdentifierMap;return ne?.forEach($=>{const W=me.get($.identifier.id);(!W||re(W,$,!1))&&me.set($.identifier.id,$)}),te?.forEach($=>{const W=me.get($.identifier.id);if(!W&&ne&&$.type===0){this.t.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!W||re(W,$,!1))&&me.set($.identifier.id,$)}),x?.forEach($=>{const W=me.get($.identifier.id);(!W||re(W,$,!0))&&me.set($.identifier.id,$),me.set($.identifier.id,$)}),[...me.values()]}async H(ne,te){this.t.trace("Started scanning system extensions");const x=await this.L(this.systemExtensionsLocation,!1,0,!0,te,!0,void 0),Z=await(ne&&!x.devMode?this.i:this.k).scanExtensions(x);return this.t.trace("Scanned system extensions:",Z.length),Z}async I(ne,te){const x=this.u.isBuilt?[]:this.v.builtInExtensions;if(!x?.length)return[];this.t.trace("Started scanning dev system extensions");const U=te?await this.J():{},Z=[],re=f.URI.file(I.normalize(I.join(T.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $ of x){const W=U[$.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":Z.push((0,m.joinPath)(re,$.name));break;default:Z.push(f.URI.file(W));break}}const me=await Promise.all(Z.map(async $=>this.k.scanExtension(await this.L($,!1,0,!0,ne,!0,void 0))));return this.t.trace("Scanned dev system extensions:",me.length),(0,w.coalesce)(me)}async J(){try{const ne=await this.s.readFile(this.l);return JSON.parse(ne.value.toString())}catch{return{}}}async L(ne,te,x,U,Z,re,me){const $=await this.f(Z??y.language),W=await this.M(ne),N=te&&!this.w.extUri.isEqual(ne,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,P=N?await this.M(N):void 0;return new le(ne,W,N,P,te,me,x,U,re,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,Z,$)}async M(ne){try{const te=await this.s.stat(ne);if(typeof te.mtime=="number")return te.mtime}catch{}}};q=Le([Ae(4,E.IUserDataProfilesService),Ae(5,u.IExtensionsProfileScannerService),Ae(6,n.IFileService),Ae(7,i.ILogService),Ae(8,d.IEnvironmentService),Ae(9,l.IProductService),Ae(10,k.IUriIdentityService),Ae(11,r.IInstantiationService)],q),e.AbstractExtensionsScannerService=q;class le{constructor(ne,te,x,U,Z,re,me,$,W,N,P,M,Y,ie,z){this.location=ne,this.mtime=te,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=U,this.profile=Z,this.profileScanOptions=re,this.type=me,this.excludeObsolete=$,this.validate=W,this.productVersion=N,this.productDate=P,this.productCommit=M,this.devMode=Y,this.language=ie,this.translations=z}static createNlsConfiguration(ne){return{language:ne.language,pseudo:ne.language==="pseudo",devMode:ne.devMode,translations:ne.translations}}static equals(ne,te){return(0,m.isEqual)(ne.location,te.location)&&ne.mtime===te.mtime&&(0,m.isEqual)(ne.applicationExtensionslocation,te.applicationExtensionslocation)&&ne.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&ne.profile===te.profile&&o.equals(ne.profileScanOptions,te.profileScanOptions)&&ne.type===te.type&&ne.excludeObsolete===te.excludeObsolete&&ne.validate===te.validate&&ne.productVersion===te.productVersion&&ne.productDate===te.productDate&&ne.productCommit===te.productCommit&&ne.devMode===te.devMode&&ne.language===te.language&&B.equals(ne.translations,te.translations)}}e.ExtensionScannerInput=le;let de=class extends g.Disposable{constructor(ne,te,x,U,Z){super(),this.f=ne,this.g=te,this.h=x,this.i=U,this.j=Z}async scanExtensions(ne){const te=ne.profile?await this.l(ne):await this.k(ne);let x={};if(ne.excludeObsolete&&ne.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();x=JSON.parse(U)}catch{}return(0,a.isEmptyObject)(x)?te:te.filter(U=>!x[S.ExtensionKey.create(U).toString()])}async k(ne){const te=await this.i.resolve(ne.location);if(!te.children?.length)return[];const x=await Promise.all(te.children.map(async U=>{if(!U.isDirectory||ne.type===1&&(0,m.basename)(U.resource).indexOf(".")===0)return null;const Z=new le(U.resource,ne.mtime,ne.applicationExtensionslocation,ne.applicationExtensionslocationMtime,ne.profile,ne.profileScanOptions,ne.type,ne.excludeObsolete,ne.validate,ne.productVersion,ne.productDate,ne.productCommit,ne.devMode,ne.language,ne.translations);return this.scanExtension(Z)}));return(0,w.coalesce)(x).sort((U,Z)=>U.location.path<Z.location.path?-1:1)}async l(ne){let te=await this.m(ne.location,()=>!0,ne);if(ne.applicationExtensionslocation&&!this.h.extUri.isEqual(ne.location,ne.applicationExtensionslocation)){te=te.filter(U=>!U.metadata?.isApplicationScoped);const x=await this.m(ne.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,ne);te.push(...x)}return te}async m(ne,te,x){const U=await this.g.scanProfileExtensions(ne,x.profileScanOptions);if(!U.length)return[];const Z=await Promise.all(U.map(async re=>{if(te(re)){const me=new le(re.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(me,re.metadata)}return null}));return(0,w.coalesce)(Z)}async scanOneOrMultipleExtensions(ne){try{if(await this.i.exists((0,m.joinPath)(ne.location,"package.json"))){const te=await this.scanExtension(ne);return te?[te]:[]}else return await this.scanExtensions(ne)}catch(te){return this.j.error(`Error scanning extensions at ${ne.location.path}:`,(0,C.getErrorMessage)(te)),[]}}async scanExtension(ne,te){try{let x=await this.scanExtensionManifest(ne.location);if(x){x.publisher||(x.publisher=L.UNDEFINED_PUBLISHER),te=te??x.__metadata,delete x.__metadata;const U=(0,S.getGalleryExtensionId)(x.publisher,x.name),Z=te?.id?{id:U,uuid:te.id}:{id:U},re=te?.isSystem?0:ne.type,me=re===0||!!te?.isBuiltin;x=await this.n(ne.location,x,le.createNlsConfiguration(ne));const $={type:re,identifier:Z,manifest:x,location:ne.location,isBuiltin:me,targetPlatform:te?.targetPlatform??"undefined",metadata:te,isValid:!0,validations:[]};return ne.validate?this.validate($,ne):$}}catch(x){ne.type!==0&&this.j.error(x)}return null}validate(ne,te){let x=!0;const U=(0,t.validateExtensionManifest)(te.productVersion,te.productDate,te.location,ne.manifest,ne.isBuiltin);for(const[Z,re]of U)Z===b.default.Error&&(x=!1,this.j.error(this.u(te.location,re)));return ne.isValid=x,ne.validations=U,ne}async scanExtensionManifest(ne){const te=(0,m.joinPath)(ne,"package.json");let x;try{x=(await this.i.readFile(te)).value.toString()}catch(Z){return(0,n.toFileOperationResult)(Z)!==1&&this.j.error(this.u(ne,(0,h.localize)(0,null,te.path,Z.message))),null}let U;try{U=JSON.parse(x)}catch{const re=[];(0,A.parse)(x,re);for(const me of re)this.j.error(this.u(ne,(0,h.localize)(1,null,te.path,me.offset,me.length,(0,v.getParseErrorMessage)(me.error))));return null}return(0,A.getNodeType)(U)!=="object"?(this.j.error(this.u(ne,(0,h.localize)(2,null,te.path))),null):U}async n(ne,te,x){const U=await this.r(ne,te,x);if(U)try{const Z=[],re=await this.s(U.default,Z);if(Z.length>0)return Z.forEach($=>{this.j.error(this.u(ne,(0,h.localize)(3,null,U.default?.path,(0,v.getParseErrorMessage)($.error))))}),te;if((0,A.getNodeType)(U)!=="object")return this.j.error(this.u(ne,(0,h.localize)(4,null,U.default?.path))),te;const me=U.values||Object.create(null);return(0,O.localizeManifest)(te,me,re)}catch{}return te}async r(ne,te,x){const U=(0,m.joinPath)(ne,"package.nls.json"),Z=(W,N)=>{N.forEach(P=>{this.j.error(this.u(ne,(0,h.localize)(5,null,W?.path,(0,v.getParseErrorMessage)(P.error))))})},re=W=>{this.j.error(this.u(ne,(0,h.localize)(6,null,W?.path)))},me=`${te.publisher}.${te.name}`,$=x.translations[me];if($)try{const W=f.URI.file($),N=(await this.i.readFile(W)).value.toString(),P=[],M=(0,A.parse)(N,P);return P.length>0?(Z(W,P),{values:void 0,default:U}):(0,A.getNodeType)(M)!=="object"?(re(W),{values:void 0,default:U}):{values:M.contents?M.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let N;try{N=await this.t(ne,x)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const P=(await this.i.readFile(N.localized)).value.toString(),M=[],Y=(0,A.parse)(P,M);return M.length>0?(Z(N.localized,M),{values:void 0,default:N.original}):(0,A.getNodeType)(Y)!=="object"?(re(N.localized),{values:void 0,default:N.original}):{values:Y,default:N.original}}catch{return{values:void 0,default:N.original}}}}async s(ne,te){if(ne)try{const x=(await this.i.readFile(ne)).value.toString();return(0,A.parse)(x,te)}catch{}}t(ne,te){return new Promise((x,U)=>{const Z=re=>{const me=(0,m.joinPath)(ne,`package.nls.${re}.json`);this.i.exists(me).then($=>{$&&x({localized:me,original:(0,m.joinPath)(ne,"package.nls.json")});const W=re.lastIndexOf("-");W===-1?x({localized:(0,m.joinPath)(ne,"package.nls.json"),original:null}):(re=re.substring(0,W),Z(re))})};if(te.devMode||te.pseudo||!te.language)return x({localized:(0,m.joinPath)(ne,"package.nls.json"),original:null});Z(te.language)})}u(ne,te){return`[${ne.path}]: ${te}`}};de=Le([Ae(1,u.IExtensionsProfileScannerService),Ae(2,k.IUriIdentityService),Ae(3,n.IFileService),Ae(4,i.ILogService)],de);let ue=class extends de{constructor(ne,te,x,U,Z,re,me){super(te,U,Z,re,me),this.z=ne,this.C=x,this.w=this.B(new R.ThrottledDelayer(3e3)),this.y=this.B(new c.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(ne){const te=this.H(ne),x=await this.D(te);if(this.v=ne,x&&x.input&&le.equals(x.input,this.v))return this.j.debug("Using cached extensions scan result",ne.location.toString()),this.w.trigger(()=>this.G()),x.result.map(Z=>(Z.location=f.URI.revive(Z.location),Z));const U=await super.scanExtensions(ne);return await this.F(te,{input:ne,result:U}),U}async D(ne){try{const te=await this.i.readFile(ne),x=JSON.parse(te.value.toString());return{result:x.result,input:(0,s.revive)(x.input)}}catch(te){this.j.debug("Error while reading the extension cache file:",ne.path,(0,C.getErrorMessage)(te))}return null}async F(ne,te){try{await this.i.writeFile(ne,D.VSBuffer.fromString(JSON.stringify(te)))}catch(x){this.j.debug("Error while writing the extension cache file:",ne.path,(0,C.getErrorMessage)(x))}}async G(){if(!this.v)return;const ne=this.H(this.v),te=await this.D(ne);if(!te)return;const x=te.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!o.equals(U,x))try{this.j.info("Invalidating Cache",x,U),await this.i.del(ne),this.y.fire()}catch(Z){this.j.error(Z)}}H(ne){const te=this.I(ne);return this.h.extUri.joinPath(te.cacheHome,ne.type===0?L.BUILTIN_MANIFEST_CACHE_FILE:L.USER_MANIFEST_CACHE_FILE)}I(ne){return ne.type===0?this.C.defaultProfile:ne.profile?this.h.extUri.isEqual(ne.location,this.z.extensionsResource)?this.z:this.C.profiles.find(te=>this.h.extUri.isEqual(ne.location,te.extensionsResource))??this.z:this.C.defaultProfile}};ue=Le([Ae(2,E.IUserDataProfilesService),Ae(3,u.IExtensionsProfileScannerService),Ae(4,k.IUriIdentityService),Ae(5,n.IFileService),Ae(6,i.ILogService)],ue);function ae(ee,ne){const te=(0,S.getExtensionId)(ee.manifest.publisher,ee.manifest.name);return{id:te,identifier:new L.ExtensionIdentifier(te),isBuiltin:ee.type===0,isUserBuiltin:ee.type===1&&ee.isBuiltin,isUnderDevelopment:ne,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,...ee.manifest}}e.toExtensionDescription=ae;class _ extends q{constructor(ne,te,x,U,Z,re,me,$,W,N,P,M){super(ne,te,(0,m.joinPath)(x,".vscode-oss-dev","extensions","control.json"),U,Z,re,me,$,W,N,P,M),this.N=(async()=>{if(y.translationsConfigFile)try{const Y=await this.s.readFile(f.URI.file(y.translationsConfigFile));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(ne){return this.N}}e.NativeExtensionsScannerService=_}),define(pe[255],ve([1,0,50,14,38,6,2,13,7,23,12,31]),function(oe,e,w,R,o,D,C,A,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends C.Disposable{constructor(p,b){super(),this.b=p,this.f=b,this.a=new R.Limiter(5)}async postUninstall(p){const b=this.g(p,"uninstall");b&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(a){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(a)}}));try{await g.Promises.rm(this.j(p))}catch(a){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(a)}}g(p,b){const a=`vscode:${b}`;if(p.location.scheme===A.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[a]=="string"){const f=p.manifest.scripts[a].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${a} should be a node script`),null):{script:(0,v.join)(p.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(p,b,a,f,h){return new Promise((d,S)=>{const L=this.i(p,b,a,h);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?S(r):d(void 0)};L.on("error",r=>{n((0,o.toErrorMessage)(r)||"Unknown")}),L.on("exit",(r,i)=>{n(r?`post-${b} process exited with code ${r}`:void 0)}),f&&(t=setTimeout(()=>{t=null,L.kill(),S("timed out")},5e3))})}i(p,b,a,f){const h={silent:!0,execArgv:void 0},d=(0,w.fork)(p,[`--type=extension-post-${b}`,...a],h);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const S=D.Event.fromNodeEventEmitter(d.stdout,"data"),L=D.Event.fromNodeEventEmitter(d.stderr,"data");S(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${b}`,r)),L(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${b}`,r));const t=D.Event.any(D.Event.map(S,r=>({data:`%c${r}`,format:[""]})),D.Event.map(L,r=>({data:`%c${r}`,format:["color: red"]})));return D.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),d}j(p){return(0,v.join)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};y=Le([Ae(0,I.IUserDataProfilesService),Ae(1,T.ILogService)],y),e.ExtensionsLifecycle=y}),define(pe[122],ve([1,0,12,31,35,30,44,16,24,4]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let T=class extends C.AbstractExtensionsProfileScannerService{constructor(y,m,p,b,a,f){super(g.URI.file(y.extensionsPath),m,p,b,a,f)}};T=Le([Ae(0,v.INativeEnvironmentService),Ae(1,A.IFileService),Ae(2,R.IUserDataProfilesService),Ae(3,o.IUriIdentityService),Ae(4,D.ITelemetryService),Ae(5,w.ILogService)],T),e.ExtensionsProfileScannerService=T}),define(pe[256],ve([1,0,14,6,2,41,8,164,5,31]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var T;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var y;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function m(h){const d=h.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=m;class p extends o.Disposable{constructor(d={flushInterval:p.a}){super(),this.j=d,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new w.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new o.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,w.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,o.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,S){if(S===e.TARGET_KEY){switch(d){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:S,target:this.F(d)[S]})}r(d){this.f.fire({reason:d})}get(d,S,L){return this.L(S)?.get(d,L)}getBoolean(d,S,L){return this.L(S)?.getBoolean(d,L)}getNumber(d,S,L){return this.L(S)?.getNumber(d,L)}store(d,S,L,t){if((0,C.isUndefinedOrNull)(S)){this.remove(d,L);return}this.t(()=>{this.u(d,L,t),this.L(L)?.set(d,S)})}remove(d,S){this.t(()=>{this.u(d,S,void 0),this.L(S)?.delete(d)})}t(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,S){const L=[],t=this.F(d);for(const n of Object.keys(t))t[n]===S&&L.push(n);return L}u(d,S,L){const t=this.F(S);typeof L=="number"?t[d]!==L&&(t[d]=L,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[d]=="number"&&(delete t[d],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.z;default:return this.w}}G(d){const S=this.L(d);return S?m(S):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=T.NONE){this.f.fire({reason:d});const S=this.L(-1),L=this.L(0),t=this.L(1);switch(d){case T.NONE:await w.Promises.settled([S?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await w.Promises.settled([S?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return f(d,S,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,S){return this.r(T.NONE),(0,g.isUserDataProfile)(d)?this.N(d,S):this.O(d,S)}H(d,S){return!(d.id===S.id||b(S)&&b(d))}I(d,S,L,t){this.t(()=>{if(t)for(const[n,r]of d)S.set(n,r);else{const n=new Set;for(const[r,i]of d)n.add(r),S.get(r)!==i&&this.n(L,r);for(const[r]of S.items)n.has(r)||this.n(L,r)}})}}p.a=60*1e3,e.AbstractStorageService=p;function b(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class a extends p{constructor(){super(),this.p=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=a;async function f(h,d,S,L,t,n){const r=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,l=new Map;h.forEach((B,q)=>{i.set(q,B),l.set(q,r(B))});const c=new Map,s=new Map;d.forEach((B,q)=>{c.set(q,B),s.set(q,r(B))});const u=new Map,E=new Map;S.forEach((B,q)=>{u.set(q,B),E.set(q,r(B))}),console.group(L!==t?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const k=[];if(i.forEach((B,q)=>{k.push({key:q,value:B})}),console.table(k),console.groupEnd(),console.log(l),L!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const B=[];c.forEach((q,le)=>{B.push({key:le,value:q})}),console.table(B),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${n})`);const O=[];u.forEach((B,q)=>{O.push({key:q,value:B})}),console.table(O),console.groupEnd(),console.log(E)}e.logStorage=f}),define(pe[123],ve([1,0,18,20,11,3,28,8,4,25,24,29,34,76,16,12,26,43,241,256,30]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const L=D.isWeb?"web":(0,I.getTargetPlatform)(D.platform,C.arch),t="X-Market-Search-Activity-Id";var n;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...N){return String(N.reduce((P,M)=>P|M,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class E{constructor(P=u){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new E({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const Y=[...this.d.criteria,...M.length?M.map(ie=>({filterType:P,value:ie})):[{filterType:P}]];return new E({...this.d,criteria:Y})}withSortBy(P){return new E({...this.d,sortBy:P})}withSortOrder(P){return new E({...this.d,sortOrder:P})}withFlags(...P){return new E({...this.d,flags:P.reduce((M,Y)=>M|Y,0)})}withAssetTypes(...P){return new E({...this.d,assetTypes:P})}withSource(P){return new E({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:Y,sortBy:ie,sortOrder:z,flags:V,assetTypes:J}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:Y,sortBy:ie,sortOrder:z}],assetTypes:J,flags:V}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(N,P){const M=(N||[]).filter(Y=>Y.statisticName===P)[0];return M?M.value:0}function O(N){const P="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(Y=>Y.assetType.indexOf(P)===0).reduce((Y,ie)=>{const z=le(N,ie.assetType);return z&&Y.push([ie.assetType.substring(P.length),z]),Y},[])}function B(N){if(N.properties){const P=N.properties.filter(ie=>ie.key===l.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=P.filter(ie=>M.test(ie.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return le(N,l.Repository)}function q(N){return{uri:`${N.fallbackAssetUri}/${l.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${l.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function le(N,P){return N.files.filter(Y=>Y.assetType===P)[0]?{uri:`${N.assetUri}/${P}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${P}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function de(N,P){const M=N.properties?N.properties.filter(ie=>ie.key===P):[],Y=M.length>0&&M[0].value;return Y?Y.split(",").map(ie=>(0,y.adoptToGalleryExtensionId)(ie)):[]}function ue(N){const P=N.properties?N.properties.filter(M=>M.key===c.Engine):[];return P.length>0&&P[0].value||""}function ae(N){const P=N.properties?N.properties.filter(M=>M.key===c.PreRelease):[];return P.length>0&&P[0].value==="true"}function _(N){const P=N.properties?N.properties.filter(Y=>Y.key===c.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function ee(N){return N.properties?.find(P=>P.key===c.SponsorLink)?.value}function ne(N){return N.indexOf("preview")!==-1}function te(N){return N.targetPlatform?(0,I.toTargetPlatform)(N.targetPlatform):"undefined"}function x(N){const P=(0,w.distinct)(N.versions.map(te)),M=!!N.tags?.includes(I.WEB_EXTENSION_TAG),Y=P.indexOf("web");return M?Y===-1&&P.push("web"):Y!==-1&&P.splice(Y,1),P}function U(N,P){const M=(0,I.getFallbackTargetPlarforms)(P);for(let Y=0;Y<N.length;Y++){const ie=N[Y];if(ie.version===N[Y-1]?.version){let z=Y;const V=te(ie);if(V===P)for(;z>0&&N[z-1].version===ie.version;)z--;else if(M.includes(V))for(;z>0&&N[z-1].version===ie.version&&te(N[z-1])!==P;)z--;z!==Y&&(N.splice(Y,1),N.splice(z,0,ie))}}return N}e.sortExtensionVersions=U;function Z(N,P,M){N.telemetryData={index:P,querySource:M,queryActivityId:N.queryContext?.[t]}}function re(N,P,M,Y){const ie=N.versions[0],z={manifest:le(P,l.Manifest),readme:le(P,l.Details),changelog:le(P,l.Changelog),license:le(P,l.License),repository:B(P),download:q(P),icon:le(P,l.Icon),signature:le(P,l.Signature),coreTranslations:O(P)};return{identifier:{id:(0,y.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:P.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:ee(ie),description:N.shortDescription||"",installCount:k(N.statistics,"install"),rating:k(N.statistics,"averagerating"),ratingCount:k(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:M,assets:z,properties:{dependencies:de(P,c.Dependency),extensionPack:de(P,c.ExtensionPack),engine:ue(P),localizedLanguages:_(P),targetPlatform:te(P),isPreReleaseVersion:ae(P)},hasPreReleaseVersion:ae(ie),hasReleaseVersion:!0,preview:ne(N.flags),isSigned:!!z.signature,queryContext:Y}}let me=class{constructor(P,M,Y,ie,z,V,J,H){this.k=M,this.l=Y,this.n=ie,this.o=z,this.q=V,this.u=J,this.w=H;const X=J.extensionsGallery,G=X?.servicePPEUrl&&H.getValue("_extensionsGallery.enablePPE");this.d=G?X.servicePPEUrl:X?.serviceUrl,this.g=G?void 0:X?.searchUrl,this.h=X?.controlUrl,this.j=(0,h.resolveMarketplaceHeaders)(J.version,J,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,Y){const ie=R.CancellationToken.isCancellationToken(M)?{}:M,z=R.CancellationToken.isCancellationToken(M)?M:Y,V=[],J=[],H=[],X=[];let G=!0;for(const Ee of P){Ee.uuid?J.push(Ee.uuid):V.push(Ee.id);const De=!!(Ee.version||Ee.preRelease);H.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:De}),Ee.version&&X.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),G=G&&!!Ee.hasPreRelease&&!De}if(!J.length&&!V.length)return[];let Q=new E().withPage(1,P.length);J.length&&(Q=Q.withFilter(i.ExtensionId,...J)),V.length&&(Q=Q.withFilter(i.ExtensionName,...V)),(ie.queryAllVersions||G)&&(Q=Q.withFlags(Q.flags,n.IncludeVersions)),ie.source&&(Q=Q.withSource(ie.source));const{extensions:ce}=await this.z(Q,{targetPlatform:ie.targetPlatform??L,includePreRelease:H,versions:X,compatible:!!ie.compatible},z);return ie.source&&ce.forEach((Ee,De)=>Z(Ee,De,ie.source)),ce}async getCompatibleExtension(P,M,Y){if((0,I.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(P,M,Y))return P;const ie=new E().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:z}=await this.z(ie,{targetPlatform:Y,compatible:!0,includePreRelease:M},R.CancellationToken.None);return z[0]||null}async isExtensionCompatible(P,M,Y){if(!(0,I.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,Y)||!M&&P.properties.isPreReleaseVersion)return!1;let ie=P.properties.engine;if(!ie){const z=await this.getManifest(P,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");ie=z.engines.vscode}return(0,m.isEngineValid)(ie,this.u.version,this.u.date)}async y(P,M,Y,ie,z){if(!(0,I.isTargetPlatformCompatible)(te(P),ie,z)||M!=="any"&&ae(P)!==(M==="prerelease"))return!1;if(Y)try{const V=await this.E(P);if(!(0,m.isEngineValid)(V,this.u.version,this.u.date))return!1}catch(V){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,o.getErrorMessage)(V)),!1}return!0}async query(P,M){let Y=P.text||"";const ie=P.pageSize??50;let z=new E().withPage(1,ie);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Q,ce)=>(z=z.withFilter(i.Category,ce||Q),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Q,ce)=>(z=z.withFilter(i.Tag,ce||Q),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(i.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),z=z.withFilter(i.SearchText,Y)),z=z.withSortBy(0)):P.ids?z=z.withFilter(i.ExtensionId,...P.ids):P.names?z=z.withFilter(i.ExtensionName,...P.names):z=z.withSortBy(4),typeof P.sortBy=="number"&&(z=z.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(z=z.withSortOrder(P.sortOrder)),P.source&&(z=z.withSource(P.source));const V=async(G,Q)=>{const{extensions:ce,total:Ee}=await this.z(G,{targetPlatform:L,compatible:!1,includePreRelease:!!P.includePreRelease},Q);return ce.forEach((De,ke)=>Z(De,(G.pageNumber-1)*G.pageSize+ke,P.source)),{extensions:ce,total:Ee}},{extensions:J,total:H}=await V(z,M),X=async(G,Q)=>{if(Q.isCancellationRequested)throw new o.CancellationError;const{extensions:ce}=await V(z.withPage(G+1),Q);return ce};return{firstPage:J,total:H,pageSize:z.pageSize,getPage:X}}async z(P,M,Y){const ie=P.flags;!!(P.flags&n.IncludeLatestVersionOnly)&&!!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(P.flags&n.IncludeLatestVersionOnly)&&!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),P=P.withFlags(P.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:z,total:V,context:J}=await this.B(P,Y);if(!(P.flags&n.IncludeLatestVersionOnly)){const Q=[];for(const ce of z){const Ee=await this.A(ce,M,J);Ee&&Q.push(Ee)}return{extensions:Q,total:V}}const X=[],G=new Map;for(let Q=0;Q<z.length;Q++){const ce=z[Q],Ee={id:(0,y.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},De=(0,A.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Ue=>(0,y.areSameExtensions)(Ue,Ee))?.includePreRelease;if(M.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(x(ce),M.targetPlatform))continue;const ke=await this.A(ce,M,J);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?G.set(ce.extensionId,Q):X.push([Q,ke])}if(G.size){const Q=new Date().getTime(),ce=new E().withFlags(ie&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,G.size).withFilter(i.ExtensionId,...G.keys()),{extensions:Ee}=await this.z(ce,M,Y);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Q,count:G.size});for(const De of Ee){const ke=G.get(De.identifier.uuid);X.push([ke,De])}}return{extensions:X.sort((Q,ce)=>Q[0]-ce[0]).map(([,Q])=>Q),total:V}}async A(P,M,Y){const ie={id:(0,y.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},z=M.versions?.find(X=>(0,y.areSameExtensions)(X,ie))?.version,V=(0,A.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(X=>(0,y.areSameExtensions)(X,ie))?.includePreRelease,J=x(P),H=U(P.versions,M.targetPlatform);if(M.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(J,M.targetPlatform))return null;for(let X=0;X<H.length;X++){const G=H[X];if(!(z&&G.version!==z)){if(await this.y(G,V?"any":"release",M.compatible,J,M.targetPlatform))return re(P,G,J,Y);if(z&&G.version===z)return null}}return z||M.compatible?null:re(P,P.versions[0],J)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const Y=await this.j,ie=JSON.stringify(P.raw),z={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},V=new Date().getTime();let J,H,X=0;try{if(J=await this.k.request({type:"POST",url:this.g&&P.criteria.some(Q=>Q.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ie,headers:z},M),J.res.statusCode&&J.res.statusCode>=400&&J.res.statusCode<500)return{galleryExtensions:[],total:X};const G=await(0,f.asJson)(J);if(G){const Q=G.results[0],ce=Q.extensions,Ee=Q.resultMetadata&&Q.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return X=Ee&&Ee.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:X,context:{[t]:J.res.headers.activityid}}}return{galleryExtensions:[],total:X}}catch(G){throw H=G,G}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(ie.length),duration:new Date().getTime()-V,success:!!J&&(0,f.isSuccess)(J),responseBodySize:J?.res.headers["Content-Length"],statusCode:J?String(J.res.statusCode):void 0,errorCode:H?(0,o.isCancellationError)(H)?"canceled":(0,o.getErrorMessage)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(P,M,Y,ie){if(!this.isEnabled())return;const z=D.isWeb?this.x(`/itemName/${P}.${M}/version/${Y}/statType/${ie==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${Y}/stats?statType=${ie}`),V=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",H={...await this.j,Accept:V};try{await this.k.request({type:"POST",url:z,headers:H},R.CancellationToken.None)}catch{}}async download(P,M,Y){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const ie=(0,y.getGalleryExtensionTelemetryData)(P),z=new Date().getTime(),V=Q=>this.o.publicLog("galleryService:downloadVSIX",{...ie,duration:Q}),J=Y===2?"install":Y===3?"update":"",H=J?{uri:`${P.assets.download.uri}${v.URI.parse(P.assets.download.uri).query?"&":"?"}${J}=true`,fallbackUri:`${P.assets.download.fallbackUri}${v.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${J}=true`}:P.assets.download,X=P.queryContext?.[t]?{[t]:P.queryContext[t]}:void 0,G=await this.D(H,X?{headers:X}:void 0);await this.q.writeFile(M,G.stream),V(new Date().getTime()-z)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const Y=await this.D(P.assets.signature);await this.q.writeFile(M,Y.stream)}async getReadme(P,M){if(P.assets.readme){const Y=await this.D(P.assets.readme,{},M);return await(0,f.asTextOrError)(Y)||""}return""}async getManifest(P,M){if(P.assets.manifest){const Y=await this.D(P.assets.manifest,{},M),ie=await(0,f.asTextOrError)(Y);return ie?JSON.parse(ie):null}return null}async C(P,M){const Y=le(P,l.Manifest);if(!Y)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},z=await this.D(Y,{headers:ie});return await(0,f.asJson)(z)}async getCoreTranslation(P,M){const Y=P.assets.coreTranslations.filter(ie=>ie[0]===M.toUpperCase())[0];if(Y){const ie=await this.D(Y[1]),z=await(0,f.asTextOrError)(ie);return z?JSON.parse(z):null}return null}async getChangelog(P,M){if(P.assets.changelog){const Y=await this.D(P.assets.changelog,{},M);return await(0,f.asTextOrError)(Y)||""}return""}async getAllCompatibleVersions(P,M,Y){let ie=new E().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?ie=ie.withFilter(i.ExtensionId,P.identifier.uuid):ie=ie.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:z}=await this.B(ie,R.CancellationToken.None);if(!z.length)return[];const V=x(z[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(V,Y))return[];const J=[];await Promise.all(z[0].versions.map(async G=>{try{await this.y(G,M?"any":"release",!0,V,Y)&&J.push(G)}catch{}}));const H=[],X=new Set;for(const G of U(J,Y))X.has(G.version)||(X.add(G.version),H.push({version:G.version,date:G.lastUpdated,isPreReleaseVersion:ae(G)}));return H}async D(P,M={},Y=R.CancellationToken.None){const ie=await this.j,z={type:"GET"},V={...ie,...M.headers||{}};M={...M,...z,headers:V};const J=P.uri,H=P.fallbackUri,X={...M,url:J};try{const G=await this.k.request(X,Y);if(G.res.statusCode===200)return G;const Q=await(0,f.asTextOrError)(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${Q}`)}catch(G){if((0,o.isCancellationError)(G))throw G;const Q=(0,o.getErrorMessage)(G);this.o.publicLog2("galleryService:cdnFallback",{url:J,message:Q});const ce={...M,url:H};return this.k.request(ce,Y)}}async E(P){let M=ue(P);if(!M){const Y=await this.C(P,R.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");M=Y.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,f.asJson)(P),Y=[],ie={};if(M){for(const z of M.malicious)Y.push({id:z});if(M.migrateToPreRelease)for(const[z,V]of Object.entries(M.migrateToPreRelease))(!V.engine||(0,m.isEngineValid)(V.engine,this.u.version,this.u.date))&&(ie[z.toLowerCase()]={disallowInstall:!0,extension:{id:V.id,displayName:V.displayName,autoMigrate:{storage:!!V.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[z,V]of Object.entries(M.deprecated))V&&(ie[z.toLowerCase()]=(0,A.isBoolean)(V)?{}:V)}return{malicious:Y,deprecated:ie}}};me=Le([Ae(1,f.IRequestService),Ae(2,b.ILogService),Ae(3,T.IEnvironmentService),Ae(4,S.ITelemetryService),Ae(5,p.IFileService),Ae(6,a.IProductService),Ae(7,g.IConfigurationService)],me);let $=class extends me{constructor(P,M,Y,ie,z,V,J,H){super(P,M,Y,ie,z,V,J,H)}};$=Le([Ae(0,d.IStorageService),Ae(1,f.IRequestService),Ae(2,b.ILogService),Ae(3,T.IEnvironmentService),Ae(4,S.ITelemetryService),Ae(5,p.IFileService),Ae(6,a.IProductService),Ae(7,g.IConfigurationService)],$),e.ExtensionGalleryService=$;let W=class extends me{constructor(P,M,Y,ie,z,V,J){super(void 0,P,M,Y,ie,z,V,J)}};W=Le([Ae(0,f.IRequestService),Ae(1,b.ILogService),Ae(2,T.IEnvironmentService),Ae(3,S.ITelemetryService),Ae(4,p.IFileService),Ae(5,a.IProductService),Ae(6,g.IConfigurationService)],W),e.ExtensionGalleryServiceWithNoStorageService=W}),define(pe[257],ve([1,0,6,2,31,49]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class C{constructor(g,T){this.a=g,this.b=T}listen(g,T){const I=this.b(g);switch(T){case"onDidChangeProfiles":return w.Event.map(this.a.onDidChangeProfiles,y=>({all:y.all.map(m=>(0,D.transformOutgoingURIs)({...m},I)),added:y.added.map(m=>(0,D.transformOutgoingURIs)({...m},I)),removed:y.removed.map(m=>(0,D.transformOutgoingURIs)({...m},I)),updated:y.updated.map(m=>(0,D.transformOutgoingURIs)({...m},I))}))}throw new Error(`Invalid listen ${T}`)}async call(g,T,I){const y=this.b(g);switch(T){case"createProfile":{const m=await this.a.createProfile(I[0],I[1],I[2]);return(0,D.transformOutgoingURIs)({...m},y)}case"updateProfile":{let m=(0,o.reviveProfile)((0,D.transformIncomingURIs)(I[0],y),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,I[1]),(0,D.transformOutgoingURIs)({...m},y)}case"removeProfile":{const m=(0,o.reviveProfile)((0,D.transformIncomingURIs)(I[0],y),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${T}`)}}e.RemoteUserDataProfilesServiceChannel=C;class A extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,T,I){super(),this.profilesHome=T,this.f=I,this.a=[],this.b=this.B(new w.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(y=>(0,o.reviveProfile)(y,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(y=>{const m=y.added.map(a=>(0,o.reviveProfile)(a,this.profilesHome.scheme)),p=y.removed.map(a=>(0,o.reviveProfile)(a,this.profilesHome.scheme)),b=y.updated.map(a=>(0,o.reviveProfile)(a,this.profilesHome.scheme));this.a=y.all.map(a=>(0,o.reviveProfile)(a,this.profilesHome.scheme)),this.b.fire({added:m,removed:p,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,T,I){const y=await this.f.call("createNamedProfile",[g,T,I]);return(0,o.reviveProfile)(y,this.profilesHome.scheme)}async createProfile(g,T,I,y){const m=await this.f.call("createProfile",[g,T,I,y]);return(0,o.reviveProfile)(m,this.profilesHome.scheme)}async createTransientProfile(g){const T=await this.f.call("createTransientProfile",[g]);return(0,o.reviveProfile)(T,this.profilesHome.scheme)}async setProfileForWorkspace(g,T){await this.f.call("setProfileForWorkspace",[g,T])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,T){const I=await this.f.call("updateProfile",[g,T]);return(0,o.reviveProfile)(I,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=A}),define(pe[124],ve([1,0,4,24,16,12,235,35,31,8,236]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let I=class Jt extends v.UserDataProfilesService{constructor(b,a,f,h,d){super(f,h,a,d),this.P=b,this.Q=f}J(){return this.P.getItem(Jt.b,[]).map(a=>({...a,location:(0,g.isString)(a.location)?this.s.extUri.joinPath(this.profilesHome,a.location):w.URI.revive(a.location)}))}M(){const b=this.P.getItem(Jt.c,{});return this.P.getItem(Jt.a,!1)?b:this.I(b)}O(){return this.s.extUri.joinPath(w.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};I.a="profileAssociationsMigration",I=Le([Ae(0,C.IStateReadService),Ae(1,A.IUriIdentityService),Ae(2,R.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,D.ILogService)],I),e.UserDataProfilesReadonlyService=I;let y=class Lt extends I{constructor(b,a,f,h,d){super(b,a,f,h,d),this.W=b}L(b){b.length?this.W.setItem(Lt.b,b.map(a=>({...a,location:this.s.extUri.basename(a.location)}))):this.W.removeItem(Lt.b)}J(){const b=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(b),this.W.setItem("userDataProfilesMigration",!0)),b}N(b){b.emptyWindows||b.workspaces?this.W.setItem(Lt.c,b):this.W.removeItem(Lt.c)}M(){const b="workspaceAndProfileInfo",a=this.W.getItem(b,void 0);if(a){this.W.removeItem(b);const h=a.reduce((d,{workspace:S,profile:L})=>(d[w.URI.revive(S).toString()]=w.URI.revive(L).toString(),d),{});this.W.setItem(Lt.c,{workspaces:h})}const f=super.M();return this.W.getItem(Lt.a,!1)||(this.N(f),this.W.setItem(Lt.a,!0)),f}};y=Le([Ae(0,C.IStateService),Ae(1,A.IUriIdentityService),Ae(2,R.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,D.ILogService)],y),e.UserDataProfilesService=y;let m=class extends y{constructor(b,a,f,h){super(new T.StateService(0,a,h,f),b,a,f,h)}async init(){return await this.W.init(),super.init()}};m=Le([Ae(0,A.IUriIdentityService),Ae(1,R.INativeEnvironmentService),Ae(2,o.IFileService),Ae(3,D.ILogService)],m),e.ServerUserDataProfilesService=m}),define(pe[125],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,w.createDecorator)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(D,C){this.a.set(D,C)}getExitInfo(D){return this.a.get(D)||null}}e.ExtensionHostStatusService=R}),define(pe[258],ve([1,0,6,14]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function o(C){let A=0,v=0,g=0;C>=1e3&&(g=Math.floor(C/1e3),C-=g*1e3),g>=60&&(v=Math.floor(g/60),g-=v*60),v>=60&&(A=Math.floor(v/60),v-=A*60);const T=A?`${A}h`:"",I=v?`${v}m`:"",y=g?`${g}s`:"",m=C?`${C}ms`:"";return`${T}${I}${y}${m}`}class D{constructor(A,v,g,T){this.i=A,this.j=v,this.a=new w.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=g,this.protocol=T,this.e=!1,this.f=new R.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${o(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${o(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${o(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(A){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${A}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${o(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end(),this.a.fire(void 0)}acceptReconnection(A,v,g){this.d=A,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,g),this.protocol.endAcceptReconnection()}}e.ManagementConnection=D}),define(pe[126],ve([1,0,32,13,7,146,52]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const A=o.join(R.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function g(y){return new Promise(m=>w.exists(y,m))}function T(y,m){return g(A).then(p=>{if(!p||!C.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const b=`${y}||${m}`;let a=v.get(b);return a||(a=D.getNLSConfiguration(C.default.commit,m,A,y,y).then(f=>(I.is(f)&&(f._languagePackSupport=!0),f)),v.set(b,a)),a})}e.getNLSConfiguration=T;var I;(function(y){function m(p){const b=p;return b&&typeof b._languagePackId=="string"}y.is=m})(I=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(pe[127],ve([1,0,19,4,24,44,55,16,5,12,26,35,31,126]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends C.AbstractExtensionsScannerService{constructor(a,f,h,d,S,L,t,n){super(R.URI.file(S.builtinExtensionsPath),R.URI.file(S.extensionsPath),(0,w.joinPath)(S.userHome,".vscode-oss-dev","extensions","control.json"),a.defaultProfile,a,f,h,d,S,L,t,n),this.N=S}async f(a){const f=await(0,m.getNLSConfiguration)(a,this.N.userDataPath);if(m.InternalNLSConfiguration.is(f))try{const h=await this.s.readFile(R.URI.file(f._translationsConfigFile));return JSON.parse(h.value.toString())}catch{}return Object.create(null)}};p=Le([Ae(0,y.IUserDataProfilesService),Ae(1,D.IExtensionsProfileScannerService),Ae(2,A.IFileService),Ae(3,g.ILogService),Ae(4,o.INativeEnvironmentService),Ae(5,T.IProductService),Ae(6,I.IUriIdentityService),Ae(7,v.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(pe[259],ve([1,0,260,32,7,22,13,23]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var g;(function(f){f[f.None=0]="None",f[f.Optional=1]="Optional",f[f.Mandatory=2]="Mandatory"})(g=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(h){return!0}}e.NoneServerConnectionToken=T;class I{constructor(h){this.value=h,this.type=1}validate(h){return h===this.value}}e.OptionalServerConnectionToken=I;class y{constructor(h){this.value=h,this.type=2}validate(h){return h===this.value}}e.MandatoryServerConnectionToken=y;class m{constructor(h){this.message=h}}e.ServerConnectionTokenParseError=m;async function p(f,h){const d=f["without-connection-token"],S=f["connection-token"],L=f["connection-token-file"],t=f.compatibility==="1.63";if(d)return typeof S<"u"||typeof L<"u"?new m("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof L<"u"){if(typeof S<"u")return new m("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let n;try{n=R.readFileSync(L).toString().replace(/\r?\n$/,"")}catch{return new m(`Unable to read the connection token file at '${L}'.`)}return v.test(n)?new y(n):new m(`The connection token defined in '${L} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof S<"u"?v.test(S)?t?new I(S):new y(S):new m(`The connection token '${S} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new I(await h())):new y(await h())}e.parseServerConnectionToken=p;async function b(f){return p(f,async()=>{if(!f["user-data-dir"])return(0,D.generateUuid)();const d=o.join(f["user-data-dir"],"token");try{const t=(await A.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(v.test(t))return t}catch{}const S=(0,D.generateUuid)();try{await A.Promises.writeFile(d,S,{mode:384})}catch{}return S})}e.determineServerConnectionToken=b;function a(f,h,d){if(f.validate(d.query[C.connectionTokenQueryName]))return!0;const S=w.parse(h.headers.cookie||"");return f.validate(S[C.connectionTokenCookieName])}e.requestHasValidConnectionToken=a}),define(pe[45],ve([1,0,195,104,63,5,24]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:w.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:w.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:w.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:w.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:w.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:w.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:w.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:w.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:w.localize(8,null)},"user-data-dir":o.OPTIONS["user-data-dir"],"enable-smoke-test-driver":o.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":o.OPTIONS["disable-telemetry"],"disable-workspace-trust":o.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:o.OPTIONS.log,logsPath:o.OPTIONS.logsPath,"force-disable-user-env":o.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:w.localize(9,null)},"default-workspace":{type:"string",description:w.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":o.OPTIONS["extensions-dir"],"extensions-download-dir":o.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":o.OPTIONS["builtin-extensions-dir"],"install-extension":o.OPTIONS["install-extension"],"install-builtin-extension":o.OPTIONS["install-builtin-extension"],"uninstall-extension":o.OPTIONS["uninstall-extension"],"list-extensions":o.OPTIONS["list-extensions"],"locate-extension":o.OPTIONS["locate-extension"],"show-versions":o.OPTIONS["show-versions"],category:o.OPTIONS.category,force:o.OPTIONS.force,"do-not-sync":o.OPTIONS["do-not-sync"],"pre-release":o.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:w.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:o.OPTIONS.help,version:o.OPTIONS.version,"locate-shell-integration-path":o.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:o.OPTIONS._},e.IServerEnvironmentService=(0,D.refineServiceDecorator)(C.IEnvironmentService);class A extends R.NativeEnvironmentService{get isRemoteServer(){return!0}get args(){return super.args}}e.ServerEnvironmentService=A}),define(pe[261],ve([1,0,32,73,82,260,117,39,57,3,12,45,7,13,22,26,43,20,4,15,8,54]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(s,u,E,k){u.writeHead(E,{"Content-Type":"text/plain"}),u.end(k)}e.serveError=n;var r;(function(s){s[s.NO_CACHING=0]="NO_CACHING",s[s.ETAG=1]="ETAG",s[s.NO_EXPIRY=2]="NO_EXPIRY"})(r=e.CacheControl||(e.CacheControl={}));async function i(s,u,E,k,O,B){try{const q=await w.promises.stat(s);if(u===1){const le=`W/"${[q.ino,q.size,q.mtime.getTime()].join("-")}"`;if(k.headers["if-none-match"]===le)return O.writeHead(304),void O.end();B.Etag=le}else u===2?B["Cache-Control"]="public, max-age=31536000":u===0&&(B["Cache-Control"]="no-store");B["Content-Type"]=t[(0,y.extname)(s)]||(0,v.getMediaMime)(s)||"text/plain",O.writeHead(200,B),(0,w.createReadStream)(s).pipe(O)}catch(q){return q.code!=="ENOENT"?(E.error(q),console.error(q.toString())):console.error(`File not found: ${s}`),O.writeHead(404,{"Content-Type":"text/plain"}),void O.end("Not found")}}e.serveFile=i;const l=(0,y.dirname)(m.FileAccess.asFileUri("").fsPath);let c=class{constructor(u,E,k,O,B){this.f=u,this.g=E,this.h=k,this.i=O,this.j=B,this.a=this.j.extensionsGallery?.resourceUrlTemplate?h.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const q=(0,L.getRemoteServerRootPath)(B);this.b=`${q}/static`,this.c=`${q}/callback`,this.d=`${q}/web-extension-resource`}async handle(u,E,k){try{const O=k.pathname;return O.startsWith(this.b)&&O.charCodeAt(this.b.length)===47?this.k(u,E,k):O==="/"?this.n(u,E,k):O===this.c?this.p(E):O.startsWith(this.d)&&O.charCodeAt(this.d.length)===47?this.m(u,E,k):n(u,E,404,"Not found.")}catch(O){return this.h.error(O),console.error(O.toString()),n(u,E,500,"Internal Server Error.")}}async k(u,E,k){const O=Object.create(null),q=decodeURIComponent(k.pathname).substring(this.b.length+1),le=(0,y.join)(l,q);return(0,A.isEqualOrParent)(le,l,!g.isLinux)?i(le,this.g.isBuilt?2:1,this.h,u,E,O):n(u,E,400,"Bad request.")}l(u){const E=u.authority.indexOf(".");return E!==-1?u.authority.substring(E+1):void 0}async m(u,E,k){if(!this.a)return n(u,E,500,"No extension gallery service configured.");const O=decodeURIComponent(k.pathname),B=(0,y.normalize)(O.substring(this.d.length+1)),q=h.URI.parse(B).with({scheme:this.a.scheme,authority:B.substring(0,B.indexOf("/")),path:B.substring(B.indexOf("/")+1)});if(this.l(this.a)!==this.l(q))return n(u,E,403,"Request Forbidden");const le={},de=te=>{const x=u.headers[te];x&&((0,S.isString)(x)||x[0])?le[te]=(0,S.isString)(x)?x:x[0]:te!==te.toLowerCase()&&de(te.toLowerCase())};de("X-Client-Name"),de("X-Client-Version"),de("X-Machine-Id"),de("X-Client-Commit");const ue=await this.i.request({type:"GET",url:q.toString(!0),headers:le},f.CancellationToken.None),ae=ue.res.statusCode||500;if(ae!==200){let te=null;try{te=await(0,a.asTextOrError)(ue)}catch{}return n(u,E,ae,te||`Request failed with status ${ae}`)}const _=Object.create(null),ee=te=>{const x=ue.res.headers[te];x?_[te]=x:te!==te.toLowerCase()&&ee(te.toLowerCase())};ee("Cache-Control"),ee("Content-Type"),E.writeHead(200,_);const ne=await(0,d.streamToBuffer)(ue.stream);return void E.end(ne.buffer)}async n(u,E,k){const O=k.query[m.connectionTokenQueryName];if(typeof O=="string"){const re=Object.create(null);re["Set-Cookie"]=D.serialize(m.connectionTokenCookieName,O,{sameSite:"lax",maxAge:60*60*24*7});const me=Object.create(null);for(const W in k.query)W!==m.connectionTokenQueryName&&(me[W]=k.query[W]);const $=o.format({pathname:"/",query:me});return re.Location=$,E.writeHead(302,re),void E.end()}const B=re=>{const me=u.headers[re];return Array.isArray(me)?me[0]:me},q=B("x-original-host")||B("x-forwarded-host")||u.headers.host;if(!q)return n(u,E,400,"Bad request.");function le(re){return JSON.stringify(re).replace(/"/g,"&quot;")}let de;this.g.args["enable-smoke-test-driver"]&&(de=!1);const ue=re=>re&&h.URI.file(R.resolve(re)).with({scheme:m.Schemas.vscodeRemote,authority:q}),ae=m.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,_=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,p.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ee={remoteAuthority:q,_wrapWebWorkerExtHostInIframe:de,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:ue(this.g.args["default-folder"]),workspaceUri:ue(this.g.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:q,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0},callbackRoute:this.c},ne=this.j.extensionsGallery?.nlsBaseUrl,te={WORKBENCH_WEB_CONFIGURATION:le(ee),WORKBENCH_AUTH_SESSION:_?le(_):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:ne?`${ne}${ne.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};let x;try{x=(await w.promises.readFile(ae)).toString().replace(/\{\{([^}]+)\}\}/g,(me,$)=>te[$]??"undefined")}catch{return E.writeHead(404,{"Content-Type":"text/plain"}),void E.end("Not found")}const U=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(x).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${q};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),Z={"Content-Type":"text/html","Content-Security-Policy":U};return this.f.type!==0&&(Z["Set-Cookie"]=D.serialize(m.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),E.writeHead(200,Z),void E.end(x)}o(u){const E=/<script>([\s\S]+?)<\/script>/img,k=[];let O;for(;O=E.exec(u);){const B=C.createHash("sha256"),q=O[1].replace(/\r\n/g,`
`),le=B.update(Buffer.from(q)).digest().toString("base64");k.push(`'sha256-${le}'`)}return k}async p(u){const E=m.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,k=(await w.promises.readFile(E)).toString(),O=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(k).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return u.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":O}),void u.end(k)}};c=Le([Ae(1,I.IServerEnvironmentService),Ae(2,T.ILogService),Ae(3,a.IRequestService),Ae(4,b.IProductService)],c),e.WebClientServer=c}),define(pe[262],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(pe[263],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class R{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=R}),define(pe[69],ve([1,0,49]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(D){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:D,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function o(D){return new w.URITransformer(R(D))}e.createURITransformer=o}),define(pe[264],ve([1,0,3,41,4,69,49,101,239,7,19]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class I{constructor(m,p,b,a){this.b=m,this.c=p,this.d=b,this.e=a}async call(m,p,b){switch(p){case"getEnvironmentData":{const a=b,f=(0,D.createURITransformer)(a.remoteAuthority);let h=await this.f(a.profile);return h=(0,C.transformOutgoingURIs)(h,f),h}case"getExtensionHostExitInfo":{const a=b;return this.e.getExitInfo(a.reconnectionToken)}case"getDiagnosticInfo":{const a=b,f={machineInfo:(0,v.getMachineInfo)()},h=a.includeProcesses?(0,A.listProcesses)(process.pid):Promise.resolve();let d=[];const S={};if(a.folders){const L=(0,D.createURITransformer)("");d=a.folders.map(n=>o.URI.revive(L.transformIncoming(n))).filter(n=>n.scheme==="file").map(n=>(0,v.collectWorkspaceStats)(n.fsPath,["node_modules",".git"]).then(r=>{S[(0,g.basename)(n.fsPath)]=r}))}return Promise.all([h,...d]).then(([L,t])=>(f.processes=L||void 0,f.workspaceMetadata=a.folders?S:void 0,f))}}throw new Error(`IPC Command ${p} not found`)}listen(m,p,b){throw new Error("Not supported")}async f(m){return m&&!this.d.profiles.some(p=>p.id===m)&&await this.d.createProfile(m,m),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:o.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,T.joinPath)(this.c.logsHome,`exthost${I.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:w.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(p=>({...p}))}}}}I.a=1,e.RemoteAgentEnvironmentChannel=I}),define(pe[265],ve([1,0,4,69,67,7,223]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class A extends C.AbstractDiskFileSystemProviderChannel{constructor(T,I){super(new o.DiskFileSystemProvider(T),T),this.H=I,this.G=new Map,this.B(this.a)}c(T){let I=this.G.get(T.remoteAuthority);return I||(I=(0,R.createURITransformer)(T.remoteAuthority),this.G.set(T.remoteAuthority,I)),I}f(T,I,y=!1){if(y&&I.path==="/vscode-resource"&&I.query){const m=JSON.parse(I.query).requestResourcePath;return w.URI.from({scheme:"file",path:m})}return w.URI.revive(T.transformIncoming(I))}F(T,I){return new v(T,I,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=A;class v extends C.AbstractSessionFileWatcher{constructor(T,I,y,m){super(T,I,y,m)}i(T){const I=T.args["file-watcher-polling"];if(I){const y=I.split(D.delimiter),m=Number(y[0]);if(m>0)return{usePolling:y.length>1?y.slice(1):!0,pollingInterval:m}}}j(T){if(T.extensionsPath)return[D.posix.join(T.extensionsPath,"**")]}}}),define(pe[86],ve([1,0,198,8,4,2,5,40,16,13,38,156,59]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var m;(function($){$[$.PROGRAMMATIC=1]="PROGRAMMATIC",$[$.USER=2]="USER",$[$.EDIT=3]="EDIT",$[$.NAVIGATION=4]="NAVIGATION",$[$.JUMP=5]="JUMP"})(m=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function($){$[$.IDENTICAL=1]="IDENTICAL",$[$.SIMILAR=2]="SIMILAR",$[$.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b($){const W=$;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}e.isEditorPaneWithSelection=b;function a($,W,N){for(const P of N.visibleEditorPanes)if(P.group.id===W&&$.matches(P.input))return P.getViewState()}e.findViewStateForEditor=a;function f($){if(u($))return!1;const W=$;return o.URI.isUri(W?.resource)}e.isResourceEditorInput=f;function h($){if(u($))return!1;const W=$;return W?.original!==void 0&&W.modified!==void 0}e.isResourceDiffEditorInput=h;function d($){if(u($)||h($))return!1;const W=$;return W?.primary!==void 0&&W.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function S($){if(u($))return!1;const W=$;return W?W.resource===void 0||W.resource.scheme===g.Schemas.untitled||W.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;const L=/Untitled-\d+/;function t($){return $.scheme===g.Schemas.untitled&&$.path.length>1&&!L.test($.path)}e.isUntitledWithAssociatedResource=t;function n($){if(u($))return!1;const W=$;return o.URI.isUri(W?.base?.resource)&&o.URI.isUri(W?.input1?.resource)&&o.URI.isUri(W?.input2?.resource)&&o.URI.isUri(W?.result?.resource)}e.isResourceMergeEditorInput=n;var r;(function($){$[$.SHORT=0]="SHORT",$[$.MEDIUM=1]="MEDIUM",$[$.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var i;(function($){$[$.EXPLICIT=1]="EXPLICIT",$[$.AUTO=2]="AUTO",$[$.FOCUS_CHANGE=3]="FOCUS_CHANGE",$[$.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(W,N){let P=this.a.get(W);return P||(P={source:W,label:N},this.a.set(W,P)),P.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.SaveSourceRegistry=new l;var c;(function($){$[$.None=0]="None",$[$.Readonly=2]="Readonly",$[$.Untitled=4]="Untitled",$[$.Singleton=8]="Singleton",$[$.RequiresTrust=16]="RequiresTrust",$[$.CanSplitInGroup=32]="CanSplitInGroup",$[$.ForceDescription=64]="ForceDescription",$[$.CanDropIntoEditor=128]="CanDropIntoEditor",$[$.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends D.Disposable{}e.AbstractEditorInput=s;function u($){return $ instanceof s}e.isEditorInput=u;function E($){const W=$;return o.URI.isUri(W?.preferredResource)}function k($){const W=$;return u(W?.primary)&&u(W?.secondary)}e.isSideBySideEditorInput=k;function O($){const W=$;return u(W?.modified)&&u(W?.original)}e.isDiffEditorInput=O;function B($,W,N,P,M){return me(P,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const Y={...N,limits:{size:Number.MAX_VALUE}};$.openEditor(W,Y)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>M.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:y.default.Warning})}e.createTooLargeFileError=B;function q($){return u($?.editor)}e.isEditorInputWithOptions=q;function le($){const W=$;return q($)&&W?.group!==void 0}e.isEditorInputWithOptionsAndGroup=le;function de($){const W=$;return typeof W?.groupId=="number"&&u(W.editor)}e.isEditorIdentifier=de;var ue;(function($){$[$.UNKNOWN=0]="UNKNOWN",$[$.REPLACE=1]="REPLACE",$[$.MOVE=2]="MOVE",$[$.UNPIN=3]="UNPIN"})(ue=e.EditorCloseContext||(e.EditorCloseContext={}));var ae;(function($){$[$.GROUP_ACTIVE=0]="GROUP_ACTIVE",$[$.GROUP_INDEX=1]="GROUP_INDEX",$[$.GROUP_LOCKED=2]="GROUP_LOCKED",$[$.EDITOR_OPEN=3]="EDITOR_OPEN",$[$.EDITOR_CLOSE=4]="EDITOR_CLOSE",$[$.EDITOR_MOVE=5]="EDITOR_MOVE",$[$.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",$[$.EDITOR_LABEL=7]="EDITOR_LABEL",$[$.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",$[$.EDITOR_PIN=9]="EDITOR_PIN",$[$.EDITOR_STICKY=10]="EDITOR_STICKY",$[$.EDITOR_DIRTY=11]="EDITOR_DIRTY",$[$.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(ae=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var _;(function($){$[$.PRIMARY=1]="PRIMARY",$[$.SECONDARY=2]="SECONDARY",$[$.BOTH=3]="BOTH",$[$.ANY=4]="ANY"})(_=e.SideBySideEditor||(e.SideBySideEditor={}));class ee{getOriginalUri(W,N){if(!W)return;if(n(W))return e.EditorResourceAccessor.getOriginalUri(W.result,N);if(N?.supportSideBySide){const{primary:M,secondary:Y}=this.a(W);if(M&&Y){if(N?.supportSideBySide===_.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===_.ANY)return this.getOriginalUri(M,{filterByScheme:N.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:N.filterByScheme});W=N.supportSideBySide===_.PRIMARY?M:Y}}if(h(W)||d(W)||n(W))return;const P=E(W)?W.preferredResource:W.resource;return!P||!N||!N.filterByScheme?P:this.b(P,N.filterByScheme)}a(W){return k(W)||d(W)?{primary:W.primary,secondary:W.secondary}:O(W)||h(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,N){if(!W)return;if(n(W))return e.EditorResourceAccessor.getCanonicalUri(W.result,N);if(N?.supportSideBySide){const{primary:M,secondary:Y}=this.a(W);if(M&&Y){if(N?.supportSideBySide===_.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===_.ANY)return this.getCanonicalUri(M,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:N.filterByScheme});W=N.supportSideBySide===_.PRIMARY?M:Y}}if(h(W)||d(W)||n(W))return;const P=W.resource;return!P||!N||!N.filterByScheme?P:this.b(P,N.filterByScheme)}b(W,N){if(Array.isArray(N)){if(N.some(P=>W.scheme===P))return W}else if(N===W.scheme)return W}}e.EditorResourceAccessor=new ee;var ne;(function($){$[$.LEFT=0]="LEFT",$[$.RIGHT=1]="RIGHT"})(ne=e.CloseDirection||(e.CloseDirection={}));class te{constructor(){this.c=new Map,this.d=new Map}start(W){const N=this.a=W.get(C.IInstantiationService);for(const[P,M]of this.c)this.e(P,M,N);this.c.clear()}e(W,N,P){const M=P.createInstance(N);this.d.set(W,M)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,R.assertIsDefined)(this.b)}registerEditorSerializer(W,N){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,N,this.a):this.c.set(W,N),(0,D.toDisposable)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new te);async function x($,W,N){return!$||!$.length?[]:await Promise.all($.map(async P=>{const M=o.URI.revive(P.fileUri);if(!M){N.info("Cannot resolve the path because it is not valid.",P);return}if(!await W.canHandleResource(M)){N.info("Cannot resolve the path because it cannot be handled",P);return}let ie=P.exists,z=P.type;if(typeof ie!="boolean"||typeof z!="number")try{z=(await W.stat(M)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ie=!0}catch(J){N.error(J),ie=!1}if(!ie&&P.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",P);return}if(z===v.FileType.Directory){N.info("Cannot resolve the path because it is a directory",P);return}const V={...P.options,pinned:!0};return ie?{resource:M,options:V}:{resource:M,options:V,forceUntitled:!0}}))}e.pathsToEditors=x;var U;(function($){$[$.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",$[$.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function Z($){const W=$;if(!W)return!1;const N=W;if(N.modified)return Z(N.modified);const P=W;return!!(P.contributionsState&&P.viewState&&Array.isArray(P.cursorState))}e.isTextEditorViewState=Z;function re($){return(0,T.isErrorWithActions)($)}e.isEditorOpenError=re;function me($,W,N){const P=(0,T.createErrorWithActions)($,W);return P.forceMessage=N?.forceMessage,P.forceSeverity=N?.forceSeverity,P.allowDialog=N?.allowDialog,P}e.createEditorOpenError=me}),define(pe[128],ve([1,0,15,75,56,57,13,7,3,65]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var m;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(m=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var b;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeCellLanguage=5]="ChangeCellLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(b=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var h;(function(_){_.scheme=C.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],ne=new RegExp(`^[${ee.join("")}]+`),te=7;function x(W,N){const P=N.toString(te),Y=`${P.length<ee.length?ee[P.length-1]:"z"}${P}s${(0,w.encodeBase64)(w.VSBuffer.fromString(W.scheme),!0,!0)}`;return W.with({scheme:_.scheme,fragment:Y})}_.generate=x;function U(W){if(W.scheme!==_.scheme)return;const N=W.fragment.indexOf("s");if(N<0)return;const P=parseInt(W.fragment.substring(0,N).replace(ne,""),te),M=(0,w.decodeBase64)(W.fragment.substring(N+1)).toString();if(!isNaN(P))return{handle:P,notebook:W.with({scheme:M,fragment:null})}}_.parse=U;function Z(W,N){return W.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${W.scheme!==C.Schemas.file?W.scheme:""}`})}_.generateCellOutputUri=Z;function re(W){if(W.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!N)return;const P=N[1]&&N[1]!==""?N[1]:void 0,M=N[2];return{outputId:P,notebook:W.with({scheme:M||C.Schemas.file,fragment:null})}}_.parseCellOutputUri=re;function me(W,N,P){return _.generate(W,N).with({scheme:P})}_.generateCellPropertyUri=me;function $(W,N){if(W.scheme===N)return _.parse(W.with({scheme:_.scheme}))}_.parseCellPropertyUri=$})(h=e.CellUri||(e.CellUri={}));const d=_=>v.isWindows?_.replace(/\//g,"\\"):_;class S{constructor(ee=[],ne=e.NOTEBOOK_DISPLAY_ORDER){this.e=ne,this.d=[...new Set(ee)].map(te=>({pattern:te,matches:R.parse(d(te))}))}sort(ee){const ne=new Map(o.Iterable.map(ee,x=>[x,d(x)]));let te=[];for(const{matches:x}of this.d)for(const[U,Z]of ne)if(x(Z)){te.push(U),ne.delete(U);break}return ne.size&&(te=te.concat([...ne.keys()].sort((x,U)=>this.e.indexOf(x)-this.e.indexOf(U)))),te}prioritize(ee,ne){const te=this.f(ee);if(te===-1){this.d.unshift({pattern:ee,matches:R.parse(d(ee))});return}const x=new Set(ne.map(Z=>this.f(Z,te)));x.delete(-1);const U=Array.from(x).sort();this.d.splice(te+1,0,...U.map(Z=>this.d[Z]));for(let Z=U.length-1;Z>=0;Z--)this.d.splice(U[Z],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,ne=this.d.length){const te=d(ee);for(let x=0;x<ne;x++)if(this.d[x].matches(te))return x;return-1}}e.MimeTypeDisplayOrder=S;function L(_,ee,ne,te=(x,U)=>x===U){const x=[];function U(me,$,W){if($===0&&W.length===0)return;const N=x[x.length-1];N&&N.start+N.deleteCount===me?(N.deleteCount+=$,N.toInsert.push(...W)):x.push({start:me,deleteCount:$,toInsert:W})}let Z=0,re=0;for(;;){if(Z===_.length){U(Z,0,ee.slice(re));break}if(re===ee.length){U(Z,_.length-Z,[]);break}const me=_[Z],$=ee[re];if(te(me,$)){Z+=1,re+=1;continue}ne($)?(U(Z,1,[]),Z+=1):(U(Z,0,[$]),re+=1)}return x}e.diff=L,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(_){_.default="default",_.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(_){const ee=_;return!!((typeof ee.include=="string"||R.isRelativePattern(ee.include))&&(typeof ee.exclude=="string"||R.isRelativePattern(ee.exclude)))}e.isDocumentExcludePattern=n;function r(_,ee,ne){if(Array.isArray(_.viewType)&&_.viewType.indexOf(ee)>=0||_.viewType===ee)return!0;if(_.filenamePattern){const te=n(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,x=n(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(R.match(te,(0,A.basename)(ne.fsPath).toLowerCase()))return!(x&&R.match(x,(0,A.basename)(ne.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var i;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(ee){return`${l.d}${ee}`}static parse(ee){if(ee.startsWith(l.d))return ee.substring(l.d.length)}}l.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=l;function c(_){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(_)}e.isTextStreamMime=c;const s=new TextDecoder;function u(_){const ee=[];let ne=!1;for(const te of _)(ee.length===0||ne)&&(ee.push(te),ne=!0);return B(ee),ae(w.VSBuffer.concat(ee.map(te=>w.VSBuffer.wrap(te))))}e.compressOutputItemStreams=u;const E=`${String.fromCharCode(27)}[A`,k=E.split("").map(_=>_.charCodeAt(0)),O=10;function B(_){_.forEach((ee,ne)=>{if(ne===0||ee.length<E.length)return;const te=_[ne-1],x=ee.subarray(0,E.length);if(x[0]===k[0]&&x[1]===k[1]&&x[2]===k[2]){const U=te.lastIndexOf(O);if(U===-1)return;_[ne-1]=te.subarray(0,U),_[ne]=ee.subarray(E.length)}})}function q(_){let ee=_;do _=ee,ee=_.replace(/[^\n]\x08/gm,"");while(ee.length<_.length);return _}function le(_){for(_=_.replace(/\r+\n/gm,`
`);_.search(/\r[^$]/g)>-1;){const ee=_.match(/^(.*)\r+/m)[1];let ne=_.match(/\r+(.*)$/m)[1];ne=ne+ee.slice(ne.length,ee.length),_=_.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return _}const de="\b".charCodeAt(0),ue="\r".charCodeAt(0);function ae(_){return!_.buffer.includes(de)&&!_.buffer.includes(ue)?_:w.VSBuffer.fromString(le(q(s.decode(_.buffer))))}}),define(pe[266],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,w.createDecorator)("environmentVariableService")}),define(pe[267],ve([1,0,7,58,3,248,8]),function(oe,e,w,R,o,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(t,n){if(!!n)if(o.isWindows)for(const r in n){let i=r;for(const c in t)if(r.toLowerCase()===c.toLowerCase()){i=c;break}const l=n[r];l!==void 0&&v(t,i,l)}else Object.keys(n).forEach(r=>{const i=n[r];i!==void 0&&v(t,r,i)})}e.mergeEnvironments=A;function v(t,n,r){typeof r=="string"?t[n]=r:delete t[n]}function g(t,n,r,i){t.TERM_PROGRAM="vscode",n&&(t.TERM_PROGRAM_VERSION=n),y(t,i)&&(t.LANG=m(r)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=g;function T(t,n){if(!!n)for(const r of Object.keys(n)){const i=n[r];i!=null&&(t[r]=i)}}async function I(t,n){return await Promise.all(Object.entries(n).map(async([r,i])=>{if(typeof i=="string")try{n[r]=await t(i)}catch{n[r]=i}})),n}function y(t,n){if(n==="on")return!0;if(n==="auto"){const r=t.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=y;function m(t){const n=t?t.split("-"):[],r=n.length;if(r===0)return"en_US.UTF-8";if(r===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in i&&n.push(i[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.getLangEnvVariable=m;async function p(t,n,r,i,l,c){if(t.cwd){const u=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,E=await b(u,r);return(0,D.sanitizeCwd)(E||u)}let s;return!t.ignoreConfigurationCwd&&l&&(r&&(l=await b(l,r,c)),l&&(w.isAbsolute(l)?s=l:i&&(s=w.join(i.fsPath,l)))),s||(s=i?i.fsPath:n||""),(0,D.sanitizeCwd)(s)}e.getCwd=p;async function b(t,n,r){if(n)try{return await n(t)}catch(i){r?.error("Could not resolve terminal cwd",i);return}return t}function a(t,n,r){if(!!r)return i=>r.resolveWithEnvironment(n,t,i)}e.createVariableResolver=a;async function f(t,n,r,i,l,c,s,u=o.platform){let E;s&&(E=d(t,"automationShell",u)),E||(E=d(t,"shell",u));let k=E||n;if(u===3&&!r&&i){const O=w.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();k&&k.toLowerCase().indexOf(O)===0&&(k=w.join(i,"System32",k.substr(O.length+1)))}if(k&&u===3&&(k=k.replace(/\//g,"\\")),l)try{k=await l(k)}catch(O){c.error("Could not resolve shell",O)}return k}e.getDefaultShell=f;async function h(t,n,r,i,l=o.platform){if(n&&d(t,"automationShell",l))return[];const c=l===3?"windows":l===1?"osx":"linux";let s=t(`terminal.integrated.shellArgs.${c}`);if(!s)return[];if(typeof s=="string"&&l===3)return r?await r(s):s;if(r){const u=[];for(const E of s)try{u.push(await r(E))}catch(k){i.error(`Could not resolve terminal.integrated.shellArgs.${c}`,k),u.push(E)}s=u}return s}e.getDefaultShellArgs=h;function d(t,n,r=o.platform){return t(`terminal.integrated.${n}.${r===3?"windows":r===1?"osx":"linux"}`)}async function S(t,n,r,i,l,c){const s={};if(t.strictEnv)T(s,t.env);else{T(s,c);const u={...n};r&&(u&&await I(r,u),t.env&&await I(r,t.env)),(0,R.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI"),A(s,u),A(s,t.env),g(s,i,o.language,l)}return s}e.createTerminalEnvironment=S;async function L(t,n,r,i,l,c,s=o.isWindows){let u;if((0,C.isString)(t)?u=t:(u=t.fsPath,s&&c!==1?u=u.replace(/\\/g,"/"):!s&&c===1&&(u=u.replace(/\//g,"\\"))),!n)return u;const E=u.includes(" "),k=u.includes("(")||u.includes(")"),O=w.basename(n,".exe"),B=O==="pwsh"||r==="pwsh"||O==="powershell"||r==="powershell";if(B&&(E||u.includes("'")))return`& '${u.replace(/'/g,"''")}'`;if(k&&B)return`& '${u}'`;if(c===1){if(i!==void 0)return i==="gitbash"?(0,D.escapeNonWindowsPath)(u.replace(/\\/g,"/")):i==="wsl"?l?.getWslPath(u,"win-to-unix")||u:E?`"${u}"`:u;const q=n.toLowerCase();return q.includes("wsl")||q.includes("bash.exe")&&!q.toLowerCase().includes("git")?l?.getWslPath(u,"win-to-unix")||u:E?`"${u}"`:u}return(0,D.escapeNonWindowsPath)(u)}e.preparePathForShell=L}),define(pe[70],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(D){D.Delimiter="\0"})(w=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class o{static fromExtHostTestItem(C,A,v=C.parent){if(C._isRoot)return new o([A]);const g=[C.id];for(let T=v;T&&T.id!==A;T=T.parent)g.push(T.id);return g.push(A),new o(g.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const A=C.indexOf("\0");return A===-1?C:C.slice(0,A)}static fromString(C){return new o(C.split("\0"))}static join(C,A){return new o([...C.path,A])}static joinToString(C,A){return C.toString()+"\0"+A}static parentId(C){const A=C.lastIndexOf("\0");return A===-1?void 0:C.slice(0,A)}static localId(C){const A=C.lastIndexOf("\0");return A===-1?C:C.slice(A+1)}static compare(C,A){return C===A?0:A.startsWith(C+"\0")?2:C.startsWith(A+"\0")?3:1}constructor(C,A=C.length){if(this.path=C,this.d=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new o(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new o(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new o(this.path,C)}compare(C){if(typeof C=="string")return o.compare(this.toString(),C);for(let A=0;A<C.d&&A<this.d;A++)if(C.path[A]!==this.path[A])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=o}),define(pe[87],ve([1,0,4,48,70]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable",s[s.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=s=>"runId"in s;e.isStartControllerTests=A;var v;(function(s){s.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),s.deserialize=u=>({range:R.Range.lift(u.range),uri:w.URI.revive(u.uri)})})(v=e.IRichLocation||(e.IRichLocation={}));var g;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(g=e.TestMessageType||(e.TestMessageType={}));var T;(function(s){s.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&v.serialize(u.location)}),s.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&v.deserialize(u.location)})})(T=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(s,u)=>`${u?"s":"e"}${s}`;e.getMarkId=I;var y;(function(s){s.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&v.serialize(u.location)}),s.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&v.deserialize(u.location)})})(y=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(s){s.serialize=u=>u.type===0?T.serialize(u):y.serialize(u),s.deserialize=u=>u.type===0?T.deserialize(u):y.deserialize(u)})(m=e.ITestMessage||(e.ITestMessage={}));var p;(function(s){s.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),s.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.serialize)}),s.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const b="\0",a=(s,u)=>s+b+u;e.namespaceTestTag=a;const f=s=>{const u=s.indexOf(b);return{ctrlId:s.slice(0,u),tagId:s.slice(u+1)}};e.denamespaceTestTag=f;var h;(function(s){s.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),s.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?w.URI.revive(u.uri):void 0,range:u.range?R.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(h=e.ITestItem||(e.ITestItem={}));var d;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(s){s.serialize=u=>({expand:u.expand,item:h.serialize(u.item)}),s.deserialize=u=>({controllerId:o.TestId.root(u.item.extId),expand:u.expand,item:h.deserialize(u.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var L;(function(s){s.serialize=u=>{let E;return u.item&&(E={},u.item.label!==void 0&&(E.label=u.item.label),u.item.tags!==void 0&&(E.tags=u.item.tags),u.item.busy!==void 0&&(E.busy=u.item.busy),u.item.uri!==void 0&&(E.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(E.range=u.item.range?.toJSON()),u.item.description!==void 0&&(E.description=u.item.description),u.item.error!==void 0&&(E.error=u.item.error),u.item.sortText!==void 0&&(E.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:E}},s.deserialize=u=>{let E;return u.item&&(E={},u.item.label!==void 0&&(E.label=u.item.label),u.item.tags!==void 0&&(E.tags=u.item.tags),u.item.busy!==void 0&&(E.busy=u.item.busy),u.item.range!==void 0&&(E.range=u.item.range?R.Range.lift(u.item.range):null),u.item.description!==void 0&&(E.description=u.item.description),u.item.error!==void 0&&(E.error=u.item.error),u.item.sortText!==void 0&&(E.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:E}}})(L=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(s,u)=>{u.expand!==void 0&&(s.expand=u.expand),u.item!==void 0&&(s.item=s.item?Object.assign(s.item,u.item):u.item)};e.applyTestItemUpdate=t;var n;(function(s){s.serializeWithoutMessages=u=>({...S.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(p.serializeWithoutMessages),retired:u.retired}),s.serialize=u=>({...S.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(p.serialize),retired:u.retired}),s.deserialize=u=>({...S.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(p.deserialize),retired:!0})})(n=e.TestResultItem||(e.TestResultItem={}));var r;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(s){s.deserialize=u=>u.op===0?{op:u.op,item:S.deserialize(u.item)}:u.op===1?{op:u.op,item:L.deserialize(u.item)}:u.op===2?{op:u.op,uri:w.URI.revive(u.uri),docv:u.docv}:u,s.serialize=u=>u.op===0?{op:u.op,item:S.serialize(u.item)}:u.op===1?{op:u.op,item:L.serialize(u.item)}:u})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const E=this.o();for(const k of u)switch(k.op){case 0:this.j(S.deserialize(k.item),E);break;case 1:this.k(L.deserialize(k.item),E);break;case 3:this.l(k.itemId,E);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}E.complete?.()}j(u,E){const k=o.TestId.parentId(u.item.extId)?.toString();let O;if(!k)O=this.p(u),this.f.add(O),this.d.set(u.item.extId,O);else if(this.d.has(k)){const B=this.d.get(k);B.children.add(u.item.extId),O=this.p(u,B),this.d.set(u.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return E.add?.(O),u.expand===2&&this.g++,O}k(u,E){const k=this.d.get(u.extId);if(!!k)return u.expand!==void 0&&(k.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(k,u),E.update?.(k),k}l(u,E){const k=this.d.get(u);if(!k)return;const O=o.TestId.parentId(k.item.extId)?.toString();O?this.d.get(O).children.delete(k.item.extId):this.f.delete(k);const B=[[u]];for(;B.length;)for(const q of B.pop()){const le=this.d.get(q);le&&(B.push(le.children),this.d.delete(q),E.remove?.(le,le!==k),le.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(pe[129],ve([1,0,14,6,2,90,87,70]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(v=e.TestItemEventOp||(e.TestItemEventOp={}));const g=(h,d)=>h===d,I=Object.entries({range:(h,d)=>h===d?!0:!h||!d?!1:h.equalsRange(d),busy:g,label:g,description:g,error:g,sortText:g,tags:(h,d)=>!(h.length!==d.length||h.some(S=>!d.includes(S)))}),y=(h,d)=>{let S;for(const[L,t]of I)t(h[L],d[L])||(S?S[L]=d[L]:S={[L]:d[L]});return S};class m extends o.Disposable{get root(){return this.m.root}constructor(d){super(),this.m=d,this.f=this.B(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new R.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(d){this.h=d;for(const S of this.tree.values())this.G(S)}get resolveHandler(){return this.h}collectDiff(){const d=this.k;return this.k=[],d}pushDiff(d){switch(d.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===d.uri){S.docv=d.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===d.item.extId){(0,C.applyTestItemUpdate)(S.item,d.item);return}if(S.op===0&&S.item.item.extId===d.item.extId){(0,C.applyTestItemUpdate)(S.item,d.item);return}}break}}this.k.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,S){const L=this.tree.get(d);if(!!L){if((L.expandLevels===void 0||S>L.expandLevels)&&(L.expandLevels=S),L.expand===1){const t=this.I(L);return t.isOpen()?this.H(L,S-1):t.wait().then(()=>this.H(L,S-1))}else if(L.expand===3)return L.resolveBarrier?.isOpen()===!1?L.resolveBarrier.wait().then(()=>this.H(L,S-1)):this.H(L,S-1)}}dispose(){for(const d of this.tree.values())this.m.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(d,S){switch(S.op){case 3:this.L(A.TestId.joinToString(d.fullId,S.id));break;case 0:this.u(S.item,d);break;case 5:for(const L of S.ops)this.p(d,L);break;case 1:this.w(S.new,S.old,d.fullId.toString());break;case 2:this.G(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:S.update}});break;case 6:this.s(d.actual.uri);break;default:(0,D.assertNever)(S)}}s(d){d&&this.pushDiff({op:2,uri:d,docv:this.m.getDocumentVersion(d)})}u(d,S){const L=A.TestId.fromExtHostTestItem(d,this.root.id,S?.actual),t=this.m.getApiFor(d);t.parent&&t.parent!==S?.actual&&this.m.getChildren(t.parent).delete(d.id);let n=this.tree.get(L.toString());if(!n){n={fullId:L,actual:d,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},d.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(d,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(d)}}),this.F(d,n,S);return}if(n.actual===d){this.D(d,n,S);return}if(n.actual.uri?.toString()!==d.uri?.toString())return this.L(L.toString()),this.u(d,S);const r=this.m.getChildren(n.actual),i=n.actual,l=y(this.m.toITestItem(i),this.m.toITestItem(d));this.m.getApiFor(i).listener=void 0,n.actual=d,n.expand=0,l&&(l.hasOwnProperty("tags")&&(this.w(d.tags,i.tags,L.toString()),delete l.tags),this.p(n,{op:4,update:l})),this.F(d,n,S);for(const[c,s]of r)this.m.getChildren(d).get(s.id)||this.L(A.TestId.joinToString(L,s.id));this.s(n.actual.uri)}w(d,S,L){const t=new Set(S.map(n=>n.id));for(const n of d)t.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:L,item:{tags:d.map(n=>(0,C.namespaceTestTag)(this.m.controllerId,n.id))}}}),t.forEach(this.z,this)}y(d){const S=this.j.get(d.id);S?S.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,d.id)}}))}z(d){const S=this.j.get(d);S&&!--S.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,d)}))}C(d,S){this.m.getApiFor(d).parent=S&&S.actual!==this.root?S.actual:void 0}D(d,S,L){this.C(d,L);const t=this.m.getApiFor(d);t.parent=L?.actual,t.listener=n=>this.p(S,n),this.G(S)}F(d,S,L){this.D(d,S,L);for(const[t,n]of this.m.getChildren(d))this.u(n,S)}G(d){let S;this.h?d.resolveBarrier?S=d.resolveBarrier.isOpen()?3:2:S=d.actual.canResolveChildren?1:0:S=0,S!==d.expand&&(d.expand=S,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:S}}),S===1&&d.expandLevels!==void 0&&this.I(d))}H(d,S){if(S<0)return;const L=[];for(const[t,n]of this.m.getChildren(d.actual)){const r=this.expand(A.TestId.joinToString(d.fullId,n.id),S);(0,w.isThenable)(r)&&L.push(r)}if(L.length)return Promise.all(L).then(()=>{})}I(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const n=new w.Barrier;return n.open(),n}d.expand=2,this.J(d);const S=d.resolveBarrier=new w.Barrier,L=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let t;try{t=this.h(d.actual===this.root?void 0:d.actual)}catch(n){L(n)}return(0,w.isThenable)(t)?t.catch(L).then(()=>{S.open(),this.G(d)}):(S.open(),this.G(d)),d.resolveBarrier}J(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}L(d){const S=this.tree.get(d);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const L=[S];for(;L.length;){const t=L.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.z(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.m.getChildren(t.actual))L.push(this.tree.get(A.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.TestItemCollection=m;class p extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=p;class b extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class a extends Error{constructor(d,S,L){super(`TestItem with ID "${d}" is from controller "${S}" and cannot be added as a child of an item from controller "${L}".`)}}e.MixedTestItemController=a;const f=(h,d,S)=>{let L=new Map;return{get size(){return L.size},forEach(t,n){for(const r of L.values())t.call(n,r,this)},[Symbol.iterator](){return L.entries()},replace(t){const n=new Map,r=new Set(L.keys()),i={op:5,ops:[]};for(const l of t){if(!(l instanceof S))throw new b(l.id);const c=d(l).controllerId;if(c!==h.controllerId)throw new a(l.id,c,h.controllerId);if(n.has(l.id))throw new p(l.id);n.set(l.id,l),r.delete(l.id),i.ops.push({op:0,item:l})}for(const l of r.keys())i.ops.push({op:3,id:l});h.listener?.(i),L=n},add(t){if(!(t instanceof S))throw new b(t.id);L.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){L.delete(t)&&h.listener?.({op:3,id:t})},get(t){return L.get(t)},toJSON(){return Array.from(L.values())}}};e.createTestItemChildren=f}),define(pe[130],ve([1,0,129]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,o=(C,A)=>{const v={controllerId:A};return R.set(C,v),v};e.createPrivateApiFor=o;const D=C=>{const A=R.get(C);if(!A)throw new w.InvalidTestItemError(C?.id||"<unknown>");return A};e.getPrivateApiFor=D}),define(pe[268],ve([1,0,25,5]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,R.refineServiceDecorator)(w.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(pe[131],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var R;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator"})(R=e.VariableKind||(e.VariableKind={}));class o extends Error{constructor(C,A){super(A),this.variable=C}}e.VariableError=o}),define(pe[269],ve([1,0,7,28,8,21,3,161,199,131,17]),function(oe,e,w,R,o,D,C,A,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(m,p,b,a){this.g=new Map,this.a=m,this.b=p,this.d=b,a&&(this.c=a.then(f=>this.h(f)))}h(m){if(C.isWindows){const p=Object.create(null);return Object.keys(m).forEach(b=>{p[b.toLowerCase()]=m[b]}),p}return m}resolveWithEnvironment(m,p,b){return this.j({env:this.h(m),userHome:void 0},p?p.uri:void 0,b)}async resolveAsync(m,p){const b={env:await this.c,userHome:await this.d};return this.j(b,m?m.uri:void 0,p)}async i(m,p,b,a){const f=D.deepClone(p);C.isWindows&&f.windows?Object.keys(f.windows).forEach(d=>f[d]=f.windows[d]):C.isMacintosh&&f.osx?Object.keys(f.osx).forEach(d=>f[d]=f.osx[d]):C.isLinux&&f.linux&&Object.keys(f.linux).forEach(d=>f[d]=f.linux[d]),delete f.windows,delete f.osx,delete f.linux;const h={env:await this.c,userHome:await this.d};return this.j(h,m?m.uri:void 0,f,b,a)}async resolveAnyAsync(m,p,b){return this.i(m,p,b)}async resolveAnyMap(m,p,b){const a=new Map;return{newConfig:await this.i(m,p,b,a),resolvedVariables:a}}resolveWithInteractionReplace(m,p,b,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,p,b,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,p){if(this.g.has(m))throw new Error("Variable "+m+" is contributed twice.");this.g.set(m,p)}async j(m,p,b,a,f){if(o.isString(b))return this.l(m,p,b,a,f);if(Array.isArray(b))return Promise.all(b.map(h=>this.j(m,p,h,a,f)));if(o.isObject(b)){const h=Object.create(null),d=await Promise.all(Object.keys(b).map(async S=>[await this.l(m,p,S,a,f),await this.j(m,p,b[S],a,f)]));for(const[S,L]of d)h[S]=L;return h}return b}l(m,p,b,a,f){return(0,T.replaceAsync)(b,I.VARIABLE_REGEXP,async(h,d)=>{if(d.includes(I.VARIABLE_LHS))return h;let S=await this.n(m,h,d,p,a);return f?.set(d,S),S!==h&&o.isString(S)&&S.match(I.VARIABLE_REGEXP)&&(S=await this.l(m,p,S,a,f)),S})}m(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async n(m,p,b,a,f){let h;const d=b.split(":");d.length>1&&(b=d[0],h=d[1]);const S=n=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new g.VariableError(n,(0,v.localize)(0,null,p))},L=n=>{const r=S(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,A.normalizeDriveLetter)(i)}throw new g.VariableError(n,(0,v.localize)(1,null,p,w.basename(r)))},t=n=>{if(h){const r=this.a.getFolderUri(h);if(r)return r;throw new g.VariableError(n,(0,v.localize)(2,null,p,h))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new g.VariableError(n,(0,v.localize)(3,null,p)):new g.VariableError(n,(0,v.localize)(4,null,p))};switch(b){case"env":if(h){if(m.env){const n=m.env[C.isWindows?h.toLowerCase():h];if(o.isString(n))return n}return""}throw new g.VariableError(g.VariableKind.Env,(0,v.localize)(5,null,p));case"config":if(h){const n=this.a.getConfigurationValue(a,h);if(o.isUndefinedOrNull(n))throw new g.VariableError(g.VariableKind.Config,(0,v.localize)(6,null,p,h));if(o.isObject(n))throw new g.VariableError(g.VariableKind.Config,(0,v.localize)(7,null,p,h));return n}throw new g.VariableError(g.VariableKind.Config,(0,v.localize)(8,null,p));case"command":return this.o(g.VariableKind.Command,p,h,f,"command");case"input":return this.o(g.VariableKind.Input,p,h,f,"input");case"extensionInstallFolder":if(h){const n=await this.a.getExtension(h);if(!n)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,p,h));return this.m(n.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,p));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(t(g.VariableKind.WorkspaceFolder)));case"cwd":return a||h?(0,A.normalizeDriveLetter)(this.m(t(g.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(w.basename(this.m(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,v.localize)(11,null,p))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new g.VariableError(g.VariableKind.LineNumber,(0,v.localize)(12,null,p))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new g.VariableError(g.VariableKind.SelectedText,(0,v.localize)(13,null,p))}case"file":return S(g.VariableKind.File);case"fileWorkspaceFolder":return L(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return a||h?w.relative(this.m(t(g.VariableKind.RelativeFile)),S(g.VariableKind.RelativeFile)):S(g.VariableKind.RelativeFile);case"relativeFileDirname":{const n=w.dirname(S(g.VariableKind.RelativeFileDirname));if(a||h){const r=w.relative(this.m(t(g.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return w.dirname(S(g.VariableKind.FileDirname));case"fileExtname":return w.extname(S(g.VariableKind.FileExtname));case"fileBasename":return w.basename(S(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=w.basename(S(g.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-w.extname(n).length)}case"fileDirnameBasename":return w.basename(w.dirname(S(g.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||p}case"execInstallFolder":{const n=this.a.getAppRoot();return n||p}case"pathSeparator":return w.sep;default:try{const n=h?`${b}:${h}`:b;return this.o(g.VariableKind.Unknown,p,n,f,void 0)}catch{return p}}}}o(m,p,b,a,f){if(b&&a){const h=f===void 0?a[b]:a[f+":"+b];if(typeof h=="string")return h;throw new g.VariableError(m,(0,v.localize)(14,null,p))}return p}}I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=I}),define(pe[270],ve([1,0,5,86]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var o;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(o=e.GroupDirection||(e.GroupDirection={}));var D;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var A;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function g(p){const b=p;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=g;var T;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function y(p){const b=p;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=y;function m(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(pe[132],ve([1,0,5,270]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function o(D){const C=D;return typeof D=="number"||(0,R.isEditorGroup)(C)}e.isPreferredGroup=o}),define(pe[271],ve([1,0,8,268,12,113,85,84,131,86,132,13,219,266]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let p=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(a,f,h,d,S,L,t,n,r,i){this.a=a,this.b=f,this.c=h,this.d=d,this.e=S,this.f=L,this.g=t,this.h=n,this.i=r,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(a,f,h,d,S,L,t,n){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),i=h?(0,w.withNullAsUndefined)(this.d.getWorkspaceFolder(h)):void 0;let l;try{l=(await this.e.resolveAnyMap(i,{shellLaunchConfig:a,configuration:f})).resolvedVariables}catch(le){this.h.error(le)}if(l)for(const[le,de]of l.entries())(/^config:/.test(le)||le==="selectedText"||le==="lineNumber")&&(r[le]=de);const c=[];for(const[le,de]of this.f.collections.entries())c.push([le,(0,A.serializeEnvironmentVariableCollection)(de.map)]);const s=await this.g.resolveAuthority(this.a),u=s.options&&s.options.extensionHostEnv,E=this.d.getWorkspace(),k=E.folders,O=h?this.d.getWorkspaceFolder(h):null,B=g.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:g.SideBySideEditor.PRIMARY,filterByScheme:[I.Schemas.file,I.Schemas.vscodeUserData,I.Schemas.vscodeRemote]}),q={configuration:f,resolvedVariables:r,envVariableCollections:c,shellLaunchConfig:a,workspaceId:E.id,workspaceName:this.j.getWorkspaceLabel(E),workspaceFolders:k,activeWorkspaceFolder:O,activeFileResource:B,shouldPersistTerminal:S,options:d,cols:L,rows:t,unicodeVersion:n,resolverEnv:u};return await this.b.call("$createProcess",q)}requestDetachInstance(a,f){return this.b.call("$requestDetachInstance",[a,f])}acceptDetachInstanceReply(a,f){return this.b.call("$acceptDetachInstanceReply",[a,f])}attachToProcess(a){return this.b.call("$attachToProcess",[a])}detachFromProcess(a,f){return this.b.call("$detachFromProcess",[a,f])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(a,f){return this.b.call("$processBinary",[a,f])}start(a){return this.b.call("$start",[a])}input(a,f){return this.b.call("$input",[a,f])}acknowledgeDataEvent(a,f){return this.b.call("$acknowledgeDataEvent",[a,f])}setUnicodeVersion(a,f){return this.b.call("$setUnicodeVersion",[a,f])}shutdown(a,f){return this.b.call("$shutdown",[a,f])}resize(a,f,h){return this.b.call("$resize",[a,f,h])}getInitialCwd(a){return this.b.call("$getInitialCwd",[a])}getCwd(a){return this.b.call("$getCwd",[a])}orphanQuestionReply(a){return this.b.call("$orphanQuestionReply",[a])}sendCommandResult(a,f,h){return this.b.call("$sendCommandResult",[a,f,h])}freePortKillProcess(a){return this.b.call("$freePortKillProcess",[a])}installAutoReply(a,f){return this.b.call("$installAutoReply",[a,f])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(a){return this.b.call("$getDefaultSystemShell",[a])}getProfiles(a,f,h){return this.b.call("$getProfiles",[this.d.getWorkspace().id,a,f,h])}acceptPtyHostResolvedVariables(a,f){return this.b.call("$acceptPtyHostResolvedVariables",[a,f])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(a,f){return this.b.call("$getWslPath",[a,f])}setTerminalLayoutInfo(a){const h={workspaceId:this.d.getWorkspace().id,tabs:a?a.tabs:[]};return this.b.call("$setTerminalLayoutInfo",h)}updateTitle(a,f,h){return this.b.call("$updateTitle",[a,f,h])}updateIcon(a,f,h,d){return this.b.call("$updateIcon",[a,f,h,d])}refreshProperty(a,f){return this.b.call("$refreshProperty",[a,f])}updateProperty(a,f,h){return this.b.call("$updateProperty",[a,f,h])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",f)}reviveTerminalProcesses(a,f){return this.b.call("$reviveTerminalProcesses",[a,f])}getRevivedPtyNewId(a){return this.b.call("$getRevivedPtyNewId",[a])}serializeTerminalState(a){return this.b.call("$serializeTerminalState",[a])}};p=Le([Ae(2,R.IWorkbenchConfigurationService),Ae(3,C.IWorkspaceContextService),Ae(4,v.IConfigurationResolverService),Ae(5,m.IEnvironmentVariableService),Ae(6,D.IRemoteAuthorityResolverService),Ae(7,o.ILogService),Ae(8,T.IEditorService),Ae(9,y.ILabelService)],p),e.RemoteTerminalChannelClient=p}),define(pe[272],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var w;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(w=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class R{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[R.ENV_KEY]=this.pipeName}}R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=R;class o{constructor(){this.type=2}serialize(I){I[o.ENV_KEY]="1"}}o.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=o;class D{constructor(){this.type=3}serialize(I){I[D.ENV_KEY]="1"}}D.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=D;function C(T){delete T[R.ENV_KEY],delete T[o.ENV_KEY],delete T[D.ENV_KEY]}function A(T,I){C(I),T.serialize(I)}e.writeExtHostConnection=A;function v(T){if(T[R.ENV_KEY])return g(T,new R(T[R.ENV_KEY]));if(T[o.ENV_KEY])return g(T,new o);if(T[D.ENV_KEY])return g(T,new D);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=v;function g(T,I){return C(T),I}}),define(pe[133],ve([1,0,50,94,126,13,7,15,6,62,83,12,45,3,58,125,2,272,25]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function d(i={},l,c,s,u,E){const k=await(0,o.getNLSConfiguration)(c,s.userDataPath);let O={};if(l)try{O=await(0,T.getResolvedShellEnv)(E,u,s.args,process.env)}catch(ae){u.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ae)}const q={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(k,void 0,0),...i},le=s.isBuilt?(0,C.join)(s.appRoot,"bin"):(0,C.join)(s.appRoot,"resources","server","bin-dev"),de=(0,C.join)(le,"remote-cli");let ue=t(q,"PATH");return ue?ue=de+C.delimiter+ue:ue=de,n(q,"PATH",ue),s.args["without-browser-env-var"]||(q.BROWSER=(0,C.join)(le,"helpers",m.isWindows?"browser.cmd":"browser.sh")),r(q),q}e.buildUserEnvironment=d;class S{constructor(l,c){this.socket=l,this.initialDataChunk=c}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let l,c,s;return this.socket instanceof g.NodeSocket?(l=!0,c=!1,s=A.VSBuffer.alloc(0)):(l=!1,c=this.socket.permessageDeflate,s=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:l,permessageDeflate:c,inflateBytes:s.buffer.toString("base64")}}}let L=class{constructor(l,c,s,u,E,k,O,B){this.i=l,this.j=E,this.l=k,this.m=O,this.n=B,this.b=new v.Emitter,this.onClose=this.b.event,this.c=!m.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=c,this.g=null,this.h=new S(s,u),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(l){this.l.info(`${this.o}${l}`)}q(l){this.l.error(`${this.o}${l}`)}async r(l,c){const s=new a.DisposableStore;s.add(c.socket),s.add((0,a.toDisposable)(()=>{l.destroy()}));const u=()=>{s.dispose()};s.add(c.socket.onEnd(u)),s.add(c.socket.onClose(u)),s.add(v.Event.fromNodeEventEmitter(l,"end")(u)),s.add(v.Event.fromNodeEventEmitter(l,"close")(u)),s.add(v.Event.fromNodeEventEmitter(l,"error")(u)),s.add(c.socket.onData(E=>l.write(E.buffer))),s.add(v.Event.fromNodeEventEmitter(l,"data")(E=>{c.socket.write(A.VSBuffer.wrap(E))})),c.initialDataChunk.byteLength>0&&l.write(c.initialDataChunk.buffer)}async s(l,c){await c.socketDrain();const s=c.toIExtHostSocketMessage();let u;c.socket instanceof g.NodeSocket?u=c.socket.socket:u=c.socket.socket.socket,l.send(s,u)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const l={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(l)}acceptReconnection(l,c,s){this.f=l,this.p("The client has reconnected.");const u=new S(c,s);if(!this.g){this.h=u;return}this.s(this.g,u)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(l){try{let c=process.execArgv?process.execArgv.filter(de=>!/^--inspect(-brk)?=/.test(de)):[];l.port&&!process.pkg&&(c=[`--inspect${l.break?"-brk":""}=${l.port}`]);const s=await d(l.env,!0,l.language,this.j,this.l,this.n);(0,p.removeDangerousEnvVariables)(s);let u;if(this.c)(0,f.writeExtHostConnection)(new f.SocketExtHostConnection,s),u=null;else{const{namedPipeServer:de,pipeName:ue}=await this.u();(0,f.writeExtHostConnection)(new f.IPCExtHostConnection(ue),s),u=de}const E={env:s,execArgv:c,silent:!0},k=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];k.push(`--useHostProxy=${O?"true":"false"}`),this.g=w.fork(D.FileAccess.asFileUri("bootstrap-fork").fsPath,k,E);const B=this.g.pid;this.p(`<${B}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const q=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),le=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(q(de=>this.p(`<${B}> ${de}`)),le(de=>this.p(`<${B}><stderr> ${de}`)),this.g.on("error",de=>{this.q(`<${B}> Extension Host Process had an error`),this.l.error(de),this.t()}),this.g.on("exit",(de,ue)=>{this.m.setExitInfo(this.i,{code:de,signal:ue}),this.p(`<${B}> Extension Host Process exited with code: ${de}, signal: ${ue}.`),this.t()}),u)u.on("connection",de=>{u.close(),this.r(de,this.h)});else{const de=ue=>{ue.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",de),this.s(this.g,this.h),this.h=null)};this.g.on("message",de)}}catch(c){console.error("ExtensionHostConnection errored"),c&&console.error(c)}}u(){return new Promise((l,c)=>{const s=(0,g.createRandomIPCHandle)(),u=R.createServer();u.on("error",c),u.listen(s,()=>{u?.removeListener("error",c),l({pipeName:s,namedPipeServer:u})})})}};L=Le([Ae(4,y.IServerEnvironmentService),Ae(5,I.ILogService),Ae(6,b.IExtensionHostStatusService),Ae(7,h.IConfigurationService)],L),e.ExtensionHostConnection=L;function t(i,l){const c=Object.keys(i).filter(u=>u.toLowerCase()===l.toLowerCase()),s=c.length>0?c[0]:l;return i[s]}function n(i,l,c){const s=Object.keys(i).filter(E=>E.toLowerCase()===l.toLowerCase()),u=s.length>0?s[0]:l;i[u]=c}function r(i){for(const l of Object.keys(i))i[l]===null&&delete i[l]}}),define(pe[273],ve([1,0,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var o;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(o=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function C(g){const T=w.VSBuffer.alloc(1);switch(g){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=C;function A(g,T){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=A;var v;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(v=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(pe[274],ve([1,0,5,6,12,262,273,54,37,21,4,2,197]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let m=class extends I.Disposable{constructor(f,h){super(),this.m=f,this.n=h,this.a=this.B(new R.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=T.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:v.extensionTelemetryLogChannelId,name:(0,y.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(d=>{(0,o.isLogLevel)(d)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===o.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(f,h,d){const S=this.getTelemetryDetails(),L=new p(h,d,f,this.k,this.i,this.getBuiltInCommonProperties(f),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled});return this.l.set(f.identifier.value,L),L.apiTelemetryLogger}$initializeTelemetryLevel(f,h,d){this.f=f,this.g=h,this.c=d??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(f){const h=Object.create(null);switch(h["common.extname"]=`${f.publisher}.${f.name}`,h["common.extversion"]=f.version,h["common.vscodemachineid"]=this.m.telemetryInfo.machineId,h["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,h["common.vscodeversion"]=this.m.version,h["common.isnewappinstall"]=b(this.m.telemetryInfo.firstSessionDate),h["common.product"]=this.m.environment.appHost,this.m.uiKind){case C.UIKind.Web:h["common.uikind"]="web";break;case C.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,A.getRemoteName)((0,v.cleanRemoteAuthority)(this.m.remote.authority)),h}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const h=this.getTelemetryDetails();this.l.forEach((d,S)=>{d.isDisposed&&this.l.delete(S)}),this.l.forEach(d=>{d.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(f,h){const d=this.l.get(f.value);return d&&d.isDisposed?(this.l.delete(f.value),!1):!d||d.ignoreUnhandledExtHostErrors?!1:(d.logError(h),!0)}};m=Le([Ae(0,D.IExtHostInitDataService),Ae(1,o.ILoggerService)],m),e.ExtHostTelemetry=m;class p{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,h,d,S,L,t,n){this.g=d,this.h=S,this.i=L,this.j=t,this.a=new R.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(f,h){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let h=f.properties??f;return h=(0,v.cleanData)(h,[]),this.c&&(h=(0,g.mixin)(h,this.c)),this.b||(h=(0,g.mixin)(h,this.j)),f.properties?f.properties=h:f=h,f}k(f,h){!this.f||(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(f,h),this.h.trace(f,h))}logUsage(f,h){!this.d.isUsageEnabled||this.k(f,h)}logError(f,h){!this.d.isErrorsEnabled||!this.f||(typeof f=="string"?this.k(f,h):this.f.sendErrorData(f,h))}get apiTelemetryLogger(){if(!this.e){const f=this,h={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=p;function b(a){const f=Date.now()-new Date(a).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(pe[275],ve([1,0,6,4,34,230,36,5]),function(oe,e,w,R,o,D,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class v{constructor(L){this.dependency=L}}e.MissingExtensionDependency=v;var g;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(g=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class T{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:D.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(L,t){const n=[],r=[],i=[],l=[],c=I(this.c),s=I(L),u=(q,le)=>q.extensionLocation.toString()===le.extensionLocation.toString()||q.isBuiltin===le.isBuiltin||q.isUserBuiltin===le.isUserBuiltin||q.isUnderDevelopment===le.isUnderDevelopment;for(const q of this.c){const le=s.get(q.identifier);if(!le){n.push(q.identifier),c.delete(q.identifier);continue}if(!u(q,le)){n.push(q.identifier),c.delete(q.identifier);continue}}for(const q of L){const le=c.get(q.identifier);if(!le){r.push(q);continue}if(!u(le,q)){n.push(le.identifier),c.delete(le.identifier);continue}}const E=new C.ExtensionIdentifierSet(this.d),k=new C.ExtensionIdentifierSet(t);for(const q of this.d)k.has(q)||i.push(q);for(const q of t)E.has(q)||l.push(q);const O=D.ImplicitActivationEvents.createActivationEventsMap(r),B={toRemove:n,toAdd:r,addActivationEvents:O,myToRemove:i,myToAdd:l};return this.delta(B),B}delta(L){const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=L,l=new C.ExtensionIdentifierSet(t),c=new C.ExtensionIdentifierSet(r);for(let s=0;s<this.c.length;s++)l.has(this.c[s].identifier)&&(this.c.splice(s,1),s--);for(let s=0;s<this.d.length;s++)c.has(this.d[s])&&(this.d.splice(s,1),s--);for(const s of n)this.c.push(s);for(const s of i)this.d.push(s)}containsExtension(L){for(const t of this.d)if(C.ExtensionIdentifier.equals(t,L))return!0;return!1}}e.ExtensionHostExtensions=T;function I(S){const L=new C.ExtensionIdentifierMap;for(const t of S)L.set(t.identifier,t);return L}function y(S,L){return S.enabledApiProposals?S.enabledApiProposals.includes(L):!1}e.isProposedApiEnabled=y;function m(S,L){if(!y(S,L))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${L}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${L}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.checkProposedApiEnabled=m;class p{constructor(L,t,n,r){this.codeLoadingTime=L,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.ActivationTimes=p;class b{constructor(L,t){this.description=L,this.value=t}}e.ExtensionPointContribution=b;var a;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function f(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,o.getGalleryExtensionId)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.toExtension=f;function h(S,L){return{identifier:new C.ExtensionIdentifier((0,o.getExtensionId)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!L,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.toExtensionDescription=h;class d{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.extensions=[]}activateByEvent(L){return Promise.resolve(void 0)}activationEventIsDone(L){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(L){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(L,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(L){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d});var Ot=this&&this.__classPrivateFieldSet||function(oe,e,w,R,o){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!o:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?o.call(oe,w):o?o.value=w:e.set(oe,w),w},nt=this&&this.__classPrivateFieldGet||function(oe,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!R:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(oe):R?R.value:e.get(oe)};define(pe[134],ve([1,0,18,11,97,27,57,17,8,4,22,16,113,128,275]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p){"use strict";var b,a,f,h,d,S,L,t,n,r,i,l,c,s,u,E,k,O,B,q,le,de,ue,ae,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.NotebookDocumentSaveReason=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function ee(j){return Object.assign(j,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(j,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[se,...be]=arguments;return Reflect.construct(j,be,se.constructor)}}})}var ne;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(ne=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var te;(function(j){j[j.Command=0]="Command",j[j.Opener=1]="Opener"})(te=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let x=t=class{static from(...F){let se=F;return new t(function(){if(se){for(const be of se)be&&typeof be.dispose=="function"&&be.dispose();se=void 0}})}constructor(F){b.set(this,void 0),Ot(this,b,F,"f")}dispose(){typeof nt(this,b,"f")=="function"&&(nt(this,b,"f").call(this),Ot(this,b,void 0,"f"))}};b=new WeakMap,x=t=Le([ee],x),e.Disposable=x;let U=n=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let be=1;be<F.length;be++){const Be=F[be];Be.isBefore(se)&&(se=Be)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let be=1;be<F.length;be++){const Be=F[be];Be.isAfter(se)&&(se=Be)}return se}static isPosition(F){if(!F)return!1;if(F instanceof n)return!0;const{line:se,character:be}=F;return typeof se=="number"&&typeof be=="number"}static of(F){if(F instanceof n)return F;if(this.isPosition(F))return new n(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,se){if(F<0)throw(0,R.illegalArgument)("line must be non-negative");if(se<0)throw(0,R.illegalArgument)("character must be non-negative");this.c=F,this.e=se}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,se=0){if(F===null||se===null)throw(0,R.illegalArgument)();let be;return typeof F>"u"?be=0:typeof F=="number"?be=F:(be=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),be===0&&se===0?this:new n(this.line+be,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,R.illegalArgument)();let be;return typeof F>"u"?be=this.line:typeof F=="number"?be=F:(be=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),be===this.line&&se===this.character?this:new n(be,se)}toJSON(){return{line:this.line,character:this.character}}};U=n=Le([ee],U),e.Position=U;let Z=r=class{static isRange(F){return F instanceof r?!0:F?U.isPosition(F.start)&&U.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,se,be,Be){let We,Ze;if(typeof F=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Be=="number"?(We=new U(F,se),Ze=new U(be,Be)):U.isPosition(F)&&U.isPosition(se)&&(We=U.of(F),Ze=U.of(se)),!We||!Ze)throw new Error("Invalid arguments");We.isBefore(Ze)?(this.c=We,this.e=Ze):(this.c=Ze,this.e=We)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):U.isPosition(F)?!(U.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const se=U.Max(F.start,this.c),be=U.Min(F.end,this.e);if(!se.isAfter(be))return new r(se,be)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=U.Min(F.start,this.c),be=U.Max(F.end,this.end);return new r(se,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,se=this.end){if(F===null||se===null)throw(0,R.illegalArgument)();let be;return F?U.isPosition(F)?be=F:(be=F.start||this.start,se=F.end||this.end):be=this.start,be.isEqual(this.c)&&se.isEqual(this.end)?this:new r(be,se)}toJSON(){return[this.start,this.end]}};Z=r=Le([ee],Z),e.Range=Z;let re=i=class extends Z{static isSelection(F){return F instanceof i?!0:F?Z.isRange(F)&&U.isPosition(F.anchor)&&U.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,se,be,Be){let We,Ze;if(typeof F=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Be=="number"?(We=new U(F,se),Ze=new U(be,Be)):U.isPosition(F)&&U.isPosition(se)&&(We=U.of(F),Ze=U.of(se)),!We||!Ze)throw new Error("Invalid arguments");super(We,Ze),this.f=We,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=i=Le([ee],re),e.Selection=re;class me{constructor(F,se,be){if(typeof F!="string"||F.length===0)throw(0,R.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,R.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(se),this.connectionToken=be}}e.ResolvedAuthority=me;class $ extends Error{static NotAvailable(F,se){return new $(F,y.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new $(F,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=y.RemoteAuthorityResolverErrorCode.Unknown,be){super(F),this._message=F,this._code=se,this._detail=be,Object.setPrototypeOf(this,$.prototype)}}e.RemoteAuthorityResolverError=$;var W;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var N;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let P=l=class{static isTextEdit(F){return F instanceof l?!0:F?Z.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new l(F,se)}static insert(F,se){return l.replace(new Z(F,F),se)}static delete(F){return l.replace(F,"")}static setEndOfLine(F){const se=new l(new Z(new U(0,0),new U(0,0)),"");return se.newEol=F,se}get range(){return this.c}set range(F){if(F&&!Z.isRange(F))throw(0,R.illegalArgument)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,R.illegalArgument)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,R.illegalArgument)("newEol");this.f=F}constructor(F,se){this.c=F,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};P=l=Le([ee],P),e.TextEdit=P;var M;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(M=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));let Y=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?Rt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new c(F,se)}static insertCells(F,se){return new c(new Rt(F,F),se)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,se){const be=new c(new Rt(F,F),[]);return be.newCellMetadata=se,be}static updateNotebookMetadata(F){const se=new c(new Rt(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};Y=c=Le([ee],Y),e.NotebookEdit=Y;class ie{static isSnippetTextEdit(F){return F instanceof ie?!0:F?Z.isRange(F.range)&&J.isSnippetString(F.snippet):!1}static replace(F,se){return new ie(F,se)}static insert(F,se){return ie.replace(new Z(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.SnippetTextEdit=ie;var z;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(z=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,se,be,Be){this.c.push({_type:1,from:F,to:se,options:be,metadata:Be})}createFile(F,se,be){this.c.push({_type:1,from:void 0,to:F,options:se,metadata:be})}deleteFile(F,se,be){this.c.push({_type:1,from:F,to:void 0,options:se,metadata:be})}e(F,se,be){this.c.push({_type:3,metadata:be,uri:F,edit:{editType:5,metadata:se},notebookMetadata:se})}f(F,se,be,Be){const We=se.start,Ze=se.end;(We!==Ze||be.length>0)&&this.c.push({_type:5,uri:F,index:We,count:Ze-We,cells:be,metadata:Be})}g(F,se,be,Be){this.c.push({_type:3,metadata:Be,uri:F,edit:{editType:8,index:se,metadata:be}})}replace(F,se,be,Be){this.c.push({_type:2,uri:F,edit:new P(se,be),metadata:Be})}insert(F,se,be,Be){this.replace(F,new Z(se,se),be,Be)}delete(F,se,be){this.replace(F,se,"",be)}has(F){return this.c.some(se=>se._type===2&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const be of se){if(!be)continue;let Be,We;Array.isArray(be)?(Be=be[0],We=be[1]):Be=be,Y.isNotebookCellEdit(Be)?Be.newCellMetadata?this.g(F,Be.range.start,Be.newCellMetadata,We):Be.newNotebookMetadata?this.e(F,Be.newNotebookMetadata,We):this.f(F,Be.range,Be.newCells,We):ie.isSnippetTextEdit(Be)?this.c.push({_type:6,uri:F,range:Be.range,edit:Be.snippet,metadata:We}):this.c.push({_type:2,uri:F,edit:Be,metadata:We})}else{for(let be=0;be<this.c.length;be++){const Be=this.c[be];switch(Be._type){case 2:case 6:case 3:case 5:Be.uri.toString()===F.toString()&&(this.c[be]=void 0);break}}(0,w.coalesceInPlace)(this.c)}}get(F){const se=[];for(const be of this.c)be._type===2&&be.uri.toString()===F.toString()&&se.push(be.edit);return se}entries(){const F=new D.ResourceMap;for(const se of this.c)if(se._type===2){let be=F.get(se.uri);be||(be=[se.uri,[]],F.set(se.uri,be)),be[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=Le([ee],V),e.WorkspaceEdit=V;let J=s=class{static isSnippetString(F){return F instanceof s?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=s.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this.e++){if(typeof F=="function"){const be=new s;be.e=this.e,F(be),this.e=be.e,F=be.value}else F=s.c(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this.e++){const be=F.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const be=new s;be.e=this.e,se(be),this.e=be.e,se=be.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};J=s=Le([ee],J),e.SnippetString=J;var H;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var X;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(X=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=u=class{static isLocation(F){return F instanceof u?!0:F?Z.isRange(F.range)&&g.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(Z.isRange(se))this.range=Z.of(se);else if(U.isPosition(se))this.range=new Z(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};G=u=Le([ee],G),e.Location=G;let Q=class{static is(F){return F?typeof F.message=="string"&&F.location&&Z.isRange(F.location.range)&&g.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};Q=Le([ee],Q),e.DiagnosticRelatedInformation=Q;let ce=class{constructor(F,se,be=X.Error){if(!Z.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=be}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,w.equals)(F.tags,se.tags)&&(0,w.equals)(F.relatedInformation,se.relatedInformation,Q.isEqual)}};ce=Le([ee],ce),e.Diagnostic=ce;let Ee=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};Ee=Le([ee],Ee),e.Hover=Ee;var De;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(De=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(F,se=De.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:De[this.kind]}}};ke=Le([ee],ke),e.DocumentHighlight=ke;var Ue;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ue=e.SymbolKind||(e.SymbolKind={}));var $e;(function(j){j[j.Deprecated=1]="Deprecated"})($e=e.SymbolTag||(e.SymbolTag={}));let ge=E=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,be,Be,We){this.name=F,this.kind=se,this.containerName=We,typeof be=="string"&&(this.containerName=be),Be instanceof G?this.location=Be:be instanceof Z&&(this.location=new G(Be,be)),E.validate(this)}toJSON(){return{name:this.name,kind:Ue[this.kind],location:this.location,containerName:this.containerName}}};ge=E=Le([ee],ge),e.SymbolInformation=ge;let Se=k=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(k.validate)}constructor(F,se,be,Be,We){this.name=F,this.detail=se,this.kind=be,this.range=Be,this.selectionRange=We,this.children=[],k.validate(this)}};Se=k=Le([ee],Se),e.DocumentSymbol=Se;var ye;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Me=class{constructor(F,se){this.title=F,this.kind=se}};Me=Le([ee],Me),e.CodeAction=Me;let Fe=O=class{constructor(F){this.value=F}append(F){return new O(this.value?this.value+O.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+O.c)}};Fe.c=".",Fe=O=Le([ee],Fe),e.CodeActionKind=Fe,Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll");let _e=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=Le([ee],_e),e.SelectionRange=_e;class He{constructor(F,se,be,Be,We,Ze){this.kind=F,this.name=se,this.detail=be,this.uri=Be,this.range=We,this.selectionRange=Ze}}e.CallHierarchyItem=He;class Je{constructor(F,se){this.fromRanges=se,this.from=F}}e.CallHierarchyIncomingCall=Je;class Qe{constructor(F,se){this.fromRanges=se,this.to=F}}e.CallHierarchyOutgoingCall=Qe;var et;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(et=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};Ke=Le([ee],Ke),e.CodeLens=Ke;let he=B=class{static isMarkdownString(F){return F instanceof B?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){a.set(this,void 0),Ot(this,a,new o.MarkdownString(F,{supportThemeIcons:se}),"f")}get value(){return nt(this,a,"f").value}set value(F){nt(this,a,"f").value=F}get isTrusted(){return nt(this,a,"f").isTrusted}set isTrusted(F){nt(this,a,"f").isTrusted=F}get supportThemeIcons(){return nt(this,a,"f").supportThemeIcons}set supportThemeIcons(F){nt(this,a,"f").supportThemeIcons=F}get supportHtml(){return nt(this,a,"f").supportHtml}set supportHtml(F){nt(this,a,"f").supportHtml=F}get baseUri(){return nt(this,a,"f").baseUri}set baseUri(F){nt(this,a,"f").baseUri=F}appendText(F){return nt(this,a,"f").appendText(F),this}appendMarkdown(F){return nt(this,a,"f").appendMarkdown(F),this}appendCodeblock(F,se){return nt(this,a,"f").appendCodeblock(se??"",F),this}};a=new WeakMap,he=B=Le([ee],he),e.MarkdownString=he;let Ce=class{constructor(F,se){this.label=F,this.documentation=se}};Ce=Le([ee],Ce),e.ParameterInformation=Ce;let Te=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};Te=Le([ee],Te),e.SignatureInformation=Te;let Ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ne=Le([ee],Ne),e.SignatureHelp=Ne;var Re;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ze;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ze=e.InlayHintKind||(e.InlayHintKind={}));let qe=class{constructor(F){this.value=F}};qe=Le([ee],qe),e.InlayHintLabelPart=qe;let Ve=class{constructor(F,se,be){this.position=F,this.label=se,this.kind=be}};Ve=Le([ee],Ve),e.InlayHint=Ve;var Ge;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Xe;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Xe=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(j){j[j.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let st=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};st=Le([ee],st),e.CompletionItem=st;let ct=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};ct=Le([ee],ct),e.CompletionList=ct;let ot=class{constructor(F,se,be){this.insertText=F,this.range=se,this.command=be}};ot=Le([ee],ot),e.InlineSuggestion=ot;let Nt=class{constructor(F){this.commands=void 0,this.items=F}};Nt=Le([ee],Nt),e.InlineSuggestionList=Nt;var wt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var Ut;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var vt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(vt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var It;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(It=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var At;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(At=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function F(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=F}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(F,se){if(se&&!g.URI.isUri(se))throw(0,R.illegalArgument)("target");if(!Z.isRange(F)||F.isEmpty)throw(0,R.illegalArgument)("range");this.range=F,this.target=se}};Ft=Le([ee],Ft),e.DocumentLink=Ft;let ht=class{constructor(F,se,be,Be){this.red=F,this.green=se,this.blue=be,this.alpha=Be}};ht=Le([ee],ht),e.Color=ht;let Tt=class{constructor(F,se){if(se&&!(se instanceof ht))throw(0,R.illegalArgument)("color");if(!Z.isRange(F)||F.isEmpty)throw(0,R.illegalArgument)("range");this.range=F,this.color=se}};Tt=Le([ee],Tt),e.ColorInformation=Tt;let rt=class{constructor(F){if(!F||typeof F!="string")throw(0,R.illegalArgument)("label");this.label=F}};rt=Le([ee],rt),e.ColorPresentation=rt;var ft;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ft=e.ColorFormat||(e.ColorFormat={}));var dt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var $t;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})($t=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(F,se,be){if(this.startIndex=F,this.length=se,this.tooltip=be,typeof F!="number"||F<0)throw(0,R.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,R.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=we;class Ie{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=Ie;class fe{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=fe;var K;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(K=e.TerminalLocation||(e.TerminalLocation={}));class Pe{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Pe;var Oe;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var xe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(xe=e.TaskPanelKind||(e.TaskPanelKind={}));let je=q=class{static from(F){switch(F){case"clean":return q.Clean;case"build":return q.Build;case"rebuild":return q.Rebuild;case"test":return q.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,R.illegalArgument)("name");this.c=F}get id(){return this.c}};je.Clean=new q("clean","Clean"),je.Build=new q("build","Build"),je.Rebuild=new q("rebuild","Rebuild"),je.Test=new q("test","Test"),je=q=Le([ee],je),e.TaskGroup=je;function tt(j){let F="";for(let se=0;se<j.length;se++)F+=j[se].replace(/,/g,",,")+",";return F}let at=class{constructor(F,se,be){if(typeof F!="string")throw(0,R.illegalArgument)("process");this.e=[],this.c=F,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=be):this.f=se)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,R.illegalArgument)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const se of this.e)F.push(se);return tt(F)}};at=Le([ee],at),e.ProcessExecution=at;let bt=class{constructor(F,se,be){if(this.f=[],Array.isArray(se)){if(!F)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.illegalArgument)("command");this.e=F,this.f=se,this.g=be}else{if(typeof F!="string")throw(0,R.illegalArgument)("commandLine");this.c=F,this.g=se}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,R.illegalArgument)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.illegalArgument)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)F.push(typeof se=="string"?se:se.value);return tt(F)}};bt=Le([ee],bt),e.ShellExecution=bt;var Ct;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ct=e.ShellQuoting||(e.ShellQuoting={}));var ut;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ut=e.TaskScope||(e.TaskScope={}));class Et{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(F){this.c=F}get callback(){return this.c}}e.CustomExecution=Et;let Mt=le=class{constructor(F,se,be,Be,We,Ze){this.j=!1,this.k=this.definition=F;let it;typeof se=="string"?(this.m=this.name=se,this.t=this.source=be,this.execution=Be,it=We,this.j=!0):se===ut.Global||se===ut.Workspace?(this.target=se,this.m=this.name=be,this.t=this.source=Be,this.execution=We,it=Ze):(this.target=se,this.m=this.name=be,this.t=this.source=Be,this.execution=We,it=Ze),typeof it=="string"?(this.o=[it],this.q=!0):Array.isArray(it)?(this.o=it,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof at?this.k={type:le.e,id:this.n.computeId()}:this.n instanceof bt?this.k={type:le.f,id:this.n.computeId()}:this.n instanceof Et?this.k={type:le.c,id:this.n.computeId()}:this.k={type:le.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=F}get scope(){return this.l}set target(F){this.y(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,R.illegalArgument)("name");this.y(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.y(),this.n=F;const se=this.k.type;(le.g===se||le.e===se||le.f===se||le.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.y(),this.o=F,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.y(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.y(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.y(),this.u=F}get detail(){return this.x}set detail(F){F===null&&(F=void 0),this.x=F}get presentationOptions(){return this.v}set presentationOptions(F){F==null&&(F=Object.create(null)),this.y(),this.v=F}get runOptions(){return this.w}set runOptions(F){F==null&&(F=Object.create(null)),this.y(),this.w=F}};Mt.c="customExecution",Mt.e="process",Mt.f="shell",Mt.g="$empty",Mt=le=Le([ee],Mt),e.Task=Mt;var Oi;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Oi=e.ProgressLocation||(e.ProgressLocation={}));var Ni;(function(j){function F(se){const be=se;return(0,v.isNumber)(be.value)?be.tooltip&&!(0,v.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}j.isViewBadge=F})(Ni=e.ViewBadge||(e.ViewBadge={}));let Xt=de=class{static isTreeItem(F,se){const be=F;if(be.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(se,"treeItemCheckbox");const Be=(0,v.isNumber)(be.checkboxState)?be.checkboxState:(0,v.isObject)(be.checkboxState)&&(0,v.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,We=!(0,v.isNumber)(be.checkboxState)&&(0,v.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Be===void 0||Be!==Qt.Checked&&Be!==Qt.Unchecked||We!==void 0&&!(0,v.isString)(We))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}if(F instanceof de)return!0;if(be.label!==void 0&&!(0,v.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,v.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,v.isString)(be.iconPath)&&!g.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,v.isString)(be.iconPath.id))){const Be=be.iconPath;if(!Be||!(0,v.isString)(Be.light)&&!g.URI.isUri(Be.light)&&!(0,v.isString)(Be.dark)&&!g.URI.isUri(Be.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,v.isString)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!g.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,v.isString)(be.tooltip)&&!(be.tooltip instanceof he)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<Vt.None&&be.collapsibleState>Vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,v.isString)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):!0}constructor(F,se=Vt.None){this.collapsibleState=se,g.URI.isUri(F)?this.resourceUri=F:this.label=F}};Xt=de=Le([ee],Xt),e.TreeItem=Xt;var Vt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Qt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Qt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,se){this.value=F,this.id=se??(0,T.generateUuid)()}};Zt=Le([ee],Zt),e.DataTransferItem=Zt;let _t=class{constructor(F){f.add(this),h.set(this,new Map);for(const[se,be]of F??[]){const Be=nt(this,h,"f").get(nt(this,f,"m",d).call(this,se));Be?Be.push(be):nt(this,h,"f").set(nt(this,f,"m",d).call(this,se),[be])}}get(F){return nt(this,h,"f").get(nt(this,f,"m",d).call(this,F))?.[0]}set(F,se){nt(this,h,"f").set(nt(this,f,"m",d).call(this,F),[se])}forEach(F,se){for(const[be,Be]of nt(this,h,"f"))for(const We of Be)F.call(se,We,be,this)}*[(h=new WeakMap,f=new WeakSet,Symbol.iterator)](){for(const[F,se]of nt(this,h,"f"))for(const be of se)yield[F,be]}};d=function(F){return F.toLowerCase()},_t=Le([ee],_t),e.DataTransfer=_t;let ei=class{constructor(F){this.insertText=F}};ei=Le([ee],ei),e.DocumentDropEdit=ei;let ti=class{constructor(F){this.insertText=F}};ti=Le([ee],ti),e.DocumentPasteEdit=ti;let Dt=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};Dt=Le([ee],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let ii=class{constructor(F){this.id=F}};ii=Le([ee],ii),e.ThemeColor=ii;var Fi;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Fi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ni=class{get base(){return this.c}set base(F){this.c=F,this.e=g.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!g.URI.isUri(F)&&!g.URI.isUri(F.uri)))throw(0,R.illegalArgument)("base");if(typeof se!="string")throw(0,R.illegalArgument)("pattern");typeof F=="string"?this.baseUri=g.URI.file(F):g.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ni=Le([ee],ni),e.RelativePattern=ni;const Ri=new WeakMap;function Mi(j,F){Ri.set(j,F)}e.setBreakpointId=Mi;let jt=class{constructor(F,se,be,Be){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof be=="string"&&(this.hitCondition=be),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this.c||(this.c=Ri.get(this)??(0,T.generateUuid)()),this.c}};jt=Le([ee],jt),e.Breakpoint=jt;let ri=class extends jt{constructor(F,se,be,Be,We){if(super(se,be,Be,We),F===null)throw(0,R.illegalArgument)("location");this.location=F}};ri=Le([ee],ri),e.SourceBreakpoint=ri;let si=class extends jt{constructor(F,se,be,Be,We){super(se,be,Be,We),this.functionName=F}};si=Le([ee],si),e.FunctionBreakpoint=si;let oi=class extends jt{constructor(F,se,be,Be,We,Ze,it){if(super(Be,We,Ze,it),!se)throw(0,R.illegalArgument)("dataId");this.label=F,this.dataId=se,this.canPersist=be}};oi=Le([ee],oi),e.DataBreakpoint=oi;let ai=class{constructor(F,se,be){this.command=F,this.args=se||[],this.options=be}};ai=Le([ee],ai),e.DebugAdapterExecutable=ai;let li=class{constructor(F,se){this.port=F,this.host=se}};li=Le([ee],li),e.DebugAdapterServer=li;let ci=class{constructor(F){this.path=F}};ci=Le([ee],ci),e.DebugAdapterNamedPipeServer=ci;let ui=class{constructor(F){this.implementation=F}};ui=Le([ee],ui),e.DebugAdapterInlineImplementation=ui;let hi=class{constructor(F,se){this.range=F,this.expression=se}};hi=Le([ee],hi),e.EvaluatableExpression=hi;var Ui;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ui=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let fi=class{constructor(F,se){this.range=F,this.text=se}};fi=Le([ee],fi),e.InlineValueText=fi;let di=class{constructor(F,se,be=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=be}};di=Le([ee],di),e.InlineValueVariableLookup=di;let mi=class{constructor(F,se){this.range=F,this.expression=se}};mi=Le([ee],mi),e.InlineValueEvaluatableExpression=mi;let gi=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};gi=Le([ee],gi),e.InlineValueContext=gi;var Bi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let pi=ue=class extends Error{static FileExists(F){return new ue(F,I.FileSystemProviderErrorCode.FileExists,ue.FileExists)}static FileNotFound(F){return new ue(F,I.FileSystemProviderErrorCode.FileNotFound,ue.FileNotFound)}static FileNotADirectory(F){return new ue(F,I.FileSystemProviderErrorCode.FileNotADirectory,ue.FileNotADirectory)}static FileIsADirectory(F){return new ue(F,I.FileSystemProviderErrorCode.FileIsADirectory,ue.FileIsADirectory)}static NoPermissions(F){return new ue(F,I.FileSystemProviderErrorCode.NoPermissions,ue.NoPermissions)}static Unavailable(F){return new ue(F,I.FileSystemProviderErrorCode.Unavailable,ue.Unavailable)}constructor(F,se=I.FileSystemProviderErrorCode.Unknown,be){super(g.URI.isUri(F)?F.toString(!0):F),this.code=be?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,ue.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};pi=ue=Le([ee],pi),e.FileSystemError=pi;let vi=class{constructor(F,se,be){this.start=F,this.end=se,this.kind=be}};vi=Le([ee],vi),e.FoldingRange=vi;var ji;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(ji=e.FoldingRangeKind||(e.FoldingRangeKind={}));var zi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(zi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $i;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})($i=e.CommentMode||(e.CommentMode={}));var Wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Wi=e.CommentThreadState||(e.CommentThreadState={}));class Hi{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.SemanticTokensLegend=Hi;function Vi(j){return typeof j>"u"||(0,v.isStringArray)(j)}class bi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let se=0,be=F.tokenTypes.length;se<be;se++)this.j.set(F.tokenTypes[se],se);for(let se=0,be=F.tokenModifiers.length;se<be;se++)this.k.set(F.tokenModifiers[se],se)}}push(F,se,be,Be,We){if(typeof F=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Be=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.n(F,se,be,Be,We);if(Z.isRange(F)&&typeof se=="string"&&Vi(be))return this.m(F,se,be);throw(0,R.illegalArgument)()}m(F,se,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Be=F.start.line,We=F.start.character,Ze=F.end.character-F.start.character,it=this.j.get(se);let lt=0;if(be)for(const mt of be){if(!this.k.has(mt))throw new Error("`tokenModifier` is not in the provided legend");const pt=this.k.get(mt);lt|=1<<pt>>>0}this.n(Be,We,Ze,it,lt)}n(F,se,be,Be,We){if(this.f&&(F<this.c||F===this.c&&se<this.e)){this.f=!1;const lt=this.g.length/5|0;let mt=0,pt=0;for(let yt=0;yt<lt;yt++){let Pt=this.g[5*yt],Wt=this.g[5*yt+1];Pt===0?(Pt=mt,Wt+=pt):Pt+=mt,this.g[5*yt]=Pt,this.g[5*yt+1]=Wt,mt=Pt,pt=Wt}}let Ze=F,it=se;this.f&&this.h>0&&(Ze-=this.c,Ze===0&&(it-=this.e)),this.g[this.h++]=Ze,this.g[this.h++]=it,this.g[this.h++]=be,this.g[this.h++]=Be,this.g[this.h++]=We,this.c=F,this.e=se}static o(F){const se=[],be=F.length/5|0;for(let it=0;it<be;it++)se[it]=it;se.sort((it,lt)=>{const mt=F[5*it],pt=F[5*lt];if(mt===pt){const yt=F[5*it+1],Pt=F[5*lt+1];return yt-Pt}return mt-pt});const Be=new Uint32Array(F.length);let We=0,Ze=0;for(let it=0;it<be;it++){const lt=5*se[it],mt=F[lt+0],pt=F[lt+1],yt=F[lt+2],Pt=F[lt+3],Wt=F[lt+4],Li=mt-We,On=Li===0?pt-Ze:pt,Ht=5*it;Be[Ht+0]=Li,Be[Ht+1]=On,Be[Ht+2]=yt,Be[Ht+3]=Pt,Be[Ht+4]=Wt,We=mt,Ze=pt}return Be}build(F){return this.f?new Ei(new Uint32Array(this.g),F):new Ei(bi.o(this.g),F)}}e.SemanticTokensBuilder=bi;class Ei{constructor(F,se){this.resultId=se,this.data=F}}e.SemanticTokens=Ei;class qi{constructor(F,se,be){this.start=F,this.deleteCount=se,this.data=be}}e.SemanticTokensEdit=qi;class xi{constructor(F,se){this.resultId=se,this.edits=F}}e.SemanticTokensEdits=xi;var Gi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Gi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let qt=class{constructor(){}};qt.Back={iconPath:new Dt("arrow-left")},qt=Le([ee],qt),e.QuickInputButtons=qt;var Ki;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ki=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Yi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Yi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ji;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Ji=e.ExtensionKind||(e.ExtensionKind={}));class Xi{static validate(F){if(typeof F.badge=="string"){let se=(0,A.nextCharLength)(F.badge,0);if(se<F.badge.length&&(se+=(0,A.nextCharLength)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Dt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,be){this.badge=F,this.tooltip=se,this.color=be}}e.FileDecoration=Xi;let yi=class{constructor(F){this.kind=F}};yi=Le([ee],yi),e.ColorTheme=yi;var Qi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Qi=e.ColorThemeKind||(e.ColorThemeKind={}));class Rt{static isNotebookRange(F){return F instanceof Rt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,se){if(F<0)throw(0,R.illegalArgument)("start must be positive");if(se<0)throw(0,R.illegalArgument)("end must be positive");F<=se?(this.c=F,this.e=se):(this.c=se,this.e=F)}with(F){let se=this.c,be=this.e;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(be=F.end),se===this.c&&be===this.e?this:new Rt(se,be)}}e.NotebookRange=Rt;class xt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>xt.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,be,Be,We,Ze,it){this.kind=F,this.value=se,this.languageId=be,this.mime=Be,this.outputs=We??[],this.metadata=Ze,this.executionSummary=it,xt.validate(this)}}e.NotebookCellData=xt;class Zi{constructor(F){this.cells=F}}e.NotebookData=Zi;class gt{static isNotebookCellOutputItem(F){return F instanceof gt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return gt.json(se,"application/vnd.code.notebook.error")}static stdout(F){return gt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return gt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new gt(F,se)}static text(F,se=C.Mimes.text){const be=nt(gt,S,"f",L).encode(String(F));return new gt(be,se)}static json(F,se="text/x-json"){const be=JSON.stringify(F,void 0,"	");return gt.text(be,se)}constructor(F,se){this.data=F,this.mime=se;const be=(0,C.normalizeMimeType)(se,!0);if(!be)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}S=gt,L={value:new TextEncoder},e.NotebookCellOutputItem=gt;class Gt{static isNotebookCellOutput(F){return F instanceof Gt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const be=new Set,Be=new Set;for(let We=0;We<F.length;We++){const Ze=F[We],it=(0,C.normalizeMimeType)(Ze.mime);if(!be.has(it)||(0,m.isTextStreamMime)(it)){be.add(it);continue}Be.add(We),se&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Be.size===0?F:F.filter((We,Ze)=>!Be.has(Ze))}constructor(F,se,be){this.items=Gt.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=be):(this.id=(0,T.generateUuid)(),this.metadata=se??be)}}e.NotebookCellOutput=Gt;var _i;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(_i=e.NotebookCellKind||(e.NotebookCellKind={}));var en;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(en=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var tn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var nn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(nn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class rn{constructor(F,se){this.text=F,this.alignment=se}}e.NotebookCellStatusBarItem=rn;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(on=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class an{constructor(F,se=[]){this.uri=F,this.provides=(0,w.asArray)(se)}}e.NotebookRendererScript=an;class ln{constructor(F){this.label=F}}e.NotebookKernelSourceAction=ln;let wi=class{constructor(F,se){this.label=F,this.timestamp=se}};wi=Le([ee],wi),e.TimelineItem=wi;var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn=e.ExtensionMode||(e.ExtensionMode={}));var un;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(un=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.LinkedEditingRanges=fn;class dn{constructor(F,se){this.c=F,this.e=se}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=dn;var mn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(mn=e.TestResultState||(e.TestResultState={}));var gn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(gn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Kt=class{constructor(F=void 0,se=void 0,be=void 0,Be=!1){this.include=F,this.exclude=se,this.profile=be,this.continuous=Be}};Kt=Le([ee],Kt),e.TestRunRequest=Kt;let Si=class extends Kt{};Si=Le([ee],Si),e.TestRunRequest2=Si;let Ii=ae=class{static diff(F,se,be){const Be=new ae(F);return Be.expectedOutput=se,Be.actualOutput=be,Be}constructor(F){this.message=F}};Ii=ae=Le([ee],Ii),e.TestMessage=Ii;let Ci=class{constructor(F){this.id=F}};Ci=Le([ee],Ci),e.TestTag=Ci;let zt=class{constructor(F,se){this.covered=F,this.total=se}};zt=Le([ee],zt),e.CoveredCount=zt;let Di=_=class{static fromDetails(F,se){const be=new zt(0,0),Be=new zt(0,0),We=new zt(0,0);for(const it of se)if("branches"in it){be.total+=1,be.covered+=it.executionCount>0?1:0;for(const lt of it.branches)Be.total+=1,Be.covered+=lt.executionCount>0?1:0}else We.total+=1,We.covered+=it.executionCount>0?1:0;const Ze=new _(F,be,Be.total>0?Be:void 0,We.total>0?We:void 0);return Ze.detailedCoverage=se,Ze}constructor(F,se,be,Be){this.uri=F,this.statementCoverage=se,this.branchCoverage=be,this.functionCoverage=Be}};Di=_=Le([ee],Di),e.FileCoverage=Di;let Pi=class{constructor(F,se,be=[]){this.executionCount=F,this.location=se,this.branches=be}};Pi=Le([ee],Pi),e.StatementCoverage=Pi;let ki=class{constructor(F,se){this.executionCount=F,this.location=se}};ki=Le([ee],ki),e.BranchCoverage=ki;let Ai=class{constructor(F,se){this.executionCount=F,this.location=se}};Ai=Le([ee],Ai),e.FunctionCoverage=Ai;var pn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(pn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(F,se,be,Be,We,Ze){this.kind=F,this.name=se,this.detail=be,this.uri=Be,this.range=We,this.selectionRange=Ze}}e.TypeHierarchyItem=En;class yn{constructor(F){this.uri=F}}e.TextTabInput=yn;class wn{constructor(F,se){this.original=F,this.modified=se}}e.TextDiffTabInput=wn;class Sn{constructor(F,se,be,Be){this.base=F,this.input1=se,this.input2=be,this.result=Be}}e.TextMergeTabInput=Sn;class In{constructor(F,se){this.uri=F,this.viewType=se}}e.CustomEditorTabInput=In;class Cn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=Cn;class Dn{constructor(F,se){this.uri=F,this.notebookType=se}}e.NotebookEditorTabInput=Dn;class Pn{constructor(F,se,be){this.original=F,this.modified=se,this.notebookType=be}}e.NotebookDiffEditorTabInput=Pn;class kn{constructor(){}}e.TerminalEditorTabInput=kn;class An{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.InteractiveWindowInput=An;var Tn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(Tn=e.InteractiveSessionVoteDirection||(e.InteractiveSessionVoteDirection={}));var Rn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Rn=e.InteractiveSessionCopyKind||(e.InteractiveSessionCopyKind={}));var Ln;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone"})(Ln=e.InteractiveEditorResponseFeedbackKind||(e.InteractiveEditorResponseFeedbackKind={}))}),define(pe[135],ve([1,0,18,15,145,71,97,27,141,61,57,21,8,4,48,166,225,130,86,128,70,87,132,134]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.NotebookDocumentSaveReason=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(we){function Ie(K){const{selectionStartLineNumber:Pe,selectionStartColumn:Oe,positionLineNumber:xe,positionColumn:je}=K,tt=new n.Position(Pe-1,Oe-1),at=new n.Position(xe-1,je-1);return new n.Selection(tt,at)}we.to=Ie;function fe(K){const{anchor:Pe,active:Oe}=K;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}we.from=fe})(r=e.Selection||(e.Selection={}));var i;(function(we){function Ie(K){if(!K)return;const{start:Pe,end:Oe}=K;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}we.from=Ie;function fe(K){if(!K)return;const{startLineNumber:Pe,startColumn:Oe,endLineNumber:xe,endColumn:je}=K;return new n.Range(Pe-1,Oe-1,xe-1,je-1)}we.to=fe})(i=e.Range||(e.Range={}));var l;(function(we){function Ie(fe){switch(fe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}we.to=Ie})(l=e.TokenType||(e.TokenType={}));var c;(function(we){function Ie(K){return new n.Position(K.lineNumber-1,K.column-1)}we.to=Ie;function fe(K){return{lineNumber:K.line+1,column:K.character+1}}we.from=fe})(c=e.Position||(e.Position={}));var s;(function(we){function Ie(Pe,Oe){return(0,w.coalesce)((0,w.asArray)(Pe).map(xe=>fe(xe,Oe)))}we.from=Ie;function fe(Pe,Oe){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:K(Pe.scheme,Oe),pattern:Te.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function K(Pe,Oe){return Oe&&typeof Pe=="string"?Oe.transformOutgoingScheme(Pe):Pe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(we){function Ie(K){switch(K){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}we.from=Ie;function fe(K){switch(K){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}we.to=fe})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var E;(function(we){function Ie(K){let Pe;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?Pe=String(K.code):Pe={value:String(K.code.value),target:K.code.target}),{...i.from(K.range),message:K.message,source:K.source,code:Pe,severity:O.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(k.from),tags:Array.isArray(K.tags)?(0,w.coalesce)(K.tags.map(u.from)):void 0}}we.from=Ie;function fe(K){const Pe=new n.Diagnostic(i.to(K),K.message,O.to(K.severity));return Pe.source=K.source,Pe.code=(0,y.isString)(K.code)?K.code:K.code?.value,Pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(k.to),Pe.tags=K.tags&&(0,w.coalesce)(K.tags.map(u.to)),Pe}we.to=fe})(E=e.Diagnostic||(e.Diagnostic={}));var k;(function(we){function Ie(K){return{...i.from(K.location.range),message:K.message,resource:K.location.uri}}we.from=Ie;function fe(K){return new n.DiagnosticRelatedInformation(new n.Location(K.resource,i.to(K)),K.message)}we.to=fe})(k=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(we){function Ie(K){switch(K){case n.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}we.from=Ie;function fe(K){switch(K){case a.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}we.to=fe})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var B;(function(we){function Ie(K){return typeof K=="number"&&K>=n.ViewColumn.One?K-1:K===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}we.from=Ie;function fe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=fe})(B=e.ViewColumn||(e.ViewColumn={}));function q(we){return typeof we.range<"u"}function le(we){return we.length===0?!0:!!q(we[0])}e.isDecorationOptionsArr=le;var de;(function(we){function Ie(je){return je.map(we.from)}we.fromMany=Ie;function fe(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function K(je){let tt;if(fe(je)){const{language:ut,value:Et}=je;tt={value:"```"+ut+`
`+Et+"\n```\n"}}else n.MarkdownString.isMarkdownString(je)?tt={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?tt={value:je}:tt={value:""};const at=Object.create(null);tt.uris=at;const bt=ut=>{try{let Et=m.URI.parse(ut,!0);Et=Et.with({query:Pe(Et.query,at)}),at[ut]=Et}catch{}return""},Ct=new v.marked.Renderer;return Ct.link=bt,Ct.image=ut=>typeof ut=="string"?bt(C.parseHrefAndDimensions(ut).href):"",(0,v.marked)(tt.value,{renderer:Ct}),tt}we.from=K;function Pe(je,tt){if(!je)return je;let at;try{at=(0,g.parse)(je)}catch{}if(!at)return je;let bt=!1;return at=(0,I.cloneAndChange)(at,Ct=>{if(m.URI.isUri(Ct)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[ut]=Ct,bt=!0,ut}else return}),bt?JSON.stringify(at):je}function Oe(je){const tt=new n.MarkdownString(je.value,je.supportThemeIcons);return tt.isTrusted=je.isTrusted,tt.supportHtml=je.supportHtml,tt.baseUri=je.baseUri?m.URI.from(je.baseUri):void 0,tt}we.to=Oe;function xe(je){if(!!je)return typeof je=="string"?je:we.from(je)}we.fromStrict=xe})(de=e.MarkdownString||(e.MarkdownString={}));function ue(we){return le(we)?we.map(Ie=>({range:i.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?de.fromMany(Ie.hoverMessage):Ie.hoverMessage?de.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):we.map(Ie=>({range:i.from(Ie)}))}e.fromRangeOrRangeWithMessage=ue;function ae(we){return typeof we>"u"?we:typeof we=="string"?m.URI.file(we):we}e.pathOrURIToURI=ae;var _;(function(we){function Ie(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ae(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}we.from=Ie})(_=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var ee;(function(we){function Ie(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ae(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?_.from(fe.before):void 0,after:fe.after?_.from(fe.after):void 0}}we.from=Ie})(ee=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ne;(function(we){function Ie(fe){if(typeof fe>"u")return fe;switch(fe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ie})(ne=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var te;(function(we){function Ie(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ne.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ee.from(fe.light):void 0,dark:fe.dark?ee.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ae(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?_.from(fe.before):void 0,after:fe.after?_.from(fe.after):void 0}}we.from=Ie})(te=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(we){function Ie(K){return{text:K.newText,eol:K.newEol&&Qe.from(K.newEol),range:i.from(K.range)}}we.from=Ie;function fe(K){const Pe=new n.TextEdit(i.to(K.range),K.text);return Pe.newEol=typeof K.eol>"u"?void 0:Qe.to(K.eol),Pe}we.to=fe})(x=e.TextEdit||(e.TextEdit={}));var U;(function(we){function Ie(K,Pe){const Oe={edits:[]};if(K instanceof n.WorkspaceEdit){const xe=new A.ResourceSet;for(const je of K._allEntries())je._type===1&&m.URI.isUri(je.to)&&je.from===void 0&&xe.add(je.to);for(const je of K._allEntries())je._type===1?Oe.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,R.encodeBase64)(R.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?Oe.edits.push({resource:je.uri,textEdit:x.from(je.edit),versionId:xe.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?Oe.edits.push({resource:je.uri,textEdit:{range:i.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:xe.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Oe.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Oe.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(Ye.from)}})}return Oe}we.from=Ie;function fe(K){const Pe=new n.WorkspaceEdit;for(const Oe of K.edits)Oe.textEdit?Pe.replace(m.URI.revive(Oe.resource),i.to(Oe.textEdit.range),Oe.textEdit.text):Pe.renameFile(m.URI.revive(Oe.oldResource),m.URI.revive(Oe.newResource),Oe.options);return Pe}we.to=fe})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Z;(function(we){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}we.from=fe;function K(Pe){for(const Oe in Ie)if(Ie[Oe]===Pe)return Number(Oe);return n.SymbolKind.Property}we.to=K})(Z=e.SymbolKind||(e.SymbolKind={}));var re;(function(we){function Ie(K){switch(K){case n.SymbolTag.Deprecated:return 1}}we.from=Ie;function fe(K){switch(K){case 1:return n.SymbolTag.Deprecated}}we.to=fe})(re=e.SymbolTag||(e.SymbolTag={}));var me;(function(we){function Ie(K){return{name:K.name,kind:Z.from(K.kind),tags:K.tags&&K.tags.map(re.from),containerName:K.containerName,location:M.from(K.location)}}we.from=Ie;function fe(K){const Pe=new n.SymbolInformation(K.name,Z.to(K.kind),K.containerName,M.to(K.location));return Pe.tags=K.tags&&K.tags.map(re.to),Pe}we.to=fe})(me=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(we){function Ie(K){const Pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:i.from(K.range),selectionRange:i.from(K.selectionRange),kind:Z.from(K.kind),tags:K.tags?.map(re.from)??[]};return K.children&&(Pe.children=K.children.map(Ie)),Pe}we.from=Ie;function fe(K){const Pe=new n.DocumentSymbol(K.name,K.detail,Z.to(K.kind),i.to(K.range),i.to(K.selectionRange));return(0,w.isNonEmptyArray)(K.tags)&&(Pe.tags=K.tags.map(re.to)),K.children&&(Pe.children=K.children.map(fe)),Pe}we.to=fe})($=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(we){function Ie(K){const Pe=new n.CallHierarchyItem(Z.to(K.kind),K.name,K.detail||"",m.URI.revive(K.uri),i.to(K.range),i.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}we.to=Ie;function fe(K,Pe,Oe){if(Pe=Pe??K._sessionId,Oe=Oe??K._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,name:K.name,detail:K.detail,kind:Z.from(K.kind),uri:K.uri,range:i.from(K.range),selectionRange:i.from(K.selectionRange),tags:K.tags?.map(re.from)}}we.from=fe})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(we){function Ie(fe){return new n.CallHierarchyIncomingCall(W.to(fe.from),fe.fromRanges.map(K=>i.to(K)))}we.to=Ie})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var P;(function(we){function Ie(fe){return new n.CallHierarchyOutgoingCall(W.to(fe.to),fe.fromRanges.map(K=>i.to(K)))}we.to=Ie})(P=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(we){function Ie(K){return{range:K.range&&i.from(K.range),uri:K.uri}}we.from=Ie;function fe(K){return new n.Location(m.URI.revive(K.uri),i.to(K.range))}we.to=fe})(M=e.location||(e.location={}));var Y;(function(we){function Ie(K){const Pe=K,Oe=K;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Oe.uri,range:i.from(Pe.targetRange?Pe.targetRange:Oe.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}we.from=Ie;function fe(K){return{targetUri:m.URI.revive(K.uri),targetRange:i.to(K.range),targetSelectionRange:K.targetSelectionRange?i.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?i.to(K.originSelectionRange):void 0}}we.to=fe})(Y=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(we){function Ie(K){return{range:i.from(K.range),contents:de.fromMany(K.contents)}}we.from=Ie;function fe(K){return new n.Hover(K.contents.map(de.to),i.to(K.range))}we.to=fe})(ie=e.Hover||(e.Hover={}));var z;(function(we){function Ie(K){return{range:i.from(K.range),expression:K.expression}}we.from=Ie;function fe(K){return new n.EvaluatableExpression(i.to(K.range),K.expression)}we.to=fe})(z=e.EvaluatableExpression||(e.EvaluatableExpression={}));var V;(function(we){function Ie(K){if(K instanceof n.InlineValueText)return{type:"text",range:i.from(K.range),text:K.text};if(K instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ie;function fe(K){switch(K.type){case"text":return{range:i.to(K.range),text:K.text};case"variable":return{range:i.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:i.to(K.range),expression:K.expression}}}we.to=fe})(V=e.InlineValue||(e.InlineValue={}));var J;(function(we){function Ie(K){return{frameId:K.frameId,stoppedLocation:i.from(K.stoppedLocation)}}we.from=Ie;function fe(K){return new n.InlineValueContext(K.frameId,i.to(K.stoppedLocation))}we.to=fe})(J=e.InlineValueContext||(e.InlineValueContext={}));var H;(function(we){function Ie(K){return{range:i.from(K.range),kind:K.kind}}we.from=Ie;function fe(K){return new n.DocumentHighlight(i.to(K.range),K.kind)}we.to=fe})(H=e.DocumentHighlight||(e.DocumentHighlight={}));var X;(function(we){function Ie(fe){switch(fe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}we.to=Ie})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(we){function Ie(fe){return{triggerKind:X.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}we.to=Ie})(G=e.CompletionContext||(e.CompletionContext={}));var Q;(function(we){function Ie(K){switch(K){case n.CompletionItemTag.Deprecated:return 1}}we.from=Ie;function fe(K){switch(K){case 1:return n.CompletionItemTag.Deprecated}}we.to=fe})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var ce;(function(we){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function fe(Oe){return Ie.get(Oe)??9}we.from=fe;const K=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Oe){return K.get(Oe)??n.CompletionItemKind.Property}we.to=Pe})(ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Ee;(function(we){function Ie(fe,K){const Pe=new n.CompletionItem(fe.label);return Pe.insertText=fe.insertText,Pe.kind=ce.to(fe.kind),Pe.tags=fe.tags?.map(Q.to),Pe.detail=fe.detail,Pe.documentation=C.isMarkdownString(fe.documentation)?de.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,p.Range.isIRange(fe.range)?Pe.range=i.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Pe.insertText=new n.SnippetString(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Oe=>x.to(Oe))),Pe.command=K&&fe.command?K.fromInternal(fe.command):void 0,Pe}we.to=Ie})(Ee=e.CompletionItem||(e.CompletionItem={}));var De;(function(we){function Ie(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:de.fromStrict(K.documentation)}}we.from=Ie;function fe(K){return{label:K.label,documentation:C.isMarkdownString(K.documentation)?de.to(K.documentation):K.documentation}}we.to=fe})(De=e.ParameterInformation||(e.ParameterInformation={}));var ke;(function(we){function Ie(K){return{label:K.label,documentation:de.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(De.from):[],activeParameter:K.activeParameter}}we.from=Ie;function fe(K){return{label:K.label,documentation:C.isMarkdownString(K.documentation)?de.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(De.to):[],activeParameter:K.activeParameter}}we.to=fe})(ke=e.SignatureInformation||(e.SignatureInformation={}));var Ue;(function(we){function Ie(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ke.from):[]}}we.from=Ie;function fe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ke.to):[]}}we.to=fe})(Ue=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(we){function Ie(fe,K){const Pe=new n.InlayHint(c.to(K.position),typeof K.label=="string"?K.label:K.label.map(ge.to.bind(void 0,fe)),K.kind&&Se.to(K.kind));return Pe.textEdits=K.textEdits&&K.textEdits.map(x.to),Pe.tooltip=C.isMarkdownString(K.tooltip)?de.to(K.tooltip):K.tooltip,Pe.paddingLeft=K.paddingLeft,Pe.paddingRight=K.paddingRight,Pe}we.to=Ie})($e=e.InlayHint||(e.InlayHint={}));var ge;(function(we){function Ie(fe,K){const Pe=new n.InlayHintLabelPart(K.label);return Pe.tooltip=C.isMarkdownString(K.tooltip)?de.to(K.tooltip):K.tooltip,b.Command.is(K.command)&&(Pe.command=fe.fromInternal(K.command)),K.location&&(Pe.location=M.to(K.location)),Pe}we.to=Ie})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Se;(function(we){function Ie(K){return K}we.from=Ie;function fe(K){return K}we.to=fe})(Se=e.InlayHintKind||(e.InlayHintKind={}));var ye;(function(we){function Ie(K){return{range:i.from(K.range),url:K.target,tooltip:K.tooltip}}we.from=Ie;function fe(K){let Pe;if(K.url)try{Pe=typeof K.url=="string"?m.URI.parse(K.url,!0):m.URI.revive(K.url)}catch{}return new n.DocumentLink(i.to(K.range),Pe)}we.to=fe})(ye=e.DocumentLink||(e.DocumentLink={}));var Me;(function(we){function Ie(K){const Pe=new n.ColorPresentation(K.label);return K.textEdit&&(Pe.textEdit=x.to(K.textEdit)),K.additionalTextEdits&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Oe=>x.to(Oe))),Pe}we.to=Ie;function fe(K){return{label:K.label,textEdit:K.textEdit?x.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Pe=>x.from(Pe)):void 0}}we.from=fe})(Me=e.ColorPresentation||(e.ColorPresentation={}));var Fe;(function(we){function Ie(K){return new n.Color(K[0],K[1],K[2],K[3])}we.to=Ie;function fe(K){return[K.red,K.green,K.blue,K.alpha]}we.from=fe})(Fe=e.Color||(e.Color={}));var _e;(function(we){function Ie(K){return{range:i.from(K.range)}}we.from=Ie;function fe(K){return new n.SelectionRange(i.to(K.range))}we.to=fe})(_e=e.SelectionRange||(e.SelectionRange={}));var He;(function(we){function Ie(fe){switch(fe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}we.to=Ie})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(we){function Ie(K){switch(K){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ie;function fe(K){switch(K){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}we.to=fe})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(we){function Ie(K){if(K===n.EndOfLine.CRLF)return 1;if(K===n.EndOfLine.LF)return 0}we.from=Ie;function fe(K){if(K===1)return n.EndOfLine.CRLF;if(K===0)return n.EndOfLine.LF}we.to=fe})(Qe=e.EndOfLine||(e.EndOfLine={}));var et;(function(we){function Ie(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ie})(et=e.ProgressLocation||(e.ProgressLocation={}));var Ke;(function(we){function Ie(K){const Pe={start:K.start+1,end:K.end+1};return K.kind&&(Pe.kind=he.from(K.kind)),Pe}we.from=Ie;function fe(K){const Pe={start:K.start-1,end:K.end-1};return K.kind&&(Pe.kind=he.to(K.kind)),Pe}we.to=fe})(Ke=e.FoldingRange||(e.FoldingRange={}));var he;(function(we){function Ie(K){if(K)switch(K){case n.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}we.from=Ie;function fe(K){if(K)switch(K.value){case b.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}we.to=fe})(he=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ce;(function(we){function Ie(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=Ie})(Ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Te;(function(we){function Ie(Oe){return Oe instanceof n.RelativePattern?Oe.toJSON():typeof Oe=="string"?Oe:fe(Oe)||K(Oe)?new n.RelativePattern(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}we.from=Ie;function fe(Oe){const xe=Oe;return xe?m.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function K(Oe){const xe=Oe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Pe(Oe){return typeof Oe=="string"?Oe:new n.RelativePattern(m.URI.revive(Oe.baseUri),Oe.pattern)}we.to=Pe})(Te=e.GlobPattern||(e.GlobPattern={}));var Ne;(function(we){function Ie(fe){if(fe){if(Array.isArray(fe))return fe.map(Ie);if(typeof fe=="string")return fe;{const K=fe;return{language:K.language,scheme:K.scheme,pattern:Te.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}we.from=Ie})(Ne=e.LanguageSelector||(e.LanguageSelector={}));var Re;(function(we){function Ie(fe){switch(fe){case 2:return n.NotebookDocumentSaveReason.AfterDelay;case 1:return n.NotebookDocumentSaveReason.Manual;case 3:case 4:return n.NotebookDocumentSaveReason.FocusOut}}we.to=Ie})(Re=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));var ze;(function(we){function Ie(K){return{start:K.start,end:K.end}}we.from=Ie;function fe(K){return new n.NotebookRange(K.start,K.end)}we.to=fe})(ze=e.NotebookRange||(e.NotebookRange={}));var qe;(function(we){function Ie(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}we.to=Ie;function fe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}we.from=fe})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(we){function Ie(fe){if(fe===d.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(fe===d.NotebookCellExecutionState.Pending)return;if(fe===d.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}we.to=Ie})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(we){function Ie(K){switch(K){case n.NotebookCellKind.Markup:return d.CellKind.Markup;case n.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=Ie;function fe(K){switch(K){case d.CellKind.Markup:return n.NotebookCellKind.Markup;case d.CellKind.Code:default:return n.NotebookCellKind.Code}}we.to=fe})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var Xe;(function(we){function Ie(K){const Pe={metadata:K.metadata??Object.create(null),cells:[]};for(const Oe of K.cells)n.NotebookCellData.validate(Oe),Pe.cells.push(Ye.from(Oe));return Pe}we.from=Ie;function fe(K){const Pe=new n.NotebookData(K.cells.map(Ye.to));return(0,y.isEmptyObject)(K.metadata)||(Pe.metadata=K.metadata),Pe}we.to=fe})(Xe=e.NotebookData||(e.NotebookData={}));var Ye;(function(we){function Ie(K){return{cellKind:Ge.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:qe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(ct.from):[]}}we.from=Ie;function fe(K){return new n.NotebookCellData(Ge.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(ct.to):void 0,K.metadata,K.internalMetadata?qe.to(K.internalMetadata):void 0)}we.to=fe})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(we){function Ie(K){return{mime:K.mime,valueBytes:R.VSBuffer.wrap(K.data)}}we.from=Ie;function fe(K){return new n.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}we.to=fe})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(we){function Ie(K){return{outputId:K.id,items:K.items.map(st.from),metadata:K.metadata}}we.from=Ie;function fe(K){const Pe=K.items.map(st.to);return new n.NotebookCellOutput(Pe,K.outputId,K.metadata)}we.to=fe})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(we){function Ie(Pe){return K(Pe)?{include:(0,y.withNullAsUndefined)(Te.from(Pe.include)),exclude:(0,y.withNullAsUndefined)(Te.from(Pe.exclude))}:(0,y.withNullAsUndefined)(Te.from(Pe))}we.from=Ie;function fe(Pe){return K(Pe)?{include:Te.to(Pe.include),exclude:Te.to(Pe.exclude)}:Te.to(Pe)}we.to=fe;function K(Pe){const Oe=Pe;return Oe?!(0,y.isUndefinedOrNull)(Oe.include)&&!(0,y.isUndefinedOrNull)(Oe.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Nt;(function(we){function Ie(fe,K,Pe){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Oe,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}we.from=Ie})(Nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var wt;(function(we){function Ie(fe,K,Pe){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:K.toInternal(Oe,Pe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}we.from=Ie})(wt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ut;(function(we){function Ie(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}we.from=Ie})(Ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var St;(function(we){function Ie(K){return{uri:K.uri,provides:K.provides}}we.from=Ie;function fe(K){return new n.NotebookRendererScript(m.URI.revive(K.uri),K.provides)}we.to=fe})(St=e.NotebookRendererScript||(e.NotebookRendererScript={}));var vt;(function(we){function Ie(K){return{message:de.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:i.from(K.location.range),uri:K.location.uri}}}we.from=Ie;function fe(K){const Pe=new n.TestMessage(typeof K.message=="string"?K.message:de.to(K.message));return Pe.actualOutput=K.actual,Pe.expectedOutput=K.expected,Pe.location=K.location?M.to(K.location):void 0,Pe}we.to=fe})(vt=e.TestMessage||(e.TestMessage={}));var It;(function(we){we.namespace=L.namespaceTestTag,we.denamespace=L.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var kt;(function(we){function Ie(K){const Pe=(0,f.getPrivateApiFor)(K).controllerId;return{extId:S.TestId.fromExtHostTestItem(K,Pe).toString(),label:K.label,uri:m.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Oe=>It.namespace(Pe,Oe.id)),range:p.Range.lift(i.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&de.fromStrict(K.error)||null}}we.from=Ie;function fe(K){return{parent:void 0,error:void 0,id:S.TestId.fromString(K.extId).localId,label:K.label,uri:m.URI.revive(K.uri),tags:(K.tags||[]).map(Pe=>{const{tagId:Oe}=It.denamespace(Pe);return new n.TestTag(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}we.toPlain=fe})(kt=e.TestItem||(e.TestItem={})),function(we){function Ie(K){return{id:K.id}}we.from=Ie;function fe(K){return new n.TestTag(K.id)}we.to=fe}(It=e.TestTag||(e.TestTag={}));var At;(function(we){const Ie=(K,Pe)=>{const Oe=[];for(const[je,tt]of Pe)S.TestId.compare(tt.item.extId,je)===2&&(Pe.delete(je),Oe.push(tt));const xe={...kt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(tt=>tt.type===0).map(vt.to)})),children:Oe.map(je=>Ie(je,Pe))};for(const je of xe.children)je.parent=xe;return xe};function fe(K){const Pe=[],Oe=new Map;for(const xe of K.items){Oe.set(xe.item.extId,xe);const je=S.TestId.root(xe.item.extId);K.request.targets.some(tt=>tt.controllerId===je&&tt.testIds.includes(xe.item.extId))&&Pe.push(xe)}return{completedAt:K.completedAt,results:Pe.map(xe=>Ie(xe,Oe))}}we.to=fe})(At=e.TestResults||(e.TestResults={}));var Bt;(function(we){function Ie(Oe){return{covered:Oe.covered,total:Oe.covered}}function fe(Oe){return"line"in Oe?c.from(Oe):i.from(Oe)}function K(Oe){return"branches"in Oe?{count:Oe.executionCount,location:fe(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&fe(xe.location)})):void 0}:{type:0,count:Oe.executionCount,location:fe(Oe.location)}}we.fromDetailed=K;function Pe(Oe){return{uri:Oe.uri,statement:Ie(Oe.statementCoverage),branch:Oe.branchCoverage&&Ie(Oe.branchCoverage),function:Oe.functionCoverage&&Ie(Oe.functionCoverage),details:Oe.detailedCoverage?.map(K)}}we.fromFile=Pe})(Bt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(we){function Ie(fe){switch(fe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}we.to=Ie})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ht;(function(we){function Ie(K){const Pe=new n.TypeHierarchyItem(Z.to(K.kind),K.name,K.detail||"",m.URI.revive(K.uri),i.to(K.range),i.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}we.to=Ie;function fe(K,Pe,Oe){if(Pe=Pe??K._sessionId,Oe=Oe??K._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,kind:Z.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:i.from(K.range),selectionRange:i.from(K.selectionRange),tags:K.tags?.map(re.from)}}we.from=fe})(ht=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(we){function Ie(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}we.from=Ie})(Tt=e.ViewBadge||(e.ViewBadge={}));var rt;(function(we){function Ie(Oe,xe,je){const tt=xe.fileData;return tt?new class extends n.DataTransferItem{asFile(){return{name:tt.name,uri:m.URI.revive(tt.uri),data:(0,D.once)(()=>je())}}}("",xe.id):Oe===T.Mimes.uriList&&xe.uriListData?new n.DataTransferItem(Pe(xe.uriListData)):new n.DataTransferItem(xe.asString)}we.to=Ie;async function fe(Oe,xe){const je=await xe.asString();if(Oe===T.Mimes.uriList)return{id:xe.id,asString:je,fileData:void 0,uriListData:K(je)};const tt=xe.asFile();return{id:xe.id,asString:je,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}we.from=fe;function K(Oe){return o.UriList.split(Oe).map(xe=>{if(xe.startsWith("#"))return xe;try{return m.URI.parse(xe)}catch{}return xe})}function Pe(Oe){return o.UriList.create(Oe.map(xe=>typeof xe=="string"?xe:m.URI.revive(xe)))}})(rt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(we){function Ie(K,Pe){const Oe=K.items.map(([xe,je])=>[xe,rt.to(xe,je,()=>Pe(je.id))]);return new n.DataTransfer(Oe)}we.toDataTransfer=Ie;async function fe(K){const Pe={items:[]},Oe=[];return K.forEach((xe,je)=>{Oe.push((async()=>{Pe.items.push([je,await rt.from(je,xe)])})())}),await Promise.all(Oe),Pe}we.toDataTransferDTO=fe})(ft=e.DataTransfer||(e.DataTransfer={}));var dt;(function(we){function Ie(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}we.to=Ie;function fe(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}we.from=fe})(dt=e.InteractiveSessionReplyFollowup||(e.InteractiveSessionReplyFollowup={}));var $t;(function(we){function Ie(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",args:fe.args}:dt.from(fe)}we.from=Ie})($t=e.InteractiveSessionFollowup||(e.InteractiveSessionFollowup={}))}),define(pe[276],ve([1,0,48,130,70,129,87,135,4]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(d,S,L,t)=>{let n=S;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!L(n,r)){const i=n;n=r,d.listener?.(t(r,i))}}}},T=(d,S)=>d===S,I={range:(d,S)=>d===S?!0:!d||!S?!1:d.isEqual(S),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(d,S)=>!(d.length!==S.length||d.some(L=>!S.find(t=>L.id===t.id)))},y=d=>S=>({op:4,update:d(S)}),m=(d,S)=>({range:(()=>{let L;const t=y(n=>({range:w.Range.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return L},set(n){d.listener?.({op:6}),I.range(L,n)||(L=n,d.listener?.(t(n)))}}})(),label:g(d,S,I.label,y(L=>({label:L}))),description:g(d,void 0,I.description,y(L=>({description:L}))),sortText:g(d,void 0,I.sortText,y(L=>({sortText:L}))),canResolveChildren:g(d,!1,I.canResolveChildren,L=>({op:2,state:L})),busy:g(d,!1,I.busy,y(L=>({busy:L}))),error:g(d,void 0,I.error,y(L=>({error:A.MarkdownString.fromStrict(L)||null}))),tags:g(d,[],I.tags,(L,t)=>({op:1,new:L.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),p=d=>{const S=o.TestId.fromString(d.extId),L=new a(S.controllerId,S.localId,d.label,v.URI.revive(d.uri)||void 0);return L.range=A.Range.to(d.range||void 0),L.description=d.description||void 0,L.sortText=d.sortText||void 0,L.tags=d.tags.map(t=>A.TestTag.to({id:(0,C.denamespaceTestTag)(t).tagId})),L},b=d=>{let S;for(const L of d.tests){const t=p(L.item);(0,R.getPrivateApiFor)(t).parent=S,S=t}return S};e.toItemFromContext=b;class a{constructor(S,L,t,n){if(L.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(L)} symbol`);const r=(0,R.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof f?void 0:r.parent}},children:{value:(0,D.createTestItemChildren)(r,R.getPrivateApiFor,a),enumerable:!0,writable:!1},...m(r,t)})}}e.TestItemImpl=a;class f extends a{constructor(S,L){super(S,S,L,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class h extends D.TestItemCollection{constructor(S,L,t){super({controllerId:S,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:R.getPrivateApiFor,getChildren:n=>n.children,root:new f(S,L),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(pe[277],ve([1,0,36,200,51]),function(oe,e,w,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function D(C,A,v,g){const T=new w.ExtensionIdentifierMap;return C.forEach(I=>{const y=T.get(I.identifier);y&&g.warn((0,R.localize)(0,null,y.extensionLocation.fsPath,I.extensionLocation.fsPath)),T.set(I.identifier,I)}),A.forEach(I=>{const y=T.get(I.identifier);if(y)if(y.isBuiltin){if(o.gte(y.version,I.version)){g.warn(`Skipping extension ${I.extensionLocation.path} in favour of the builtin extension ${y.extensionLocation.path}.`);return}I.isBuiltin=!0}else g.warn((0,R.localize)(1,null,y.extensionLocation.fsPath,I.extensionLocation.fsPath));else if(I.isBuiltin){g.warn(`Skipping obsolete builtin extension ${I.extensionLocation.path}`);return}T.set(I.identifier,I)}),v.forEach(I=>{g.info((0,R.localize)(2,null,I.extensionLocation.fsPath));const y=T.get(I.identifier);y&&y.isBuiltin&&(I.isBuiltin=!0),T.set(I.identifier,I)}),Array.from(T.values())}e.dedupExtensions=D}),define(pe[278],ve([1,0,7,3,28,4,41,49,65,55,277,13]),function(oe,e,w,R,o,D,C,A,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class y{constructor(b,a,f,h,d,S,L){this.b=b,this.c=f,this.d=h,this.f=d,this.g=S,this.h=L;const t=a.args["install-builtin-extension"];if(t){d.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!a.args["do-not-sync"],installPreReleaseVersion:!!a.args["pre-release"]};C.mark("code/server/willInstallBuiltinExtensions"),this.a=b.installExtensions([],this.i(t),r,!!a.args.force).then(()=>{C.mark("code/server/didInstallBuiltinExtensions"),d.trace("Finished installing builtin extensions")},i=>{d.error(i)})}else this.a=Promise.resolve();const n=a.args["install-extension"];n&&(d.trace("Installing extensions passed via args..."),this.a.then(()=>b.installExtensions(this.i(n),[],{isMachineScoped:!!a.args["do-not-sync"],installPreReleaseVersion:!!a.args["pre-release"],isApplicationScoped:!0},!!a.args.force)).then(()=>{d.trace("Finished installing extensions")},r=>{d.error(r)}))}i(b){return b.map(a=>/\.vsix$/i.test(a)?D.URI.file((0,w.isAbsolute)(a)?a:(0,w.join)((0,o.cwd)(),a)):a)}whenExtensionsReady(){return this.a}async scanExtensions(b,a,f,h){C.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${b}`),await this.whenExtensionsReady();const d=f?f.filter(L=>L.scheme===I.Schemas.file).map(L=>L.fsPath):void 0;a=a??this.c.defaultProfile.extensionsResource;const S=await this.j(a,b??R.language,d,h);return this.f.trace("Scanned Extensions",S),this.q(S),C.mark("code/server/didScanExtensions"),S}async scanSingleExtension(b,a,f){await this.whenExtensionsReady();const h=b.scheme===I.Schemas.file?b.fsPath:null;if(!h)return null;const d=await this.n(h,a,f??R.language);return d?(this.q([d]),d):null}async j(b,a,f,h){await this.o(a,h);const[d,S,L]=await Promise.all([this.l(a),this.m(b,a),this.k(a,f)]);return(0,T.dedupExtensions)(d,S,L,this.f)}async k(b,a){return a?(await Promise.all(a.map(f=>this.d.scanOneOrMultipleExtensions(D.URI.file((0,w.resolve)(f)),1,{language:b})))).flat().map(f=>(0,g.toExtensionDescription)(f,!0)):[]}async l(b){return(await this.d.scanSystemExtensions({language:b,useCache:!0})).map(f=>(0,g.toExtensionDescription)(f,!1))}async m(b,a){return(await this.d.scanUserExtensions({profileLocation:b,language:a,useCache:!0})).map(h=>(0,g.toExtensionDescription)(h,!1))}async n(b,a,f){const h=D.URI.file((0,w.resolve)(b)),d=a?0:1,S=await this.d.scanExistingExtension(h,d,{language:f});return S?(0,g.toExtensionDescription)(S,!1):null}async o(b,a){if(!(b===R.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(h=>h.id===b)){this.f.trace(`Language Pack ${b} is already installed. Skipping language pack installation.`);return}}catch(f){this.f.error(f)}if(!a){this.f.trace(`No language pack id provided for language ${b}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${a} for language ${b} is not installed. It will be installed now.`);try{await this.b.installExtensions([a],[],{isMachineScoped:!0},!0)}catch(f){this.f.error(f)}}}q(b){const a=(t,n)=>t.replace(/file/g,"vscode-remote"),f=t=>{let n="";return n+=t.global?"g":"",n+=t.ignoreCase?"i":"",n+=t.multiline?"m":"",new RegExp(a(t.source,!0),n)},h=new class{mapDefined(t){return v.ContextKeyDefinedExpr.create(t)}mapNot(t){return v.ContextKeyNotExpr.create(t)}mapEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyEqualsExpr.create(t,a(n,!1)):v.ContextKeyEqualsExpr.create(t,n)}mapNotEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyNotEqualsExpr.create(t,a(n,!1)):v.ContextKeyNotEqualsExpr.create(t,n)}mapGreater(t,n){return v.ContextKeyGreaterExpr.create(t,n)}mapGreaterEquals(t,n){return v.ContextKeyGreaterEqualsExpr.create(t,n)}mapSmaller(t,n){return v.ContextKeySmallerExpr.create(t,n)}mapSmallerEquals(t,n){return v.ContextKeySmallerEqualsExpr.create(t,n)}mapRegex(t,n){return t==="resourceScheme"&&n?v.ContextKeyRegexExpr.create(t,f(n)):v.ContextKeyRegexExpr.create(t,n)}mapIn(t,n){return v.ContextKeyInExpr.create(t,n)}mapNotIn(t,n){return v.ContextKeyNotInExpr.create(t,n)}},d=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const n=v.ContextKeyExpr.deserialize(t.when);if(!n)return;const r=n.map(h);t.when=r.serialize()},S=t=>{if(Array.isArray(t))for(const n of t)d(n);else d(t)},L=t=>{for(const n in t)S(t[n])};b.forEach(t=>{t.contributes&&(t.contributes.menus&&L(t.contributes.menus),t.contributes.keybindings&&S(t.contributes.keybindings),t.contributes.views&&L(t.contributes.views))})}}e.RemoteExtensionsScannerService=y;class m{constructor(b,a){this.a=b,this.b=a}listen(b,a){throw new Error("Invalid listen")}async call(b,a,f){const h=this.b(b);switch(a){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const d=f[0],S=f[1]?D.URI.revive(h.transformIncoming(f[1])):void 0,L=Array.isArray(f[2])?f[2].map(r=>D.URI.revive(h.transformIncoming(r))):void 0,t=f[3];return(await this.a.scanExtensions(d,S,L,t)).map(r=>(0,A.transformOutgoingURIs)(r,h))}case"scanSingleExtension":{const d=await this.a.scanSingleExtension(D.URI.revive(h.transformIncoming(f[0])),f[1],f[2]);return d?(0,A.transformOutgoingURIs)(d,h):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=m}),define(pe[136],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++w.count}}w.count=0,e.ProxyIdentifier=w;const R=[];function o(A){const v=new w(A);return R[v.nid]=v,v}e.createProxyIdentifier=o;function D(A){return R[A].sid}e.getStringIdentifierForProxy=D;class C{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=C}),define(pe[279],ve([1,0,136]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var o;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(o=e.TabInputKind||(e.TabInputKind={}));var D;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var v;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(v=e.CellOutputKind||(e.CellOutputKind={}));var g;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(g=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(a){return a._id=I.a++,a}}I.a=0,e.IdObject=I;var y;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(y=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,w.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,w.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,w.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,w.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization")}});var Ot=this&&this.__classPrivateFieldSet||function(oe,e,w,R,o){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!o:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?o.call(oe,w):o?o.value=w:e.set(oe,w),w},nt=this&&this.__classPrivateFieldGet||function(oe,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!R:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(oe):R?R.value:e.get(oe)};define(pe[280],ve([1,0,8,134,135,21,279,18,12,61,48,95,4,2,5,263,276,15,136,38,96,37,274]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t){"use strict";var n,r,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(O,B,q){n.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),i.set(this,void 0),Ot(this,n,O.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=B,Ot(this,i,q,"f"),Ot(this,r,O.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,le=>{const de=this.c.get(le);return de?.result===u.Void?de:void 0},B),this.f=[{processArgument(le){return(0,g.revive)(le)}},{processArgument(le){return(0,D.cloneAndChange)(le,function(de){if(T.Range.isIRange(de))return o.Range.to(de);if(I.Position.isIPosition(de))return o.Position.to(de);if(T.Range.isIRange(de.range)&&y.URI.isUri(de.uri))return o.location.to(de);if(de instanceof f.VSBuffer)return de.buffer.buffer;if(!Array.isArray(de))return de})}}]}registerArgumentProcessor(O){this.f.push(O)}registerApiCommand(O){const B=this.registerCommand(!1,O.id,async(...q)=>{const le=O.args.map((ue,ae)=>{if(!ue.validate(q[ae]))throw new Error(`Invalid argument '${ue.name}' when running '${O.id}', received: ${q[ae]}`);return ue.convert(q[ae])}),de=await this.executeCommand(O.internalId,...le);return O.result.convert(de,q,this.converter)},void 0,{description:O.description,args:O.args,returns:O.result.description});return this.c.set(O.id,O),new R.Disposable(()=>{B.dispose(),this.c.delete(O.id)})}registerCommand(O,B,q,le,de,ue){if(this.d.trace("ExtHostCommands#registerCommand",B),!B.trim().length)throw new Error("invalid id");if(this.b.has(B))throw new Error(`command '${B}' already exists`);return this.b.set(B,{callback:q,thisArg:le,description:de,extension:ue}),O&&nt(this,n,"f").$registerCommand(B),new R.Disposable(()=>{this.b.delete(B)&&O&&nt(this,n,"f").$unregisterCommand(B)})}executeCommand(O,...B){return this.d.trace("ExtHostCommands#executeCommand",O),this.g(O,B,!0)}async g(O,B,q){if(this.b.has(O))return nt(this,n,"f").$fireCommandActivationEvent(O),this.h(O,B,!1);{let le=!1;const de=(0,D.cloneAndChange)(B,function(ue){if(ue instanceof R.Position)return o.Position.from(ue);if(ue instanceof R.Range)return o.Range.from(ue);if(ue instanceof R.Location)return o.location.from(ue);if(R.NotebookRange.isNotebookRange(ue))return o.NotebookRange.from(ue);if(ue instanceof ArrayBuffer)return le=!0,f.VSBuffer.wrap(new Uint8Array(ue));if(ue instanceof Uint8Array)return le=!0,f.VSBuffer.wrap(ue);if(ue instanceof f.VSBuffer)return le=!0,ue;if(!Array.isArray(ue))return ue});try{const ue=await nt(this,n,"f").$executeCommand(O,le?new h.SerializableObjectWithBuffers(de):de,q);return(0,g.revive)(ue)}catch(ue){if(ue instanceof Error&&ue.message==="$executeCommand:retry")return this.g(O,B,!1);throw ue}}}async h(O,B,q){const le=this.b.get(O);if(!le)throw new Error("Unknown command");const{callback:de,thisArg:ue,description:ae}=le;if(ae)for(let ee=0;ee<ae.args.length;ee++)try{(0,w.validateConstraint)(B[ee],ae.args[ee].constraint)}catch{throw new Error(`Running the contributed command: '${O}' failed. Illegal argument '${ae.args[ee].name}' - ${ae.args[ee].description}`)}const _=S.StopWatch.create();try{return await de.apply(ue,B)}catch(ee){if(O===this.converter.delegatingCommandId){const ne=this.converter.getActualCommand(...B);ne&&(O=ne.command)}if(this.d.error(ee,O,le.extension?.identifier),!q)throw ee;if(le.extension?.identifier){const ne=nt(this,i,"f").onExtensionError(le.extension.identifier,ee);this.d.trace("forwarded error to extension?",ne,le.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.toErrorMessage)(ee)),this.id=O,this.source=le.extension?.displayName??le.extension?.name}}}finally{this.j(le,O,_.elapsed())}}j(O,B,q){!O.extension||nt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:O.extension.identifier.value,id:new L.TelemetryTrustedValue(B),duration:q})}$executeContributedCommand(O,...B){this.d.trace("ExtHostCommands#$executeContributedCommand",O);const q=this.b.get(O);return q?(B=B.map(le=>this.f.reduce((de,ue)=>ue.processArgument(de,q.extension?.identifier),le)),this.h(O,B,!0)):Promise.reject(new Error(`Contributed command '${O}' does not exist.`))}getCommands(O=!1){return this.d.trace("ExtHostCommands#getCommands",O),nt(this,n,"f").$getCommands().then(B=>(O&&(B=B.filter(q=>q[0]!=="_")),B))}$getContributedCommandHandlerDescriptions(){const O=Object.create(null);for(const[B,q]of this.b){const{description:le}=q;le&&(O[B]=le)}return Promise.resolve(O)}};n=new WeakMap,r=new WeakMap,i=new WeakMap,l=Le([Ae(0,b.IExtHostRpcService),Ae(1,v.ILogService),Ae(2,t.IExtHostTelemetry)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class c{constructor(O,B,q){this.d=O,this.f=B,this.g=q,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(O,B){if(!O)return;const q={$ident:void 0,id:O.command,title:O.title,tooltip:O.tooltip};if(!O.command)return q;const le=this.f(O.command);if(le)q.id=le.internalId,q.arguments=le.args.map((de,ue)=>de.convert(O.arguments&&O.arguments[ue]));else if((0,A.isNonEmptyArray)(O.arguments)){const de=`${O.command}/${++this.c}`;this.b.set(de,O),B.add((0,m.toDisposable)(()=>{this.b.delete(de),this.g.trace("CommandsConverter#DISPOSE",de)})),q.$ident=de,q.id=this.delegatingCommandId,q.arguments=[de],this.g.trace("CommandsConverter#CREATE",O.command,de)}return q}fromInternal(O){return typeof O.$ident=="string"?this.b.get(O.$ident):{command:O.id,title:O.title,arguments:O.arguments}}getActualCommand(...O){return this.b.get(O[0])}h(...O){const B=this.getActualCommand(...O);return this.g.trace("CommandsConverter#EXECUTE",O[0],B?B.command:"MISSING"),B?this.d.executeCommand(B.command,...B.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${O[0]}`)}}e.CommandsConverter=c;class s{constructor(O,B,q,le){this.name=O,this.description=B,this.validate=q,this.convert=le}optional(){return new s(this.name,`(optional) ${this.description}`,O=>O==null||this.validate(O),O=>O===void 0?void 0:O===null?null:this.convert(O))}with(O,B){return new s(O??this.name,B??this.description,this.validate,this.convert)}}s.Uri=new s("uri","Uri of a text document",k=>y.URI.isUri(k),k=>k),s.Position=new s("position","A position in a text document",k=>R.Position.isPosition(k),o.Position.from),s.Range=new s("range","A range in a text document",k=>R.Range.isRange(k),o.Range.from),s.Selection=new s("selection","A selection in a text document",k=>R.Selection.isSelection(k),o.Selection.from),s.Number=new s("number","",k=>typeof k=="number",k=>k),s.String=new s("string","",k=>typeof k=="string",k=>k),s.CallHierarchyItem=new s("item","A call hierarchy item",k=>k instanceof R.CallHierarchyItem,o.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",k=>k instanceof R.TypeHierarchyItem,o.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",k=>k instanceof a.TestItemImpl,o.TestItem.from),e.ApiCommandArgument=s;class u{constructor(O,B){this.description=O,this.convert=B}}u.Void=new u("no result",k=>k),e.ApiCommandResult=u;class E{constructor(O,B,q,le,de){this.id=O,this.internalId=B,this.description=q,this.args=le,this.result=de}}e.ApiCommand=E}),define(pe[281],ve([1,0,62,295,32,280,4,12,85]),function(oe,e,w,R,o,D,C,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(y,m,p){this.b=y,this.c=m,this.f=p,this.a=R.createServer((b,a)=>this.h(b,a)),this.g().catch(b=>(m.error(b),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",y=>this.c.error(y))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(y,m){const p=(a,f)=>{m.writeHead(a,{"content-type":"application/json"}),m.end(JSON.stringify(f||null),h=>h&&this.c.error(h))},b=[];y.setEncoding("utf8"),y.on("data",a=>b.push(a)),y.on("end",async()=>{try{const a=JSON.parse(b.join(""));let f;switch(a.type){case"open":f=await this.i(a);break;case"openExternal":f=await this.j(a);break;case"status":f=await this.l(a);break;case"extensionManagement":f=await this.k(a);break;default:p(404,`Unknown message type: ${a.type}`);break}p(200,f)}catch(a){const f=a instanceof Error?a.message:JSON.stringify(a);p(500,f),this.c.error("Error while processing pipe request",a)}})}async i(y){const{fileURIs:m,folderURIs:p,forceNewWindow:b,diffMode:a,mergeMode:f,addMode:h,forceReuseWindow:d,gotoLineMode:S,waitMarkerFilePath:L,remoteAuthority:t}=y,n=[];if(Array.isArray(p))for(const c of p)try{n.push({folderUri:C.URI.parse(c)})}catch{}if(Array.isArray(m))for(const c of m)try{(0,v.hasWorkspaceFileExtension)(c)?n.push({workspaceUri:C.URI.parse(c)}):n.push({fileUri:C.URI.parse(c)})}catch{}const r=L?C.URI.file(L):void 0,l={forceNewWindow:b,diffMode:a,mergeMode:f,addMode:h,gotoLineMode:S,forceReuseWindow:d,preferNewWindow:!d&&!r&&!h,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",n,l),""}async j(y){for(const m of y.uris){const p=C.URI.parse(m),b=p.scheme==="file"?p:m;await this.b.executeCommand("_remoteCLI.openExternal",b)}}async k(y){const m=b=>b?.map(a=>/\.vsix$/i.test(a)?C.URI.parse(a):a),p={list:y.list,install:m(y.install),uninstall:m(y.uninstall),force:y.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(y){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&o.existsSync(this.f)&&o.unlinkSync(this.f)}}e.CLIServerBase=g;let T=class extends g{constructor(y,m){super(y,m,(0,w.createRandomIPCHandle)())}};T=Le([Ae(0,D.IExtHostCommands),Ae(1,A.ILogService)],T),e.CLIServer=T}),define(pe[282],ve([1,0,33,6,21,2,7,3,4,62,69,281,119,84,267,269,133]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class f extends b.AbstractVariableResolverService{constructor(S,L,t,n,r){super({getFolderUri:i=>{const l=L.filter(c=>c.name===i);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>L.length,getConfigurationValue:(i,l)=>n[`config:${l}`],getExecPath:()=>S.VSCODE_EXEC_PATH,getAppRoot:()=>S.VSCODE_CWD,getFilePath:()=>{if(t)return C.normalize(t.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber,getExtension:async i=>{const c=(await r.getInstalled()).find(s=>s.identifier.id===i);return c&&{extensionLocation:c.location}}},void 0,Promise.resolve(w.homedir()),Promise.resolve(S))}}class h extends D.Disposable{constructor(S,L,t,n,r,i){super(),this.g=S,this.h=L,this.i=t,this.j=n,this.l=r,this.m=i,this.a=0,this.b=new Map,this.c=this.B(new R.Emitter),this.onExecuteCommand=this.c.event}async call(S,L,t){switch(L){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,t);case"$createProcess":{const n=(0,T.createURITransformer)(S.remoteAuthority);return this.n(n,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,t)}throw new Error(`IPC Command ${L} not found`)}listen(S,L,t){switch(L){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(S,L){const t={name:L.shellLaunchConfig.name,executable:L.shellLaunchConfig.executable,args:L.shellLaunchConfig.args,cwd:typeof L.shellLaunchConfig.cwd=="string"||typeof L.shellLaunchConfig.cwd>"u"?L.shellLaunchConfig.cwd:v.URI.revive(S.transformIncoming(L.shellLaunchConfig.cwd)),env:L.shellLaunchConfig.env,useShellEnvironment:L.shellLaunchConfig.useShellEnvironment,reconnectionProperties:L.shellLaunchConfig.reconnectionProperties,type:L.shellLaunchConfig.type,isFeatureTerminal:L.shellLaunchConfig.isFeatureTerminal},n=await(0,a.buildUserEnvironment)(L.resolverEnv,!!L.shellLaunchConfig.useShellEnvironment,A.language,this.g,this.h,this.m);this.h.trace("baseEnv",n);const r=ae=>({uri:v.URI.revive(S.transformIncoming(ae.uri)),name:ae.name,index:ae.index,toResource:()=>{throw new Error("Not implemented")}}),i=L.workspaceFolders.map(r),l=L.activeWorkspaceFolder?r(L.activeWorkspaceFolder):void 0,c=L.activeFileResource?v.URI.revive(S.transformIncoming(L.activeFileResource)):void 0,s=new f(n,i,c,L.resolvedVariables,this.l),u=p.createVariableResolver(l,process.env,s),E=await p.getCwd(t,w.homedir(),u,l?.uri,L.configuration["terminal.integrated.cwd"],this.h);t.cwd=E;const k=A.isWindows?"terminal.integrated.env.windows":A.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=L.configuration[k],B=await p.createTerminalEnvironment(t,O,u,this.j.version,L.configuration["terminal.integrated.detectLocale"],n);if(!t.strictEnv){const ae=[];for(const[ne,te]of L.envVariableCollections)ae.push([ne,{map:(0,m.deserializeEnvironmentVariableCollection)(te)}]);const _=new Map(ae);await new y.MergedEnvironmentVariableCollection(_).applyToProcessEnvironment(B,u)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:E,cols:L.cols,rows:L.rows,env:B});const q=(0,g.createRandomIPCHandle)();B.VSCODE_IPC_HOOK_CLI=q;const le=await this.i.createProcess(t,E,L.cols,L.rows,L.unicodeVersion,B,n,L.options,L.shouldPersistTerminal,L.workspaceId,L.workspaceName),de={executeCommand:(ae,..._)=>this.p(le,ae,_,S)},ue=new I.CLIServerBase(de,this.h,q);return this.i.onProcessExit(ae=>ae.id===le&&ue.dispose()),{persistentTerminalId:le,resolvedShellLaunchConfig:t}}p(S,L,t,n){let r,i;const l=new Promise((u,E)=>{r=u,i=E}),c=++this.a;this.b.set(c,{resolve:r,reject:i,uriTransformer:n});const s=(0,o.cloneAndChange)(t,u=>{if(u&&u.$mid===1)return n.transformOutgoing(u);if(u&&u instanceof v.URI)return n.transformOutgoingURI(u)});return this.c.fire({reqId:c,persistentProcessId:S,commandId:L,commandArgs:s}),l}r(S,L,t){const n=this.b.get(S);if(!n)return;this.b.delete(S);const r=(0,o.cloneAndChange)(t,i=>{if(i&&i.$mid===1)return n.uriTransformer.transformIncoming(i)});L?n.reject(r):n.resolve(r)}s(S){return this.i.getDefaultSystemShell(S)}async t(S,L,t,n){return this.i.getProfiles?.(S,L,t,n)||[]}u(){return{...process.env}}w(S,L){return this.i.getWslPath(S,L)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=h}),define(pe[283],ve([1,0,11,2,13,214]),function(oe,e,w,R,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class C extends D.DiskFileSystemProviderClient{static register(v,g,T){const I=v.getConnection();if(!I)return R.Disposable.None;const y=new R.DisposableStore,m=(async()=>{try{const p=await v.getRawEnvironment();p?g.registerProvider(o.Schemas.vscodeRemote,y.add(new C(p,I))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(p){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,w.getErrorMessage)(p))}})();return y.add(g.onWillActivateFileSystemProvider(p=>{p.scheme===o.Schemas.vscodeRemote&&p.join(m)})),y}constructor(v,g){super(g.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=C}),define(pe[88],ve([1,0,32,14,7,8,23,167,296,297]),function(oe,e,w,R,o,D,C,A,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const T=new RegExp(e.CorruptZipMessage);class I extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=r}}e.ExtractError=I;function y(t){const n=t.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function m(t){if(t instanceof I)return t;let n;return T.test(t.message)&&(n="CorruptZip"),new I(n,t)}function p(t,n,r,i,l,c){const s=o.dirname(n),u=o.join(i,s);if(!u.startsWith(i))return Promise.reject(new Error(A.localize(0,null,n)));const E=o.join(i,n);let k;return c.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(C.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((O,B)=>{if(!c.isCancellationRequested)try{k=(0,w.createWriteStream)(E,{mode:r}),k.once("close",()=>O()),k.once("error",B),t.once("error",B),t.pipe(k)}catch(q){B(q)}}))}function b(t,n,r,i){let l=(0,R.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{l.cancel(),t.close()}),new Promise((s,u)=>{const E=new R.Sequencer,k=O=>{O.isCancellationRequested||(c++,t.readEntry())};t.once("error",u),t.once("close",()=>l.then(()=>{i.isCancellationRequested||t.entryCount===c?s():u(new I("Incomplete",new Error(A.localize(1,null,c,t.entryCount))))},u)),t.readEntry(),t.on("entry",O=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){k(i);return}const B=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(B)){const de=o.join(n,B);l=(0,R.createCancelablePromise)(ue=>C.Promises.mkdir(de,{recursive:!0}).then(()=>k(ue)).then(void 0,u));return}const q=f(t,O),le=y(O);l=(0,R.createCancelablePromise)(de=>E.queue(()=>q.then(ue=>p(ue,B,le,n,r,de).then(()=>k(de)))).then(null,u))})})}function a(t,n=!1){return new Promise((r,i)=>{(0,v.open)(t,n?{lazyEntries:!0}:void 0,(l,c)=>{l?i(m(l)):r((0,D.assertIsDefined)(c))})})}function f(t,n){return new Promise((r,i)=>{t.openReadStream(n,(l,c)=>{l?i(m(l)):r((0,D.assertIsDefined)(c))})})}function h(t,n){return new Promise((r,i)=>{const l=new g.ZipFile;n.forEach(s=>{s.contents?l.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&l.addFile(s.localPath,s.path)}),l.end();const c=(0,w.createWriteStream)(t);l.outputStream.pipe(c),l.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(t))})}e.zip=h;function d(t,n,r={},i){const l=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=a(t,!0);return r.overwrite&&(c=c.then(s=>C.Promises.rm(n).then(()=>s))),c.then(s=>b(s,n,{sourcePathRegex:l},i))}e.extract=d;function S(t,n){return a(t).then(r=>new Promise((i,l)=>{r.on("entry",c=>{c.fileName===n&&f(r,c).then(s=>i(s),s=>l(s))}),r.once("close",()=>l(new Error(A.localize(2,null,n))))}))}function L(t,n){return S(t,n).then(r=>new Promise((i,l)=>{const c=[];r.once("error",l),r.on("data",s=>c.push(s)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=L}),define(pe[284],ve([1,0,14,11,2,13,3,19,51,8,22,23,88,25,24,29,34,79,16,12]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let S=class Ti extends o.Disposable{constructor(t,n,r,i,l,c){super(),this.h=n,this.i=r,this.j=i,this.k=l,this.l=c,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,n,r){await this.g;const i=(0,A.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,c=>this.i.download(t,c,n))}catch(c){throw new b.ExtensionManagementError(c.message,b.ExtensionManagementErrorCode.Download)}let l=!1;if(r&&this.m(t)){const c=await this.n(t);try{l=await this.k.verify(i.fsPath,c.fsPath,this.l.getLevel()===d.LogLevel.Trace)}catch(s){const u=s;if(l=u.code,u.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${u.output}`),l===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||l===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.ExtensionManagementError(y.CorruptZipMessage,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(c)}catch(s){this.l.error(s)}}}return l===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):l===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${l}': ${t.identifier.id}`),{location:i,verificationStatus:l}}m(t){if(!t.isSigned)return!1;const n=this.j.getValue("extensions.verifySignature");return(0,g.isBoolean)(n)?n:!0}async n(t){await this.g;const n=(0,A.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${Ti.c}`);return await this.r(t,n,r=>this.i.downloadSignatureArchive(t,r)),n}async r(t,n,r){if(await this.h.exists(n))return;if(n.scheme!==D.Schemas.file){await r(n);return}const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);await this.h.exists(i)||await r(i);try{await this.t(i,n,Date.now()+2*60*1e3)}catch(l){try{await this.h.del(i)}catch{}if(l.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.l.info(`Rename failed because of ${(0,R.getErrorMessage)(l)}. Deleted the file from downloaded location`,i.path),l}}async delete(t){await this.g,await this.h.del(t)}async t(t,n,r){try{await I.Promises.rename(t.fsPath,n.fsPath)}catch(i){if(C.isWindows&&i&&i.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.t(t,n,r);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],r=[],i=[];for(const s of t.children)if(s.name.endsWith(Ti.c))i.push(s.resource);else{const u=a.ExtensionKey.parse(s.name);u&&r.push([u,s])}const l=(0,a.groupByExtension)(r,([s])=>s),c=[];for(const s of l)s.sort((u,E)=>v.rcompare(u[0].version,E[0].version)),n.push(...s.slice(1).map(u=>u[1].resource)),c.push(s[0][1]);c.sort((s,u)=>s.mtime-u.mtime),n.push(...c.slice(0,Math.max(0,c.length-this.f)).map(s=>s.resource)),n.push(...i),await w.Promises.settled(n.map(s=>(this.l.trace("Deleting from cache",s.path),this.h.del(s))))}}catch(t){this.l.error(t)}}v(t){return this.f?a.ExtensionKey.create(t).toString().toLowerCase():(0,T.generateUuid)()}};S.c=".sigzip",S=Le([Ae(0,p.INativeEnvironmentService),Ae(1,h.IFileService),Ae(2,b.IExtensionGalleryService),Ae(3,m.IConfigurationService),Ae(4,f.IExtensionSignatureVerificationService),Ae(5,d.ILogService)],S),e.ExtensionsDownloader=S}),define(pe[285],ve([1,0,88,179]),function(oe,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function o(D){return(0,w.buffer)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=o}),define(pe[137],ve([1,0,14,15,20,38,11,6,2,27,13,7,3,19,51,8,4,22,23,88,178,78,24,254,29,34,44,55,284,255,285,231,240,76,16,5,12,26,30,35,31]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t,n,r,i,l,c,s,u,E,k,O,B,q,le,de,ue,ae,_,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,le.refineServiceDecorator)(r.IExtensionManagementService);let ne=class extends n.AbstractExtensionManagementService{constructor($,W,N,P,M,Y,ie,z,V,J,H,X){super($,W,N,J,X),this.Z=M,this.ab=Y,this.bb=ie,this.cb=V,this.db=H,this.X=this.B(new A.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new g.ResourceSet;const G=this.B(z.createInstance(u.ExtensionsLifecycle));this.S=this.B(z.createInstance(te,ce=>G.postUninstall(ce))),this.U=this.B(new k.ExtensionsManifestCache(X,V,H,this,this.v)),this.W=this.B(z.createInstance(s.ExtensionsDownloader));const Q=this.B(new O.ExtensionsWatcher(this,this.Z,X,Y,H,V,N));this.B(Q.onDidChangeExtensionsByAnotherSource(ce=>this.kb(ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip($){this.v.trace("ExtensionManagementService#zip",$.identifier.id);const W=await this.jb($),N=await(0,d.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,W);return a.URI.file(N)}async unzip($){return this.v.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const{location:W,cleanup:N}=await this.fb($),P=I.resolve(W.fsPath);try{return await(0,E.getManifest)(P)}finally{await N()}}getInstalled($,W=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions($??null,W)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation($){return this.S.scanUserExtensionAtLocation($)}async install($,W={}){this.v.trace("ExtensionManagementService#install",$.toString());const{location:N,cleanup:P}=await this.fb($);try{const M=await(0,E.getManifest)(I.resolve(N.fsPath));if(M.engines&&M.engines.vscode&&!(0,B.isEngineValid)(M.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,i.getGalleryExtensionId)(M.publisher,M.name),this.w.version));return await this.z(M,N,W)}finally{await P()}}async installFromLocation($,W){this.v.trace("ExtensionManagementService#installFromLocation",$.toString());const N=await this.S.scanUserExtensionAtLocation($);if(!N)throw new Error(`Cannot find a valid extension from the location ${$.toString()}`);return await this.ob([[N,void 0]],W),this.v.info("Successfully installed extension",N.identifier.id,W.toString()),N}async installExtensionsFromProfile($,W,N){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",$,W.toString(),N.toString());const P=(await this.S.scanExtensions(1,W)).filter(M=>$.some(Y=>(0,i.areSameExtensions)(Y,M.identifier)));if(P.length){const M=await Promise.all(P.map(Y=>this.S.scanMetadata(Y,W)));await this.ob(P.map((Y,ie)=>[Y,M[ie]]),N),this.v.info("Successfully installed extensions",P.map(Y=>Y.identifier.id),N.toString())}return P}async updateMetadata($,W,N=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",$.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0),W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.pinned=W.pinned||void 0,$=await this.S.updateMetadata($,W,N),this.U.invalidate(N),this.X.fire($),$}async reinstallFromGallery($){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",$.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const W=await this.getTargetPlatform(),[N]=await this.t.getExtensions([{...$.identifier,preRelease:$.preRelease}],{targetPlatform:W,compatible:!0},o.CancellationToken.None);if(!N)throw new Error(S.localize(2,null));await this.S.setUninstalled($);try{await this.S.removeUninstalledExtension($)}catch(P){throw new Error(S.localize(3,null,(0,D.toErrorMessage)(P)))}return this.installFromGallery(N)}copyExtensions($,W){return this.S.copyExtensions($,W)}markAsUninstalled(...$){return this.S.setUninstalled(...$)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch($){this.v.error($)}}async download($,W,N){const{location:P}=await this.W.download($,W,!N);return P}async fb($){if($.scheme===T.Schemas.file)return{location:$,async cleanup(){}};this.v.trace("Downloading extension from",$.toString());const W=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download($,W),this.v.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.cb.del(W)}catch(P){this.v.error(P)}}}}P(){return this.y.defaultProfile.extensionsResource}Q($,W,N){if(a.URI.isUri(W))return new Z($,W,N,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const P=i.ExtensionKey.create(W).toString();let M=this.Y.get(P);return M||(this.Y.set(P,M=new U($,W,N,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),M.waitUntilTaskIsFinished().finally(()=>this.Y.delete(P))),M}R($,W){return new re($,W.profileLocation,this.ab)}async jb($){const W=async P=>{let M=await h.Promises.readdir(P);M=M.map(z=>I.join(P,z));const Y=await Promise.all(M.map(z=>h.Promises.stat(z)));let ie=Promise.resolve([]);return Y.forEach((z,V)=>{const J=M[V];z.isFile()&&(ie=ie.then(H=>[...H,J])),z.isDirectory()&&(ie=ie.then(H=>W(J).then(X=>[...H,...X])))}),ie};return(await W($.location.fsPath)).map(P=>({path:`extension/${I.relative($.location.fsPath,P)}`,localPath:P}))}async kb({added:$,removed:W}){if(W)for(const N of W.extensions)this.v.info("Extensions removed from another source",N.id,W.profileLocation.toString()),this.p.fire({identifier:N,profileLocation:W.profileLocation});if($){const P=(await this.S.scanExtensions(1,$.profileLocation)).filter(M=>$.extensions.some(Y=>(0,i.areSameExtensions)(Y,M.identifier)));this.m.fire(P.map(M=>(this.v.info("Extensions added from another source",M.identifier.id,$.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:$.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(W=>this.lb.add(W)));const $=await this.cb.resolve(this.Z.userExtensionsLocation);for(const W of $.children??[])W.isDirectory&&this.lb.add(W.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(W=>this.nb(W)))}async nb($){if(!$.affects(this.Z.userExtensionsLocation,1))return;const W=[];for(const N of $.rawAdded){if(this.lb.has(N)||!this.db.extUri.isEqual(this.db.extUri.dirname(N),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(N,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(N).startsWith(".")||!(await this.cb.stat(N)).isDirectory)continue;const P=await this.S.scanUserExtensionAtLocation(N);P&&P.installedTimestamp===void 0&&(this.lb.add(N),W.push(P))}W.length&&(await this.ob(W.map(N=>[N,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",W.map(N=>N.identifier.id)))}async ob($,W){const N=$.map(P=>P[0]);await this.pb(N),await this.ab.addExtensionsToProfile($,W),this.m.fire(N.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:W})))}async pb($){const W=await this.S.getUninstalledExtensions();for(const N of $){const P=i.ExtensionKey.create(N);!W[P.toString()]||(this.v.trace("Removing the extension from uninstalled list:",P.id),await this.S.setInstalled(P),this.v.info("Removed the extension from uninstalled list:",P.id))}}};ne=Le([Ae(0,r.IExtensionGalleryService),Ae(1,ae.ITelemetryService),Ae(2,de.ILogService),Ae(3,t.INativeEnvironmentService),Ae(4,c.IExtensionsScannerService),Ae(5,l.IExtensionsProfileScannerService),Ae(6,L.IDownloadService),Ae(7,le.IInstantiationService),Ae(8,q.IFileService),Ae(9,ue.IProductService),Ae(10,_.IUriIdentityService),Ae(11,ee.IUserDataProfilesService)],ne),e.ExtensionManagementService=ne;let te=class extends v.Disposable{constructor($,W,N,P,M,Y){super(),this.k=$,this.l=W,this.m=N,this.n=P,this.p=M,this.s=Y,this.h=this.B(new A.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,m.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new w.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions($,W){const N={includeInvalid:!0,profileLocation:W};let P=[];return $===null||$===0?P.push(...await this.m.scanAllExtensions({includeInvalid:!0},N,!1)):$===1&&P.push(...await this.m.scanUserExtensions(N)),P=$!==null?P.filter(M=>M.type===$):P,Promise.all(P.map(M=>this.y(M)))}async scanAllUserExtensions($){const W=await this.m.scanUserExtensions({includeAllVersions:!$,includeInvalid:!0});return Promise.all(W.map(N=>this.y(N)))}async scanUserExtensionAtLocation($){try{const W=await this.m.scanExistingExtension($,1,{includeInvalid:!0});if(W)return await this.y(W)}catch(W){this.s.error(W)}return null}async extractUserExtension($,W,N,P){await this.j.catch(()=>{});const M=$.toString(),Y=I.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),ie=I.join(this.m.userExtensionsLocation.fsPath,M);try{await h.Promises.rm(ie)}catch{throw new r.ExtensionManagementError(S.localize(4,null,ie,$.id),r.ExtensionManagementErrorCode.Delete)}await this.u($,W,Y,P),await this.m.updateMetadata(a.URI.file(Y),N);try{this.h.fire(a.URI.file(ie)),await this.v($,Y,ie,Date.now()+2*60*1e3),this.s.info("Renamed to",ie)}catch(z){try{await h.Promises.rm(Y)}catch{}if(z.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",$.id);else throw this.s.info(`Rename failed because of ${(0,C.getErrorMessage)(z)}. Deleted from extracted location`,Y),z}return this.w(a.URI.file(ie),1)}async scanMetadata($,W){return W?(await this.n.scanProfileExtensions(W)).find(P=>(0,i.areSameExtensions)(P.identifier,$.identifier))?.metadata:this.m.scanMetadata($.location)}async updateMetadata($,W,N){return N?await this.n.updateMetadata([[$,W]],N):await this.m.updateMetadata($.location,W),this.w($.location,$.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...$){const W=$.map(N=>i.ExtensionKey.create(N));await this.t(N=>W.forEach(P=>{N[P.toString()]=!0,this.s.info("Marked extension as uninstalled",P.toString())}))}async setInstalled($){await this.t(W=>delete W[$.toString()])}async removeExtension($,W){this.s.trace(`Deleting ${W} extension from disk`,$.identifier.id,$.location.fsPath);const N=this.p.extUri.joinPath(this.p.extUri.dirname($.location),`.${(0,f.generateUuid)()}`);await this.v($.identifier,$.location.fsPath,N.fsPath,Date.now()+2*60*1e3),await this.l.del(N,{recursive:!0}),this.s.info("Deleted from disk",$.identifier.id,$.location.fsPath)}async removeUninstalledExtension($){await this.removeExtension($,"uninstalled"),await this.t(W=>delete W[i.ExtensionKey.create($).toString()])}async copyExtensions($,W){const N=await this.scanExtensions(1,$),P=await Promise.all(N.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,$)]));await this.n.addExtensionsToProfile(P,W)}async t($){return this.g.queue(async()=>{let W;try{W=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,q.toFileOperationResult)(P)!==1)throw P}let N={};if(W)try{N=JSON.parse(W)}catch{}return $&&($(N),Object.keys(N).length?await this.l.writeFile(this.c,R.VSBuffer.fromString(JSON.stringify(N))):await this.l.del(this.c)),N})}async u($,W,N,P){this.s.trace(`Started extracting the extension from ${W} to ${N}`);try{await h.Promises.rm(N)}catch(M){throw new r.ExtensionManagementError(this.D(M).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(W,N,{sourcePath:"extension",overwrite:!0},P),this.s.info(`Extracted extension to ${N}:`,$.id)}catch(M){try{await h.Promises.rm(N)}catch{}let Y=r.ExtensionManagementErrorCode.Extract;throw M instanceof d.ExtractError&&(M.type==="CorruptZip"?Y=r.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(Y=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(M.message,Y)}}async v($,W,N,P){try{await h.Promises.rename(W,N)}catch(M){if(y.isWindows&&M&&M.code==="EPERM"&&Date.now()<P)return this.s.info(`Failed renaming ${W} to ${N} with 'EPERM' error. Trying again...`,$.id),this.v($,W,N,P);throw new r.ExtensionManagementError(M.message||S.localize(5,null,W,N),M.code||r.ExtensionManagementErrorCode.Rename)}}async w($,W){const N=await this.m.scanExistingExtension($,W,{includeInvalid:!0});if(N)return this.y(N);throw new Error(S.localize(6,null,$.path))}async y($){const W=await this.l.resolve($.location);let N,P;return W.children&&(N=W.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=W.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:$.identifier,type:$.type,isBuiltin:$.isBuiltin||!!$.metadata?.isBuiltin,location:$.location,manifest:$.manifest,targetPlatform:$.targetPlatform,validations:$.validations,isValid:$.isValid,readmeUrl:N,changelogUrl:P,publisherDisplayName:$.metadata?.publisherDisplayName||null,publisherId:$.metadata?.publisherId||null,isApplicationScoped:!!$.metadata?.isApplicationScoped,isMachineScoped:!!$.metadata?.isMachineScoped,isPreReleaseVersion:!!$.metadata?.isPreReleaseVersion,preRelease:!!$.metadata?.preRelease,installedTimestamp:$.metadata?.installedTimestamp,updated:!!$.metadata?.updated,pinned:!!$.metadata?.pinned}}async z(){const $=await this.getUninstalledExtensions();if(Object.keys($).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys($));const W=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const M of W)$[i.ExtensionKey.create(M).toString()]||N.add(M.identifier.id.toLowerCase());try{const M=(0,i.groupByExtension)(W,Y=>Y.identifier);await w.Promises.settled(M.map(async Y=>{const ie=Y.sort((z,V)=>p.rcompare(z.manifest.version,V.manifest.version))[0];N.has(ie.identifier.id.toLowerCase())||await this.k(await this.y(ie))}))}catch(M){this.s.error(M)}const P=W.filter(M=>M.metadata&&$[i.ExtensionKey.create(M).toString()]);await Promise.allSettled(P.map(M=>this.removeUninstalledExtension(M)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const $=[];let W;try{W=await this.l.resolve(this.m.userExtensionsLocation)}catch(N){(0,q.toFileOperationResult)(N)!==1&&this.s.error(N)}for(const N of W?.children??[])N.isDirectory&&N.name.startsWith(".")&&(0,f.isUUID)(N.name.substring(1))&&$.push((async()=>{this.s.trace("Deleting the generated extension folder",N.resource.toString());try{await this.l.del(N.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",N.resource.toString())}catch(P){this.s.error(P)}})());await Promise.allSettled($)}D($){const W=Array.isArray($)?$:[$];return W.length===1?W[0]instanceof Error?W[0]:new Error(W[0]):W.reduce((N,P)=>new Error(`${N.message}${N.message?",":""}${P instanceof Error?P.message:P}`),new Error(""))}};te=Le([Ae(1,q.IFileService),Ae(2,c.IExtensionsScannerService),Ae(3,l.IExtensionsProfileScannerService),Ae(4,_.IUriIdentityService),Ae(5,de.ILogService)],te),e.ExtensionsScanner=te;class x extends n.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor($,W,N,P,M,Y,ie,z,V){super(),this.identifier=$,this.source=W,this.m=N,this.n=P,this.o=M,this.p=Y,this.q=ie,this.s=z,this.t=V,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h($){const[W,N]=await this.y($);return this.j=W.isBuiltin||W.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[W,N]],this.j),W}async v({zipPath:$,key:W,metadata:N},P){let M=await this.w(W);return M||(this.t.trace("Extracting extension...",W.id),M=await this.n.extractUserExtension(W,$,N,P),this.t.info("Extracting extension completed.",W.id)),M}async w($){return await this.x($)?(this.t.trace("Removing the extension from uninstalled list:",$.id),await this.n.setInstalled($),this.t.info("Removed the extension from uninstalled list:",$.id),(await this.n.scanAllUserExtensions(!0)).find(P=>i.ExtensionKey.create(P).equals($))):void 0}async x($){return!!(await this.n.getUninstalledExtensions())[$.toString()]}}class U extends x{constructor($,W,N,P,M,Y,ie,z,V,J){super(W.identifier,W,N,M,Y,ie,z,V,J),this.z=W,this.A=P}async y($){const N=(await this.n.scanExtensions(null,this.m.profileLocation)).find(ie=>(0,i.areSameExtensions)(ie.identifier,this.z.identifier));N&&(this.l=3);const P={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||N?.isMachineScoped,isBuiltin:this.m.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,b.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.z.version)return[await this.n.updateMetadata(N,P),P];const{location:M,verificationStatus:Y}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=Y,this.C(M.fsPath),[await this.v({zipPath:M.fsPath,key:i.ExtensionKey.create(this.z),metadata:P},$),P]}catch(ie){try{await this.A.delete(M)}catch(z){this.t.warn("Error while deleting the downloaded file",M.toString(),(0,C.getErrorMessage)(z))}throw ie}}async C($){try{await(0,E.getManifest)($)}catch(W){throw new r.ExtensionManagementError((0,n.joinErrors)(W).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class Z extends x{constructor($,W,N,P,M,Y,ie,z,V,J){super({id:(0,i.getGalleryExtensionId)($.publisher,$.name)},W,N,M,Y,ie,z,V,J),this.z=$,this.A=W,this.B=P}async h($){const W=await super.h($);return this.E(W,$),W}async y($){const W=new i.ExtensionKey(this.identifier,this.z.version),P=(await this.n.scanExtensions(1,this.m.profileLocation)).find(ie=>(0,i.areSameExtensions)(this.identifier,ie.identifier)),M={isApplicationScoped:this.m.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||P?.isMachineScoped,isBuiltin:this.m.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(P)if(this.l=3,W.equals(new i.ExtensionKey(P.identifier,P.manifest.version)))try{await this.n.removeExtension(P,"existing")}catch{throw new Error(S.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&p.gt(P.manifest.version,this.z.version)&&await this.n.setUninstalled(P);else{const ie=await this.w(W);if(ie)try{await this.n.removeExtension(ie,"existing")}catch{throw new Error(S.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:I.resolve(this.A.fsPath),key:W,metadata:M},$),M]}async E($,W){try{let[N]=await this.B.getExtensions([{id:$.identifier.id,version:$.manifest.version}],W);if(N||([N]=await this.B.getExtensions([{id:$.identifier.id}],W)),N){const P={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata($,P,this.m.profileLocation)}}catch{}}}class re extends n.AbstractExtensionTask{constructor($,W,N){super(),this.extension=$,this.j=W,this.k=N}async h($){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[138],ve([1,0,82,14,15,11,8,25,24,83,12,43,234,298]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let p=class extends I.AbstractRequestService{constructor(h,d,S,L){super(!!d.isRemoteServer,L),this.j=h,this.k=d,this.l=S,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,d){const{f:S,g:L}=this;let t;try{t=await(0,g.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,D.getErrorMessage)(i)))}const n={...process.env,...t},r=h.agent?h.agent:await(0,y.getProxyAgent)(h.url||"",n,{proxyUrl:S,strictSSL:L});return h.agent=r,h.strictSSL=L,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>a(h,d))}async resolveProxy(h){}};p=Le([Ae(0,A.IConfigurationService),Ae(1,v.INativeEnvironmentService),Ae(2,T.ILogService),Ae(3,T.ILoggerService)],p),e.RequestService=p;async function b(f){return((0,w.parse)(f.url).protocol==="https:"?await new Promise((S,L)=>{oe(["https"],S,L)}):await new Promise((S,L)=>{oe(["http"],S,L)})).request}async function a(f,h){return R.Promises.withAsyncBody(async(d,S)=>{const L=(0,w.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await b(f),n={hostname:L.hostname,port:L.port?parseInt(L.port):L.protocol==="https:"?443:80,protocol:L.protocol,path:L.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,C.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(n.auth=f.user+":"+f.password);const r=t(n,i=>{const l=(0,C.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&l>0&&i.headers.location)a({...f,url:i.headers.location,followRedirects:l-1},h).then(d,S);else{let c=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,m.createGunzip)())),d({res:i,stream:(0,o.streamToBufferReadableStream)(c)})}});r.on("error",S),f.timeout&&r.setTimeout(f.timeout),f.isChromiumNetwork&&r.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&r.write(f.data),r.end(),h.onCancellationRequested(()=>{r.abort(),S(new D.CancellationError)})})}e.nodeRequest=a}),define(pe[286],ve([1,0,80,12,64,112,25,43,138,37,30,29,123,137,79,106,52,2,107,67,13,16,26,45,115,81,116,11,4,7,28,232,78,35,121,63,3,55,127,31,44,68,124,122,109,110,194]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t,n,r,i,l,c,s,u,E,k,O,B,q,le,de,ue,ae,_,ee,ne,te,x,U,Z,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class me extends f.Disposable{constructor(P,M){super(),this.a=P,this.b=M,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const P=await this.f();await P.invokeFunction(async M=>{const Y=M.get(R.ILogService);try{await this.g(P.createInstance(r.ExtensionManagementCLI,new R.ConsoleLogger(Y.getLevel(),!1)))}catch(ie){throw Y.error(ie),console.error((0,c.getErrorMessage)(ie)),ie}})}async f(){const P=new w.ServiceCollection,M={_serviceBrand:void 0,...a.default};P.set(t.IProductService,M);const Y=new n.ServerEnvironmentService(this.a,M);P.set(n.IServerEnvironmentService,Y);const ie=new Z.LoggerService((0,R.getLogLevel)(Y),Y.logsHome);P.set(R.ILoggerService,ie);const z=new U.LogService(this.B(ie.createLogger("remoteCLI",{name:(0,re.localize)(0,null)})));P.set(R.ILogService,z),z.trace(`Remote configuration data at ${this.b}`),z.trace("process arguments:",this.a);const V=this.B(new h.FileService(z));P.set(L.IFileService,V),V.registerProvider(S.Schemas.file,this.B(new d.DiskFileSystemProvider(z)));const J=new q.UriIdentityService(V);P.set(B.IUriIdentityService,J);const H=this.B(new te.ServerUserDataProfilesService(J,Y,V,z));P.set(_.IUserDataProfilesService,H);const X=this.B(new D.ConfigurationService(H.defaultProfile.settingsResource,V,new ne.NullPolicyService,z));return P.set(C.IConfigurationService,X),await Promise.all([X.initialize(),H.init()]),P.set(A.IRequestService,new o.SyncDescriptor(v.RequestService)),P.set(O.IDownloadService,new o.SyncDescriptor(k.DownloadService)),P.set(T.ITelemetryService,g.NullTelemetryService),P.set(I.IExtensionGalleryService,new o.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService)),P.set(ee.IExtensionsProfileScannerService,new o.SyncDescriptor(x.ExtensionsProfileScannerService)),P.set(ue.IExtensionsScannerService,new o.SyncDescriptor(ae.ExtensionsScannerService)),P.set(p.IExtensionSignatureVerificationService,new o.SyncDescriptor(p.ExtensionSignatureVerificationService)),P.set(m.INativeServerExtensionManagementService,new o.SyncDescriptor(m.ExtensionManagementService)),P.set(i.ILanguagePackService,new o.SyncDescriptor(l.NativeLanguagePackService)),new b.InstantiationService(P)}async g(P){if(this.a["list-extensions"])return P.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const M={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return P.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),M,!!this.a.force)}else{if(this.a["uninstall-extension"])return P.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return P.locateExtension(this.a["locate-extension"])}}h(P){return P.map(M=>/\.vsix$/i.test(M)?s.URI.file((0,u.isAbsolute)(M)?M:(0,u.join)((0,E.cwd)(),M)):M)}}function $(N){setTimeout(()=>process.exit(N),0)}async function W(N,P,M){if(N.help){const ie=a.default.serverApplicationName+(de.isWindows?".cmd":"");console.log((0,le.buildHelpMessage)(a.default.nameLong,ie,a.default.version,M,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,le.buildVersionMessage)(a.default.version,a.default.commit));return}const Y=new me(N,P);try{await Y.run(),$(0)}catch{$(1)}finally{Y.dispose()}}e.run=W}),define(pe[287],ve([1,0,33,6,2,13,7,98,23,42,25,112,77,226,202,78,203,212,221,24,123,29,79,115,213,137,16,107,67,64,106,80,81,116,12,52,26,43,233,138,114,30,37,246,120,253,35,121,264,265,238,244,282,69,45,271,283,125,55,127,44,31,68,245,110,124,122,109,108,196,278,229,257]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t,n,r,i,l,c,s,u,E,k,O,B,q,le,de,ue,ae,_,ee,ne,te,x,U,Z,re,me,$,W,N,P,M,Y,ie,z,V,J,H,X,G,Q,ce,Ee,De,ke,Ue,$e,ge,Se,ye,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const _e="monacoworkbench";async function He(Ne,Re,ze,qe){const Ve=new k.ServiceCollection,Ge=new et,Xe={_serviceBrand:void 0,...le.default};Ve.set(de.IProductService,Xe);const Ye=new ie.ServerEnvironmentService(Re,Xe);Ve.set(d.IEnvironmentService,Ye),Ve.set(d.INativeEnvironmentService,Ye);const st=new De.LoggerService((0,q.getLogLevel)(Ye),Ye.logsHome);Ve.set(q.ILoggerService,st),Ge.registerChannel("logger",new ge.LoggerChannel(st,rt=>Qe(rt.remoteAuthority)));const ct=st.createLogger("remoteagent",{name:(0,Se.localize)(0,null)}),ot=new $e.LogService(ct,[new Ke((0,q.getLogLevel)(Ye))]);Ve.set(q.ILogService,ot),setTimeout(()=>Te(Ye.logsHome.fsPath).then(null,rt=>ot.error(rt)),1e4),ot.onDidChangeLogLevel(rt=>(0,q.log)(ot,rt,`Log level changed to ${(0,q.LogLevelToString)(ot.getLevel())}`)),ot.trace(`Remote configuration data at ${ze}`),ot.trace("process arguments:",Ye.args),Array.isArray(Xe.serverGreeting)&&ot.info(`

${Xe.serverGreeting.join(`
`)}

`),Ge.registerChannel(p.ExtensionHostDebugBroadcastChannel.ChannelName,new p.ExtensionHostDebugBroadcastChannel);const Nt=new g.StaticRouter(rt=>rt.clientId==="renderer"),wt=qe.add(new c.FileService(ot));Ve.set(l.IFileService,wt),wt.registerProvider(D.Schemas.file,qe.add(new s.DiskFileSystemProvider(ot)));const Ut=new me.UriIdentityService(wt);Ve.set(re.IUriIdentityService,Ut);const St=new I.ConfigurationService(Ye.machineSettingsResource,wt,new ce.NullPolicyService,ot);Ve.set(T.IConfigurationService,St);const vt=new ke.ServerUserDataProfilesService(Ut,Ye,wt,ot);Ve.set(Q.IUserDataProfilesService,vt),Ge.registerChannel("userDataProfiles",new Fe.RemoteUserDataProfilesServiceChannel(vt,rt=>Qe(rt.remoteAuthority)));const[,,It]=await Promise.all([St.initialize(),vt.init(),(0,A.getMachineId)(ot.error.bind(ot))]),kt=new J.ExtensionHostStatusService;Ve.set(J.IExtensionHostStatusService,kt),Ve.set(ue.IRequestService,new u.SyncDescriptor(_.RequestService));let At=te.NullAppender;const Bt=(0,te.isInternalTelemetry)(Xe,St);if((0,te.supportsTelemetry)(Xe,Ye)){Xe.aiConfig&&Xe.aiConfig.ariaKey&&(At=new Ee.OneDataSystemAppender(Bt,_e,null,Xe.aiConfig.ariaKey),qe.add((0,o.toDisposable)(()=>At?.flush())));const rt={appenders:[At],commonProperties:(0,ee.resolveCommonProperties)((0,w.release)(),(0,w.hostname)(),process.arch,Xe.commit,Xe.version+"-remote",It,Bt,"remoteAgent"),piiPaths:(0,te.getPiiPathsFromEnvironment)(Ye)},ft=Ye.args["telemetry-level"];let dt=3;ft==="all"?dt=3:ft==="error"?dt=2:ft==="crash"?dt=1:ft!==void 0&&(dt=0),Ve.set(P.IServerTelemetryService,new u.SyncDescriptor(P.ServerTelemetryService,[rt,dt]))}else Ve.set(P.IServerTelemetryService,P.ServerNullTelemetryService);Ve.set(L.IExtensionGalleryService,new u.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService));const Ft=Ge.getChannel("download",Nt);Ve.set(b.IDownloadService,new a.DownloadServiceChannelClient(Ft,()=>Qe("renderer"))),Ve.set(G.IExtensionsProfileScannerService,new u.SyncDescriptor(Ue.ExtensionsProfileScannerService)),Ve.set(H.IExtensionsScannerService,new u.SyncDescriptor(X.ExtensionsScannerService)),Ve.set(t.IExtensionSignatureVerificationService,new u.SyncDescriptor(t.ExtensionSignatureVerificationService)),Ve.set(i.INativeServerExtensionManagementService,new u.SyncDescriptor(i.ExtensionManagementService));const ht=new E.InstantiationService(Ve);Ve.set(O.ILanguagePackService,ht.createInstance(B.NativeLanguagePackService));const Tt=ht.createInstance(Z.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:St.getValue("terminal.integrated.persistentSessionScrollback")??100},!0);return Ve.set(U.IPtyService,Tt),Ve.set(f.IEncryptionMainService,new u.SyncDescriptor(h.EncryptionMainService,[It])),Ve.set(y.ICredentialsMainService,new u.SyncDescriptor(m.CredentialsWebMainService)),ht.invokeFunction(rt=>{const ft=rt.get(i.INativeServerExtensionManagementService),dt=rt.get(H.IExtensionsScannerService),$t=rt.get(L.IExtensionGalleryService),we=rt.get(O.ILanguagePackService),Ie=new $.RemoteAgentEnvironmentChannel(Ne,Ye,vt,kt);Ge.registerChannel("remoteextensionsenvironment",Ie);const fe=new N.ServerTelemetryChannel(rt.get(P.IServerTelemetryService),At);Ge.registerChannel("telemetry",fe),Ge.registerChannel(z.REMOTE_TERMINAL_CHANNEL_NAME,new M.RemoteTerminalChannel(Ye,ot,Tt,Xe,ft,St));const K=new ye.RemoteExtensionsScannerService(ht.createInstance(n.ExtensionManagementCLI,ot),Ye,vt,dt,ot,$t,we);Ge.registerChannel(Me.RemoteExtensionsScannerChannelName,new ye.RemoteExtensionsScannerChannel(K,tt=>Qe(tt.remoteAuthority)));const Pe=new W.RemoteAgentFileSystemProviderChannel(ot,Ye);Ge.registerChannel(V.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Pe),Ge.registerChannel("request",new ae.RequestChannel(rt.get(ue.IRequestService)));const Oe=new r.ExtensionManagementChannel(ft,tt=>Qe(tt.remoteAuthority));Ge.registerChannel("extensions",Oe);const xe=g.ProxyChannel.fromService(rt.get(f.IEncryptionMainService));Ge.registerChannel("encryption",xe);const je=g.ProxyChannel.fromService(rt.get(y.ICredentialsMainService));return Ge.registerChannel("credentials",je),K.whenExtensionsReady().then(()=>ft.cleanUp()),qe.add(new x.default(rt.get(ne.ITelemetryService))),{telemetryService:rt.get(ne.ITelemetryService)}}),{socketServer:Ge,instantiationService:ht}}e.setupServerServices=He;const Je=Object.create(null);function Qe(Ne){return Je[Ne]||(Je[Ne]=(0,Y.createURITransformer)(Ne)),Je[Ne]}class et extends g.IPCServer{constructor(){const Re=new R.Emitter;super(Re.event),this.b=Re}acceptConnection(Re,ze){this.b.fire({protocol:Re,onDidClientDisconnect:ze})}}e.SocketServer=et;class Ke extends q.AbstractLogger{constructor(Re=q.DEFAULT_LOG_LEVEL){super(),this.setLevel(Re),this.g=Boolean(process.stdout.isTTY)}trace(Re,...ze){this.f(q.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${he()}]\x1B[0m`,Re,...ze):console.log(`[${he()}]`,Re,...ze))}debug(Re,...ze){this.f(q.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${he()}]\x1B[0m`,Re,...ze):console.log(`[${he()}]`,Re,...ze))}info(Re,...ze){this.f(q.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${he()}]\x1B[0m`,Re,...ze):console.log(`[${he()}]`,Re,...ze))}warn(Re,...ze){this.f(q.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${he()}]\x1B[0m`,Re,...ze):console.warn(`[${he()}]`,Re,...ze))}error(Re,...ze){this.f(q.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${he()}]\x1B[0m`,Re,...ze):console.error(`[${he()}]`,Re,...ze))}dispose(){}flush(){}}function he(){const Ne=new Date;return`${Ce(Ne.getHours())}:${Ce(Ne.getMinutes())}:${Ce(Ne.getSeconds())}`}function Ce(Ne){return Ne<10?`0${Ne}`:String(Ne)}async function Te(Ne){const Re=C.basename(Ne),ze=C.dirname(Ne),Ge=(await v.Promises.readdir(ze)).filter(Ye=>/^\d{8}T\d{6}$/.test(Ye)).sort().filter(Ye=>Ye!==Re),Xe=Ge.slice(0,Math.max(0,Ge.length-9));await Promise.all(Xe.map(Ye=>v.Promises.rm(C.join(ze,Ye))))}}),define(pe[288],ve([1,0,117,32,94,289,82,139,15,11,39,2,13,7,41,3,17,4,22,148,102,62,5,12,26,54,30,133,258,259,45,287,261]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y,m,p,b,a,f,h,d,S,L,t,n,r,i,l,c,s,u,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const B=5*60*1e3;let q=class extends I.Disposable{constructor(ae,_,ee,ne,te,x,U,Z){super(),this.k=ae,this.l=_,this.m=ee,this.n=te,this.p=x,this.r=U,this.s=Z,this.h=de.create(this.p),this.i=(0,i.getRemoteServerRootPath)(x),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ne?this.s.createInstance(O.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(ae,_){if(ae.method!=="GET")return(0,O.serveError)(ae,_,405,`Unsupported method ${ae.method}`);if(!ae.url)return(0,O.serveError)(ae,_,400,"Bad request.");const ee=C.parse(ae.url,!0);let ne=ee.pathname;if(!ne)return(0,O.serveError)(ae,_,400,"Bad request.");if(ne.startsWith(this.i)&&ne.charCodeAt(this.i.length)===47&&(ne=ne.substring(this.i.length)),ne==="/version")return _.writeHead(200,{"Content-Type":"text/plain"}),void _.end(this.p.commit||"");if(ne==="/delay-shutdown")return this.H(),_.writeHead(200),void _.end("OK");if(!(0,u.requestHasValidConnectionToken)(this.l,ae,ee))return(0,O.serveError)(ae,_,403,"Forbidden.");if(ne==="/vscode-remote-resource"){const te=ee.query.path;if(typeof te!="string")return(0,O.serveError)(ae,_,400,"Bad request.");let x;try{x=f.URI.from({scheme:y.Schemas.file,path:te}).fsPath}catch{return(0,O.serveError)(ae,_,400,"Bad request.")}const U=Object.create(null);this.n.isBuilt&&((0,T.isEqualOrParent)(x,this.n.builtinExtensionsPath,!b.isLinux)||(0,T.isEqualOrParent)(x,this.n.extensionsPath,!b.isLinux))&&(U["Cache-Control"]="public, max-age=31536000"),U.Vary="Origin";const Z=ae.headers.origin;return Z&&this.h.matches(Z)&&(U["Access-Control-Allow-Origin"]=Z),(0,O.serveFile)(x,1,this.r,ae,_,U)}if(this.g){this.g.handle(ae,_,ee);return}return _.writeHead(404,{"Content-Type":"text/plain"}),void _.end("Not found")}handleUpgrade(ae,_){let ee=(0,h.generateUuid)(),ne=!1,te=!1;if(ae.url){const $=C.parse(ae.url,!0).query;typeof $.reconnectionToken=="string"&&(ee=$.reconnectionToken),$.reconnection==="true"&&(ne=!0),$.skipWebSocketFrames==="true"&&(te=!0)}if(ae.headers.upgrade===void 0||ae.headers.upgrade.toLowerCase()!=="websocket"){_.end("HTTP/1.1 400 Bad Request");return}const x=ae.headers["sec-websocket-key"],U=w.createHash("sha1");U.update(x+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Z=U.digest("base64"),re=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${Z}`];let me=!1;if(!te&&!this.n.args["disable-websocket-compression"]&&ae.headers["sec-websocket-extensions"]){const $=Array.isArray(ae.headers["sec-websocket-extensions"])?ae.headers["sec-websocket-extensions"]:[ae.headers["sec-websocket-extensions"]];for(const W of $)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(W)){if(/\b(permessage-deflate)\b/.test(W)){me=!0,re.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(W)){me=!0,re.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}_.write(re.join(`\r
`)+`\r
\r
`),_.setTimeout(0),_.setNoDelay(!0),te?this.v(new L.NodeSocket(_,`server-connection-${ee}`),ne,ee):this.v(new L.WebSocketNodeSocket(new L.NodeSocket(_,`server-connection-${ee}`),me,null,!0),ne,ee)}handleServerError(ae){this.r.error("Error occurred in server"),this.r.error(ae)}t(ae){let _;return ae instanceof L.NodeSocket?_=ae.socket:_=ae.socket.socket,_.remoteAddress||"<unknown>"}async u(ae,_,ee){const ne=_.getSocket();this.r.error(`${ae} ${ee}.`);const te={type:"error",reason:ee};_.sendControl(v.VSBuffer.fromString(JSON.stringify(te))),_.dispose(),await ne.drain(),ne.dispose()}v(ae,_,ee){const ne=this.t(ae),te=`[${ne}][${ee.substr(0,8)}]`,x=new S.PersistentProtocol({socket:ae}),U=this.m?new this.m.validator:null,Z=this.m?new this.m.signer:null;let re;(function(N){N[N.WaitingForAuth=0]="WaitingForAuth",N[N.WaitingForConnectionType=1]="WaitingForConnectionType",N[N.Done=2]="Done",N[N.Error=3]="Error"})(re||(re={}));let me=0;const $=N=>{me=3,W.dispose(),this.u(te,x,N)},W=x.onControlMessage(N=>{if(me===0){let P;try{P=JSON.parse(N.toString())}catch{return $("Malformed first message")}if(P.type!=="auth")return $("Invalid first message");if(this.l.type===2&&!this.l.validate(P.auth))return $("Unauthorized client refused: auth mismatch");let M=(0,h.generateUuid)();if(Z)try{M=Z.sign(P.data)}catch{}let Y=(0,h.generateUuid)();if(U)try{Y=U.createNewMessage(Y)}catch{}const ie={type:"sign",data:Y,signedData:M};x.sendControl(v.VSBuffer.fromString(JSON.stringify(ie))),me=1}else if(me===1){let P;try{P=JSON.parse(N.toString())}catch{return $("Malformed second message")}if(P.type!=="connectionType")return $("Invalid second message");if(typeof P.signedData!="string")return $("Invalid second message field type");const M=P.commit,Y=this.p.commit;if(M&&Y&&M!==Y)return $("Client refused: version mismatch");let ie=!1;if(!U)ie=!0;else if(this.l.validate(P.signedData))ie=!0;else try{ie=U.validate(P.signedData)==="ok"}catch{}if(!ie){if(this.n.isBuilt)return $("Unauthorized client refused");this.r.error(`${te} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const z in this.b)this.b[z].shortenReconnectionGraceTimeIfNecessary();for(const z in this.a)this.a[z].shortenReconnectionGraceTimeIfNecessary();me=2,W.dispose(),this.w(ne,te,x,ae,_,ee,P)}})}async w(ae,_,ee,ne,te,x,U){const Z=U.desiredConnectionType===1?`${_}[ManagementConnection]`:U.desiredConnectionType===2?`${_}[ExtensionHostConnection]`:_;if(U.desiredConnectionType===1)if(te){if(!this.b[x])return this.f.has(x)?this.u(Z,ee,"Unknown reconnection token (seen before)"):this.u(Z,ee,"Unknown reconnection token (never seen)");ee.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=ee.readEntireBuffer();ee.dispose(),this.b[x].acceptReconnection(ae,ne,re)}else{if(this.b[x])return this.u(Z,ee,"Duplicate reconnection token");ee.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=new s.ManagementConnection(this.r,x,ae,ee);this.k.acceptConnection(re.protocol,re.onClose),this.b[x]=re,this.f.add(x),re.onClose(()=>{delete this.b[x]})}else if(U.desiredConnectionType===2){const re=U.args||{language:"en"},me=await this.C(re);if(me.port&&this.r.trace(`${Z} - startParams debug port ${me.port}`),this.r.trace(`${Z} - startParams language: ${me.language}`),this.r.trace(`${Z} - startParams env: ${JSON.stringify(me.env)}`),te){if(!this.a[x])return this.f.has(x)?this.u(Z,ee,"Unknown reconnection token (seen before)"):this.u(Z,ee,"Unknown reconnection token (never seen)");ee.sendPause(),ee.sendControl(v.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const $=ee.readEntireBuffer();ee.dispose(),this.a[x].acceptReconnection(ae,ne,$)}else{if(this.a[x])return this.u(Z,ee,"Duplicate reconnection token");ee.sendPause(),ee.sendControl(v.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const $=ee.readEntireBuffer();ee.dispose();const W=this.s.createInstance(c.ExtensionHostConnection,x,ae,ne,$);this.a[x]=W,this.f.add(x),W.onClose(()=>{delete this.a[x],this.D()}),W.start(me)}}else if(U.desiredConnectionType===3){const re=U.args;this.y(ee,re)}else return this.u(Z,ee,"Unknown initial data received")}async y(ae,_){const ee=ae.getSocket().socket,ne=ae.readEntireBuffer();ae.dispose(),ee.pause();const te=await this.z(_.host,_.port);ne.byteLength>0&&te.write(ne.buffer),te.on("end",()=>ee.end()),te.on("close",()=>ee.end()),te.on("error",()=>ee.destroy()),ee.on("end",()=>te.end()),ee.on("close",()=>te.end()),ee.on("error",()=>te.destroy()),te.pipe(ee),ee.pipe(te)}z(ae,_){return new Promise((ee,ne)=>{const te=o.createConnection({host:ae,port:_},()=>{te.removeListener("error",ne),te.pause(),ee(te)});te.once("error",ne)})}C(ae){return typeof ae.port=="number"?(0,d.findFreePort)(ae.port,10,5e3).then(_=>(ae.port=_,ae)):(ae.debugId=void 0,ae.port=void 0,ae.break=void 0,Promise.resolve(ae))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(ae=!1){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]&&!ae?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},B))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};q=Le([Ae(4,E.IServerEnvironmentService),Ae(5,r.IProductService),Ae(6,n.ILogService),Ae(7,t.IInstantiationService)],q);async function le(ue,ae,_){const ee=await(0,u.determineServerConnectionToken)(ae);ee instanceof u.ServerConnectionTokenParseError&&(console.warn(ee.message),process.exit(1));function ne(ie){(0,g.setUnexpectedErrorHandler)(z=>{(0,g.isSigPipeError)(z)&&z.stack&&/unexpectedErrorHandler/.test(z.stack)||ie(z)})}const te=[];ne(ie=>{te.push(ie),console.error(ie)});let x=!1;process.on("SIGPIPE",()=>{x||(x=!0,(0,g.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const U=new I.DisposableStore,{socketServer:Z,instantiationService:re}=await(0,k.setupServerServices)(ee,ae,_,U);re.invokeFunction(ie=>{const z=ie.get(n.ILogService);te.forEach(V=>z.error(V)),te.length=0,ne(V=>z.error(V))}),re.invokeFunction(ie=>{const z=ie.get(n.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const V=(0,m.join)(process.env.HOMEDRIVE,"node_modules"),J=(0,m.dirname)((0,m.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),H=(0,m.join)(J,"node_modules");if(R.existsSync(V)||R.existsSync(H)){const X=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${V}
* ${H}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;z.warn(X),console.warn(X),process.exit(0)}}});const me=re.invokeFunction(ie=>{const z=ie.get(n.ILogService);if(R.existsSync((0,m.join)(y.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(J){z.error(J)}return null}),$=R.existsSync(y.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if($&&ue&&typeof ue!="string"){const ie=ee.type!==0?`?${y.connectionTokenQueryName}=${ee.value}`:"";console.log(`Web UI available at http://localhost${ue.port===80?"":`:${ue.port}`}/${ie}`)}const W=re.createInstance(q,Z,ee,me,$);p.mark("code/server/ready");const N=D.performance.now(),P=global.vscodeServerStartTime,M=global.vscodeServerListenTime,Y=global.vscodeServerCodeLoadedTime;if(re.invokeFunction(ie=>{ie.get(l.ITelemetryService).publicLog2("serverStart",{startTime:P,startedTime:M,codeLoadedTime:Y,readyTime:N})}),ae["print-startup-performance"]){const ie=A.LoaderStats.get();let z="";z+=`

### Load AMD-module
`,z+=A.LoaderStats.toMarkdownTable(["Module","Duration"],ie.amdLoad),z+=`

### Load commonjs-module
`,z+=A.LoaderStats.toMarkdownTable(["Module","Duration"],ie.nodeRequire),z+=`

### Invoke AMD-module factory
`,z+=A.LoaderStats.toMarkdownTable(["Module","Duration"],ie.amdInvoke),z+=`

### Invoke commonjs-module
`,z+=A.LoaderStats.toMarkdownTable(["Module","Duration"],ie.nodeEval),z+=`Start-up time: ${M-P}
`,z+=`Code loading time: ${Y-P}
`,z+=`Initialized time: ${N-P}
`,z+=`
`,console.log(z)}return W}e.createServer=le;class de{static create(ae){const _=ae.webEndpointUrlTemplate,ee=ae.commit,ne=ae.quality;if(!_||!ee||!ne)return new de(null);const te=(0,h.generateUuid)(),U=new URL(_.replace("{{uuid}}",te).replace("{{commit}}",ee).replace("{{quality}}",ne)).origin,Z=(0,a.escapeRegExpCharacters)(U).replace(te,"[a-zA-Z0-9\\-]+");try{const re=(0,a.createRegExp)(`^${Z}$`,!0,{matchCase:!1});return new de(re)}catch{return new de(null)}}constructor(ae){this.a=ae}matches(ae){return this.a?this.a.test(ae):!1}}}),define(pe[299],ve([1,0,33,32,13,286,288,63,7,289,45,52,41]),function(oe,e,w,R,o,D,C,A,v,g,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,y.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=g.performance.now();const m={onMultipleValues:(i,l)=>{console.error(`Option '${i}' can only be defined once. Using value ${l}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,l)=>{console.warn(`Option '${i}' is deprecated: ${l}`)}},p=(0,A.parseArgs)(process.argv.slice(2),T.serverOptions,m),b=p["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(w.homedir(),I.default.serverDataFolderName||".vscode-remote"),a=(0,v.join)(b,"data"),f=(0,v.join)(a,"User"),h=(0,v.join)(f,"globalStorage"),d=(0,v.join)(f,"History"),S=(0,v.join)(a,"Machine");p["user-data-dir"]=a;const L=(0,v.dirname)(o.FileAccess.asFileUri("").fsPath),t=(0,v.join)(L,"extensions");p["builtin-extensions-dir"]=t,p["extensions-dir"]=p["extensions-dir"]||(0,v.join)(b,"extensions"),[b,p["extensions-dir"],a,f,S,h,d].forEach(i=>{try{R.existsSync(i)||R.mkdirSync(i,{mode:448})}catch(l){console.error(l)}});function n(){(0,D.run)(p,b,T.serverOptions)}e.spawnCli=n;function r(i){return(0,C.createServer)(i,p,b)}e.createServer=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b7886d7461186a5eac768481578c1d7ca80e2d21/core/vs/server/node/server.main.js.map
